library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity sorter is
    Port ( FFA : in std_logic_vector(31 downto 0);
           FFB : in std_logic_vector(31 downto 0);
           FFC : in std_logic_vector(31 downto 0);
           FFD : in std_logic_vector(31 downto 0);
           FFE : in std_logic_vector(31 downto 0);
           FFF : in std_logic_vector(31 downto 0);
           FFG : in std_logic_vector(31 downto 0);
           FFH : in std_logic_vector(31 downto 0);
           FFI : in std_logic_vector(31 downto 0);

           SFA : in std_logic_vector(31 downto 0);
           SFB : in std_logic_vector(31 downto 0);
           SFC : in std_logic_vector(31 downto 0);
           SFD : in std_logic_vector(31 downto 0);
           SFE : in std_logic_vector(31 downto 0);
           SFF : in std_logic_vector(31 downto 0);
           SFG : in std_logic_vector(31 downto 0);
           SFH : in std_logic_vector(31 downto 0);
           SFI : in std_logic_vector(31 downto 0);
 
           CLK1: in std_logic;

           OA : out std_logic_vector(18 downto 1);
           OB : out std_logic_vector(18 downto 1);
           OC : out std_logic_vector(18 downto 1);
           OD : out std_logic_vector(18 downto 1);
           OE : out std_logic_vector(18 downto 1);
           OFE : out std_logic_vector(18 downto 1);
           OG : out std_logic_vector(18 downto 1);
           OH : out std_logic_vector(18 downto 1);
           OI : out std_logic_vector(18 downto 1);
           OJ : out std_logic_vector(18 downto 1);
           OK : out std_logic_vector(18 downto 1);
           OL : out std_logic_vector(18 downto 1);			  

           OFIR : out std_logic_vector(31 downto 0);
           OSEC : out std_logic_vector(31 downto 0);
           OTHI : out std_logic_vector(31 downto 0);
			  
           FIR : out std_logic_vector(31 downto 0);
           SEC : out std_logic_vector(31 downto 0);
           THI : out std_logic_vector(31 downto 0);
           FOU : out std_logic_vector(31 downto 0);
           FIF : out std_logic_vector(31 downto 0);
           SIX : out std_logic_vector(31 downto 0);
           SEV : out std_logic_vector(31 downto 0);
           EIG : out std_logic_vector(31 downto 0);
           NIN : out std_logic_vector(31 downto 0);
           TEN : out std_logic_vector(31 downto 0);
           ELE : out std_logic_vector(31 downto 0);
           TWE : out std_logic_vector(31 downto 0)		  
		 
		 );

end sorter;

architecture structural  of sorter is

component FLAG
Port (
		 FLA : in std_logic_vector(5 downto 1);
		 FLB : in std_logic_vector(5 downto 1);
		 FLC : in std_logic_vector(5 downto 1);
		 FLD : in std_logic_vector(5 downto 1);
		 FLE : in std_logic_vector(5 downto 1);
		 FLF : in std_logic_vector(5 downto 1);
		 FLG : in std_logic_vector(5 downto 1);
		 FLH : in std_logic_vector(5 downto 1);
		 FLI : in std_logic_vector(5 downto 1);
		 FLJ : in std_logic_vector(5 downto 1);
		 FLK : in std_logic_vector(5 downto 1);
		 FLL : in std_logic_vector(5 downto 1);
		 FLM : in std_logic_vector(5 downto 1);
		 FLN : in std_logic_vector(5 downto 1);
		 FLP : in std_logic_vector(5 downto 1);
		 FLQ : in std_logic_vector(5 downto 1);
		 FLR : in std_logic_vector(5 downto 1);
		 FLS : in std_logic_vector(5 downto 1);

 		 OUTA : out std_logic_vector(5 downto 1);
		 OUTB : out std_logic_vector(5 downto 1);
		 OUTC : out std_logic_vector(5 downto 1);
		 OUTD : out std_logic_vector(5 downto 1);
		 OUTE : out std_logic_vector(5 downto 1);
		 OUTF : out std_logic_vector(5 downto 1);
		 OUTG : out std_logic_vector(5 downto 1);
		 OUTH : out std_logic_vector(5 downto 1);
		 OUTI : out std_logic_vector(5 downto 1);
		 OUTJ : out std_logic_vector(5 downto 1);
		 OUTK : out std_logic_vector(5 downto 1);
		 OUTL : out std_logic_vector(5 downto 1);
		 OUTM : out std_logic_vector(5 downto 1);
		 OUTN : out std_logic_vector(5 downto 1);
		 OUTP : out std_logic_vector(5 downto 1);
		 OUTQ : out std_logic_vector(5 downto 1);
		 OUTR : out std_logic_vector(5 downto 1);
		 OUTS : out std_logic_vector(5 downto 1));

end component;

component DFF4 
    Port ( DIN : in std_logic_vector(4 downto 1);
           QOUT : out std_logic_vector(4 downto 1);
           CLK : in std_logic);
end component;

component MERGEROLD
Port ( FA : in std_logic_vector(31 downto 0);
		 FB : in std_logic_vector(31 downto 0);
		 FC : in std_logic_vector(31 downto 0);
		 FD : in std_logic_vector(31 downto 0);
		 FE : in std_logic_vector(31 downto 0);
		 FF : in std_logic_vector(31 downto 0);
		 FG : in std_logic_vector(31 downto 0);
		 FH : in std_logic_vector(31 downto 0);
		 FI : in std_logic_vector(31 downto 0);

		 SA : in std_logic_vector(31 downto 0);
		 SB : in std_logic_vector(31 downto 0);
		 SC : in std_logic_vector(31 downto 0);
		 SD : in std_logic_vector(31 downto 0);
		 SE : in std_logic_vector(31 downto 0);
		 SF : in std_logic_vector(31 downto 0);
		 SG : in std_logic_vector(31 downto 0);
		 SH : in std_logic_vector(31 downto 0);
		 SI : in std_logic_vector(31 downto 0);

        A : in std_logic_vector(18 downto 1);
   	  B : in std_logic_vector(18 downto 1);
        C : in std_logic_vector(18 downto 1);

        OUTA : out std_logic_vector(31 downto 0);
        OUTB : out std_logic_vector(31 downto 0);
        OUTC : out std_logic_vector(31 downto 0) 	   
	   );

		  end component;

component MERGER
Port ( FA : in std_logic_vector(31 downto 0);
		 FB : in std_logic_vector(31 downto 0);
		 FC : in std_logic_vector(31 downto 0);
		 FD : in std_logic_vector(31 downto 0);
		 FE : in std_logic_vector(31 downto 0);
		 FF : in std_logic_vector(31 downto 0);
		 FG : in std_logic_vector(31 downto 0);
		 FH : in std_logic_vector(31 downto 0);
		 FI : in std_logic_vector(31 downto 0);

		 SA : in std_logic_vector(31 downto 0);
		 SB : in std_logic_vector(31 downto 0);
		 SC : in std_logic_vector(31 downto 0);
		 SD : in std_logic_vector(31 downto 0);
		 SE : in std_logic_vector(31 downto 0);
		 SF : in std_logic_vector(31 downto 0);
		 SG : in std_logic_vector(31 downto 0);
		 SH : in std_logic_vector(31 downto 0);
		 SI : in std_logic_vector(31 downto 0);

        A : in std_logic_vector(18 downto 1);
   	  B : in std_logic_vector(18 downto 1);
        C : in std_logic_vector(18 downto 1);
        D : in std_logic_vector(18 downto 1);
        E : in std_logic_vector(18 downto 1);
        F : in std_logic_vector(18 downto 1);
        G : in std_logic_vector(18 downto 1);
        H : in std_logic_vector(18 downto 1);
        I : in std_logic_vector(18 downto 1);
        J : in std_logic_vector(18 downto 1);
        K : in std_logic_vector(18 downto 1);
        L : in std_logic_vector(18 downto 1);		  

        OUTA : out std_logic_vector(31 downto 0);
        OUTB : out std_logic_vector(31 downto 0);
        OUTC : out std_logic_vector(31 downto 0);
        OUTD : out std_logic_vector(31 downto 0);
        OUTE : out std_logic_vector(31 downto 0);
        OUTF : out std_logic_vector(31 downto 0);
        OUTG : out std_logic_vector(31 downto 0);
        OUTH : out std_logic_vector(31 downto 0);
        OUTI : out std_logic_vector(31 downto 0);
        OUTJ : out std_logic_vector(31 downto 0);
        OUTK : out std_logic_vector(31 downto 0);
        OUTL : out std_logic_vector(31 downto 0)	  
   	   
	   );

		  end component;

component COMP153 
    Port ( INA : in std_logic_vector(5 downto 1);
           INB : in std_logic_vector(5 downto 1);
           INC : in std_logic_vector(5 downto 1);
           IND : in std_logic_vector(5 downto 1);
           INE : in std_logic_vector(5 downto 1);
           INF : in std_logic_vector(5 downto 1);
           ING : in std_logic_vector(5 downto 1);
           INH : in std_logic_vector(5 downto 1);
           INI : in std_logic_vector(5 downto 1);
           INJ : in std_logic_vector(5 downto 1);
           INK : in std_logic_vector(5 downto 1);
           INL : in std_logic_vector(5 downto 1);
           INM : in std_logic_vector(5 downto 1);
           INN : in std_logic_vector(5 downto 1);
           INP : in std_logic_vector(5 downto 1);
           INQ : in std_logic_vector(5 downto 1);
           INR : in std_logic_vector(5 downto 1);
           INS : in std_logic_vector(5 downto 1);
           ZERO : out std_logic_vector(18 downto 1);
           OUTA : out std_logic_vector(153 downto 1));
end component;

component SELECT1 
    Port ( INPUT  : in std_logic_vector(153 downto 1);
           ZERO   : in std_logic_vector(18 downto 1);      
           OUTPUT : out std_logic_vector(18 downto 1));
end component;

component SELECT2 
    Port ( IINPUT : in std_logic_vector(153 downto 1);
           ZZERO  : in std_logic_vector(18 downto 1);
           INPUTT : in std_logic_vector(18 downto 1);
           OUTPUTT : out std_logic_vector(18 downto 1));
end component;

component SELECT3 
    Port ( IIINPUT : in std_logic_vector(153 downto 1);
           ZZZERO  : in std_logic_vector(18 downto 1);
           INPUTTA : in std_logic_vector(18 downto 1);
           INPUTTT : in std_logic_vector(18 downto 1);
           OUTPUTTT : out std_logic_vector(18 downto 1));
end component;

 component SELECT4 
    Port ( IIINPUT : in std_logic_vector(153 downto 1);
           ZEROBA  : in std_logic_vector(18 downto 1);
           INPUTTA : in std_logic_vector(18 downto 1);
           INPUTTT : in std_logic_vector(18 downto 1);
		 INPUTB : in std_logic_vector(18 downto 1);
           OUTPUTB : out std_logic_vector(18 downto 1));
end component;

 component SELECT5 
    Port ( IIINPUT : in std_logic_vector(153 downto 1);
           ZEROB  : in std_logic_vector(18 downto 1);
           INPUTTA : in std_logic_vector(18 downto 1);
           INPUTTT : in std_logic_vector(18 downto 1);
		 INPUTB : in std_logic_vector(18 downto 1);
		 INPUTC : in std_logic_vector(18 downto 1);
           OUTPUTC : out std_logic_vector(18 downto 1));
end component;

component SELECT6 
    Port ( IIINPUT : in std_logic_vector(153 downto 1);
           ZEROB  : in std_logic_vector(18 downto 1);
           INPUTTA : in std_logic_vector(18 downto 1);
           INPUTTT : in std_logic_vector(18 downto 1);
		 INPUTB : in std_logic_vector(18 downto 1);
		 INPUTC : in std_logic_vector(18 downto 1);
 		 INPUTD : in std_logic_vector(18 downto 1);
           OUTPUTD : out std_logic_vector(18 downto 1));
end component;

component SELECT7 
    Port ( IIINPUT : in std_logic_vector(153 downto 1);
           ZEROB  : in std_logic_vector(18 downto 1);
           INPUTTA : in std_logic_vector(18 downto 1);
           INPUTTT : in std_logic_vector(18 downto 1);
		 INPUTB : in std_logic_vector(18 downto 1);
		 INPUTC : in std_logic_vector(18 downto 1);
 		 INPUTD : in std_logic_vector(18 downto 1);
 		 INPUTE : in std_logic_vector(18 downto 1);
           OUTPUTE : out std_logic_vector(18 downto 1));
end component;
 
component SELECT8 
    Port ( IIINPUT : in std_logic_vector(153 downto 1);
           ZEROB  : in std_logic_vector(18 downto 1);
           INPUTTA : in std_logic_vector(18 downto 1);
           INPUTTT : in std_logic_vector(18 downto 1);
		 INPUTB : in std_logic_vector(18 downto 1);
		 INPUTC : in std_logic_vector(18 downto 1);
 		 INPUTD : in std_logic_vector(18 downto 1);
 		 INPUTE : in std_logic_vector(18 downto 1);
 		 INPUTF : in std_logic_vector(18 downto 1);		 
           OUTPUTF : out std_logic_vector(18 downto 1));
end component; 
 
component SELECT9 
    Port ( IIINPUT : in std_logic_vector(153 downto 1);
           ZEROB  : in std_logic_vector(18 downto 1);
           INPUTTA : in std_logic_vector(18 downto 1);
           INPUTTT : in std_logic_vector(18 downto 1);
		 INPUTB : in std_logic_vector(18 downto 1);
		 INPUTC : in std_logic_vector(18 downto 1);
 		 INPUTD : in std_logic_vector(18 downto 1);
 		 INPUTE : in std_logic_vector(18 downto 1);
 		 INPUTF : in std_logic_vector(18 downto 1);	
 		 INPUTG : in std_logic_vector(18 downto 1);			 
           OUTPUTG : out std_logic_vector(18 downto 1));
end component;  

component SELECT10 
    Port ( IIINPUT : in std_logic_vector(153 downto 1);
           ZEROB  : in std_logic_vector(18 downto 1);
           INPUTTA : in std_logic_vector(18 downto 1);
           INPUTTT : in std_logic_vector(18 downto 1);
		 INPUTB : in std_logic_vector(18 downto 1);
		 INPUTC : in std_logic_vector(18 downto 1);
 		 INPUTD : in std_logic_vector(18 downto 1);
 		 INPUTE : in std_logic_vector(18 downto 1);
 		 INPUTF : in std_logic_vector(18 downto 1);	
 		 INPUTG : in std_logic_vector(18 downto 1);	
 		 INPUTH : in std_logic_vector(18 downto 1);			 
           OUTPUTH : out std_logic_vector(18 downto 1));
end component; 

component SELECT11 
    Port ( IIINPUT : in std_logic_vector(153 downto 1);
           ZEROB  : in std_logic_vector(18 downto 1);
           INPUTTA : in std_logic_vector(18 downto 1);
           INPUTTT : in std_logic_vector(18 downto 1);
		 INPUTB : in std_logic_vector(18 downto 1);
		 INPUTC : in std_logic_vector(18 downto 1);
 		 INPUTD : in std_logic_vector(18 downto 1);
 		 INPUTE : in std_logic_vector(18 downto 1);
 		 INPUTF : in std_logic_vector(18 downto 1);	
 		 INPUTG : in std_logic_vector(18 downto 1);	
 		 INPUTH : in std_logic_vector(18 downto 1);	
 		 INPUTI : in std_logic_vector(18 downto 1);		 
           OUTPUTI : out std_logic_vector(18 downto 1));
end component; 

component SELECT12 
    Port ( IIINPUT : in std_logic_vector(153 downto 1);
           ZEROB  : in std_logic_vector(18 downto 1);
           INPUTTA : in std_logic_vector(18 downto 1);
           INPUTTT : in std_logic_vector(18 downto 1);
		 INPUTB : in std_logic_vector(18 downto 1);
		 INPUTC : in std_logic_vector(18 downto 1);
 		 INPUTD : in std_logic_vector(18 downto 1);
 		 INPUTE : in std_logic_vector(18 downto 1);
 		 INPUTF : in std_logic_vector(18 downto 1);	
 		 INPUTG : in std_logic_vector(18 downto 1);	
 		 INPUTH : in std_logic_vector(18 downto 1);	
 		 INPUTI : in std_logic_vector(18 downto 1);	
 		 INPUTJ : in std_logic_vector(18 downto 1);			 
           OUTPUTJ : out std_logic_vector(18 downto 1));
end component;
 
component DFF18 
    Port ( DIN : in std_logic_vector(18 downto 1);
           CLK: in std_logic;
           QOUT : out std_logic_vector(18 downto 1));
end component;

component DFF32 
    Port ( DIN : in std_logic_vector(31 downto 0);
           CLK: in std_logic;
           QOUT : out std_logic_vector(31 downto 0));
end component;

component DFF153 
    Port ( DIN : in std_logic_vector(153 downto 1);
           CLK: in std_logic;
           QOUT : out std_logic_vector(153 downto 1));
end component;

SIGNAL FFAD :  std_logic_vector(31 downto 0);
SIGNAL FFBD :  std_logic_vector(31 downto 0);
SIGNAL FFCD :  std_logic_vector(31 downto 0);
SIGNAL FFDD :  std_logic_vector(31 downto 0);
SIGNAL FFED :  std_logic_vector(31 downto 0);
SIGNAL FFFD :  std_logic_vector(31 downto 0);
SIGNAL FFGD :  std_logic_vector(31 downto 0);
SIGNAL FFHD :  std_logic_vector(31 downto 0);
SIGNAL FFID :  std_logic_vector(31 downto 0);

SIGNAL FFADD :  std_logic_vector(31 downto 0);
SIGNAL FFBDD :  std_logic_vector(31 downto 0);
SIGNAL FFCDD :  std_logic_vector(31 downto 0);
SIGNAL FFDDD :  std_logic_vector(31 downto 0);
SIGNAL FFEDD :  std_logic_vector(31 downto 0);
SIGNAL FFFDD :  std_logic_vector(31 downto 0);
SIGNAL FFGDD :  std_logic_vector(31 downto 0);
SIGNAL FFHDD :  std_logic_vector(31 downto 0);
SIGNAL FFIDD :  std_logic_vector(31 downto 0);

SIGNAL FFADDD :  std_logic_vector(31 downto 0);
SIGNAL FFBDDD :  std_logic_vector(31 downto 0);
SIGNAL FFCDDD :  std_logic_vector(31 downto 0);
SIGNAL FFDDDD :  std_logic_vector(31 downto 0);
SIGNAL FFEDDD :  std_logic_vector(31 downto 0);
SIGNAL FFFDDD :  std_logic_vector(31 downto 0);
SIGNAL FFGDDD :  std_logic_vector(31 downto 0);
SIGNAL FFHDDD :  std_logic_vector(31 downto 0);
SIGNAL FFIDDD :  std_logic_vector(31 downto 0);

SIGNAL FFADDDD :  std_logic_vector(31 downto 0);
SIGNAL FFBDDDD :  std_logic_vector(31 downto 0);
SIGNAL FFCDDDD :  std_logic_vector(31 downto 0);
SIGNAL FFDDDDD :  std_logic_vector(31 downto 0);
SIGNAL FFEDDDD :  std_logic_vector(31 downto 0);
SIGNAL FFFDDDD :  std_logic_vector(31 downto 0);
SIGNAL FFGDDDD :  std_logic_vector(31 downto 0);
SIGNAL FFHDDDD :  std_logic_vector(31 downto 0);
SIGNAL FFIDDDD :  std_logic_vector(31 downto 0);

SIGNAL FFADDDDD :  std_logic_vector(31 downto 0);
SIGNAL FFBDDDDD :  std_logic_vector(31 downto 0);
SIGNAL FFCDDDDD :  std_logic_vector(31 downto 0);
SIGNAL FFDDDDDD :  std_logic_vector(31 downto 0);
SIGNAL FFEDDDDD :  std_logic_vector(31 downto 0);
SIGNAL FFFDDDDD :  std_logic_vector(31 downto 0);
SIGNAL FFGDDDDD :  std_logic_vector(31 downto 0);
SIGNAL FFHDDDDD :  std_logic_vector(31 downto 0);
SIGNAL FFIDDDDD :  std_logic_vector(31 downto 0);

SIGNAL SFAD :  std_logic_vector(31 downto 0);
SIGNAL SFBD :  std_logic_vector(31 downto 0);
SIGNAL SFCD :  std_logic_vector(31 downto 0);
SIGNAL SFDD :  std_logic_vector(31 downto 0);
SIGNAL SFED :  std_logic_vector(31 downto 0);
SIGNAL SFFD :  std_logic_vector(31 downto 0);
SIGNAL SFGD :  std_logic_vector(31 downto 0);
SIGNAL SFHD :  std_logic_vector(31 downto 0);
SIGNAL SFID :  std_logic_vector(31 downto 0);

SIGNAL SFADD :  std_logic_vector(31 downto 0);
SIGNAL SFBDD :  std_logic_vector(31 downto 0);
SIGNAL SFCDD :  std_logic_vector(31 downto 0);
SIGNAL SFDDD :  std_logic_vector(31 downto 0);
SIGNAL SFEDD :  std_logic_vector(31 downto 0);
SIGNAL SFFDD :  std_logic_vector(31 downto 0);
SIGNAL SFGDD :  std_logic_vector(31 downto 0);
SIGNAL SFHDD :  std_logic_vector(31 downto 0);
SIGNAL SFIDD :  std_logic_vector(31 downto 0);

SIGNAL SFADDD :  std_logic_vector(31 downto 0);
SIGNAL SFBDDD :  std_logic_vector(31 downto 0);
SIGNAL SFCDDD :  std_logic_vector(31 downto 0);
SIGNAL SFDDDD :  std_logic_vector(31 downto 0);
SIGNAL SFEDDD :  std_logic_vector(31 downto 0);
SIGNAL SFFDDD :  std_logic_vector(31 downto 0);
SIGNAL SFGDDD :  std_logic_vector(31 downto 0);
SIGNAL SFHDDD :  std_logic_vector(31 downto 0);
SIGNAL SFIDDD :  std_logic_vector(31 downto 0);

SIGNAL SFADDDD :  std_logic_vector(31 downto 0);
SIGNAL SFBDDDD :  std_logic_vector(31 downto 0);
SIGNAL SFCDDDD :  std_logic_vector(31 downto 0);
SIGNAL SFDDDDD :  std_logic_vector(31 downto 0);
SIGNAL SFEDDDD :  std_logic_vector(31 downto 0);
SIGNAL SFFDDDD :  std_logic_vector(31 downto 0);
SIGNAL SFGDDDD :  std_logic_vector(31 downto 0);
SIGNAL SFHDDDD :  std_logic_vector(31 downto 0);
SIGNAL SFIDDDD :  std_logic_vector(31 downto 0);

SIGNAL SORA :  std_logic_vector(5 downto 1);
SIGNAL SORB :  std_logic_vector(5 downto 1);
SIGNAL SORC :  std_logic_vector(5 downto 1);
SIGNAL SORD :  std_logic_vector(5 downto 1);
SIGNAL SORE :  std_logic_vector(5 downto 1);
SIGNAL SORF :  std_logic_vector(5 downto 1);
SIGNAL SORG :  std_logic_vector(5 downto 1);
SIGNAL SORH :  std_logic_vector(5 downto 1);
SIGNAL SORI :  std_logic_vector(5 downto 1);
SIGNAL SORJ :  std_logic_vector(5 downto 1);
SIGNAL SORK :  std_logic_vector(5 downto 1);
SIGNAL SORL :  std_logic_vector(5 downto 1);
SIGNAL SORM :  std_logic_vector(5 downto 1);
SIGNAL SORN :  std_logic_vector(5 downto 1);
SIGNAL SORP :  std_logic_vector(5 downto 1);
SIGNAL SORQ :  std_logic_vector(5 downto 1);
SIGNAL SORR :  std_logic_vector(5 downto 1);
SIGNAL SORS :  std_logic_vector(5 downto 1);

SIGNAL OTA :  std_logic_vector(31 downto 0);
SIGNAL OTB :  std_logic_vector(31 downto 0);
SIGNAL OTC :  std_logic_vector(31 downto 0);

SIGNAL TA :  std_logic_vector(31 downto 0);
SIGNAL TB :  std_logic_vector(31 downto 0);
SIGNAL TC :  std_logic_vector(31 downto 0);
SIGNAL TD :  std_logic_vector(31 downto 0);
SIGNAL TE :  std_logic_vector(31 downto 0);
SIGNAL TF :  std_logic_vector(31 downto 0);
SIGNAL TG :  std_logic_vector(31 downto 0);
SIGNAL TH :  std_logic_vector(31 downto 0);
SIGNAL TI :  std_logic_vector(31 downto 0);
SIGNAL TJ :  std_logic_vector(31 downto 0);
SIGNAL TK :  std_logic_vector(31 downto 0);
SIGNAL TL :  std_logic_vector(31 downto 0);
 
SIGNAL TEMA  :  std_logic_vector(153 downto 1);
SIGNAL TEMAD  :  std_logic_vector(153 downto 1);
SIGNAL TEMADD  :  std_logic_vector(153 downto 1);
SIGNAL TEMADDD  :  std_logic_vector(153 downto 1);
SIGNAL TEMADDDD  :  std_logic_vector(153 downto 1);

SIGNAL AOUT  :  std_logic_vector(18 downto 1);
SIGNAL BOUT  :  std_logic_vector(18 downto 1);
SIGNAL COUT  :  std_logic_vector(18 downto 1);

SIGNAL AOUTD  :  std_logic_vector(18 downto 1);
SIGNAL BOUTD  :  std_logic_vector(18 downto 1);
SIGNAL COUTD  :  std_logic_vector(18 downto 1);

SIGNAL AOUTDD  :  std_logic_vector(18 downto 1);
SIGNAL BOUTDD  :  std_logic_vector(18 downto 1);
SIGNAL COUTDD  :  std_logic_vector(18 downto 1);

SIGNAL AOUTDDD  :  std_logic_vector(18 downto 1);
SIGNAL BOUTDDD  :  std_logic_vector(18 downto 1);
SIGNAL COUTDDD  :  std_logic_vector(18 downto 1);

SIGNAL AOUTDDDD  :  std_logic_vector(18 downto 1);
SIGNAL BOUTDDDD  :  std_logic_vector(18 downto 1);
SIGNAL COUTDDDD  :  std_logic_vector(18 downto 1);

SIGNAL DOUT  :  std_logic_vector(18 downto 1);
SIGNAL EOUT  :  std_logic_vector(18 downto 1);
SIGNAL FOUT  :  std_logic_vector(18 downto 1);

SIGNAL DOUTD  :  std_logic_vector(18 downto 1);
SIGNAL EOUTD  :  std_logic_vector(18 downto 1);
SIGNAL FOUTD  :  std_logic_vector(18 downto 1);

SIGNAL DOUTDD  :  std_logic_vector(18 downto 1);
SIGNAL EOUTDD  :  std_logic_vector(18 downto 1);
SIGNAL FOUTDD  :  std_logic_vector(18 downto 1);

SIGNAL DOUTDDD  :  std_logic_vector(18 downto 1);
SIGNAL EOUTDDD  :  std_logic_vector(18 downto 1);
SIGNAL FOUTDDD  :  std_logic_vector(18 downto 1);

SIGNAL GOUT  :  std_logic_vector(18 downto 1);
SIGNAL HOUT  :  std_logic_vector(18 downto 1);
SIGNAL IOUT  :  std_logic_vector(18 downto 1);

SIGNAL GOUTD  :  std_logic_vector(18 downto 1);
SIGNAL HOUTD  :  std_logic_vector(18 downto 1);
SIGNAL IOUTD  :  std_logic_vector(18 downto 1);

SIGNAL GOUTDD  :  std_logic_vector(18 downto 1);
SIGNAL HOUTDD  :  std_logic_vector(18 downto 1);
SIGNAL IOUTDD  :  std_logic_vector(18 downto 1);

SIGNAL JOUT  :  std_logic_vector(18 downto 1);
SIGNAL KOUT  :  std_logic_vector(18 downto 1);
SIGNAL LOUT  :  std_logic_vector(18 downto 1);

SIGNAL JOUTD  :  std_logic_vector(18 downto 1);
SIGNAL KOUTD  :  std_logic_vector(18 downto 1);
SIGNAL LOUTD  :  std_logic_vector(18 downto 1);
 
SIGNAL ZEROA :  std_logic_vector(18 downto 1);
SIGNAL ZEROAD :  std_logic_vector(18 downto 1);
SIGNAL ZEROADD :  std_logic_vector(18 downto 1);
SIGNAL ZEROADDD :  std_logic_vector(18 downto 1);
SIGNAL ZEROADDDD :  std_logic_vector(18 downto 1);

BEGIN

U10: FLAG
PORT MAP (FLA(4) => FFA(14), FLA(3) => FFA(13), FLA(2) => FFA(12), FLA(1) => FFA(11), FLA(5) => FFA(15), OUTA => SORA,
          FLB(4) => FFA(30), FLB(3) => FFA(29), FLB(2) => FFA(28), FLB(1) => FFA(27), FLB(5) => FFA(31), OUTB => SORB,
          FLC(4) => FFB(14), FLC(3) => FFB(13), FLC(2) => FFB(12), FLC(1) => FFB(11), FLC(5) => FFB(15), OUTC => SORC,
          FLD(4) => FFB(30), FLD(3) => FFB(29), FLD(2) => FFB(28), FLD(1) => FFB(27), FLD(5) => FFB(31), OUTD => SORD,
          FLE(4) => FFC(14), FLE(3) => FFC(13), FLE(2) => FFC(12), FLE(1) => FFC(11), FLE(5) => FFC(15), OUTE => SORE,
          FLF(4) => FFC(30), FLF(3) => FFC(29), FLF(2) => FFC(28), FLF(1) => FFC(27), FLF(5) => FFC(31), OUTF => SORF,
          FLG(4) => FFD(14), FLG(3) => FFD(13), FLG(2) => FFD(12), FLG(1) => FFD(11), FLG(5) => FFD(15), OUTG => SORG,
          FLH(4) => FFD(30), FLH(3) => FFD(29), FLH(2) => FFD(28), FLH(1) => FFD(27), FLH(5) => FFD(31), OUTH => SORH,
          FLI(4) => FFE(14), FLI(3) => FFE(13), FLI(2) => FFE(12), FLI(1) => FFE(11), FLI(5) => FFE(15), OUTI => SORI,
          FLJ(4) => FFE(30), FLJ(3) => FFE(29), FLJ(2) => FFE(28), FLJ(1) => FFE(27), FLJ(5) => FFE(31), OUTJ => SORJ,
          FLK(4) => FFF(14), FLK(3) => FFF(13), FLK(2) => FFF(12), FLK(1) => FFF(11), FLK(5) => FFF(15), OUTK => SORK,
          FLL(4) => FFF(30), FLL(3) => FFF(29), FLL(2) => FFF(28), FLL(1) => FFF(27), FLL(5) => FFF(31), OUTL => SORL,
          FLM(4) => FFG(14), FLM(3) => FFG(13), FLM(2) => FFG(12), FLM(1) => FFG(11), FLM(5) => FFG(15), OUTM => SORM,
          FLN(4) => FFG(30), FLN(3) => FFG(29), FLN(2) => FFG(28), FLN(1) => FFG(27), FLN(5) => FFG(31), OUTN => SORN,
          FLP(4) => FFH(14), FLP(3) => FFH(13), FLP(2) => FFH(12), FLP(1) => FFH(11), FLP(5) => FFH(15), OUTP => SORP,
          FLQ(4) => FFH(30), FLQ(3) => FFH(29), FLQ(2) => FFH(28), FLQ(1) => FFH(27), FLQ(5) => FFH(31), OUTQ => SORQ,
          FLR(4) => FFI(14), FLR(3) => FFI(13), FLR(2) => FFI(12), FLR(1) => FFI(11), FLR(5) => FFI(15), OUTR => SORR,
          FLS(4) => FFI(30), FLS(3) => FFI(29), FLS(2) => FFI(28), FLS(1) => FFI(27), FLS(5) => FFI(31), OUTS => SORS);

U20: DFF18
PORT MAP (DIN => AOUT, QOUT => AOUTD, CLK => CLK1);

U30: DFF18
PORT MAP (DIN => BOUT, QOUT => BOUTD, CLK => CLK1);

U40: DFF18
PORT MAP (DIN => COUT, QOUT => COUTD, CLK => CLK1);

U42: DFF18
PORT MAP (DIN => DOUT, QOUT => DOUTD, CLK => CLK1);

U44: DFF18
PORT MAP (DIN => EOUT, QOUT => EOUTD, CLK => CLK1);

U45: DFF18
PORT MAP (DIN => FOUT, QOUT => FOUTD, CLK => CLK1);

U70: DFF18
PORT MAP (DIN => AOUTD, QOUT => AOUTDD, CLK => CLK1);

U80: DFF18
PORT MAP (DIN => BOUTD, QOUT => BOUTDD, CLK => CLK1);

U90: DFF18
PORT MAP (DIN => COUTD, QOUT => COUTDD, CLK => CLK1);

U71: DFF18
PORT MAP (DIN => AOUTDD, QOUT => AOUTDDD, CLK => CLK1);

U81: DFF18
PORT MAP (DIN => BOUTDD, QOUT => BOUTDDD, CLK => CLK1);

U91: DFF18
PORT MAP (DIN => COUTDD, QOUT => COUTDDD, CLK => CLK1);

U75: DFF18
PORT MAP (DIN => AOUTDDD, QOUT => AOUTDDDD, CLK => CLK1);

U85: DFF18
PORT MAP (DIN => BOUTDDD, QOUT => BOUTDDDD, CLK => CLK1);

U95: DFF18
PORT MAP (DIN => COUTDDD, QOUT => COUTDDDD, CLK => CLK1);

U72: DFF18
PORT MAP (DIN => DOUTD, QOUT => DOUTDD, CLK => CLK1);

U82: DFF18
PORT MAP (DIN => EOUTD, QOUT => EOUTDD, CLK => CLK1);

U92: DFF18
PORT MAP (DIN => FOUTD, QOUT => FOUTDD, CLK => CLK1);

U76: DFF18
PORT MAP (DIN => DOUTDD, QOUT => DOUTDDD, CLK => CLK1);

U86: DFF18
PORT MAP (DIN => EOUTDD, QOUT => EOUTDDD, CLK => CLK1);

U96: DFF18
PORT MAP (DIN => FOUTDD, QOUT => FOUTDDD, CLK => CLK1);

U73: DFF18
PORT MAP (DIN => GOUT, QOUT => GOUTD, CLK => CLK1);

U83: DFF18
PORT MAP (DIN => HOUT, QOUT => HOUTD, CLK => CLK1);

U93: DFF18
PORT MAP (DIN => IOUT, QOUT => IOUTD, CLK => CLK1);

U78: DFF18
PORT MAP (DIN => JOUT, QOUT => JOUTD, CLK => CLK1);

U88: DFF18
PORT MAP (DIN => KOUT, QOUT => KOUTD, CLK => CLK1);

U98: DFF18
PORT MAP (DIN => LOUT, QOUT => LOUTD, CLK => CLK1);

U77: DFF18
PORT MAP (DIN => GOUTD, QOUT => GOUTDD, CLK => CLK1);

U87: DFF18
PORT MAP (DIN => HOUTD, QOUT => HOUTDD, CLK => CLK1);

U97: DFF18
PORT MAP (DIN => IOUTD, QOUT => IOUTDD, CLK => CLK1);
   
U600: DFF18
PORT MAP (DIN => ZEROA, QOUT => ZEROAD, CLK => CLK1);
						  
U50: DFF18
PORT MAP (DIN => ZEROAD, QOUT => ZEROADD, CLK => CLK1);
						  
U100: DFF18
PORT MAP (DIN => ZEROADD, QOUT => ZEROADDD, CLK => CLK1);

U101: DFF18
PORT MAP (DIN => ZEROADDD, QOUT => ZEROADDDD, CLK => CLK1);

U590: DFF153
PORT MAP (DIN => TEMA, QOUT => TEMAD, CLK => CLK1);

U60: DFF153
PORT MAP (DIN => TEMAD, QOUT => TEMADD, CLK => CLK1);

U110: DFF153
PORT MAP (DIN => TEMADD, QOUT => TEMADDD, CLK => CLK1);

U111: DFF153
PORT MAP (DIN => TEMADDD, QOUT => TEMADDDD, CLK => CLK1);

U120: DFF32
PORT MAP (DIN => FFA, QOUT => FFAD, CLK => CLK1);
U130: DFF32
PORT MAP (DIN => FFB, QOUT => FFBD, CLK => CLK1);
U140: DFF32
PORT MAP (DIN => FFC, QOUT => FFCD, CLK => CLK1);
U150: DFF32
PORT MAP (DIN => FFD, QOUT => FFDD, CLK => CLK1);
U160: DFF32
PORT MAP (DIN => FFE, QOUT => FFED, CLK => CLK1);
U170: DFF32
PORT MAP (DIN => FFF, QOUT => FFFD, CLK => CLK1);
U180: DFF32
PORT MAP (DIN => FFG, QOUT => FFGD, CLK => CLK1);
U190: DFF32
PORT MAP (DIN => FFH, QOUT => FFHD, CLK => CLK1);
U200: DFF32
PORT MAP (DIN => FFI, QOUT => FFID, CLK => CLK1);

U210: DFF32
PORT MAP (DIN => FFAD, QOUT => FFADD, CLK => CLK1);
U220: DFF32
PORT MAP (DIN => FFBD, QOUT => FFBDD, CLK => CLK1);
U230: DFF32
PORT MAP (DIN => FFCD, QOUT => FFCDD, CLK => CLK1);
U240: DFF32
PORT MAP (DIN => FFDD, QOUT => FFDDD, CLK => CLK1);
U250: DFF32
PORT MAP (DIN => FFED, QOUT => FFEDD, CLK => CLK1);
U260: DFF32
PORT MAP (DIN => FFFD, QOUT => FFFDD, CLK => CLK1);
U270: DFF32
PORT MAP (DIN => FFGD, QOUT => FFGDD, CLK => CLK1);
U280: DFF32
PORT MAP (DIN => FFHD, QOUT => FFHDD, CLK => CLK1);
U290: DFF32
PORT MAP (DIN => FFID, QOUT => FFIDD, CLK => CLK1);

U480: DFF32
PORT MAP (DIN => FFADD, QOUT => FFADDD, CLK => CLK1);
U490: DFF32
PORT MAP (DIN => FFBDD, QOUT => FFBDDD, CLK => CLK1);
U500: DFF32
PORT MAP (DIN => FFCDD, QOUT => FFCDDD, CLK => CLK1);
U510: DFF32
PORT MAP (DIN => FFDDD, QOUT => FFDDDD, CLK => CLK1);
U520: DFF32
PORT MAP (DIN => FFEDD, QOUT => FFEDDD, CLK => CLK1);
U530: DFF32
PORT MAP (DIN => FFFDD, QOUT => FFFDDD, CLK => CLK1);
U540: DFF32
PORT MAP (DIN => FFGDD, QOUT => FFGDDD, CLK => CLK1);
U550: DFF32
PORT MAP (DIN => FFHDD, QOUT => FFHDDD, CLK => CLK1);
U560: DFF32
PORT MAP (DIN => FFIDD, QOUT => FFIDDD, CLK => CLK1);

U481: DFF32
PORT MAP (DIN => FFADDD, QOUT => FFADDDD, CLK => CLK1);
U491: DFF32
PORT MAP (DIN => FFBDDD, QOUT => FFBDDDD, CLK => CLK1);
U501: DFF32
PORT MAP (DIN => FFCDDD, QOUT => FFCDDDD, CLK => CLK1);
U511: DFF32
PORT MAP (DIN => FFDDDD, QOUT => FFDDDDD, CLK => CLK1);
U521: DFF32
PORT MAP (DIN => FFEDDD, QOUT => FFEDDDD, CLK => CLK1);
U531: DFF32
PORT MAP (DIN => FFFDDD, QOUT => FFFDDDD, CLK => CLK1);
U541: DFF32
PORT MAP (DIN => FFGDDD, QOUT => FFGDDDD, CLK => CLK1);
U551: DFF32
PORT MAP (DIN => FFHDDD, QOUT => FFHDDDD, CLK => CLK1);
U561: DFF32
PORT MAP (DIN => FFIDDD, QOUT => FFIDDDD, CLK => CLK1);

U482: DFF32
PORT MAP (DIN => FFADDDD, QOUT => FFADDDDD, CLK => CLK1);
U492: DFF32
PORT MAP (DIN => FFBDDDD, QOUT => FFBDDDDD, CLK => CLK1);
U502: DFF32
PORT MAP (DIN => FFCDDDD, QOUT => FFCDDDDD, CLK => CLK1);
U512: DFF32
PORT MAP (DIN => FFDDDDD, QOUT => FFDDDDDD, CLK => CLK1);
U522: DFF32
PORT MAP (DIN => FFEDDDD, QOUT => FFEDDDDD, CLK => CLK1);
U532: DFF32
PORT MAP (DIN => FFFDDDD, QOUT => FFFDDDDD, CLK => CLK1);
U542: DFF32
PORT MAP (DIN => FFGDDDD, QOUT => FFGDDDDD, CLK => CLK1);
U552: DFF32
PORT MAP (DIN => FFHDDDD, QOUT => FFHDDDDD, CLK => CLK1);
U562: DFF32
PORT MAP (DIN => FFIDDDD, QOUT => FFIDDDDD, CLK => CLK1);

U300: DFF32
PORT MAP (DIN => SFA, QOUT => SFAD, CLK => CLK1);
U310: DFF32
PORT MAP (DIN => SFB, QOUT => SFBD, CLK => CLK1);
U320: DFF32
PORT MAP (DIN => SFC, QOUT => SFCD, CLK => CLK1);
U330: DFF32
PORT MAP (DIN => SFD, QOUT => SFDD, CLK => CLK1);
U340: DFF32
PORT MAP (DIN => SFE, QOUT => SFED, CLK => CLK1);
U350: DFF32
PORT MAP (DIN => SFF, QOUT => SFFD, CLK => CLK1);
U360: DFF32
PORT MAP (DIN => SFG, QOUT => SFGD, CLK => CLK1);
U370: DFF32
PORT MAP (DIN => SFH, QOUT => SFHD, CLK => CLK1);
U380: DFF32
PORT MAP (DIN => SFI, QOUT => SFID, CLK => CLK1);

U390: DFF32
PORT MAP (DIN => SFAD, QOUT => SFADD, CLK => CLK1);
U400: DFF32
PORT MAP (DIN => SFBD, QOUT => SFBDD, CLK => CLK1);
U410: DFF32
PORT MAP (DIN => SFCD, QOUT => SFCDD, CLK => CLK1);
U420: DFF32
PORT MAP (DIN => SFDD, QOUT => SFDDD, CLK => CLK1);
U430: DFF32
PORT MAP (DIN => SFED, QOUT => SFEDD, CLK => CLK1);
U440: DFF32
PORT MAP (DIN => SFFD, QOUT => SFFDD, CLK => CLK1);
U450: DFF32
PORT MAP (DIN => SFGD, QOUT => SFGDD, CLK => CLK1);
U460: DFF32
PORT MAP (DIN => SFHD, QOUT => SFHDD, CLK => CLK1);
U470: DFF32
PORT MAP (DIN => SFID, QOUT => SFIDD, CLK => CLK1);

U391: DFF32
PORT MAP (DIN => SFADD, QOUT => SFADDD, CLK => CLK1);
U401: DFF32
PORT MAP (DIN => SFBDD, QOUT => SFBDDD, CLK => CLK1);
U411: DFF32
PORT MAP (DIN => SFCDD, QOUT => SFCDDD, CLK => CLK1);
U421: DFF32
PORT MAP (DIN => SFDDD, QOUT => SFDDDD, CLK => CLK1);
U431: DFF32
PORT MAP (DIN => SFEDD, QOUT => SFEDDD, CLK => CLK1);
U441: DFF32
PORT MAP (DIN => SFFDD, QOUT => SFFDDD, CLK => CLK1);
U451: DFF32
PORT MAP (DIN => SFGDD, QOUT => SFGDDD, CLK => CLK1);
U461: DFF32
PORT MAP (DIN => SFHDD, QOUT => SFHDDD, CLK => CLK1);
U471: DFF32
PORT MAP (DIN => SFIDD, QOUT => SFIDDD, CLK => CLK1);

U392: DFF32
PORT MAP (DIN => SFADDD, QOUT => SFADDDD, CLK => CLK1);
U402: DFF32
PORT MAP (DIN => SFBDDD, QOUT => SFBDDDD, CLK => CLK1);
U412: DFF32
PORT MAP (DIN => SFCDDD, QOUT => SFCDDDD, CLK => CLK1);
U422: DFF32
PORT MAP (DIN => SFDDDD, QOUT => SFDDDDD, CLK => CLK1);
U432: DFF32
PORT MAP (DIN => SFEDDD, QOUT => SFEDDDD, CLK => CLK1);
U442: DFF32
PORT MAP (DIN => SFFDDD, QOUT => SFFDDDD, CLK => CLK1);
U452: DFF32
PORT MAP (DIN => SFGDDD, QOUT => SFGDDDD, CLK => CLK1);
U462: DFF32
PORT MAP (DIN => SFHDDD, QOUT => SFHDDDD, CLK => CLK1);
U472: DFF32
PORT MAP (DIN => SFIDDD, QOUT => SFIDDDD, CLK => CLK1);

U570: COMP153
PORT MAP (INA => SORA, INB => SORB, INC => SORC,
          IND => SORD, INE => SORE, INF => SORF,
          ING => SORG, INH => SORH, INI => SORI,
          INJ => SORJ, INK => SORK, INL => SORL,
          INM => SORM, INN => SORN, INP => SORP,
          INQ => SORQ, INR => SORR, INS => SORS,
          ZERO => ZEROA, OUTA => TEMA);

U580: SELECT1
PORT MAP (INPUT => TEMAD, ZERO => ZEROAD, OUTPUT => AOUT);
 
U610: SELECT2
PORT MAP (IINPUT => TEMAD, INPUTT => AOUT, ZZERO => ZEROAD, OUTPUTT => BOUT);

U620: SELECT3
PORT MAP (IIINPUT => TEMAD, INPUTTA => AOUT, INPUTTT => BOUT, 
          ZZZERO => ZEROAD, OUTPUTTT => COUT);
  
U630: SELECT4
PORT MAP (IIINPUT => TEMAD, INPUTTA => AOUT, INPUTTT => BOUT, 
          INPUTB => COUT, ZEROBA => ZEROAD, OUTPUTB => DOUT);

U640: SELECT5
PORT MAP (IIINPUT => TEMADD, INPUTTA => AOUTD, INPUTTT => BOUTD, 
          INPUTB => COUTD, INPUTC => DOUTD, ZEROB => ZEROADD, OUTPUTC => EOUT);

U650: SELECT6
PORT MAP (IIINPUT => TEMADD, INPUTTA => AOUTD, INPUTTT => BOUTD, 
          INPUTB => COUTD, INPUTC => DOUTD, INPUTD => EOUT, 
	    	ZEROB => ZEROADD, OUTPUTD => FOUT);

U660: SELECT7
PORT MAP (IIINPUT => TEMADD, INPUTTA => AOUTD, INPUTTT => BOUTD, 
          INPUTB => COUTD, INPUTC => DOUTD, INPUTD => EOUT, 
          INPUTE => FOUT, ZEROB => ZEROADD, OUTPUTE => GOUT);

U661: SELECT8
PORT MAP (IIINPUT => TEMADD, INPUTTA => AOUTD, INPUTTT => BOUTD, 
          INPUTB => COUTD, INPUTC => DOUTD, INPUTD => EOUT, 
          INPUTE => FOUT, INPUTF => GOUT, ZEROB => ZEROADD, OUTPUTF => HOUT);

U662: SELECT9
PORT MAP (IIINPUT => TEMADDD, INPUTTA => AOUTDD, INPUTTT => BOUTDD, 
          INPUTB => COUTDD, INPUTC => DOUTDD, INPUTD => EOUTD, 
          INPUTE => FOUTD, INPUTF => GOUTD, INPUTG => HOUTD,
			 ZEROB => ZEROADDD, OUTPUTG => IOUT);

U663: SELECT10
PORT MAP (IIINPUT => TEMADDD, INPUTTA => AOUTDD, INPUTTT => BOUTDD, 
          INPUTB => COUTDD, INPUTC => DOUTDD, INPUTD => EOUTD, 
          INPUTE => FOUTD, INPUTF => GOUTD, INPUTG => HOUTD, INPUTH => IOUT,
			 ZEROB => ZEROADDD, OUTPUTH => JOUT);

U664: SELECT11
PORT MAP (IIINPUT => TEMADDD, INPUTTA => AOUTDD, INPUTTT => BOUTDD, 
          INPUTB => COUTDD, INPUTC => DOUTDD, INPUTD => EOUTD, 
          INPUTE => FOUTD, INPUTF => GOUTD, INPUTG => HOUTD, INPUTH => IOUT,
			 INPUTI => JOUT, ZEROB => ZEROADDD, OUTPUTI => KOUT);
			 
U665: SELECT12
PORT MAP (IIINPUT => TEMADDD, INPUTTA => AOUTDD, INPUTTT => BOUTDD, 
          INPUTB => COUTDD, INPUTC => DOUTDD, INPUTD => EOUTD, 
          INPUTE => FOUTD, INPUTF => GOUTD, INPUTG => HOUTD, INPUTH => IOUT,
			 INPUTI => JOUT, INPUTJ => KOUT, ZEROB => ZEROADDD, OUTPUTJ => LOUT);			 


U670: DFF18
PORT MAP (DIN => AOUTDD, QOUT => OA, CLK => CLK1);

U680: DFF18
PORT MAP (DIN => BOUTDD, QOUT => OB, CLK => CLK1);

U690: DFF18
PORT MAP (DIN => COUTDD, QOUT => OC, CLK => CLK1);


U700: DFF18
PORT MAP (DIN => DOUTDD, QOUT => OD, CLK => CLK1);

U710: DFF18
PORT MAP (DIN => EOUTD, QOUT => OE, CLK => CLK1);

U720: DFF18
PORT MAP (DIN => FOUTD, QOUT => OFE, CLK => CLK1);

U734: DFF18
PORT MAP (DIN => GOUTD, QOUT => OG, CLK => CLK1);

U735: DFF18
PORT MAP (DIN => HOUTD, QOUT => OH, CLK => CLK1);

U736: DFF18
PORT MAP (DIN => IOUT, QOUT => OI, CLK => CLK1);

U737: DFF18
PORT MAP (DIN => JOUT, QOUT => OJ, CLK => CLK1);

U738: DFF18
PORT MAP (DIN => KOUT, QOUT => OK, CLK => CLK1);

U739: DFF18
PORT MAP (DIN => LOUT, QOUT => OL, CLK => CLK1);

U740: MERGER
PORT MAP (FA => FFADDD, FB => FFBDDD, FC => FFCDDD, FD => FFDDDD, 
          FE => FFEDDD, FF => FFFDDD, FG => FFGDDD, FH => FFHDDD, FI => FFIDDD,
          SA => SFADD, SB => SFBDD, SC => SFCDD, SD => SFDDD, 
		    SE => SFEDD, SF => SFFDD, SG => SFGDD, SH => SFHDD, SI => SFIDD,
          A => AOUTDD, B => BOUTDD, C => COUTDD, D => DOUTDD, E => EOUTD,
		    F => FOUTD, G => GOUTD,  H => HOUTD, I => IOUT,
			 J => JOUT, K => KOUT, L => LOUT,
     	    OUTA => TA, OUTB => TB, OUTC => TC, OUTD => TD, OUTE => TE, OUTF => TF,
			 OUTG => TG, OUTH => TH, OUTI => TI, OUTJ => TJ, OUTK => TK, OUTL => TL);

U745: MERGEROLD
PORT MAP (FA => FFAD, FB => FFBD, FC => FFCD, FD => FFDD, 
          FE => FFED, FF => FFFD, FG => FFGD, FH => FFHD, FI => FFID,
          SA => SFA, SB => SFB, SC => SFC, SD => SFD, 
		    SE => SFE, SF => SFF, SG => SFG, SH => SFH, SI => SFI,
          A => AOUT, B => BOUT, C => COUT, 
     	    OUTA => OTA, OUTB => OTB, OUTC => OTC);

U752: DFF32
PORT MAP (DIN => OTA, QOUT => OFIR, CLK => CLK1);

U762: DFF32
PORT MAP (DIN => OTB, QOUT => OSEC, CLK => CLK1);

U772: DFF32
PORT MAP (DIN => OTC, QOUT => OTHI, CLK => CLK1);

U750: DFF32
PORT MAP (DIN => TA, QOUT => FIR, CLK => CLK1);

U760: DFF32
PORT MAP (DIN => TB, QOUT => SEC, CLK => CLK1);

U770: DFF32
PORT MAP (DIN => TC, QOUT => THI, CLK => CLK1);

U780: DFF32
PORT MAP (DIN => TD, QOUT => FOU, CLK => CLK1);

U790: DFF32
PORT MAP (DIN => TE, QOUT => FIF, CLK => CLK1);

U800: DFF32
PORT MAP (DIN => TF, QOUT => SIX, CLK => CLK1);

U810: DFF32
PORT MAP (DIN => TG, QOUT => SEV, CLK => CLK1);

U820: DFF32
PORT MAP (DIN => TH, QOUT => EIG, CLK => CLK1);

U830: DFF32
PORT MAP (DIN => TI, QOUT => NIN, CLK => CLK1);

U840: DFF32
PORT MAP (DIN => TJ, QOUT => TEN, CLK => CLK1);

U850: DFF32
PORT MAP (DIN => TK, QOUT => ELE, CLK => CLK1);

U860: DFF32
PORT MAP (DIN => TL, QOUT => TWE, CLK => CLK1);

end structural;
