LIBRARY IEEE;
USE IEEE.std_logic_1164.ALL;

ENTITY MUX48X16 IS

    Port ( FA : in std_logic_vector(31 downto 0);
           FB : in std_logic_vector(31 downto 0);
           FC : in std_logic_vector(31 downto 0);
           FDD : in std_logic_vector(31 downto 0);
           FE : in std_logic_vector(31 downto 0);
           FF : in std_logic_vector(31 downto 0);
           FG : in std_logic_vector(31 downto 0);
           FH : in std_logic_vector(31 downto 0);
           FI : in std_logic_vector(31 downto 0);

           SA : in std_logic_vector(31 downto 0);
           SB : in std_logic_vector(31 downto 0);
           SC : in std_logic_vector(31 downto 0);
           SD : in std_logic_vector(31 downto 0);
           SE : in std_logic_vector(31 downto 0);
           SF : in std_logic_vector(31 downto 0);
           SG : in std_logic_vector(31 downto 0);
           SH : in std_logic_vector(31 downto 0);
           SI : in std_logic_vector(31 downto 0);
 
           DA : out std_logic_vector(15 downto 0);
           DB : out std_logic_vector(15 downto 0);
           DC : out std_logic_vector(15 downto 0);
           DD : out std_logic_vector(15 downto 0);
           DE : out std_logic_vector(15 downto 0);
           DF : out std_logic_vector(15 downto 0);
           DG : out std_logic_vector(15 downto 0);
           DH : out std_logic_vector(15 downto 0);
 	
           BC0A : in std_logic_vector(2 downto 0);		
           BC0B : in std_logic_vector(2 downto 0);					  
           BC0C : in std_logic_vector(2 downto 0);		
           BC0D : in std_logic_vector(2 downto 0);		
           BC0E : in std_logic_vector(2 downto 0);		
           BC0F : in std_logic_vector(2 downto 0);					  
           BC0G : in std_logic_vector(2 downto 0);		
           BC0H : in std_logic_vector(2 downto 0);		
           BC0I : in std_logic_vector(2 downto 0);			
           BC0J : in std_logic_vector(2 downto 0);		
           BC0K : in std_logic_vector(2 downto 0);					  
           BC0L : in std_logic_vector(2 downto 0);		
           BC0M : in std_logic_vector(2 downto 0);		
           BC0N : in std_logic_vector(2 downto 0);		
           BC0P : in std_logic_vector(2 downto 0);					  
           BC0Q : in std_logic_vector(2 downto 0);		
           BC0R : in std_logic_vector(2 downto 0);		
           BC0S : in std_logic_vector(2 downto 0);				  

           CA : in std_logic_vector(2 downto 0);			  
           CB : in std_logic_vector(2 downto 0);					  
           CC : in std_logic_vector(2 downto 0);			  
           CD : in std_logic_vector(2 downto 0);				  
           CE : in std_logic_vector(2 downto 0);			  
           CF : in std_logic_vector(2 downto 0);					  
           CG : in std_logic_vector(2 downto 0);			  
           CH : in std_logic_vector(2 downto 0);	
           CI : in std_logic_vector(2 downto 0);	
           CJ : in std_logic_vector(2 downto 0);			  
           CK : in std_logic_vector(2 downto 0);					  
           CL : in std_logic_vector(2 downto 0);			  
           CM : in std_logic_vector(2 downto 0);				  
           CN : in std_logic_vector(2 downto 0);			  
           CP : in std_logic_vector(2 downto 0);					  
           CQ : in std_logic_vector(2 downto 0);			  
           CR : in std_logic_vector(2 downto 0);	
           CS : in std_logic_vector(2 downto 0);

           POS : in std_logic;
           NEG : in std_logic		  
			  
 );

END ENTITY MUX48X16;

ARCHITECTURE ARC OF MUX48X16 IS

BEGIN

-- LINK 1
DA(0) <= (SC(27) AND NOT CF(0) AND NOT CF(1) AND CF(2)) OR (FC(10) AND CE(0) AND CE(1) AND NOT CE(2)) OR (SC(17) AND CF(0) AND NOT CF(1) AND NOT CF(2)) OR (FC(31) AND NOT CF(0) AND NOT CF(1) AND NOT CF(2)); 
DA(1) <= (SC(26) AND NOT CF(0) AND NOT CF(1) AND CF(2)) OR (FC(0) AND CE(0) AND CE(1) AND NOT CE(2)) OR (SC(18) AND CF(0) AND NOT CF(1) AND NOT CF(2)) OR (FC(27) AND NOT CF(0) AND NOT CF(1) AND NOT CF(2)); 
DA(2) <= (SC(25) AND NOT CF(0) AND NOT CF(1) AND CF(2)) OR (FC(1) AND CE(0) AND CE(1) AND NOT CE(2)) OR (SC(19) AND CF(0) AND NOT CF(1) AND NOT CF(2)) OR (FC(28) AND NOT CF(0) AND NOT CF(1) AND NOT CF(2)); 
DA(3) <= (FF(31) AND NOT CL(0) AND NOT CL(1) AND CL(2)) OR (FC(2) AND CE(0) AND CE(1) AND NOT CE(2)) OR (SC(20) AND CF(0) AND NOT CF(1) AND NOT CF(2)) OR (FC(29) AND NOT CF(0) AND NOT CF(1) AND NOT CF(2)); 
DA(4) <= (FF(27) AND NOT CL(0) AND NOT CL(1) AND CL(2)) OR (FC(3) AND CE(0) AND CE(1) AND NOT CE(2)) OR (SC(21) AND CF(0) AND NOT CF(1) AND NOT CF(2)) OR (FC(30) AND NOT CF(0) AND NOT CF(1) AND NOT CF(2)); 
DA(5) <= (FF(28) AND NOT CL(0) AND NOT CL(1) AND CL(2)) OR (FC(4) AND CE(0) AND CE(1) AND NOT CE(2)) OR (SC(22) AND CF(0) AND NOT CF(1) AND NOT CF(2)) OR (FC(23) AND NOT CF(0) AND NOT CF(1) AND NOT CF(2)); 
DA(6) <= (FF(29) AND NOT CL(0) AND NOT CL(1) AND CL(2)) OR (FC(5) AND CE(0) AND CE(1) AND NOT CE(2)) OR (SC(23) AND CF(0) AND NOT CF(1) AND NOT CF(2)) OR (FC(24) AND NOT CF(0) AND NOT CF(1) AND NOT CF(2)); 
DA(7) <= (FF(30) AND NOT CL(0) AND NOT CL(1) AND CL(2)) OR (SC(0) AND CE(0) AND CE(1) AND NOT CE(2)) OR (SC(24) AND CF(0) AND NOT CF(1) AND NOT CF(2)) OR (FC(25) AND NOT CF(0) AND NOT CF(1) AND NOT CF(2)); 
DA(8) <= (FF(23) AND NOT CL(0) AND NOT CL(1) AND CL(2)) OR (SC(1) AND CE(0) AND CE(1) AND NOT CE(2)) OR (FC(15) AND CE(0) AND NOT CE(1) AND NOT CE(2)) OR (FC(26) AND NOT CF(0) AND NOT CF(1) AND NOT CF(2)); 
DA(9) <= (FF(24) AND NOT CL(0) AND NOT CL(1) AND CL(2)) OR (SC(2) AND CE(0) AND CE(1) AND NOT CE(2)) OR (FC(11) AND CE(0) AND NOT CE(1) AND NOT CE(2)) OR (FC(16) AND NOT CF(0) AND NOT CF(1) AND NOT CF(2)); 
DA(10) <= (FF(25) AND NOT CL(0) AND NOT CL(1) AND CL(2)) OR (SC(3) AND CE(0) AND CE(1) AND NOT CE(2)) OR (FC(12) AND CE(0) AND NOT CE(1) AND NOT CE(2)) OR (FC(17) AND NOT CF(0) AND NOT CF(1) AND NOT CF(2)); 
DA(11) <= (FF(26) AND NOT CL(0) AND NOT CL(1) AND CL(2)) OR (SC(4) AND CE(0) AND CE(1) AND NOT CE(2)) OR (FC(13) AND CE(0) AND NOT CE(1) AND NOT CE(2)) OR (FC(18) AND NOT CF(0) AND NOT CF(1) AND NOT CF(2)); 
DA(12) <= (FF(16) AND NOT CL(0) AND NOT CL(1) AND CL(2)) OR (SC(5) AND CE(0) AND CE(1) AND NOT CE(2)) OR (FC(14) AND CE(0) AND NOT CE(1) AND NOT CE(2)) OR (FC(19) AND NOT CF(0) AND NOT CF(1) AND NOT CF(2)); 
DA(13) <= (FF(17) AND NOT CL(0) AND NOT CL(1) AND CL(2)) OR (SC(6) AND CE(0) AND CE(1) AND NOT CE(2)) OR (FC(7) AND CE(0) AND NOT CE(1) AND NOT CE(2)) OR (FC(20) AND NOT CF(0) AND NOT CF(1) AND NOT CF(2)); 
DA(14) <= (FF(18) AND NOT CL(0) AND NOT CL(1) AND CL(2)) OR (SC(7) AND CE(0) AND CE(1) AND NOT CE(2)) OR (FC(8) AND CE(0) AND NOT CE(1) AND NOT CE(2)) OR (FC(21) AND NOT CF(0) AND NOT CF(1) AND NOT CF(2)); 
DA(15) <= (FF(19) AND NOT CL(0) AND NOT CL(1) AND CL(2)) OR (SC(8) AND CE(0) AND CE(1) AND NOT CE(2)) OR (FC(9) AND CE(0) AND NOT CE(1) AND NOT CE(2)) OR (SC(16) AND NOT CF(0) AND NOT CF(1) AND NOT CF(2)); 

-- LINK 2
DB(0) <= (FI(17) AND NOT CS(0) AND NOT CS(1) AND CS(2)) OR (SF(6) AND CK(0) AND CK(1) AND NOT CK(2)) OR (FF(7) AND CK(0) AND NOT CK(1) AND NOT CK(2)) OR (FF(20) AND NOT CL(0) AND NOT CL(1) AND NOT CL(2)); 
DB(1) <= (FI(18) AND NOT CS(0) AND NOT CS(1) AND CS(2)) OR (SF(7) AND CK(0) AND CK(1) AND NOT CK(2)) OR (FF(8) AND CK(0) AND NOT CK(1) AND NOT CK(2)) OR (FF(21) AND NOT CL(0) AND NOT CL(1) AND NOT CL(2)); 
DB(2) <= (FI(19) AND NOT CS(0) AND NOT CS(1) AND CS(2)) OR (SF(8) AND CK(0) AND CK(1) AND NOT CK(2)) OR (FF(9) AND CK(0) AND NOT CK(1) AND NOT CK(2)) OR (SF(16) AND NOT CL(0) AND NOT CL(1) AND NOT CL(2)); 
DB(3) <= (FI(20) AND NOT CS(0) AND NOT CS(1) AND CS(2)) OR (SF(27) AND CL(0) AND CL(1) AND NOT CL(2)) OR (FF(10) AND CK(0) AND NOT CK(1) AND NOT CK(2)) OR (SF(17) AND NOT CL(0) AND NOT CL(1) AND NOT CL(2)); 
DB(4) <= (SI(16) AND NOT CS(0) AND NOT CS(1) AND CS(2)) OR (SF(26) AND CL(0) AND CL(1) AND NOT CL(2)) OR (FF(0) AND CK(0) AND NOT CK(1) AND NOT CK(2)) OR (SF(18) AND NOT CL(0) AND NOT CL(1) AND NOT CL(2)); 
DB(5) <= (SI(17) AND NOT CS(0) AND NOT CS(1) AND CS(2)) OR (SF(25) AND CL(0) AND CL(1) AND NOT CL(2)) OR (FF(1) AND CK(0) AND NOT CK(1) AND NOT CK(2)) OR (SF(19) AND NOT CL(0) AND NOT CL(1) AND NOT CL(2)); 
DB(6) <= (SI(18) AND NOT CS(0) AND NOT CS(1) AND CS(2)) OR (FI(31) AND CS(0) AND CS(1) AND NOT CS(2)) OR (FF(2) AND CK(0) AND NOT CK(1) AND NOT CK(2)) OR (SF(20) AND NOT CL(0) AND NOT CL(1) AND NOT CL(2)); 
DB(7) <= (SI(19) AND NOT CS(0) AND NOT CS(1) AND CS(2)) OR (FI(27) AND CS(0) AND CS(1) AND NOT CS(2)) OR (FF(3) AND CK(0) AND NOT CK(1) AND NOT CK(2)) OR (SF(21) AND NOT CL(0) AND NOT CL(1) AND NOT CL(2)); 
DB(8) <= (SI(20) AND NOT CS(0) AND NOT CS(1) AND CS(2)) OR (FI(28) AND CS(0) AND CS(1) AND NOT CS(2)) OR (FF(4) AND CK(0) AND NOT CK(1) AND NOT CK(2)) OR (SF(22) AND NOT CL(0) AND NOT CL(1) AND NOT CL(2)); 
DB(9) <= (SI(21) AND NOT CS(0) AND NOT CS(1) AND CS(2)) OR (FI(29) AND CS(0) AND CS(1) AND NOT CS(2)) OR (FF(5) AND CK(0) AND NOT CK(1) AND NOT CK(2)) OR (SF(23) AND NOT CL(0) AND NOT CL(1) AND NOT CL(2)); 
DB(10) <= (SI(22) AND NOT CS(0) AND NOT CS(1) AND CS(2)) OR (FI(30) AND CS(0) AND CS(1) AND NOT CS(2)) OR (SF(0) AND CK(0) AND NOT CK(1) AND NOT CK(2)) OR (SF(24) AND NOT CL(0) AND NOT CL(1) AND NOT CL(2)); 
DB(11) <= (SI(23) AND NOT CS(0) AND NOT CS(1) AND CS(2)) OR (FI(23) AND CS(0) AND CS(1) AND NOT CS(2)) OR (SF(1) AND CK(0) AND NOT CK(1) AND NOT CK(2)) OR (FF(15) AND NOT CK(0) AND NOT CK(1) AND NOT CK(2)); 
DB(12) <= (SI(24) AND NOT CS(0) AND NOT CS(1) AND CS(2)) OR (FI(24) AND CS(0) AND CS(1) AND NOT CS(2)) OR (SF(2) AND CK(0) AND NOT CK(1) AND NOT CK(2)) OR (FF(11) AND NOT CK(0) AND NOT CK(1) AND NOT CK(2)); 
DB(13) <= (FI(15) AND NOT CR(0) AND NOT CR(1) AND CR(2)) OR (FI(25) AND CS(0) AND CS(1) AND NOT CS(2)) OR (SF(3) AND CK(0) AND NOT CK(1) AND NOT CK(2)) OR (FF(12) AND NOT CK(0) AND NOT CK(1) AND NOT CK(2)); 
DB(14) <= (FI(11) AND NOT CR(0) AND NOT CR(1) AND CR(2)) OR (FI(26) AND CS(0) AND CS(1) AND NOT CS(2)) OR (SF(4) AND CK(0) AND NOT CK(1) AND NOT CK(2)) OR (FF(13) AND NOT CK(0) AND NOT CK(1) AND NOT CK(2)); 
DB(15) <= (FI(12) AND NOT CR(0) AND NOT CR(1) AND CR(2)) OR (FI(16) AND CS(0) AND CS(1) AND NOT CS(2)) OR (SF(5) AND CK(0) AND NOT CK(1) AND NOT CK(2)) OR (FF(14) AND NOT CK(0) AND NOT CK(1) AND NOT CK(2)); 

-- LINK 3
DC(0) <= (NEG AND NOT CS(0) AND NOT CS(1) AND CS(2)) OR (NEG AND CR(0) AND CR(1) AND NOT CR(2)) OR (SI(5) AND CR(0) AND NOT CR(1) AND NOT CR(2)) OR (FI(13) AND NOT CR(0) AND NOT CR(1) AND NOT CR(2)); 
DC(1) <= (NEG AND NOT CS(0) AND NOT CS(1) AND CS(2)) OR (NEG AND CR(0) AND CR(1) AND NOT CR(2)) OR (SI(6) AND CR(0) AND NOT CR(1) AND NOT CR(2)) OR (FI(14) AND NOT CR(0) AND NOT CR(1) AND NOT CR(2)); 
DC(2) <= (NEG AND NOT CS(0) AND NOT CS(1) AND CS(2)) OR (NEG AND CR(0) AND CR(1) AND NOT CR(2)) OR (SI(7) AND CR(0) AND NOT CR(1) AND NOT CR(2)) OR (FI(7) AND NOT CR(0) AND NOT CR(1) AND NOT CR(2)); 
DC(3) <= (NEG AND NOT CS(0) AND NOT CS(1) AND CS(2)) OR (NEG AND CR(0) AND CR(1) AND NOT CR(2)) OR (SI(8) AND CR(0) AND NOT CR(1) AND NOT CR(2)) OR (FI(8) AND NOT CR(0) AND NOT CR(1) AND NOT CR(2)); 
DC(4) <= (NEG AND NOT CS(0) AND NOT CS(1) AND CS(2)) OR (NEG AND CR(0) AND CR(1) AND NOT CR(2)) OR (SI(27) AND CS(0) AND NOT CS(1) AND NOT CS(2)) OR (FI(9) AND NOT CR(0) AND NOT CR(1) AND NOT CR(2)); 
DC(5) <= (NEG AND NOT CS(0) AND NOT CS(1) AND CS(2)) OR (NEG AND CR(0) AND CR(1) AND NOT CR(2)) OR (SI(26) AND CS(0) AND NOT CS(1) AND NOT CS(2)) OR (FI(10) AND NOT CR(0) AND NOT CR(1) AND NOT CR(2)); 
DC(6) <= (NEG AND NOT CS(0) AND NOT CS(1) AND CS(2)) OR (NEG AND CR(0) AND CR(1) AND NOT CR(2)) OR (SI(25) AND CS(0) AND NOT CS(1) AND NOT CS(2)) OR (FI(0) AND NOT CR(0) AND NOT CR(1) AND NOT CR(2)); 
DC(7) <= (NEG AND NOT CS(0) AND NOT CS(1) AND CS(2)) OR (NEG AND CR(0) AND CR(1) AND NOT CR(2)) OR (NEG AND CS(0) AND NOT CS(1) AND NOT CS(2)) OR (FI(1) AND NOT CR(0) AND NOT CR(1) AND NOT CR(2)); 
DC(8) <= (NEG AND NOT CS(0) AND NOT CS(1) AND CS(2)) OR (NEG AND CR(0) AND CR(1) AND NOT CR(2)) OR (NEG AND CS(0) AND NOT CS(1) AND NOT CS(2)) OR (FI(2) AND NOT CR(0) AND NOT CR(1) AND NOT CR(2)); 
DC(9) <= (NEG AND NOT CS(0) AND NOT CS(1) AND CS(2)) OR (NEG AND CR(0) AND CR(1) AND NOT CR(2)) OR (NEG AND CS(0) AND NOT CS(1) AND NOT CS(2)) OR (FI(3) AND NOT CR(0) AND NOT CR(1) AND NOT CR(2)); 
DC(10) <= (NEG AND NOT CS(0) AND NOT CS(1) AND CS(2)) OR (NEG AND CR(0) AND CR(1) AND NOT CR(2)) OR (NEG AND CS(0) AND NOT CS(1) AND NOT CS(2)) OR (FI(4) AND NOT CR(0) AND NOT CR(1) AND NOT CR(2)); 
DC(11) <= (NEG AND NOT CS(0) AND NOT CS(1) AND CS(2)) OR (NEG AND CR(0) AND CR(1) AND NOT CR(2)) OR (NEG AND CS(0) AND NOT CS(1) AND NOT CS(2)) OR (SI(0) AND NOT CR(0) AND NOT CR(1) AND NOT CR(2)); 
DC(12) <= (NEG AND NOT CS(0) AND NOT CS(1) AND CS(2)) OR (NEG AND CR(0) AND CR(1) AND NOT CR(2)) OR (NEG AND CS(0) AND NOT CS(1) AND NOT CS(2)) OR (SI(1) AND NOT CR(0) AND NOT CR(1) AND NOT CR(2)); 
DC(13) <= (NEG AND NOT CS(0) AND NOT CS(1) AND CS(2)) OR (NEG AND CR(0) AND CR(1) AND NOT CR(2)) OR (NEG AND CS(0) AND NOT CS(1) AND NOT CS(2)) OR (SI(2) AND NOT CR(0) AND NOT CR(1) AND NOT CR(2)); 
DC(14) <= (NEG AND NOT CS(0) AND NOT CS(1) AND CS(2)) OR (NEG AND CR(0) AND CR(1) AND NOT CR(2)) OR (NEG AND CS(0) AND NOT CS(1) AND NOT CS(2)) OR (SI(3) AND NOT CR(0) AND NOT CR(1) AND NOT CR(2)); 
DC(15) <= (NEG AND NOT CS(0) AND NOT CS(1) AND CS(2)) OR (NEG AND CR(0) AND CR(1) AND NOT CR(2)) OR (NEG AND CS(0) AND NOT CS(1) AND NOT CS(2)) OR (SI(4) AND NOT CR(0) AND NOT CR(1) AND NOT CR(2)); 

-- LINK 4
DD(0) <= (SB(27) AND NOT CD(0) AND NOT CD(1) AND CD(2)) OR (FB(10) AND CC(0) AND CC(1) AND NOT CC(2)) OR (SB(17) AND CD(0) AND NOT CD(1) AND NOT CD(2)) OR (FB(31) AND NOT CD(0) AND NOT CD(1) AND NOT CD(2)); 
DD(1) <= (SB(26) AND NOT CD(0) AND NOT CD(1) AND CD(2)) OR (FB(0) AND CC(0) AND CC(1) AND NOT CC(2)) OR (SB(18) AND CD(0) AND NOT CD(1) AND NOT CD(2)) OR (FB(27) AND NOT CD(0) AND NOT CD(1) AND NOT CD(2)); 
DD(2) <= (SB(25) AND NOT CD(0) AND NOT CD(1) AND CD(2)) OR (FB(1) AND CC(0) AND CC(1) AND NOT CC(2)) OR (SB(19) AND CD(0) AND NOT CD(1) AND NOT CD(2)) OR (FB(28) AND NOT CD(0) AND NOT CD(1) AND NOT CD(2)); 
DD(3) <= (FE(31) AND NOT CJ(0) AND NOT CJ(1) AND CJ(2)) OR (FB(2) AND CC(0) AND CC(1) AND NOT CC(2)) OR (SB(20) AND CD(0) AND NOT CD(1) AND NOT CD(2)) OR (FB(29) AND NOT CD(0) AND NOT CD(1) AND NOT CD(2)); 
DD(4) <= (FE(27) AND NOT CJ(0) AND NOT CJ(1) AND CJ(2)) OR (FB(3) AND CC(0) AND CC(1) AND NOT CC(2)) OR (SB(21) AND CD(0) AND NOT CD(1) AND NOT CD(2)) OR (FB(30) AND NOT CD(0) AND NOT CD(1) AND NOT CD(2)); 
DD(5) <= (FE(28) AND NOT CJ(0) AND NOT CJ(1) AND CJ(2)) OR (FB(4) AND CC(0) AND CC(1) AND NOT CC(2)) OR (SB(22) AND CD(0) AND NOT CD(1) AND NOT CD(2)) OR (FB(23) AND NOT CD(0) AND NOT CD(1) AND NOT CD(2)); 
DD(6) <= (FE(29) AND NOT CJ(0) AND NOT CJ(1) AND CJ(2)) OR (FB(5) AND CC(0) AND CC(1) AND NOT CC(2)) OR (SB(23) AND CD(0) AND NOT CD(1) AND NOT CD(2)) OR (FB(24) AND NOT CD(0) AND NOT CD(1) AND NOT CD(2)); 
DD(7) <= (FE(30) AND NOT CJ(0) AND NOT CJ(1) AND CJ(2)) OR (SB(0) AND CC(0) AND CC(1) AND NOT CC(2)) OR (SB(24) AND CD(0) AND NOT CD(1) AND NOT CD(2)) OR (FB(25) AND NOT CD(0) AND NOT CD(1) AND NOT CD(2)); 
DD(8) <= (FE(23) AND NOT CJ(0) AND NOT CJ(1) AND CJ(2)) OR (SB(1) AND CC(0) AND CC(1) AND NOT CC(2)) OR (FB(15) AND CC(0) AND NOT CC(1) AND NOT CC(2)) OR (FB(26) AND NOT CD(0) AND NOT CD(1) AND NOT CD(2)); 
DD(9) <= (FE(24) AND NOT CJ(0) AND NOT CJ(1) AND CJ(2)) OR (SB(2) AND CC(0) AND CC(1) AND NOT CC(2)) OR (FB(11) AND CC(0) AND NOT CC(1) AND NOT CC(2)) OR (FB(16) AND NOT CD(0) AND NOT CD(1) AND NOT CD(2)); 
DD(10) <= (FE(25) AND NOT CJ(0) AND NOT CJ(1) AND CJ(2)) OR (SB(3) AND CC(0) AND CC(1) AND NOT CC(2)) OR (FB(12) AND CC(0) AND NOT CC(1) AND NOT CC(2)) OR (FB(17) AND NOT CD(0) AND NOT CD(1) AND NOT CD(2)); 
DD(11) <= (FE(26) AND NOT CJ(0) AND NOT CJ(1) AND CJ(2)) OR (SB(4) AND CC(0) AND CC(1) AND NOT CC(2)) OR (FB(13) AND CC(0) AND NOT CC(1) AND NOT CC(2)) OR (FB(18) AND NOT CD(0) AND NOT CD(1) AND NOT CD(2)); 
DD(12) <= (FE(16) AND NOT CJ(0) AND NOT CJ(1) AND CJ(2)) OR (SB(5) AND CC(0) AND CC(1) AND NOT CC(2)) OR (FB(14) AND CC(0) AND NOT CC(1) AND NOT CC(2)) OR (FB(19) AND NOT CD(0) AND NOT CD(1) AND NOT CD(2)); 
DD(13) <= (FE(17) AND NOT CJ(0) AND NOT CJ(1) AND CJ(2)) OR (SB(6) AND CC(0) AND CC(1) AND NOT CC(2)) OR (FB(7) AND CC(0) AND NOT CC(1) AND NOT CC(2)) OR (FB(20) AND NOT CD(0) AND NOT CD(1) AND NOT CD(2)); 
DD(14) <= (FE(18) AND NOT CJ(0) AND NOT CJ(1) AND CJ(2)) OR (SB(7) AND CC(0) AND CC(1) AND NOT CC(2)) OR (FB(8) AND CC(0) AND NOT CC(1) AND NOT CC(2)) OR (FB(21) AND NOT CD(0) AND NOT CD(1) AND NOT CD(2)); 
DD(15) <= (FE(19) AND NOT CJ(0) AND NOT CJ(1) AND CJ(2)) OR (SB(8) AND CC(0) AND CC(1) AND NOT CC(2)) OR (FB(9) AND CC(0) AND NOT CC(1) AND NOT CC(2)) OR (SB(16) AND NOT CD(0) AND NOT CD(1) AND NOT CD(2)); 

-- LINK 5
DE(0) <= (FH(17) AND NOT CQ(0) AND NOT CQ(1) AND CQ(2)) OR (SE(6) AND CI(0) AND CI(1) AND NOT CI(2)) OR (FE(7) AND CI(0) AND NOT CI(1) AND NOT CI(2)) OR (FE(20) AND NOT CJ(0) AND NOT CJ(1) AND NOT CJ(2)); 
DE(1) <= (FH(18) AND NOT CQ(0) AND NOT CQ(1) AND CQ(2)) OR (SE(7) AND CI(0) AND CI(1) AND NOT CI(2)) OR (FE(8) AND CI(0) AND NOT CI(1) AND NOT CI(2)) OR (FE(21) AND NOT CJ(0) AND NOT CJ(1) AND NOT CJ(2)); 
DE(2) <= (FH(19) AND NOT CQ(0) AND NOT CQ(1) AND CQ(2)) OR (SE(8) AND CI(0) AND CI(1) AND NOT CI(2)) OR (FE(9) AND CI(0) AND NOT CI(1) AND NOT CI(2)) OR (SE(16) AND NOT CJ(0) AND NOT CJ(1) AND NOT CJ(2)); 
DE(3) <= (FH(20) AND NOT CQ(0) AND NOT CQ(1) AND CQ(2)) OR (SE(27) AND CJ(0) AND CJ(1) AND NOT CJ(2)) OR (FE(10) AND CI(0) AND NOT CI(1) AND NOT CI(2)) OR (SE(17) AND NOT CJ(0) AND NOT CJ(1) AND NOT CJ(2)); 
DE(4) <= (SH(16) AND NOT CQ(0) AND NOT CQ(1) AND CQ(2)) OR (SE(26) AND CJ(0) AND CJ(1) AND NOT CJ(2)) OR (FE(0) AND CI(0) AND NOT CI(1) AND NOT CI(2)) OR (SE(18) AND NOT CJ(0) AND NOT CJ(1) AND NOT CJ(2)); 
DE(5) <= (SH(17) AND NOT CQ(0) AND NOT CQ(1) AND CQ(2)) OR (SE(25) AND CJ(0) AND CJ(1) AND NOT CJ(2)) OR (FE(1) AND CI(0) AND NOT CI(1) AND NOT CI(2)) OR (SE(19) AND NOT CJ(0) AND NOT CJ(1) AND NOT CJ(2)); 
DE(6) <= (SH(18) AND NOT CQ(0) AND NOT CQ(1) AND CQ(2)) OR (FH(31) AND CQ(0) AND CQ(1) AND NOT CQ(2)) OR (FE(2) AND CI(0) AND NOT CI(1) AND NOT CI(2)) OR (SE(20) AND NOT CJ(0) AND NOT CJ(1) AND NOT CJ(2)); 
DE(7) <= (SH(19) AND NOT CQ(0) AND NOT CQ(1) AND CQ(2)) OR (FH(27) AND CQ(0) AND CQ(1) AND NOT CQ(2)) OR (FE(3) AND CI(0) AND NOT CI(1) AND NOT CI(2)) OR (SE(21) AND NOT CJ(0) AND NOT CJ(1) AND NOT CJ(2)); 
DE(8) <= (SH(20) AND NOT CQ(0) AND NOT CQ(1) AND CQ(2)) OR (FH(28) AND CQ(0) AND CQ(1) AND NOT CQ(2)) OR (FE(4) AND CI(0) AND NOT CI(1) AND NOT CI(2)) OR (SE(22) AND NOT CJ(0) AND NOT CJ(1) AND NOT CJ(2)); 
DE(9) <= (SH(21) AND NOT CQ(0) AND NOT CQ(1) AND CQ(2)) OR (FH(29) AND CQ(0) AND CQ(1) AND NOT CQ(2)) OR (FE(5) AND CI(0) AND NOT CI(1) AND NOT CI(2)) OR (SE(23) AND NOT CJ(0) AND NOT CJ(1) AND NOT CJ(2)); 
DE(10) <= (SH(22) AND NOT CQ(0) AND NOT CQ(1) AND CQ(2)) OR (FH(30) AND CQ(0) AND CQ(1) AND NOT CQ(2)) OR (SE(0) AND CI(0) AND NOT CI(1) AND NOT CI(2)) OR (SE(24) AND NOT CJ(0) AND NOT CJ(1) AND NOT CJ(2)); 
DE(11) <= (SH(23) AND NOT CQ(0) AND NOT CQ(1) AND CQ(2)) OR (FH(23) AND CQ(0) AND CQ(1) AND NOT CQ(2)) OR (SE(1) AND CI(0) AND NOT CI(1) AND NOT CI(2)) OR (FE(15) AND NOT CI(0) AND NOT CI(1) AND NOT CI(2)); 
DE(12) <= (SH(24) AND NOT CQ(0) AND NOT CQ(1) AND CQ(2)) OR (FH(24) AND CQ(0) AND CQ(1) AND NOT CQ(2)) OR (SE(2) AND CI(0) AND NOT CI(1) AND NOT CI(2)) OR (FE(11) AND NOT CI(0) AND NOT CI(1) AND NOT CI(2)); 
DE(13) <= (FH(15) AND NOT CP(0) AND NOT CP(1) AND CP(2)) OR (FH(25) AND CQ(0) AND CQ(1) AND NOT CQ(2)) OR (SE(3) AND CI(0) AND NOT CI(1) AND NOT CI(2)) OR (FE(12) AND NOT CI(0) AND NOT CI(1) AND NOT CI(2)); 
DE(14) <= (FH(11) AND NOT CP(0) AND NOT CP(1) AND CP(2)) OR (FH(26) AND CQ(0) AND CQ(1) AND NOT CQ(2)) OR (SE(4) AND CI(0) AND NOT CI(1) AND NOT CI(2)) OR (FE(13) AND NOT CI(0) AND NOT CI(1) AND NOT CI(2)); 
DE(15) <= (FH(12) AND NOT CP(0) AND NOT CP(1) AND CP(2)) OR (FH(16) AND CQ(0) AND CQ(1) AND NOT CQ(2)) OR (SE(5) AND CI(0) AND NOT CI(1) AND NOT CI(2)) OR (FE(14) AND NOT CI(0) AND NOT CI(1) AND NOT CI(2)); 

-- LINK 6
DF(0) <= (FA(11) AND NOT CA(0) AND NOT CA(1) AND CA(2)) OR (FA(16) AND CB(0) AND CB(1) AND NOT CB(2)) OR (SH(5) AND CP(0) AND NOT CP(1) AND NOT CP(2)) OR (FH(13) AND NOT CP(0) AND NOT CP(1) AND NOT CP(2)); 
DF(1) <= (FA(12) AND NOT CA(0) AND NOT CA(1) AND CA(2)) OR (FA(17) AND CB(0) AND CB(1) AND NOT CB(2)) OR (SH(6) AND CP(0) AND NOT CP(1) AND NOT CP(2)) OR (FH(14) AND NOT CP(0) AND NOT CP(1) AND NOT CP(2)); 
DF(2) <= (FA(13) AND NOT CA(0) AND NOT CA(1) AND CA(2)) OR (FA(18) AND CB(0) AND CB(1) AND NOT CB(2)) OR (SH(7) AND CP(0) AND NOT CP(1) AND NOT CP(2)) OR (FH(7) AND NOT CP(0) AND NOT CP(1) AND NOT CP(2)); 
DF(3) <= (FA(14) AND NOT CA(0) AND NOT CA(1) AND CA(2)) OR (FA(19) AND CB(0) AND CB(1) AND NOT CB(2)) OR (SH(8) AND CP(0) AND NOT CP(1) AND NOT CP(2)) OR (FH(8) AND NOT CP(0) AND NOT CP(1) AND NOT CP(2)); 
DF(4) <= (FA(7) AND NOT CA(0) AND NOT CA(1) AND CA(2)) OR (FA(20) AND CB(0) AND CB(1) AND NOT CB(2)) OR (SH(27) AND CQ(0) AND NOT CQ(1) AND NOT CQ(2)) OR (FH(9) AND NOT CP(0) AND NOT CP(1) AND NOT CP(2)); 
DF(5) <= (FA(8) AND NOT CA(0) AND NOT CA(1) AND CA(2)) OR (FA(21) AND CB(0) AND CB(1) AND NOT CB(2)) OR (SH(26) AND CQ(0) AND NOT CQ(1) AND NOT CQ(2)) OR (FH(10) AND NOT CP(0) AND NOT CP(1) AND NOT CP(2)); 
DF(6) <= (FA(9) AND NOT CA(0) AND NOT CA(1) AND CA(2)) OR (SA(16) AND CB(0) AND CB(1) AND NOT CB(2)) OR (SH(25) AND CQ(0) AND NOT CQ(1) AND NOT CQ(2)) OR (FH(0) AND NOT CP(0) AND NOT CP(1) AND NOT CP(2)); 
DF(7) <= (FA(10) AND NOT CA(0) AND NOT CA(1) AND CA(2)) OR (SA(17) AND CB(0) AND CB(1) AND NOT CB(2)) OR (FA(31) AND CB(0) AND NOT CB(1) AND NOT CB(2)) OR (FH(1) AND NOT CP(0) AND NOT CP(1) AND NOT CP(2)); 
DF(8) <= (FA(0) AND NOT CA(0) AND NOT CA(1) AND CA(2)) OR (SA(18) AND CB(0) AND CB(1) AND NOT CB(2)) OR (FA(27) AND CB(0) AND NOT CB(1) AND NOT CB(2)) OR (FH(2) AND NOT CP(0) AND NOT CP(1) AND NOT CP(2)); 
DF(9) <= (FA(1) AND NOT CA(0) AND NOT CA(1) AND CA(2)) OR (SA(19) AND CB(0) AND CB(1) AND NOT CB(2)) OR (FA(28) AND CB(0) AND NOT CB(1) AND NOT CB(2)) OR (FH(3) AND NOT CP(0) AND NOT CP(1) AND NOT CP(2)); 
DF(10) <= (FA(2) AND NOT CA(0) AND NOT CA(1) AND CA(2)) OR (SA(20) AND CB(0) AND CB(1) AND NOT CB(2)) OR (FA(29) AND CB(0) AND NOT CB(1) AND NOT CB(2)) OR (FH(4) AND NOT CP(0) AND NOT CP(1) AND NOT CP(2)); 
DF(11) <= (FA(3) AND NOT CA(0) AND NOT CA(1) AND CA(2)) OR (SA(21) AND CB(0) AND CB(1) AND NOT CB(2)) OR (FA(30) AND CB(0) AND NOT CB(1) AND NOT CB(2)) OR (SH(0) AND NOT CP(0) AND NOT CP(1) AND NOT CP(2)); 
DF(12) <= (FA(4) AND NOT CA(0) AND NOT CA(1) AND CA(2)) OR (SA(22) AND CB(0) AND CB(1) AND NOT CB(2)) OR (FA(23) AND CB(0) AND NOT CB(1) AND NOT CB(2)) OR (SH(1) AND NOT CP(0) AND NOT CP(1) AND NOT CP(2)); 
DF(13) <= (FA(5) AND NOT CA(0) AND NOT CA(1) AND CA(2)) OR (SA(23) AND CB(0) AND CB(1) AND NOT CB(2)) OR (FA(24) AND CB(0) AND NOT CB(1) AND NOT CB(2)) OR (SH(2) AND NOT CP(0) AND NOT CP(1) AND NOT CP(2)); 
DF(14) <= (SA(0) AND NOT CA(0) AND NOT CA(1) AND CA(2)) OR (SA(24) AND CB(0) AND CB(1) AND NOT CB(2)) OR (FA(25) AND CB(0) AND NOT CB(1) AND NOT CB(2)) OR (SH(3) AND NOT CP(0) AND NOT CP(1) AND NOT CP(2)); 
DF(15) <= (SA(1) AND NOT CA(0) AND NOT CA(1) AND CA(2)) OR (FA(15) AND CA(0) AND CA(1) AND NOT CA(2)) OR (FA(26) AND CB(0) AND NOT CB(1) AND NOT CB(2)) OR (SH(4) AND NOT CP(0) AND NOT CP(1) AND NOT CP(2)); 

-- LINK 7
DG(0) <= (FDD(5) AND NOT CG(0) AND NOT CG(1) AND CG(2)) OR (SD(23) AND CH(0) AND CH(1) AND NOT CH(2)) OR (FDD(24) AND CH(0) AND NOT CH(1) AND NOT CH(2)) OR (SA(2) AND NOT CA(0) AND NOT CA(1) AND NOT CA(2)); 
DG(1) <= (SD(0) AND NOT CG(0) AND NOT CG(1) AND CG(2)) OR (SD(24) AND CH(0) AND CH(1) AND NOT CH(2)) OR (FDD(25) AND CH(0) AND NOT CH(1) AND NOT CH(2)) OR (SA(3) AND NOT CA(0) AND NOT CA(1) AND NOT CA(2)); 
DG(2) <= (SD(1) AND NOT CG(0) AND NOT CG(1) AND CG(2)) OR (FDD(15) AND CG(0) AND CG(1) AND NOT CG(2)) OR (FDD(26) AND CH(0) AND NOT CH(1) AND NOT CH(2)) OR (SA(4) AND NOT CA(0) AND NOT CA(1) AND NOT CA(2)); 
DG(3) <= (SD(2) AND NOT CG(0) AND NOT CG(1) AND CG(2)) OR (FDD(11) AND CG(0) AND CG(1) AND NOT CG(2)) OR (FDD(16) AND CH(0) AND NOT CH(1) AND NOT CH(2)) OR (SA(5) AND NOT CA(0) AND NOT CA(1) AND NOT CA(2)); 
DG(4) <= (SD(3) AND NOT CG(0) AND NOT CG(1) AND CG(2)) OR (FDD(12) AND CG(0) AND CG(1) AND NOT CG(2)) OR (FDD(17) AND CH(0) AND NOT CH(1) AND NOT CH(2)) OR (SA(6) AND NOT CA(0) AND NOT CA(1) AND NOT CA(2)); 
DG(5) <= (SD(4) AND NOT CG(0) AND NOT CG(1) AND CG(2)) OR (FDD(13) AND CG(0) AND CG(1) AND NOT CG(2)) OR (FDD(18) AND CH(0) AND NOT CH(1) AND NOT CH(2)) OR (SA(7) AND NOT CA(0) AND NOT CA(1) AND NOT CA(2)); 
DG(6) <= (SD(5) AND NOT CG(0) AND NOT CG(1) AND CG(2)) OR (FDD(14) AND CG(0) AND CG(1) AND NOT CG(2)) OR (FDD(19) AND CH(0) AND NOT CH(1) AND NOT CH(2)) OR (SA(8) AND NOT CA(0) AND NOT CA(1) AND NOT CA(2)); 
DG(7) <= (SD(6) AND NOT CG(0) AND NOT CG(1) AND CG(2)) OR (FDD(7) AND CG(0) AND CG(1) AND NOT CG(2)) OR (FDD(20) AND CH(0) AND NOT CH(1) AND NOT CH(2)) OR (SA(27) AND NOT CB(0) AND NOT CB(1) AND NOT CB(2)); 
DG(8) <= (SD(7) AND NOT CG(0) AND NOT CG(1) AND CG(2)) OR (FDD(8) AND CG(0) AND CG(1) AND NOT CG(2)) OR (FDD(21) AND CH(0) AND NOT CH(1) AND NOT CH(2)) OR (SA(26) AND NOT CB(0) AND NOT CB(1) AND NOT CB(2)); 
DG(9) <= (SD(8) AND NOT CG(0) AND NOT CG(1) AND CG(2)) OR (FDD(9) AND CG(0) AND CG(1) AND NOT CG(2)) OR (SD(16) AND CH(0) AND NOT CH(1) AND NOT CH(2)) OR (SA(25) AND NOT CB(0) AND NOT CB(1) AND NOT CB(2)); 
DG(10) <= (SD(27) AND NOT CH(0) AND NOT CH(1) AND CH(2)) OR (FDD(10) AND CG(0) AND CG(1) AND NOT CG(2)) OR (SD(17) AND CH(0) AND NOT CH(1) AND NOT CH(2)) OR (FDD(31) AND NOT CH(0) AND NOT CH(1) AND NOT CH(2)); 
DG(11) <= (SD(26) AND NOT CH(0) AND NOT CH(1) AND CH(2)) OR (FDD(0) AND CG(0) AND CG(1) AND NOT CG(2)) OR (SD(18) AND CH(0) AND NOT CH(1) AND NOT CH(2)) OR (FDD(27) AND NOT CH(0) AND NOT CH(1) AND NOT CH(2)); 
DG(12) <= (SD(25) AND NOT CH(0) AND NOT CH(1) AND CH(2)) OR (FDD(1) AND CG(0) AND CG(1) AND NOT CG(2)) OR (SD(19) AND CH(0) AND NOT CH(1) AND NOT CH(2)) OR (FDD(28) AND NOT CH(0) AND NOT CH(1) AND NOT CH(2)); 
DG(13) <= (FG(31) AND NOT CN(0) AND NOT CN(1) AND CN(2)) OR (FDD(2) AND CG(0) AND CG(1) AND NOT CG(2)) OR (SD(20) AND CH(0) AND NOT CH(1) AND NOT CH(2)) OR (FDD(29) AND NOT CH(0) AND NOT CH(1) AND NOT CH(2)); 
DG(14) <= (FG(27) AND NOT CN(0) AND NOT CN(1) AND CN(2)) OR (FDD(3) AND CG(0) AND CG(1) AND NOT CG(2)) OR (SD(21) AND CH(0) AND NOT CH(1) AND NOT CH(2)) OR (FDD(30) AND NOT CH(0) AND NOT CH(1) AND NOT CH(2)); 
DG(15) <= (FG(28) AND NOT CN(0) AND NOT CN(1) AND CN(2)) OR (FDD(4) AND CG(0) AND CG(1) AND NOT CG(2)) OR (SD(22) AND CH(0) AND NOT CH(1) AND NOT CH(2)) OR (FDD(23) AND NOT CH(0) AND NOT CH(1) AND NOT CH(2)); 

-- LINK 8
DH(0) <= (NEG AND NOT CN(0) AND NOT CN(1) AND CN(2)) OR (FG(3) AND CM(0) AND CM(1) AND NOT CM(2)) OR (SG(21) AND CN(0) AND NOT CN(1) AND NOT CN(2)) OR (FG(29) AND NOT CN(0) AND NOT CN(1) AND NOT CN(2)); 
DH(1) <= (NEG AND NOT CN(0) AND NOT CN(1) AND CN(2)) OR (FG(4) AND CM(0) AND CM(1) AND NOT CM(2)) OR (SG(22) AND CN(0) AND NOT CN(1) AND NOT CN(2)) OR (FG(30) AND NOT CN(0) AND NOT CN(1) AND NOT CN(2)); 
DH(2) <= (NEG AND NOT CN(0) AND NOT CN(1) AND CN(2)) OR (SG(0) AND CM(0) AND CM(1) AND NOT CM(2)) OR (SG(23) AND CN(0) AND NOT CN(1) AND NOT CN(2)) OR (FG(23) AND NOT CN(0) AND NOT CN(1) AND NOT CN(2)); 
DH(3) <= (NEG AND NOT CN(0) AND NOT CN(1) AND CN(2)) OR (SG(1) AND CM(0) AND CM(1) AND NOT CM(2)) OR (SG(24) AND CN(0) AND NOT CN(1) AND NOT CN(2)) OR (FG(24) AND NOT CN(0) AND NOT CN(1) AND NOT CN(2)); 
DH(4) <= (NEG AND NOT CN(0) AND NOT CN(1) AND CN(2)) OR (SG(2) AND CM(0) AND CM(1) AND NOT CM(2)) OR (FG(15) AND CM(0) AND NOT CM(1) AND NOT CM(2)) OR (FG(25) AND NOT CN(0) AND NOT CN(1) AND NOT CN(2)); 
DH(5) <= (NEG AND NOT CN(0) AND NOT CN(1) AND CN(2)) OR (SG(3) AND CM(0) AND CM(1) AND NOT CM(2)) OR (FG(11) AND CM(0) AND NOT CM(1) AND NOT CM(2)) OR (FG(26) AND NOT CN(0) AND NOT CN(1) AND NOT CN(2)); 
DH(6) <= (NEG AND NOT CN(0) AND NOT CN(1) AND CN(2)) OR (SG(4) AND CM(0) AND CM(1) AND NOT CM(2)) OR (FG(12) AND CM(0) AND NOT CM(1) AND NOT CM(2)) OR (FG(16) AND NOT CN(0) AND NOT CN(1) AND NOT CN(2)); 
DH(7) <= (NEG AND NOT CN(0) AND NOT CN(1) AND CN(2)) OR (SG(5) AND CM(0) AND CM(1) AND NOT CM(2)) OR (FG(13) AND CM(0) AND NOT CM(1) AND NOT CM(2)) OR (FG(17) AND NOT CN(0) AND NOT CN(1) AND NOT CN(2)); 
DH(8) <= (NEG AND NOT CN(0) AND NOT CN(1) AND CN(2)) OR (SG(6) AND CM(0) AND CM(1) AND NOT CM(2)) OR (FG(14) AND CM(0) AND NOT CM(1) AND NOT CM(2)) OR (FG(18) AND NOT CN(0) AND NOT CN(1) AND NOT CN(2)); 
DH(9) <= (NEG AND NOT CN(0) AND NOT CN(1) AND CN(2)) OR (SG(7) AND CM(0) AND CM(1) AND NOT CM(2)) OR (FG(7) AND CM(0) AND NOT CM(1) AND NOT CM(2)) OR (FG(19) AND NOT CN(0) AND NOT CN(1) AND NOT CN(2)); 
DH(10) <= (NEG AND NOT CN(0) AND NOT CN(1) AND CN(2)) OR (SG(8) AND CM(0) AND CM(1) AND NOT CM(2)) OR (FG(8) AND CM(0) AND NOT CM(1) AND NOT CM(2)) OR (FG(20) AND NOT CN(0) AND NOT CN(1) AND NOT CN(2)); 
DH(11) <= (NEG AND NOT CN(0) AND NOT CN(1) AND CN(2)) OR (SG(27) AND CN(0) AND CN(1) AND NOT CN(2)) OR (FG(9) AND CM(0) AND NOT CM(1) AND NOT CM(2)) OR (SG(16) AND NOT CN(0) AND NOT CN(1) AND NOT CN(2)); 
DH(12) <= (NEG AND NOT CN(0) AND NOT CN(1) AND CN(2)) OR (SG(26) AND CN(0) AND CN(1) AND NOT CN(2)) OR (FG(10) AND CM(0) AND NOT CM(1) AND NOT CM(2)) OR (SG(17) AND NOT CN(0) AND NOT CN(1) AND NOT CN(2)); 
DH(13) <= (NEG AND NOT CN(0) AND NOT CN(1) AND CN(2)) OR (SG(25) AND CN(0) AND CN(1) AND NOT CN(2)) OR (FG(0) AND CM(0) AND NOT CM(1) AND NOT CM(2)) OR (SG(18) AND NOT CN(0) AND NOT CN(1) AND NOT CN(2)); 
DH(14) <= (NEG AND NOT CN(0) AND NOT CN(1) AND CN(2)) OR (NEG AND CN(0) AND CN(1) AND NOT CN(2)) OR (FG(1) AND CM(0) AND NOT CM(1) AND NOT CM(2)) OR (SG(19) AND NOT CN(0) AND NOT CN(1) AND NOT CN(2)); 
DH(15) <= (NEG AND NOT CN(0) AND NOT CN(1) AND CN(2)) OR (NEG AND CN(0) AND CN(1) AND NOT CN(2)) OR (FG(2) AND CM(0) AND NOT CM(1) AND NOT CM(2)) OR (SG(20) AND NOT CN(0) AND NOT CN(1) AND NOT CN(2)); 

END ARC;
