library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity merger is

    Port ( 
		 FA : in std_logic_vector(31 downto 0);
		 FB : in std_logic_vector(31 downto 0);
		 FC : in std_logic_vector(31 downto 0);
		 FD : in std_logic_vector(31 downto 0);
		 FE : in std_logic_vector(31 downto 0);
		 FF : in std_logic_vector(31 downto 0);
		 FG : in std_logic_vector(31 downto 0);
		 FH : in std_logic_vector(31 downto 0);
		 FI : in std_logic_vector(31 downto 0);

		 SA : in std_logic_vector(31 downto 0);
		 SB : in std_logic_vector(31 downto 0);
		 SC : in std_logic_vector(31 downto 0);
		 SD : in std_logic_vector(31 downto 0);
		 SE : in std_logic_vector(31 downto 0);
		 SF : in std_logic_vector(31 downto 0);
		 SG : in std_logic_vector(31 downto 0);
		 SH : in std_logic_vector(31 downto 0);
		 SI : in std_logic_vector(31 downto 0);

       A : in std_logic_vector(18 downto 1);
       B : in std_logic_vector(18 downto 1);
       C : in std_logic_vector(18 downto 1);
       D : in std_logic_vector(18 downto 1);
       E : in std_logic_vector(18 downto 1);
       F : in std_logic_vector(18 downto 1);
       G : in std_logic_vector(18 downto 1);
       H : in std_logic_vector(18 downto 1);
       I : in std_logic_vector(18 downto 1);
       J : in std_logic_vector(18 downto 1);
       K : in std_logic_vector(18 downto 1);
       L : in std_logic_vector(18 downto 1);		 
		 
       OUTA : out std_logic_vector(31 downto 0);
       OUTB : out std_logic_vector(31 downto 0);
       OUTC : out std_logic_vector(31 downto 0);
       OUTD : out std_logic_vector(31 downto 0);
       OUTE : out std_logic_vector(31 downto 0);	  
       OUTF : out std_logic_vector(31 downto 0);
       OUTG : out std_logic_vector(31 downto 0);	 
       OUTH : out std_logic_vector(31 downto 0);
       OUTI : out std_logic_vector(31 downto 0);
       OUTJ : out std_logic_vector(31 downto 0);	  
       OUTK : out std_logic_vector(31 downto 0);
       OUTL : out std_logic_vector(31 downto 0)	 		 
	  );

end merger;

architecture ARC  of merger is

BEGIN

OUTA(0) <= ((FA(0)  AND A(1))  OR 
           (FA(16) AND A(2))  OR 
		 (FB(0)  AND A(3))  OR 
		 (FB(16) AND A(4))  OR
		 (FC(0)  AND A(5))  OR 
		 (FC(16) AND A(6))  OR 
		 (FD(0)  AND A(7))  OR 
		 (FD(16) AND A(8))  OR
           (FE(0)  AND A(9))  OR 
		 (FE(16) AND A(10)) OR 
		 (FF(0)  AND A(11)) OR 
		 (FF(16) AND A(12)) OR 
           (FG(0)  AND A(13)) OR 
		 (FG(16) AND A(14)) OR
		 (FH(0)  AND A(15)) OR 
		 (FH(16) AND A(16)) OR
		 (FI(0)  AND A(17)) OR
		 (FI(16) AND A(18)));

OUTA(1) <= ((FA(1) AND A(1))  OR 
           (FA(17) AND A(2))  OR 
		 (FB(1)  AND A(3))  OR 
		 (FB(17) AND A(4))  OR
		 (FC(1)  AND A(5))  OR 
		 (FC(17) AND A(6))  OR 
		 (FD(1)  AND A(7))  OR 
		 (FD(17) AND A(8))  OR
           (FE(1)  AND A(9))  OR 
		 (FE(17) AND A(10)) OR 
		 (FF(1)  AND A(11)) OR 
		 (FF(17) AND A(12)) OR 
           (FG(1)  AND A(13)) OR 
		 (FG(17) AND A(14)) OR
		 (FH(1)  AND A(15)) OR 
		 (FH(17) AND A(16)) OR
		 (FI(1)  AND A(17)) OR
		 (FI(17) AND A(18)));
				    
OUTA(2) <= ((FA(2)  AND A(1))  OR 
           (FA(18) AND A(2))  OR 
		 (FB(2)  AND A(3))  OR 
		 (FB(18) AND A(4))  OR
		 (FC(2)  AND A(5))  OR 
		 (FC(18) AND A(6))  OR 
		 (FD(2)  AND A(7))  OR 
		 (FD(18) AND A(8))  OR
           (FE(2)  AND A(9))  OR 
		 (FE(18) AND A(10)) OR 
		 (FF(2)  AND A(11)) OR 
		 (FF(18) AND A(12)) OR 
           (FG(2)  AND A(13)) OR 
		 (FG(18) AND A(14)) OR
		 (FH(2)  AND A(15)) OR 
		 (FH(18) AND A(16)) OR
		 (FI(2)  AND A(17)) OR
		 (FI(18) AND A(18)));
	
OUTA(3) <= ((FA(3)  AND A(1))  OR 
           (FA(19) AND A(2))  OR 
		 (FB(3)  AND A(3))  OR 
		 (FB(19) AND A(4))  OR
		 (FC(3)  AND A(5))  OR 
		 (FC(19) AND A(6))  OR 
		 (FD(3)  AND A(7))  OR 
		 (FD(19) AND A(8))  OR
           (FE(3)  AND A(9))  OR 
		 (FE(19) AND A(10)) OR 
		 (FF(3)  AND A(11)) OR 
		 (FF(19) AND A(12)) OR 
           (FG(3)  AND A(13)) OR 
		 (FG(19) AND A(14)) OR
		 (FH(3)  AND A(15)) OR 
		 (FH(19) AND A(16)) OR
		 (FI(3)  AND A(17)) OR
		 (FI(19) AND A(18)));

OUTA(4) <= ((FA(4)  AND A(1))  OR 
           (FA(20) AND A(2))  OR 
		 (FB(4)  AND A(3))  OR 
		 (FB(20) AND A(4))  OR
		 (FC(4)  AND A(5))  OR 
		 (FC(20) AND A(6))  OR 
		 (FD(4)  AND A(7))  OR 
		 (FD(20) AND A(8))  OR
           (FE(4)  AND A(9))  OR 
		 (FE(20) AND A(10)) OR 
		 (FF(4)  AND A(11)) OR 
		 (FF(20) AND A(12)) OR 
           (FG(4)  AND A(13)) OR 
		 (FG(20) AND A(14)) OR
		 (FH(4)  AND A(15)) OR 
		 (FH(20) AND A(16)) OR
		 (FI(4)  AND A(17)) OR
		 (FI(20) AND A(18)));
		 
OUTA(5) <= ((FA(5)  AND A(1))  OR 
           (FA(21) AND A(2))  OR 
		 (FB(5)  AND A(3))  OR 
		 (FB(21) AND A(4))  OR
		 (FC(5)  AND A(5))  OR 
		 (FC(21) AND A(6))  OR 
		 (FD(5)  AND A(7))  OR 
		 (FD(21) AND A(8))  OR
           (FE(5)  AND A(9))  OR 
		 (FE(21) AND A(10)) OR 
		 (FF(5)  AND A(11)) OR 
		 (FF(21) AND A(12)) OR 
           (FG(5)  AND A(13)) OR 
		 (FG(21) AND A(14)) OR
		 (FH(5)  AND A(15)) OR 
		 (FH(21) AND A(16)) OR
		 (FI(5)  AND A(17)) OR
		 (FI(21) AND A(18)));
		 
OUTA(6) <= ((FA(6)  AND A(1))  OR 
           (FA(22) AND A(2))  OR 
		 (FB(6)  AND A(3))  OR 
		 (FB(22) AND A(4))  OR
		 (FC(6)  AND A(5))  OR 
		 (FC(22) AND A(6))  OR 
		 (FD(6)  AND A(7))  OR 
		 (FD(22) AND A(8))  OR
           (FE(6)  AND A(9))  OR 
		 (FE(22) AND A(10)) OR 
		 (FF(6)  AND A(11)) OR 
		 (FF(22) AND A(12)) OR 
           (FG(6)  AND A(13)) OR 
		 (FG(22) AND A(14)) OR
		 (FH(6)  AND A(15)) OR 
		 (FH(22) AND A(16)) OR
		 (FI(6)  AND A(17)) OR
		 (FI(22) AND A(18)));

OUTA(7) <= ((FA(7)  AND A(1))  OR 
           (FA(23) AND A(2))  OR 
		 (FB(7)  AND A(3))  OR 
		 (FB(23) AND A(4))  OR
		 (FC(7)  AND A(5))  OR 
		 (FC(23) AND A(6))  OR 
		 (FD(7)  AND A(7))  OR 
		 (FD(23) AND A(8))  OR
           (FE(7)  AND A(9))  OR 
		 (FE(23) AND A(10)) OR 
		 (FF(7)  AND A(11)) OR 
		 (FF(23) AND A(12)) OR 
           (FG(7)  AND A(13)) OR 
		 (FG(23) AND A(14)) OR
		 (FH(7)  AND A(15)) OR 
		 (FH(23) AND A(16)) OR
		 (FI(7)  AND A(17)) OR
		 (FI(23) AND A(18)));

OUTA(8) <= ((FA(8)  AND A(1))  OR 
           (FA(24) AND A(2))  OR 
		 (FB(8)  AND A(3))  OR 
		 (FB(24) AND A(4))  OR
		 (FC(8)  AND A(5))  OR 
		 (FC(24) AND A(6))  OR 
		 (FD(8)  AND A(7))  OR 
		 (FD(24) AND A(8))  OR
           (FE(8)  AND A(9))  OR 
		 (FE(24) AND A(10)) OR 
		 (FF(8)  AND A(11)) OR 
		 (FF(24) AND A(12)) OR 
           (FG(8)  AND A(13)) OR 
		 (FG(24) AND A(14)) OR
		 (FH(8)  AND A(15)) OR 
		 (FH(24) AND A(16)) OR
		 (FI(8)  AND A(17)) OR
		 (FI(24) AND A(18)));
		 
OUTA(9) <= ((FA(9)  AND A(1))  OR 
           (FA(25) AND A(2))  OR 
		 (FB(9)  AND A(3))  OR 
		 (FB(25) AND A(4))  OR
		 (FC(9)  AND A(5))  OR 
		 (FC(25) AND A(6))  OR 
		 (FD(9)  AND A(7))  OR 
		 (FD(25) AND A(8))  OR
           (FE(9)  AND A(9))  OR 
		 (FE(25) AND A(10)) OR 
		 (FF(9)  AND A(11)) OR 
		 (FF(25) AND A(12)) OR 
           (FG(9)  AND A(13)) OR 
		 (FG(25) AND A(14)) OR
		 (FH(9)  AND A(15)) OR 
		 (FH(25) AND A(16)) OR
		 (FI(9)  AND A(17)) OR
		 (FI(25) AND A(18)));
		 
OUTA(10) <= ((FA(10)  AND A(1))  OR 
           (FA(26) AND A(2))  OR 
		 (FB(10)  AND A(3))  OR 
		 (FB(26) AND A(4))  OR
		 (FC(10)  AND A(5))  OR 
		 (FC(26) AND A(6))  OR 
		 (FD(10)  AND A(7))  OR 
		 (FD(26) AND A(8))  OR
           (FE(10)  AND A(9))  OR 
		 (FE(26) AND A(10)) OR 
		 (FF(10)  AND A(11)) OR 
		 (FF(26) AND A(12)) OR 
           (FG(10)  AND A(13)) OR 
		 (FG(26) AND A(14)) OR
		 (FH(10)  AND A(15)) OR 
		 (FH(26) AND A(16)) OR
		 (FI(10)  AND A(17)) OR
		 (FI(26) AND A(18)));
		 
OUTA(11) <= ((FA(11)  AND A(1))  OR 
           (FA(27) AND A(2))  OR 
		 (FB(11)  AND A(3))  OR 
		 (FB(27) AND A(4))  OR
		 (FC(11)  AND A(5))  OR 
		 (FC(27) AND A(6))  OR 
		 (FD(11)  AND A(7))  OR 
		 (FD(27) AND A(8))  OR
           (FE(11)  AND A(9))  OR 
		 (FE(27) AND A(10)) OR 
		 (FF(11)  AND A(11)) OR 
		 (FF(27) AND A(12)) OR 
           (FG(11)  AND A(13)) OR 
		 (FG(27) AND A(14)) OR
		 (FH(11)  AND A(15)) OR 
		 (FH(27) AND A(16)) OR
		 (FI(11)  AND A(17)) OR
		 (FI(27) AND A(18)));
		 

OUTA(12) <= ((FA(12)  AND A(1))  OR 
           (FA(28) AND A(2))  OR 
		 (FB(12)  AND A(3))  OR 
		 (FB(28) AND A(4))  OR
		 (FC(12)  AND A(5))  OR 
		 (FC(28) AND A(6))  OR 
		 (FD(12)  AND A(7))  OR 
		 (FD(28) AND A(8))  OR
           (FE(12)  AND A(9))  OR 
		 (FE(28) AND A(10)) OR 
		 (FF(12)  AND A(11)) OR 
		 (FF(28) AND A(12)) OR 
           (FG(12)  AND A(13)) OR 
		 (FG(28) AND A(14)) OR
		 (FH(12)  AND A(15)) OR 
		 (FH(28) AND A(16)) OR
		 (FI(12)  AND A(17)) OR
		 (FI(28) AND A(18)));
		 
OUTA(13) <= ((FA(13)  AND A(1))  OR 
           (FA(29) AND A(2))  OR 
		 (FB(13)  AND A(3))  OR 
		 (FB(29) AND A(4))  OR
		 (FC(13)  AND A(5))  OR 
		 (FC(29) AND A(6))  OR 
		 (FD(13)  AND A(7))  OR 
		 (FD(29) AND A(8))  OR
           (FE(13)  AND A(9))  OR 
		 (FE(29) AND A(10)) OR 
		 (FF(13)  AND A(11)) OR 
		 (FF(29) AND A(12)) OR 
           (FG(13)  AND A(13)) OR 
		 (FG(29) AND A(14)) OR
		 (FH(13)  AND A(15)) OR 
		 (FH(29) AND A(16)) OR
		 (FI(13)  AND A(17)) OR
		 (FI(29) AND A(18)));
		 
OUTA(14) <= ((FA(14)  AND A(1))  OR 
           (FA(30) AND A(2))  OR 
		 (FB(14)  AND A(3))  OR 
		 (FB(30) AND A(4))  OR
		 (FC(14)  AND A(5))  OR 
		 (FC(30) AND A(6))  OR 
		 (FD(14)  AND A(7))  OR 
		 (FD(30) AND A(8))  OR
           (FE(14)  AND A(9))  OR 
		 (FE(30) AND A(10)) OR 
		 (FF(14)  AND A(11)) OR 
		 (FF(30) AND A(12)) OR 
           (FG(14)  AND A(13)) OR 
		 (FG(30) AND A(14)) OR
		 (FH(14)  AND A(15)) OR 
		 (FH(30) AND A(16)) OR
		 (FI(14)  AND A(17)) OR
		 (FI(30) AND A(18)));
		 
OUTA(15) <= ((FA(15)  AND A(1))  OR 
           (FA(31) AND A(2))  OR 
		 (FB(15)  AND A(3))  OR 
		 (FB(31) AND A(4))  OR
		 (FC(15)  AND A(5))  OR 
		 (FC(31) AND A(6))  OR 
		 (FD(15)  AND A(7))  OR 
		 (FD(31) AND A(8))  OR
           (FE(15)  AND A(9))  OR 
		 (FE(31) AND A(10)) OR 
		 (FF(15)  AND A(11)) OR 
		 (FF(31) AND A(12)) OR 
           (FG(15)  AND A(13)) OR 
		 (FG(31) AND A(14)) OR
		 (FH(15)  AND A(15)) OR 
		 (FH(31) AND A(16)) OR
		 (FI(15)  AND A(17)) OR
		 (FI(31) AND A(18)));
		 
OUTA(16) <= ((SA(0)  AND A(1))  OR 
           (SA(16) AND A(2))  OR 
		 (SB(0)  AND A(3))  OR 
		 (SB(16) AND A(4))  OR
		 (SC(0)  AND A(5))  OR 
		 (SC(16) AND A(6))  OR 
		 (SD(0)  AND A(7))  OR 
		 (SD(16) AND A(8))  OR
           (SE(0)  AND A(9))  OR 
		 (SE(16) AND A(10)) OR 
		 (SF(0)  AND A(11)) OR 
		 (SF(16) AND A(12)) OR 
           (SG(0)  AND A(13)) OR 
		 (SG(16) AND A(14)) OR
		 (SH(0)  AND A(15)) OR 
		 (SH(16) AND A(16)) OR
		 (SI(0)  AND A(17)) OR
		 (SI(16) AND A(18)));
		 
OUTA(17) <= ((SA(1)  AND A(1))  OR 
           (SA(17) AND A(2))  OR 
		 (SB(1)  AND A(3))  OR 
		 (SB(17) AND A(4))  OR
		 (SC(1)  AND A(5))  OR 
		 (SC(17) AND A(6))  OR 
		 (SD(1)  AND A(7))  OR 
		 (SD(17) AND A(8))  OR
           (SE(1)  AND A(9))  OR 
		 (SE(17) AND A(10)) OR 
		 (SF(1)  AND A(11)) OR 
		 (SF(17) AND A(12)) OR 
           (SG(1)  AND A(13)) OR 
		 (SG(17) AND A(14)) OR
		 (SH(1)  AND A(15)) OR 
		 (SH(17) AND A(16)) OR
		 (SI(1)  AND A(17)) OR
		 (SI(17) AND A(18)));
		 
OUTA(18) <= ((SA(2)  AND A(1))  OR 
           (SA(18) AND A(2))  OR 
		 (SB(2)  AND A(3))  OR 
		 (SB(18) AND A(4))  OR
		 (SC(2)  AND A(5))  OR 
		 (SC(18) AND A(6))  OR 
		 (SD(2)  AND A(7))  OR 
		 (SD(18) AND A(8))  OR
           (SE(2)  AND A(9))  OR 
		 (SE(18) AND A(10)) OR 
		 (SF(2)  AND A(11)) OR 
		 (SF(18) AND A(12)) OR 
           (SG(2)  AND A(13)) OR 
		 (SG(18) AND A(14)) OR
		 (SH(2)  AND A(15)) OR 
		 (SH(18) AND A(16)) OR
		 (SI(2)  AND A(17)) OR
		 (SI(18) AND A(18)));
		 
OUTA(19) <= ((SA(3)  AND A(1))  OR 
           (SA(19) AND A(2))  OR 
		 (SB(3)  AND A(3))  OR 
		 (SB(19) AND A(4))  OR
		 (SC(3)  AND A(5))  OR 
		 (SC(19) AND A(6))  OR 
		 (SD(3)  AND A(7))  OR 
		 (SD(19) AND A(8))  OR
           (SE(3)  AND A(9))  OR 
		 (SE(19) AND A(10)) OR 
		 (SF(3)  AND A(11)) OR 
		 (SF(19) AND A(12)) OR 
           (SG(3)  AND A(13)) OR 
		 (SG(19) AND A(14)) OR
		 (SH(3)  AND A(15)) OR 
		 (SH(19) AND A(16)) OR
		 (SI(3)  AND A(17)) OR
		 (SI(19) AND A(18)));
		 
OUTA(20) <= ((SA(4)  AND A(1))  OR 
           (SA(20) AND A(2))  OR 
		 (SB(4)  AND A(3))  OR 
		 (SB(20) AND A(4))  OR
		 (SC(4)  AND A(5))  OR 
		 (SC(20) AND A(6))  OR 
		 (SD(4)  AND A(7))  OR 
		 (SD(20) AND A(8))  OR
           (SE(4)  AND A(9))  OR 
		 (SE(20) AND A(10)) OR 
		 (SF(4)  AND A(11)) OR 
		 (SF(20) AND A(12)) OR 
           (SG(4)  AND A(13)) OR 
		 (SG(20) AND A(14)) OR
		 (SH(4)  AND A(15)) OR 
		 (SH(20) AND A(16)) OR
		 (SI(4)  AND A(17)) OR
		 (SI(20) AND A(18)));
		 
OUTA(21) <= ((SA(5)  AND A(1))  OR 
           (SA(21) AND A(2))  OR 
		 (SB(5)  AND A(3))  OR 
		 (SB(21) AND A(4))  OR
		 (SC(5)  AND A(5))  OR 
		 (SC(21) AND A(6))  OR 
		 (SD(5)  AND A(7))  OR 
		 (SD(21) AND A(8))  OR
           (SE(5)  AND A(9))  OR 
		 (SE(21) AND A(10)) OR 
		 (SF(5)  AND A(11)) OR 
		 (SF(21) AND A(12)) OR 
           (SG(5)  AND A(13)) OR 
		 (SG(21) AND A(14)) OR
		 (SH(5)  AND A(15)) OR 
		 (SH(21) AND A(16)) OR
		 (SI(5)  AND A(17)) OR
		 (SI(21) AND A(18)));
		 
OUTA(22) <= ((SA(6)  AND A(1))  OR 
           (SA(22) AND A(2))  OR 
		 (SB(6)  AND A(3))  OR 
		 (SB(22) AND A(4))  OR
		 (SC(6)  AND A(5))  OR 
		 (SC(22) AND A(6))  OR 
		 (SD(6)  AND A(7))  OR 
		 (SD(22) AND A(8))  OR
           (SE(6)  AND A(9))  OR 
		 (SE(22) AND A(10)) OR 
		 (SF(6)  AND A(11)) OR 
		 (SF(22) AND A(12)) OR 
           (SG(6)  AND A(13)) OR 
		 (SG(22) AND A(14)) OR
		 (SH(6)  AND A(15)) OR 
		 (SH(22) AND A(16)) OR
		 (SI(6)  AND A(17)) OR
		 (SI(22) AND A(18)));
		 

OUTA(23) <= ((SA(7)  AND A(1))  OR 
           (SA(23) AND A(2))  OR 
		 (SB(7)  AND A(3))  OR 
		 (SB(23) AND A(4))  OR
		 (SC(7)  AND A(5))  OR 
		 (SC(23) AND A(6))  OR 
		 (SD(7)  AND A(7))  OR 
		 (SD(23) AND A(8))  OR
           (SE(7)  AND A(9))  OR 
		 (SE(23) AND A(10)) OR 
		 (SF(7)  AND A(11)) OR 
		 (SF(23) AND A(12)) OR 
           (SG(7)  AND A(13)) OR 
		 (SG(23) AND A(14)) OR
		 (SH(7)  AND A(15)) OR 
		 (SH(23) AND A(16)) OR
		 (SI(7)  AND A(17)) OR
		 (SI(23) AND A(18)));

OUTA(24) <= ((SA(8)  AND A(1))  OR 
           (SA(24) AND A(2))  OR 
		 (SB(8)  AND A(3))  OR 
		 (SB(24) AND A(4))  OR
		 (SC(8)  AND A(5))  OR 
		 (SC(24) AND A(6))  OR 
		 (SD(8)  AND A(7))  OR 
		 (SD(24) AND A(8))  OR
           (SE(8)  AND A(9))  OR 
		 (SE(24) AND A(10)) OR 
		 (SF(8)  AND A(11)) OR 
		 (SF(24) AND A(12)) OR 
           (SG(8)  AND A(13)) OR 
		 (SG(24) AND A(14)) OR
		 (SH(8)  AND A(15)) OR 
		 (SH(24) AND A(16)) OR
		 (SI(8)  AND A(17)) OR
		 (SI(24) AND A(18)));
		 
OUTA(25) <= ((SA(9)  AND A(1))  OR 
           (SA(25) AND A(2))  OR 
		 (SB(9)  AND A(3))  OR 
		 (SB(25) AND A(4))  OR
		 (SC(9)  AND A(5))  OR 
		 (SC(25) AND A(6))  OR 
		 (SD(9)  AND A(7))  OR 
		 (SD(25) AND A(8))  OR
           (SE(9)  AND A(9))  OR 
		 (SE(25) AND A(10)) OR 
		 (SF(9)  AND A(11)) OR 
		 (SF(25) AND A(12)) OR 
           (SG(9)  AND A(13)) OR 
		 (SG(25) AND A(14)) OR
		 (SH(9)  AND A(15)) OR 
		 (SH(25) AND A(16)) OR
		 (SI(9)  AND A(17)) OR
		 (SI(25) AND A(18)));
		 
OUTA(26) <= ((SA(10)  AND A(1))  OR 
           (SA(26) AND A(2))  OR 
		 (SB(10)  AND A(3))  OR 
		 (SB(26) AND A(4))  OR
		 (SC(10)  AND A(5))  OR 
		 (SC(26) AND A(6))  OR 
		 (SD(10)  AND A(7))  OR 
		 (SD(26) AND A(8))  OR
           (SE(10)  AND A(9))  OR 
		 (SE(26) AND A(10)) OR 
		 (SF(10)  AND A(11)) OR 
		 (SF(26) AND A(12)) OR 
           (SG(10)  AND A(13)) OR 
		 (SG(26) AND A(14)) OR
		 (SH(10)  AND A(15)) OR 
		 (SH(26) AND A(16)) OR
		 (SI(10)  AND A(17)) OR
		 (SI(26) AND A(18)));
		 
OUTA(27) <= (SA(11)  OR 
       SA(27)   OR 
		 SB(11)   OR 
		 SB(27)   OR
		 SC(11)   OR 
		 SC(27)   OR 
		 SD(11)   OR 
		 SD(27)   OR
       SE(11)   OR 
		 SE(27)   OR 
		 SF(11)   OR 
		 SF(27)   OR 
       SG(11)   OR 
		 SG(27)   OR
		 SH(11)   OR 
		 SH(27)   OR
		 SI(11)   OR
		 SI(27));
		 
--OUTA(27) <= (((SA(11) AND A(1)) OR 
--       (SA(27) AND A(2))   OR 
--		 (SB(11) AND A(3))   OR 
--		 (SB(27) AND A(4))   OR
--		 (SC(11) AND A(5))   OR 
--		 (SC(27) AND A(6))   OR 
--		 (SD(11) AND A(7))  OR 
--		 (SD(27) AND A(8))  OR
--       (SE(11) AND A(9))  OR 
--		 (SE(27) AND A(10))  OR 
--		 (SF(11) AND A(11))  OR 
--		 (SF(27) AND A(12))  OR 
--       (SG(11) AND A(13))  OR 
--		 (SG(27) AND A(14))  OR
--		 (SH(11) AND A(15))  OR 
--		 (SH(27) AND A(16))  OR
--		 (SI(11) AND A(17))  OR
--		 (SI(27) AND A(18))) AND NOT SWITCH) OR
--		 (((SA(11) AND CONA(1)) OR
--		 (SA(27) AND CONA(2)) OR
--		 (SB(11) AND CONA(3)) OR
--		 (SB(27) AND CONA(4)) OR
--		 (SC(11) AND CONA(5)) OR
--		 (SC(27) AND CONA(6)) OR
--		 (SD(11) AND CONA(7)) OR
--		 (SD(27) AND CONA(8)) OR
--		 (SE(11) AND CONA(9)) OR
--		 (SE(27) AND CONA(10)) OR
--		 (SF(11) AND CONA(11)) OR
--		 (SF(27) AND CONA(12)) OR
--		 (SG(11) AND CONA(13)) OR
--		 (SG(27) AND CONA(14)) OR
--		 (SH(11) AND CONA(15)) OR
--		 (SH(27) AND CONA(16)) OR
--		 (SI(11) AND CONA(17)) OR
--		 (SI(27) AND CONA(18))) AND SWITCH); 

OUTA(28) <= ((SA(12)  AND A(1))  OR 
           (SA(28) AND A(2))  OR 
		 (SB(12)  AND A(3))  OR 
		 (SB(28) AND A(4))  OR
		 (SC(12)  AND A(5))  OR 
		 (SC(28) AND A(6))  OR 
		 (SD(12)  AND A(7))  OR 
		 (SD(28) AND A(8))  OR
           (SE(12)  AND A(9))  OR 
		 (SE(28) AND A(10)) OR 
		 (SF(12)  AND A(11)) OR 
		 (SF(28) AND A(12)) OR 
           (SG(12)  AND A(13)) OR 
		 (SG(28) AND A(14)) OR
		 (SH(12)  AND A(15)) OR 
		 (SH(28) AND A(16)) OR
		 (SI(12)  AND A(17)) OR
		 (SI(28) AND A(18)));
		 
OUTA(29) <= ((SA(13)  AND A(1))  OR 
           (SA(29) AND A(2))  OR 
		 (SB(13)  AND A(3))  OR 
		 (SB(29) AND A(4))  OR
		 (SC(13)  AND A(5))  OR 
		 (SC(29) AND A(6))  OR 
		 (SD(13)  AND A(7))  OR 
		 (SD(29) AND A(8))  OR
           (SE(13)  AND A(9))  OR 
		 (SE(29) AND A(10)) OR 
		 (SF(13)  AND A(11)) OR 
		 (SF(29) AND A(12)) OR 
           (SG(13)  AND A(13)) OR 
		 (SG(29) AND A(14)) OR
		 (SH(13)  AND A(15)) OR 
		 (SH(29) AND A(16)) OR
		 (SI(13)  AND A(17)) OR
		 (SI(29) AND A(18)));
		 
OUTA(30) <= ((SA(14)  AND A(1))  OR 
           (SA(30) AND A(2))  OR 
		 (SB(14)  AND A(3))  OR 
		 (SB(30) AND A(4))  OR
		 (SC(14)  AND A(5))  OR 
		 (SC(30) AND A(6))  OR 
		 (SD(14)  AND A(7))  OR 
		 (SD(30) AND A(8))  OR
           (SE(14)  AND A(9))  OR 
		 (SE(30) AND A(10)) OR 
		 (SF(14)  AND A(11)) OR 
		 (SF(30) AND A(12)) OR 
           (SG(14)  AND A(13)) OR 
		 (SG(30) AND A(14)) OR
		 (SH(14)  AND A(15)) OR 
		 (SH(30) AND A(16)) OR
		 (SI(14)  AND A(17)) OR
		 (SI(30) AND A(18)));
		 
OUTA(31) <= ((SA(15)  AND A(1))  OR 
           (SA(31) AND A(2))  OR 
		 (SB(15)  AND A(3))  OR 
		 (SB(31) AND A(4))  OR
		 (SC(15)  AND A(5))  OR 
		 (SC(31) AND A(6))  OR 
		 (SD(15)  AND A(7))  OR 
		 (SD(31) AND A(8))  OR
           (SE(15)  AND A(9))  OR 
		 (SE(31) AND A(10)) OR 
		 (SF(15)  AND A(11)) OR 
		 (SF(31) AND A(12)) OR 
           (SG(15)  AND A(13)) OR 
		 (SG(31) AND A(14)) OR
		 (SH(15)  AND A(15)) OR 
		 (SH(31) AND A(16)) OR
		 (SI(15)  AND A(17)) OR
		 (SI(31) AND A(18)));
		 
-- SECOND BEST

OUTB(0) <= ((FA(0)  AND B(1))  OR 
           (FA(16) AND B(2))  OR 
		 (FB(0)  AND B(3))  OR 
		 (FB(16) AND B(4))  OR
		 (FC(0)  AND B(5))  OR 
		 (FC(16) AND B(6))  OR 
		 (FD(0)  AND B(7))  OR 
		 (FD(16) AND B(8))  OR
           (FE(0)  AND B(9))  OR 
		 (FE(16) AND B(10)) OR 
		 (FF(0)  AND B(11)) OR 
		 (FF(16) AND B(12)) OR 
           (FG(0)  AND B(13)) OR 
		 (FG(16) AND B(14)) OR
		 (FH(0)  AND B(15)) OR 
		 (FH(16) AND B(16)) OR
		 (FI(0)  AND B(17)) OR
		 (FI(16) AND B(18)));
		 
OUTB(1) <= ((FA(1)  AND B(1))  OR 
           (FA(17) AND B(2))  OR 
		 (FB(1)  AND B(3))  OR 
		 (FB(17) AND B(4))  OR
		 (FC(1)  AND B(5))  OR 
		 (FC(17) AND B(6))  OR 
		 (FD(1)  AND B(7))  OR 
		 (FD(17) AND B(8))  OR
           (FE(1)  AND B(9))  OR 
		 (FE(17) AND B(10)) OR 
		 (FF(1)  AND B(11)) OR 
		 (FF(17) AND B(12)) OR 
           (FG(1)  AND B(13)) OR 
		 (FG(17) AND B(14)) OR
		 (FH(1)  AND B(15)) OR 
		 (FH(17) AND B(16)) OR
		 (FI(1)  AND B(17)) OR
		 (FI(17) AND B(18)));
		 
OUTB(2) <= ((FA(2)  AND B(1))  OR 
           (FA(18) AND B(2))  OR 
		 (FB(2)  AND B(3))  OR 
		 (FB(18) AND B(4))  OR
		 (FC(2)  AND B(5))  OR 
		 (FC(18) AND B(6))  OR 
		 (FD(2)  AND B(7))  OR 
		 (FD(18) AND B(8))  OR
           (FE(2)  AND B(9))  OR 
		 (FE(18) AND B(10)) OR 
		 (FF(2)  AND B(11)) OR 
		 (FF(18) AND B(12)) OR 
           (FG(2)  AND B(13)) OR 
		 (FG(18) AND B(14)) OR
		 (FH(2)  AND B(15)) OR 
		 (FH(18) AND B(16)) OR
		 (FI(2)  AND B(17)) OR
		 (FI(18) AND B(18)));

OUTB(3) <= ((FA(3)  AND B(1))  OR 
           (FA(19) AND B(2))  OR 
		 (FB(3)  AND B(3))  OR 
		 (FB(19) AND B(4))  OR
		 (FC(3)  AND B(5))  OR 
		 (FC(19) AND B(6))  OR 
		 (FD(3)  AND B(7))  OR 
		 (FD(19) AND B(8))  OR
           (FE(3)  AND B(9))  OR 
		 (FE(19) AND B(10)) OR 
		 (FF(3)  AND B(11)) OR 
		 (FF(19) AND B(12)) OR 
           (FG(3)  AND B(13)) OR 
		 (FG(19) AND B(14)) OR
		 (FH(3)  AND B(15)) OR 
		 (FH(19) AND B(16)) OR
		 (FI(3)  AND B(17)) OR
		 (FI(19) AND B(18)));
		 
OUTB(4) <= ((FA(4)  AND B(1))  OR 
           (FA(20) AND B(2))  OR 
		 (FB(4)  AND B(3))  OR 
		 (FB(20) AND B(4))  OR
		 (FC(4)  AND B(5))  OR 
		 (FC(20) AND B(6))  OR 
		 (FD(4)  AND B(7))  OR 
		 (FD(20) AND B(8))  OR
           (FE(4)  AND B(9))  OR 
		 (FE(20) AND B(10)) OR 
		 (FF(4)  AND B(11)) OR 
		 (FF(20) AND B(12)) OR 
           (FG(4)  AND B(13)) OR 
		 (FG(20) AND B(14)) OR
		 (FH(4)  AND B(15)) OR 
		 (FH(20) AND B(16)) OR
		 (FI(4)  AND B(17)) OR
		 (FI(20) AND B(18)));

OUTB(5) <= ((FA(5)  AND B(1))  OR 
           (FA(21) AND B(2))  OR 
		 (FB(5)  AND B(3))  OR 
		 (FB(21) AND B(4))  OR
		 (FC(5)  AND B(5))  OR 
		 (FC(21) AND B(6))  OR 
		 (FD(5)  AND B(7))  OR 
		 (FD(21) AND B(8))  OR
           (FE(5)  AND B(9))  OR 
		 (FE(21) AND B(10)) OR 
		 (FF(5)  AND B(11)) OR 
		 (FF(21) AND B(12)) OR 
           (FG(5)  AND B(13)) OR 
		 (FG(21) AND B(14)) OR
		 (FH(5)  AND B(15)) OR 
		 (FH(21) AND B(16)) OR
		 (FI(5)  AND B(17)) OR
		 (FI(21) AND B(18)));
		 
OUTB(6) <= ((FA(6)  AND B(1))  OR 
           (FA(22) AND B(2))  OR 
		 (FB(6)  AND B(3))  OR 
		 (FB(22) AND B(4))  OR
		 (FC(6)  AND B(5))  OR 
		 (FC(22) AND B(6))  OR 
		 (FD(6)  AND B(7))  OR 
		 (FD(22) AND B(8))  OR
           (FE(6)  AND B(9))  OR 
		 (FE(22) AND B(10)) OR 
		 (FF(6)  AND B(11)) OR 
		 (FF(22) AND B(12)) OR 
           (FG(6)  AND B(13)) OR 
		 (FG(22) AND B(14)) OR
		 (FH(6)  AND B(15)) OR 
		 (FH(22) AND B(16)) OR
		 (FI(6)  AND B(17)) OR
		 (FI(22) AND B(18)));
		 
OUTB(7) <= ((FA(7)  AND B(1))  OR 
           (FA(23) AND B(2))  OR 
		 (FB(7)  AND B(3))  OR 
		 (FB(23) AND B(4))  OR
		 (FC(7)  AND B(5))  OR 
		 (FC(23) AND B(6))  OR 
		 (FD(7)  AND B(7))  OR 
		 (FD(23) AND B(8))  OR
           (FE(7)  AND B(9))  OR 
		 (FE(23) AND B(10)) OR 
		 (FF(7)  AND B(11)) OR 
		 (FF(23) AND B(12)) OR 
           (FG(7)  AND B(13)) OR 
		 (FG(23) AND B(14)) OR
		 (FH(7)  AND B(15)) OR 
		 (FH(23) AND B(16)) OR
		 (FI(7)  AND B(17)) OR
		 (FI(23) AND B(18)));
		 
OUTB(8) <= ((FA(8)  AND B(1))  OR 
           (FA(24) AND B(2))  OR 
		 (FB(8)  AND B(3))  OR 
		 (FB(24) AND B(4))  OR
		 (FC(8)  AND B(5))  OR 
		 (FC(24) AND B(6))  OR 
		 (FD(8)  AND B(7))  OR 
		 (FD(24) AND B(8))  OR
           (FE(8)  AND B(9))  OR 
		 (FE(24) AND B(10)) OR 
		 (FF(8)  AND B(11)) OR 
		 (FF(24) AND B(12)) OR 
           (FG(8)  AND B(13)) OR 
		 (FG(24) AND B(14)) OR
		 (FH(8)  AND B(15)) OR 
		 (FH(24) AND B(16)) OR
		 (FI(8)  AND B(17)) OR
		 (FI(24) AND B(18)));
		 
OUTB(9) <= ((FA(9)  AND B(1))  OR 
           (FA(25) AND B(2))  OR 
		 (FB(9)  AND B(3))  OR 
		 (FB(25) AND B(4))  OR
		 (FC(9)  AND B(5))  OR 
		 (FC(25) AND B(6))  OR 
		 (FD(9)  AND B(7))  OR 
		 (FD(25) AND B(8))  OR
           (FE(9)  AND B(9))  OR 
		 (FE(25) AND B(10)) OR 
		 (FF(9)  AND B(11)) OR 
		 (FF(25) AND B(12)) OR 
           (FG(9)  AND B(13)) OR 
		 (FG(25) AND B(14)) OR
		 (FH(9)  AND B(15)) OR 
		 (FH(25) AND B(16)) OR
		 (FI(9)  AND B(17)) OR
		 (FI(25) AND B(18)));
		 
OUTB(10) <= ((FA(10)  AND B(1))  OR 
           (FA(26) AND B(2))  OR 
		 (FB(10) AND B(3))  OR 
		 (FB(26) AND B(4))  OR
		 (FC(10) AND B(5))  OR 
		 (FC(26) AND B(6))  OR 
		 (FD(10) AND B(7))  OR 
		 (FD(26) AND B(8))  OR
           (FE(10) AND B(9))  OR 
		 (FE(26) AND B(10)) OR 
		 (FF(10) AND B(11)) OR 
		 (FF(26) AND B(12)) OR 
           (FG(10) AND B(13)) OR 
		 (FG(26) AND B(14)) OR
		 (FH(10) AND B(15)) OR 
		 (FH(26) AND B(16)) OR
		 (FI(10) AND B(17)) OR
		 (FI(26) AND B(18)));
		 
OUTB(11) <= ((FA(11)  AND B(1))  OR 
           (FA(27) AND B(2))  OR 
		 (FB(11) AND B(3))  OR 
		 (FB(27) AND B(4))  OR
		 (FC(11) AND B(5))  OR 
		 (FC(27) AND B(6))  OR 
		 (FD(11) AND B(7))  OR 
		 (FD(27) AND B(8))  OR
           (FE(11) AND B(9))  OR 
		 (FE(27) AND B(10)) OR 
		 (FF(11) AND B(11)) OR 
		 (FF(27) AND B(12)) OR 
           (FG(11) AND B(13)) OR 
		 (FG(27) AND B(14)) OR
		 (FH(11) AND B(15)) OR 
		 (FH(27) AND B(16)) OR
		 (FI(11) AND B(17)) OR
		 (FI(27) AND B(18)));
		 
OUTB(12) <= ((FA(12) AND B(1))  OR 
           (FA(28) AND B(2))  OR 
		 (FB(12) AND B(3))  OR 
		 (FB(28) AND B(4))  OR
		 (FC(12) AND B(5))  OR 
		 (FC(28) AND B(6))  OR 
		 (FD(12) AND B(7))  OR 
		 (FD(28) AND B(8))  OR
           (FE(12) AND B(9))  OR 
		 (FE(28) AND B(10)) OR 
		 (FF(12) AND B(11)) OR 
		 (FF(28) AND B(12)) OR 
           (FG(12) AND B(13)) OR 
		 (FG(28) AND B(14)) OR
		 (FH(12) AND B(15)) OR 
		 (FH(28) AND B(16)) OR
		 (FI(12) AND B(17)) OR
		 (FI(28) AND B(18)));
		 
OUTB(13) <= ((FA(13) AND B(1))  OR 
           (FA(29) AND B(2))  OR 
		 (FB(13) AND B(3))  OR 
		 (FB(29) AND B(4))  OR
		 (FC(13) AND B(5))  OR 
		 (FC(29) AND B(6))  OR 
		 (FD(13) AND B(7))  OR 
		 (FD(29) AND B(8))  OR
           (FE(13) AND B(9))  OR 
		 (FE(29) AND B(10)) OR 
		 (FF(13) AND B(11)) OR 
		 (FF(29) AND B(12)) OR 
           (FG(13) AND B(13)) OR 
		 (FG(29) AND B(14)) OR
		 (FH(13) AND B(15)) OR 
		 (FH(29) AND B(16)) OR
		 (FI(13) AND B(17)) OR
		 (FI(29) AND B(18)));
		 
OUTB(14) <= ((FA(14) AND B(1))  OR 
           (FA(30) AND B(2))  OR 
		 (FB(14) AND B(3))  OR 
		 (FB(30) AND B(4))  OR
		 (FC(14) AND B(5))  OR 
		 (FC(30) AND B(6))  OR 
		 (FD(14) AND B(7))  OR 
		 (FD(30) AND B(8))  OR
           (FE(14) AND B(9))  OR 
		 (FE(30) AND B(10)) OR 
		 (FF(14) AND B(11)) OR 
		 (FF(30) AND B(12)) OR 
           (FG(14) AND B(13)) OR 
		 (FG(30) AND B(14)) OR
		 (FH(14) AND B(15)) OR 
		 (FH(30) AND B(16)) OR
		 (FI(14) AND B(17)) OR
		 (FI(30) AND B(18)));
		 
OUTB(15) <= ((FA(15) AND B(1))  OR 
           (FA(31) AND B(2))  OR 
		 (FB(15) AND B(3))  OR 
		 (FB(31) AND B(4))  OR
		 (FC(15) AND B(5))  OR 
		 (FC(31) AND B(6))  OR 
		 (FD(15) AND B(7))  OR 
		 (FD(31) AND B(8))  OR
           (FE(15) AND B(9))  OR 
		 (FE(31) AND B(10)) OR 
		 (FF(15) AND B(11)) OR 
		 (FF(31) AND B(12)) OR 
           (FG(15) AND B(13)) OR 
		 (FG(31) AND B(14)) OR
		 (FH(15) AND B(15)) OR 
		 (FH(31) AND B(16)) OR
		 (FI(15) AND B(17)) OR
		 (FI(31) AND B(18)));
		 
OUTB(16) <= ((SA(0) AND B(1))  OR 
           (SA(16) AND B(2))  OR 
		 (SB(0)  AND B(3))  OR 
		 (SB(16) AND B(4))  OR
		 (SC(0)  AND B(5))  OR 
		 (SC(16) AND B(6))  OR 
		 (SD(0)  AND B(7))  OR 
		 (SD(16) AND B(8))  OR
           (SE(0)  AND B(9))  OR 
		 (SE(16) AND B(10)) OR 
		 (SF(0)  AND B(11)) OR 
		 (SF(16) AND B(12)) OR 
           (SG(0)  AND B(13)) OR 
		 (SG(16) AND B(14)) OR
		 (SH(0)  AND B(15)) OR 
		 (SH(16) AND B(16)) OR
		 (SI(0)  AND B(17)) OR
		 (SI(16) AND B(18)));
		 
OUTB(17) <= ((SA(1)  AND B(1))  OR 
           (SA(17) AND B(2))  OR 
		 (SB(1)  AND B(3))  OR 
		 (SB(17) AND B(4))  OR
		 (SC(1)  AND B(5))  OR 
		 (SC(17) AND B(6))  OR 
		 (SD(1)  AND B(7))  OR 
		 (SD(17) AND B(8))  OR
           (SE(1)  AND B(9))  OR 
		 (SE(17) AND B(10)) OR 
		 (SF(1)  AND B(11)) OR 
		 (SF(17) AND B(12)) OR 
           (SG(1)  AND B(13)) OR 
		 (SG(17) AND B(14)) OR
		 (SH(1)  AND B(15)) OR 
		 (SH(17) AND B(16)) OR
		 (SI(1)  AND B(17)) OR
		 (SI(17) AND B(18)));
		 
OUTB(18) <= ((SA(2)  AND B(1))  OR 
           (SA(18) AND B(2))  OR 
		 (SB(2)  AND B(3))  OR 
		 (SB(18) AND B(4))  OR
		 (SC(2)  AND B(5))  OR 
		 (SC(18) AND B(6))  OR 
		 (SD(2)  AND B(7))  OR 
		 (SD(18) AND B(8))  OR
           (SE(2)  AND B(9))  OR 
		 (SE(18) AND B(10)) OR 
		 (SF(2)  AND B(11)) OR 
		 (SF(18) AND B(12)) OR 
           (SG(2)  AND B(13)) OR 
		 (SG(18) AND B(14)) OR
		 (SH(2)  AND B(15)) OR 
		 (SH(18) AND B(16)) OR
		 (SI(2)  AND B(17)) OR
		 (SI(18) AND B(18)));
		 
OUTB(19) <= ((SA(3)  AND B(1))  OR 
           (SA(19) AND B(2))  OR 
		 (SB(3)  AND B(3))  OR 
		 (SB(19) AND B(4))  OR
		 (SC(3)  AND B(5))  OR 
		 (SC(19) AND B(6))  OR 
		 (SD(3)  AND B(7))  OR 
		 (SD(19) AND B(8))  OR
           (SE(3)  AND B(9))  OR 
		 (SE(19) AND B(10)) OR 
		 (SF(3)  AND B(11)) OR 
		 (SF(19) AND B(12)) OR 
           (SG(3)  AND B(13)) OR 
		 (SG(19) AND B(14)) OR
		 (SH(3)  AND B(15)) OR 
		 (SH(19) AND B(16)) OR
		 (SI(3)  AND B(17)) OR
		 (SI(19) AND B(18)));
		 
OUTB(20) <= ((SA(4)  AND B(1))  OR 
           (SA(20) AND B(2))  OR 
		 (SB(4)  AND B(3))  OR 
		 (SB(20) AND B(4))  OR
		 (SC(4)  AND B(5))  OR 
		 (SC(20) AND B(6))  OR 
		 (SD(4)  AND B(7))  OR 
		 (SD(20) AND B(8))  OR
           (SE(4)  AND B(9))  OR 
		 (SE(20) AND B(10)) OR 
		 (SF(4)  AND B(11)) OR 
		 (SF(20) AND B(12)) OR 
           (SG(4)  AND B(13)) OR 
		 (SG(20) AND B(14)) OR
		 (SH(4)  AND B(15)) OR 
		 (SH(20) AND B(16)) OR
		 (SI(4)  AND B(17)) OR
		 (SI(20) AND B(18)));
		 
OUTB(21) <= ((SA(5)  AND B(1))  OR 
           (SA(21) AND B(2))  OR 
		 (SB(5)  AND B(3))  OR 
		 (SB(21) AND B(4))  OR
		 (SC(5)  AND B(5))  OR 
		 (SC(21) AND B(6))  OR 
		 (SD(5)  AND B(7))  OR 
		 (SD(21) AND B(8))  OR
           (SE(5)  AND B(9))  OR 
		 (SE(21) AND B(10)) OR 
		 (SF(5)  AND B(11)) OR 
		 (SF(21) AND B(12)) OR 
           (SG(5)  AND B(13)) OR 
		 (SG(21) AND B(14)) OR
		 (SH(5)  AND B(15)) OR 
		 (SH(21) AND B(16)) OR
		 (SI(5)  AND B(17)) OR
		 (SI(21) AND B(18)));

OUTB(22) <= ((SA(6)  AND B(1))  OR 
           (SA(22) AND B(2))  OR 
		 (SB(6)  AND B(3))  OR 
		 (SB(22) AND B(4))  OR
		 (SC(6)  AND B(5))  OR 
		 (SC(22) AND B(6))  OR 
		 (SD(6)  AND B(7))  OR 
		 (SD(22) AND B(8))  OR
           (SE(6)  AND B(9))  OR 
		 (SE(22) AND B(10)) OR 
		 (SF(6)  AND B(11)) OR 
		 (SF(22) AND B(12)) OR 
           (SG(6)  AND B(13)) OR 
		 (SG(22) AND B(14)) OR
		 (SH(6)  AND B(15)) OR 
		 (SH(22) AND B(16)) OR
		 (SI(6)  AND B(17)) OR
		 (SI(22) AND B(18)));

OUTB(23) <= ((SA(7)  AND B(1))  OR 
           (SA(23) AND B(2))  OR 
		 (SB(7)  AND B(3))  OR 
		 (SB(23) AND B(4))  OR
		 (SC(7)  AND B(5))  OR 
		 (SC(23) AND B(6))  OR 
		 (SD(7)  AND B(7))  OR 
		 (SD(23) AND B(8))  OR
           (SE(7)  AND B(9))  OR 
		 (SE(23) AND B(10)) OR 
		 (SF(7)  AND B(11)) OR 
		 (SF(23) AND B(12)) OR 
           (SG(7)  AND B(13)) OR 
		 (SG(23) AND B(14)) OR
		 (SH(7)  AND B(15)) OR 
		 (SH(23) AND B(16)) OR
		 (SI(7)  AND B(17)) OR
		 (SI(23) AND B(18)));
		 
OUTB(24) <= ((SA(8)  AND B(1))  OR 
           (SA(24) AND B(2))  OR 
		 (SB(8)  AND B(3))  OR 
		 (SB(24) AND B(4))  OR
		 (SC(8)  AND B(5))  OR 
		 (SC(24) AND B(6))  OR 
		 (SD(8)  AND B(7))  OR 
		 (SD(24) AND B(8))  OR
           (SE(8)  AND B(9))  OR 
		 (SE(24) AND B(10)) OR 
		 (SF(8)  AND B(11)) OR 
		 (SF(24) AND B(12)) OR 
           (SG(8)  AND B(13)) OR 
		 (SG(24) AND B(14)) OR
		 (SH(8)  AND B(15)) OR 
		 (SH(24) AND B(16)) OR
		 (SI(8)  AND B(17)) OR
		 (SI(24) AND B(18)));
		 
OUTB(25) <= ((SA(9)  AND B(1))  OR 
           (SA(25) AND B(2))  OR 
		 (SB(9)  AND B(3))  OR 
		 (SB(25) AND B(4))  OR
		 (SC(9)  AND B(5))  OR 
		 (SC(25) AND B(6))  OR 
		 (SD(9)  AND B(7))  OR 
		 (SD(25) AND B(8))  OR
           (SE(9)  AND B(9))  OR 
		 (SE(25) AND B(10)) OR 
		 (SF(9)  AND B(11)) OR 
		 (SF(25) AND B(12)) OR 
           (SG(9)  AND B(13)) OR 
		 (SG(25) AND B(14)) OR
		 (SH(9)  AND B(15)) OR 
		 (SH(25) AND B(16)) OR
		 (SI(9)  AND B(17)) OR
		 (SI(25) AND B(18)));

OUTB(26) <= ((SA(10)  AND B(1))  OR 
           (SA(26) AND B(2))  OR 
		 (SB(10) AND B(3))  OR 
		 (SB(26) AND B(4))  OR
		 (SC(10) AND B(5))  OR 
		 (SC(26) AND B(6))  OR 
		 (SD(10) AND B(7))  OR 
		 (SD(26) AND B(8))  OR
           (SE(10) AND B(9))  OR 
		 (SE(26) AND B(10)) OR 
		 (SF(10) AND B(11)) OR 
		 (SF(26) AND B(12)) OR 
           (SG(10) AND B(13)) OR 
		 (SG(26) AND B(14)) OR
		 (SH(10) AND B(15)) OR 
		 (SH(26) AND B(16)) OR
		 (SI(10) AND B(17)) OR
		 (SI(26) AND B(18)));

OUTB(27) <= (SA(11)  OR 
       SA(27)   OR 
		 SB(11)   OR 
		 SB(27)   OR
		 SC(11)   OR 
		 SC(27)   OR 
		 SD(11)   OR 
		 SD(27)   OR
       SE(11)   OR 
		 SE(27)   OR 
		 SF(11)   OR 
		 SF(27)   OR 
       SG(11)   OR 
		 SG(27)   OR
		 SH(11)   OR 
		 SH(27)   OR
		 SI(11)   OR
		 SI(27));

--OUTB(27) <= (((SA(11) AND B(1)) OR 
--       (SA(27) AND B(2))   OR 
--		 (SB(11) AND B(3))   OR 
--		 (SB(27) AND B(4))   OR
--		 (SC(11) AND B(5))   OR 
--		 (SC(27) AND B(6))   OR 
--		 (SD(11) AND B(7))  OR 
--		 (SD(27) AND B(8))  OR
--       (SE(11) AND B(9))  OR 
--		 (SE(27) AND B(10))  OR 
--		 (SF(11) AND B(11))  OR 
--		 (SF(27) AND B(12))  OR 
--       (SG(11) AND B(13))  OR 
--		 (SG(27) AND B(14))  OR
--		 (SH(11) AND B(15))  OR 
--		 (SH(27) AND B(16))  OR
--		 (SI(11) AND B(17))  OR
--		 (SI(27) AND B(18))) AND NOT SWITCH) OR
--		 (((SA(11) AND CONB(1)) OR
--		 (SA(27) AND CONB(2)) OR
--		 (SB(11) AND CONB(3)) OR
--		 (SB(27) AND CONB(4)) OR
--		 (SC(11) AND CONB(5)) OR
--		 (SC(27) AND CONB(6)) OR
-- 	 (SD(11) AND CONB(7)) OR
--		 (SD(27) AND CONB(8)) OR
--		 (SE(11) AND CONB(9)) OR
--		 (SE(27) AND CONB(10)) OR
--		 (SF(11) AND CONB(11)) OR
--		 (SF(27) AND CONB(12)) OR
--		 (SG(11) AND CONB(13)) OR
--		 (SG(27) AND CONB(14)) OR
--		 (SH(11) AND CONB(15)) OR
--		 (SH(27) AND CONB(16)) OR
--		 (SI(11) AND CONB(17)) OR
--		 (SI(27) AND CONB(18))) AND SWITCH); 

OUTB(28) <= ((SA(12)  AND B(1))  OR 
           (SA(28) AND B(2))  OR 
		 (SB(12) AND B(3))  OR 
		 (SB(28) AND B(4))  OR
		 (SC(12) AND B(5))  OR 
		 (SC(28) AND B(6))  OR 
		 (SD(12) AND B(7))  OR 
		 (SD(28) AND B(8))  OR
           (SE(12) AND B(9))  OR 
		 (SE(28) AND B(10)) OR 
		 (SF(12) AND B(11)) OR 
		 (SF(28) AND B(12)) OR 
           (SG(12) AND B(13)) OR 
		 (SG(28) AND B(14)) OR
		 (SH(12) AND B(15)) OR 
		 (SH(28) AND B(16)) OR
		 (SI(12) AND B(17)) OR
		 (SI(28) AND B(18)));

OUTB(29) <= ((SA(13)  AND B(1))  OR 
           (SA(29) AND B(2))  OR 
		 (SB(13) AND B(3))  OR 
		 (SB(29) AND B(4))  OR
		 (SC(13) AND B(5))  OR 
		 (SC(29) AND B(6))  OR 
		 (SD(13) AND B(7))  OR 
		 (SD(29) AND B(8))  OR
           (SE(13) AND B(9))  OR 
		 (SE(29) AND B(10)) OR 
		 (SF(13) AND B(11)) OR 
		 (SF(29) AND B(12)) OR 
           (SG(13) AND B(13)) OR 
		 (SG(29) AND B(14)) OR
		 (SH(13) AND B(15)) OR 
		 (SH(29) AND B(16)) OR
		 (SI(13) AND B(17)) OR
		 (SI(29) AND B(18)));
		 
OUTB(30) <= ((SA(14)  AND B(1))  OR 
           (SA(30) AND B(2))  OR 
		 (SB(14) AND B(3))  OR 
		 (SB(30) AND B(4))  OR
		 (SC(14) AND B(5))  OR 
		 (SC(30) AND B(6))  OR 
		 (SD(14) AND B(7))  OR 
		 (SD(30) AND B(8))  OR
           (SE(14) AND B(9))  OR 
		 (SE(30) AND B(10)) OR 
		 (SF(14) AND B(11)) OR 
		 (SF(30) AND B(12)) OR 
           (SG(14) AND B(13)) OR 
		 (SG(30) AND B(14)) OR
		 (SH(14) AND B(15)) OR 
		 (SH(30) AND B(16)) OR
		 (SI(14) AND B(17)) OR
		 (SI(30) AND B(18)));

OUTB(31) <= ((SA(15)  AND B(1))  OR 
           (SA(31) AND B(2))  OR 
		 (SB(15) AND B(3))  OR 
		 (SB(31) AND B(4))  OR
		 (SC(15) AND B(5))  OR 
		 (SC(31) AND B(6))  OR 
		 (SD(15) AND B(7))  OR 
		 (SD(31) AND B(8))  OR
           (SE(15) AND B(9))  OR 
		 (SE(31) AND B(10)) OR 
		 (SF(15) AND B(11)) OR 
		 (SF(31) AND B(12)) OR 
           (SG(15) AND B(13)) OR 
		 (SG(31) AND B(14)) OR
		 (SH(15) AND B(15)) OR 
		 (SH(31) AND B(16)) OR
		 (SI(15) AND B(17)) OR
		 (SI(31) AND B(18)));
		 
-- THIRD BEST 

OUTC(0) <= ((FA(0)  AND C(1))  OR 
           (FA(16) AND C(2))  OR 
		 (FB(0)  AND C(3))  OR 
		 (FB(16) AND C(4))  OR
		 (FC(0)  AND C(5))  OR 
		 (FC(16) AND C(6))  OR 
		 (FD(0)  AND C(7))  OR 
		 (FD(16) AND C(8))  OR
           (FE(0)  AND C(9))  OR 
		 (FE(16) AND C(10)) OR 
		 (FF(0)  AND C(11)) OR 
		 (FF(16) AND C(12)) OR 
           (FG(0)  AND C(13)) OR 
		 (FG(16) AND C(14)) OR
		 (FH(0)  AND C(15)) OR 
		 (FH(16) AND C(16)) OR
		 (FI(0)  AND C(17)) OR
		 (FI(16) AND C(18)));

OUTC(1) <= ((FA(1)  AND C(1))  OR 
           (FA(17) AND C(2))  OR 
		 (FB(1)  AND C(3))  OR 
		 (FB(17) AND C(4))  OR
		 (FC(1)  AND C(5))  OR 
		 (FC(17) AND C(6))  OR 
		 (FD(1)  AND C(7))  OR 
		 (FD(17) AND C(8))  OR
           (FE(1)  AND C(9))  OR 
		 (FE(17) AND C(10)) OR 
		 (FF(1)  AND C(11)) OR 
		 (FF(17) AND C(12)) OR 
           (FG(1)  AND C(13)) OR 
		 (FG(17) AND C(14)) OR
		 (FH(1)  AND C(15)) OR 
		 (FH(17) AND C(16)) OR
		 (FI(1)  AND C(17)) OR
		 (FI(17) AND C(18)));

OUTC(2) <= ((FA(2)  AND C(1))  OR 
           (FA(18) AND C(2))  OR 
		 (FB(2)  AND C(3))  OR 
		 (FB(18) AND C(4))  OR
		 (FC(2)  AND C(5))  OR 
		 (FC(18) AND C(6))  OR 
		 (FD(2)  AND C(7))  OR 
		 (FD(18) AND C(8))  OR
           (FE(2)  AND C(9))  OR 
		 (FE(18) AND C(10)) OR 
		 (FF(2)  AND C(11)) OR 
		 (FF(18) AND C(12)) OR 
           (FG(2)  AND C(13)) OR 
		 (FG(18) AND C(14)) OR
		 (FH(2)  AND C(15)) OR 
		 (FH(18) AND C(16)) OR
		 (FI(2)  AND C(17)) OR
		 (FI(18) AND C(18)));

OUTC(3) <= ((FA(3)  AND C(1))  OR 
           (FA(19) AND C(2))  OR 
		 (FB(3)  AND C(3))  OR 
		 (FB(19) AND C(4))  OR
		 (FC(3)  AND C(5))  OR 
		 (FC(19) AND C(6))  OR 
		 (FD(3)  AND C(7))  OR 
		 (FD(19) AND C(8))  OR
           (FE(3)  AND C(9))  OR 
		 (FE(19) AND C(10)) OR 
		 (FF(3)  AND C(11)) OR 
		 (FF(19) AND C(12)) OR 
           (FG(3)  AND C(13)) OR 
		 (FG(19) AND C(14)) OR
		 (FH(3)  AND C(15)) OR 
		 (FH(19) AND C(16)) OR
		 (FI(3)  AND C(17)) OR
		 (FI(19) AND C(18)));
		 
OUTC(4) <= ((FA(4)  AND C(1))  OR 
           (FA(20) AND C(2))  OR 
		 (FB(4)  AND C(3))  OR 
		 (FB(20) AND C(4))  OR
		 (FC(4)  AND C(5))  OR 
		 (FC(20) AND C(6))  OR 
		 (FD(4)  AND C(7))  OR 
		 (FD(20) AND C(8))  OR
           (FE(4)  AND C(9))  OR 
		 (FE(20) AND C(10)) OR 
		 (FF(4)  AND C(11)) OR 
		 (FF(20) AND C(12)) OR 
           (FG(4)  AND C(13)) OR 
		 (FG(20) AND C(14)) OR
		 (FH(4)  AND C(15)) OR 
		 (FH(20) AND C(16)) OR
		 (FI(4)  AND C(17)) OR
		 (FI(20) AND C(18)));

OUTC(5) <= ((FA(5)  AND C(1))  OR 
           (FA(21) AND C(2))  OR 
		 (FB(5)  AND C(3))  OR 
		 (FB(21) AND C(4))  OR
		 (FC(5)  AND C(5))  OR 
		 (FC(21) AND C(6))  OR 
		 (FD(5)  AND C(7))  OR 
		 (FD(21) AND C(8))  OR
           (FE(5)  AND C(9))  OR 
		 (FE(21) AND C(10)) OR 
		 (FF(5)  AND C(11)) OR 
		 (FF(21) AND C(12)) OR 
           (FG(5)  AND C(13)) OR 
		 (FG(21) AND C(14)) OR
		 (FH(5)  AND C(15)) OR 
		 (FH(21) AND C(16)) OR
		 (FI(5)  AND C(17)) OR
		 (FI(21) AND C(18)));

OUTC(6) <= ((FA(6)  AND C(1))  OR 
           (FA(22) AND C(2))  OR 
		 (FB(6)  AND C(3))  OR 
		 (FB(22) AND C(4))  OR
		 (FC(6)  AND C(5))  OR 
		 (FC(22) AND C(6))  OR 
		 (FD(6)  AND C(7))  OR 
		 (FD(22) AND C(8))  OR
           (FE(6)  AND C(9))  OR 
		 (FE(22) AND C(10)) OR 
		 (FF(6)  AND C(11)) OR 
		 (FF(22) AND C(12)) OR 
           (FG(6)  AND C(13)) OR 
		 (FG(22) AND C(14)) OR
		 (FH(6)  AND C(15)) OR 
		 (FH(22) AND C(16)) OR
		 (FI(6)  AND C(17)) OR
		 (FI(22) AND C(18)));

OUTC(7) <= ((FA(7)  AND C(1))  OR 
           (FA(23) AND C(2))  OR 
		 (FB(7)  AND C(3))  OR 
		 (FB(23) AND C(4))  OR
		 (FC(7)  AND C(5))  OR 
		 (FC(23) AND C(6))  OR 
		 (FD(7)  AND C(7))  OR 
		 (FD(23) AND C(8))  OR
           (FE(7)  AND C(9))  OR 
		 (FE(23) AND C(10)) OR 
		 (FF(7)  AND C(11)) OR 
		 (FF(23) AND C(12)) OR 
           (FG(7)  AND C(13)) OR 
		 (FG(23) AND C(14)) OR
		 (FH(7)  AND C(15)) OR 
		 (FH(23) AND C(16)) OR
		 (FI(7)  AND C(17)) OR
		 (FI(23) AND C(18)));

OUTC(8) <= ((FA(8)  AND C(1))  OR 
           (FA(24) AND C(2))  OR 
		 (FB(8)  AND C(3))  OR 
		 (FB(24) AND C(4))  OR
		 (FC(8)  AND C(5))  OR 
		 (FC(24) AND C(6))  OR 
		 (FD(8)  AND C(7))  OR 
		 (FD(24) AND C(8))  OR
           (FE(8)  AND C(9))  OR 
		 (FE(24) AND C(10)) OR 
		 (FF(8)  AND C(11)) OR 
		 (FF(24) AND C(12)) OR 
           (FG(8)  AND C(13)) OR 
		 (FG(24) AND C(14)) OR
		 (FH(8)  AND C(15)) OR 
		 (FH(24) AND C(16)) OR
		 (FI(8)  AND C(17)) OR
		 (FI(24) AND C(18)));

OUTC(9) <= ((FA(9)  AND C(1))  OR 
           (FA(25) AND C(2))  OR 
		 (FB(9)  AND C(3))  OR 
		 (FB(25) AND C(4))  OR
		 (FC(9)  AND C(5))  OR 
		 (FC(25) AND C(6))  OR 
		 (FD(9)  AND C(7))  OR 
		 (FD(25) AND C(8))  OR
           (FE(9)  AND C(9))  OR 
		 (FE(25) AND C(10)) OR 
		 (FF(9)  AND C(11)) OR 
		 (FF(25) AND C(12)) OR 
           (FG(9)  AND C(13)) OR 
		 (FG(25) AND C(14)) OR
		 (FH(9)  AND C(15)) OR 
		 (FH(25) AND C(16)) OR
		 (FI(9)  AND C(17)) OR
		 (FI(25) AND C(18)));

OUTC(10) <= ((FA(10)  AND C(1))  OR 
           (FA(26) AND C(2))  OR 
		 (FB(10) AND C(3))  OR 
		 (FB(26) AND C(4))  OR
		 (FC(10) AND C(5))  OR 
		 (FC(26) AND C(6))  OR 
		 (FD(10) AND C(7))  OR 
		 (FD(26) AND C(8))  OR
           (FE(10) AND C(9))  OR 
		 (FE(26) AND C(10)) OR 
		 (FF(10) AND C(11)) OR 
		 (FF(26) AND C(12)) OR 
           (FG(10) AND C(13)) OR 
		 (FG(26) AND C(14)) OR
		 (FH(10) AND C(15)) OR 
		 (FH(26) AND C(16)) OR
		 (FI(10) AND C(17)) OR
		 (FI(26) AND C(18)));

OUTC(11) <= ((FA(11)  AND C(1))  OR 
           (FA(27) AND C(2))  OR 
		 (FB(11) AND C(3))  OR 
		 (FB(27) AND C(4))  OR
		 (FC(11) AND C(5))  OR 
		 (FC(27) AND C(6))  OR 
		 (FD(11) AND C(7))  OR 
		 (FD(27) AND C(8))  OR
           (FE(11) AND C(9))  OR 
		 (FE(27) AND C(10)) OR 
		 (FF(11) AND C(11)) OR 
		 (FF(27) AND C(12)) OR 
           (FG(11) AND C(13)) OR 
		 (FG(27) AND C(14)) OR
		 (FH(11) AND C(15)) OR 
		 (FH(27) AND C(16)) OR
		 (FI(11) AND C(17)) OR
		 (FI(27) AND C(18)));

OUTC(12) <= ((FA(12) AND C(1))  OR 
           (FA(28) AND C(2))  OR 
		 (FB(12) AND C(3))  OR 
		 (FB(28) AND C(4))  OR
		 (FC(12) AND C(5))  OR 
		 (FC(28) AND C(6))  OR 
		 (FD(12) AND C(7))  OR 
		 (FD(28) AND C(8))  OR
           (FE(12) AND C(9))  OR 
		 (FE(28) AND C(10)) OR 
		 (FF(12) AND C(11)) OR 
		 (FF(28) AND C(12)) OR 
           (FG(12) AND C(13)) OR 
		 (FG(28) AND C(14)) OR
		 (FH(12) AND C(15)) OR 
		 (FH(28) AND C(16)) OR
		 (FI(12) AND C(17)) OR
		 (FI(28) AND C(18)));

OUTC(13) <= ((FA(13) AND C(1))  OR 
           (FA(29) AND C(2))  OR 
		 (FB(13) AND C(3))  OR 
		 (FB(29) AND C(4))  OR
		 (FC(13) AND C(5))  OR 
		 (FC(29) AND C(6))  OR 
		 (FD(13) AND C(7))  OR 
		 (FD(29) AND C(8))  OR
           (FE(13) AND C(9))  OR 
		 (FE(29) AND C(10)) OR 
		 (FF(13) AND C(11)) OR 
		 (FF(29) AND C(12)) OR 
           (FG(13) AND C(13)) OR 
		 (FG(29) AND C(14)) OR
		 (FH(13) AND C(15)) OR 
		 (FH(29) AND C(16)) OR
		 (FI(13) AND C(17)) OR
		 (FI(29) AND C(18)));

OUTC(14) <= ((FA(14) AND C(1))  OR 
           (FA(30) AND C(2))  OR 
		 (FB(14) AND C(3))  OR 
		 (FB(30) AND C(4))  OR
		 (FC(14) AND C(5))  OR 
		 (FC(30) AND C(6))  OR 
		 (FD(14) AND C(7))  OR 
		 (FD(30) AND C(8))  OR
           (FE(14) AND C(9))  OR 
		 (FE(30) AND C(10)) OR 
		 (FF(14) AND C(11)) OR 
		 (FF(30) AND C(12)) OR 
           (FG(14) AND C(13)) OR 
		 (FG(30) AND C(14)) OR
		 (FH(14) AND C(15)) OR 
		 (FH(30) AND C(16)) OR
		 (FI(14) AND C(17)) OR
		 (FI(30) AND C(18)));
		 
OUTC(15) <= ((FA(15) AND C(1))  OR 
           (FA(31) AND C(2))  OR 
		 (FB(15) AND C(3))  OR 
		 (FB(31) AND C(4))  OR
		 (FC(15) AND C(5))  OR 
		 (FC(31) AND C(6))  OR 
		 (FD(15) AND C(7))  OR 
		 (FD(31) AND C(8))  OR
           (FE(15) AND C(9))  OR 
		 (FE(31) AND C(10)) OR 
		 (FF(15) AND C(11)) OR 
		 (FF(31) AND C(12)) OR 
           (FG(15) AND C(13)) OR 
		 (FG(31) AND C(14)) OR
		 (FH(15) AND C(15)) OR 
		 (FH(31) AND C(16)) OR
		 (FI(15) AND C(17)) OR
		 (FI(31) AND C(18)));
		 
OUTC(16) <= ((SA(0) AND C(1))  OR 
           (SA(16) AND C(2))  OR 
		 (SB(0)  AND C(3))  OR 
		 (SB(16) AND C(4))  OR
		 (SC(0)  AND C(5))  OR 
		 (SC(16) AND C(6))  OR 
		 (SD(0)  AND C(7))  OR 
		 (SD(16) AND C(8))  OR
           (SE(0)  AND C(9))  OR 
		 (SE(16) AND C(10)) OR 
		 (SF(0)  AND C(11)) OR 
		 (SF(16) AND C(12)) OR 
           (SG(0)  AND C(13)) OR 
		 (SG(16) AND C(14)) OR
		 (SH(0)  AND C(15)) OR 
		 (SH(16) AND C(16)) OR
		 (SI(0)  AND C(17)) OR
		 (SI(16) AND C(18)));
		 
OUTC(17) <= ((SA(1)  AND C(1))  OR 
           (SA(17) AND C(2))  OR 
		 (SB(1)  AND C(3))  OR 
		 (SB(17) AND C(4))  OR
		 (SC(1)  AND C(5))  OR 
		 (SC(17) AND C(6))  OR 
		 (SD(1)  AND C(7))  OR 
		 (SD(17) AND C(8))  OR
           (SE(1)  AND C(9))  OR 
		 (SE(17) AND C(10)) OR 
		 (SF(1)  AND C(11)) OR 
		 (SF(17) AND C(12)) OR 
           (SG(1)  AND C(13)) OR 
		 (SG(17) AND C(14)) OR
		 (SH(1)  AND C(15)) OR 
		 (SH(17) AND C(16)) OR
		 (SI(1)  AND C(17)) OR
		 (SI(17) AND C(18)));
		 
OUTC(18) <= ((SA(2)  AND C(1))  OR 
           (SA(18) AND C(2))  OR 
		 (SB(2)  AND C(3))  OR 
		 (SB(18) AND C(4))  OR
		 (SC(2)  AND C(5))  OR 
		 (SC(18) AND C(6))  OR 
		 (SD(2)  AND C(7))  OR 
		 (SD(18) AND C(8))  OR
           (SE(2)  AND C(9))  OR 
		 (SE(18) AND C(10)) OR 
		 (SF(2)  AND C(11)) OR 
		 (SF(18) AND C(12)) OR 
           (SG(2)  AND C(13)) OR 
		 (SG(18) AND C(14)) OR
		 (SH(2)  AND C(15)) OR 
		 (SH(18) AND C(16)) OR
		 (SI(2)  AND C(17)) OR
		 (SI(18) AND C(18)));

OUTC(19) <= ((SA(3)  AND C(1))  OR 
           (SA(19) AND C(2))  OR 
		 (SB(3)  AND C(3))  OR 
		 (SB(19) AND C(4))  OR
		 (SC(3)  AND C(5))  OR 
		 (SC(19) AND C(6))  OR 
		 (SD(3)  AND C(7))  OR 
		 (SD(19) AND C(8))  OR
           (SE(3)  AND C(9))  OR 
		 (SE(19) AND C(10)) OR 
		 (SF(3)  AND C(11)) OR 
		 (SF(19) AND C(12)) OR 
           (SG(3)  AND C(13)) OR 
		 (SG(19) AND C(14)) OR
		 (SH(3)  AND C(15)) OR 
		 (SH(19) AND C(16)) OR
		 (SI(3)  AND C(17)) OR
		 (SI(19) AND C(18)));

OUTC(20) <= ((SA(4)  AND C(1))  OR 
           (SA(20) AND C(2))  OR 
		 (SB(4)  AND C(3))  OR 
		 (SB(20) AND C(4))  OR
		 (SC(4)  AND C(5))  OR 
		 (SC(20) AND C(6))  OR 
		 (SD(4)  AND C(7))  OR 
		 (SD(20) AND C(8))  OR
           (SE(4)  AND C(9))  OR 
		 (SE(20) AND C(10)) OR 
		 (SF(4)  AND C(11)) OR 
		 (SF(20) AND C(12)) OR 
           (SG(4)  AND C(13)) OR 
		 (SG(20) AND C(14)) OR
		 (SH(4)  AND C(15)) OR 
		 (SH(20) AND C(16)) OR
		 (SI(4)  AND C(17)) OR
		 (SI(20) AND C(18)));

OUTC(21) <= ((SA(5)  AND C(1))  OR 
           (SA(21) AND C(2))  OR 
		 (SB(5)  AND C(3))  OR 
		 (SB(21) AND C(4))  OR
		 (SC(5)  AND C(5))  OR 
		 (SC(21) AND C(6))  OR 
		 (SD(5)  AND C(7))  OR 
		 (SD(21) AND C(8))  OR
           (SE(5)  AND C(9))  OR 
		 (SE(21) AND C(10)) OR 
		 (SF(5)  AND C(11)) OR 
		 (SF(21) AND C(12)) OR 
           (SG(5)  AND C(13)) OR 
		 (SG(21) AND C(14)) OR
		 (SH(5)  AND C(15)) OR 
		 (SH(21) AND C(16)) OR
		 (SI(5)  AND C(17)) OR
		 (SI(21) AND C(18)));
		 
OUTC(22) <= ((SA(6)  AND C(1))  OR 
           (SA(22) AND C(2))  OR 
		 (SB(6)  AND C(3))  OR 
		 (SB(22) AND C(4))  OR
		 (SC(6)  AND C(5))  OR 
		 (SC(22) AND C(6))  OR 
		 (SD(6)  AND C(7))  OR 
		 (SD(22) AND C(8))  OR
           (SE(6)  AND C(9))  OR 
		 (SE(22) AND C(10)) OR 
		 (SF(6)  AND C(11)) OR 
		 (SF(22) AND C(12)) OR 
           (SG(6)  AND C(13)) OR 
		 (SG(22) AND C(14)) OR
		 (SH(6)  AND C(15)) OR 
		 (SH(22) AND C(16)) OR
		 (SI(6)  AND C(17)) OR
		 (SI(22) AND C(18)));
		 
OUTC(23) <= ((SA(7)  AND C(1))  OR 
           (SA(23) AND C(2))  OR 
		 (SB(7)  AND C(3))  OR 
		 (SB(23) AND C(4))  OR
		 (SC(7)  AND C(5))  OR 
		 (SC(23) AND C(6))  OR 
		 (SD(7)  AND C(7))  OR 
		 (SD(23) AND C(8))  OR
           (SE(7)  AND C(9))  OR 
		 (SE(23) AND C(10)) OR 
		 (SF(7)  AND C(11)) OR 
		 (SF(23) AND C(12)) OR 
           (SG(7)  AND C(13)) OR 
		 (SG(23) AND C(14)) OR
		 (SH(7)  AND C(15)) OR 
		 (SH(23) AND C(16)) OR
		 (SI(7)  AND C(17)) OR
		 (SI(23) AND C(18)));
		 
OUTC(24) <= ((SA(8)  AND C(1))  OR 
           (SA(24) AND C(2))  OR 
		 (SB(8)  AND C(3))  OR 
		 (SB(24) AND C(4))  OR
		 (SC(8)  AND C(5))  OR 
		 (SC(24) AND C(6))  OR 
		 (SD(8)  AND C(7))  OR 
		 (SD(24) AND C(8))  OR
           (SE(8)  AND C(9))  OR 
		 (SE(24) AND C(10)) OR 
		 (SF(8)  AND C(11)) OR 
		 (SF(24) AND C(12)) OR 
           (SG(8)  AND C(13)) OR 
		 (SG(24) AND C(14)) OR
		 (SH(8)  AND C(15)) OR 
		 (SH(24) AND C(16)) OR
		 (SI(8)  AND C(17)) OR
		 (SI(24) AND C(18)));
		 
OUTC(25) <= ((SA(9)  AND C(1))  OR 
           (SA(25) AND C(2))  OR 
		 (SB(9)  AND C(3))  OR 
		 (SB(25) AND C(4))  OR
		 (SC(9)  AND C(5))  OR 
		 (SC(25) AND C(6))  OR 
		 (SD(9)  AND C(7))  OR 
		 (SD(25) AND C(8))  OR
           (SE(9)  AND C(9))  OR 
		 (SE(25) AND C(10)) OR 
		 (SF(9)  AND C(11)) OR 
		 (SF(25) AND C(12)) OR 
           (SG(9)  AND C(13)) OR 
		 (SG(25) AND C(14)) OR
		 (SH(9)  AND C(15)) OR 
		 (SH(25) AND C(16)) OR
		 (SI(9)  AND C(17)) OR
		 (SI(25) AND C(18)));
		 
OUTC(26) <= ((SA(10)  AND C(1))  OR 
           (SA(26) AND C(2))  OR 
		 (SB(10) AND C(3))  OR 
		 (SB(26) AND C(4))  OR
		 (SC(10) AND C(5))  OR 
		 (SC(26) AND C(6))  OR 
		 (SD(10) AND C(7))  OR 
		 (SD(26) AND C(8))  OR
           (SE(10) AND C(9))  OR 
		 (SE(26) AND C(10)) OR 
		 (SF(10) AND C(11)) OR 
		 (SF(26) AND C(12)) OR 
           (SG(10) AND C(13)) OR 
		 (SG(26) AND C(14)) OR
		 (SH(10) AND C(15)) OR 
		 (SH(26) AND C(16)) OR
		 (SI(10) AND C(17)) OR
		 (SI(26) AND C(18)));
		 
OUTC(27) <= (SA(11)  OR 
       SA(27)   OR 
		 SB(11)   OR 
		 SB(27)   OR
		 SC(11)   OR 
		 SC(27)   OR 
		 SD(11)   OR 
		 SD(27)   OR
       SE(11)   OR 
		 SE(27)   OR 
		 SF(11)   OR 
		 SF(27)   OR 
       SG(11)   OR 
		 SG(27)   OR
		 SH(11)   OR 
		 SH(27)   OR
		 SI(11)   OR
		 SI(27));
		 
--OUTC(27) <= (((SA(11) AND C(1)) OR 
--       (SA(27) AND C(2))   OR 
--		 (SB(11) AND C(3))   OR 
--		 (SB(27) AND C(4))   OR
--		 (SC(11) AND C(5))   OR 
--		 (SC(27) AND C(6))   OR 
--		 (SD(11) AND C(7))  OR 
--		 (SD(27) AND C(8))  OR
--      (SE(11) AND C(9))  OR 
--		 (SE(27) AND C(10))  OR 
--		 (SF(11) AND C(11))  OR 
--		 (SF(27) AND C(12))  OR 
--      (SG(11) AND C(13))  OR 
--		 (SG(27) AND C(14))  OR
--		 (SH(11) AND C(15))  OR 
--		 (SH(27) AND C(16))  OR
--		 (SI(11) AND C(17))  OR
--		 (SI(27) AND C(18))) AND NOT SWITCH) OR
--		 (((SA(11) AND CONC(1)) OR
--		 (SA(27) AND CONC(2)) OR
--		 (SB(11) AND CONC(3)) OR
--		 (SB(27) AND CONC(4)) OR
--		 (SC(11) AND CONC(5)) OR
--		 (SC(27) AND CONC(6)) OR
--		 (SD(11) AND CONC(7)) OR
--		 (SD(27) AND CONC(8)) OR
--		 (SE(11) AND CONC(9)) OR
--		 (SE(27) AND CONC(10)) OR
--		 (SF(11) AND CONC(11)) OR
--		 (SF(27) AND CONC(12)) OR
--		 (SG(11) AND CONC(13)) OR
--		 (SG(27) AND CONC(14)) OR
--		 (SH(11) AND CONC(15)) OR
--		 (SH(27) AND CONC(16)) OR
--		 (SI(11) AND CONC(17)) OR
--		 (SI(27) AND CONC(18))) AND SWITCH); 

OUTC(28) <= ((SA(12)  AND C(1))  OR 
           (SA(28) AND C(2))  OR 
		 (SB(12) AND C(3))  OR 
		 (SB(28) AND C(4))  OR
		 (SC(12) AND C(5))  OR 
		 (SC(28) AND C(6))  OR 
		 (SD(12) AND C(7))  OR 
		 (SD(28) AND C(8))  OR
           (SE(12) AND C(9))  OR 
		 (SE(28) AND C(10)) OR 
		 (SF(12) AND C(11)) OR 
		 (SF(28) AND C(12)) OR 
           (SG(12) AND C(13)) OR 
		 (SG(28) AND C(14)) OR
		 (SH(12) AND C(15)) OR 
		 (SH(28) AND C(16)) OR
		 (SI(12) AND C(17)) OR
		 (SI(28) AND C(18)));
		 
OUTC(29) <= ((SA(13)  AND C(1))  OR 
           (SA(29) AND C(2))  OR 
		 (SB(13) AND C(3))  OR 
		 (SB(29) AND C(4))  OR
		 (SC(13) AND C(5))  OR 
		 (SC(29) AND C(6))  OR 
		 (SD(13) AND C(7))  OR 
		 (SD(29) AND C(8))  OR
           (SE(13) AND C(9))  OR 
		 (SE(29) AND C(10)) OR 
		 (SF(13) AND C(11)) OR 
		 (SF(29) AND C(12)) OR 
           (SG(13) AND C(13)) OR 
		 (SG(29) AND C(14)) OR
		 (SH(13) AND C(15)) OR 
		 (SH(29) AND C(16)) OR
		 (SI(13) AND C(17)) OR
		 (SI(29) AND C(18)));
		 
OUTC(30) <= ((SA(14)  AND C(1))  OR 
           (SA(30) AND C(2))  OR 
		 (SB(14) AND C(3))  OR 
		 (SB(30) AND C(4))  OR
		 (SC(14) AND C(5))  OR 
		 (SC(30) AND C(6))  OR 
		 (SD(14) AND C(7))  OR 
		 (SD(30) AND C(8))  OR
           (SE(14) AND C(9))  OR 
		 (SE(30) AND C(10)) OR 
		 (SF(14) AND C(11)) OR 
		 (SF(30) AND C(12)) OR 
           (SG(14) AND C(13)) OR 
		 (SG(30) AND C(14)) OR
		 (SH(14) AND C(15)) OR 
		 (SH(30) AND C(16)) OR
		 (SI(14) AND C(17)) OR
		 (SI(30) AND C(18)));
		 
OUTC(31) <= ((SA(15)  AND C(1))  OR 
           (SA(31) AND C(2))  OR 
		 (SB(15) AND C(3))  OR 
		 (SB(31) AND C(4))  OR
		 (SC(15) AND C(5))  OR 
		 (SC(31) AND C(6))  OR 
		 (SD(15) AND C(7))  OR 
		 (SD(31) AND C(8))  OR
           (SE(15) AND C(9))  OR 
		 (SE(31) AND C(10)) OR 
		 (SF(15) AND C(11)) OR 
		 (SF(31) AND C(12)) OR 
           (SG(15) AND C(13)) OR 
		 (SG(31) AND C(14)) OR
		 (SH(15) AND C(15)) OR 
		 (SH(31) AND C(16)) OR
		 (SI(15) AND C(17)) OR
		 (SI(31) AND C(18)));

-- FOURTH BEST 

OUTD(0) <= ((FA(0)  AND D(1))  OR 
           (FA(16) AND D(2))  OR 
		 (FB(0)  AND D(3))  OR 
		 (FB(16) AND D(4))  OR
		 (FC(0)  AND D(5))  OR 
		 (FC(16) AND D(6))  OR 
		 (FD(0)  AND D(7))  OR 
		 (FD(16) AND D(8))  OR
           (FE(0)  AND D(9))  OR 
		 (FE(16) AND D(10)) OR 
		 (FF(0)  AND D(11)) OR 
		 (FF(16) AND D(12)) OR 
           (FG(0)  AND D(13)) OR 
		 (FG(16) AND D(14)) OR
		 (FH(0)  AND D(15)) OR 
		 (FH(16) AND D(16)) OR
		 (FI(0)  AND D(17)) OR
		 (FI(16) AND D(18)));

OUTD(1) <= ((FA(1)  AND D(1))  OR 
           (FA(17) AND D(2))  OR 
		 (FB(1)  AND D(3))  OR 
		 (FB(17) AND D(4))  OR
		 (FC(1)  AND D(5))  OR 
		 (FC(17) AND D(6))  OR 
		 (FD(1)  AND D(7))  OR 
		 (FD(17) AND D(8))  OR
           (FE(1)  AND D(9))  OR 
		 (FE(17) AND D(10)) OR 
		 (FF(1)  AND D(11)) OR 
		 (FF(17) AND D(12)) OR 
           (FG(1)  AND D(13)) OR 
		 (FG(17) AND D(14)) OR
		 (FH(1)  AND D(15)) OR 
		 (FH(17) AND D(16)) OR
		 (FI(1)  AND D(17)) OR
		 (FI(17) AND D(18)));

OUTD(2) <= ((FA(2)  AND D(1))  OR 
           (FA(18) AND D(2))  OR 
		 (FB(2)  AND D(3))  OR 
		 (FB(18) AND D(4))  OR
		 (FC(2)  AND D(5))  OR 
		 (FC(18) AND D(6))  OR 
		 (FD(2)  AND D(7))  OR 
		 (FD(18) AND D(8))  OR
           (FE(2)  AND D(9))  OR 
		 (FE(18) AND D(10)) OR 
		 (FF(2)  AND D(11)) OR 
		 (FF(18) AND D(12)) OR 
           (FG(2)  AND D(13)) OR 
		 (FG(18) AND D(14)) OR
		 (FH(2)  AND D(15)) OR 
		 (FH(18) AND D(16)) OR
		 (FI(2)  AND D(17)) OR
		 (FI(18) AND D(18)));

OUTD(3) <= ((FA(3)  AND D(1))  OR 
           (FA(19) AND D(2))  OR 
		 (FB(3)  AND D(3))  OR 
		 (FB(19) AND D(4))  OR
		 (FC(3)  AND D(5))  OR 
		 (FC(19) AND D(6))  OR 
		 (FD(3)  AND D(7))  OR 
		 (FD(19) AND D(8))  OR
           (FE(3)  AND D(9))  OR 
		 (FE(19) AND D(10)) OR 
		 (FF(3)  AND D(11)) OR 
		 (FF(19) AND D(12)) OR 
           (FG(3)  AND D(13)) OR 
		 (FG(19) AND D(14)) OR
		 (FH(3)  AND D(15)) OR 
		 (FH(19) AND D(16)) OR
		 (FI(3)  AND D(17)) OR
		 (FI(19) AND D(18)));
		 
OUTD(4) <= ((FA(4)  AND D(1))  OR 
           (FA(20) AND D(2))  OR 
		 (FB(4)  AND D(3))  OR 
		 (FB(20) AND D(4))  OR
		 (FC(4)  AND D(5))  OR 
		 (FC(20) AND D(6))  OR 
		 (FD(4)  AND D(7))  OR 
		 (FD(20) AND D(8))  OR
           (FE(4)  AND D(9))  OR 
		 (FE(20) AND D(10)) OR 
		 (FF(4)  AND D(11)) OR 
		 (FF(20) AND D(12)) OR 
           (FG(4)  AND D(13)) OR 
		 (FG(20) AND D(14)) OR
		 (FH(4)  AND D(15)) OR 
		 (FH(20) AND D(16)) OR
		 (FI(4)  AND D(17)) OR
		 (FI(20) AND D(18)));

OUTD(5) <= ((FA(5)  AND D(1))  OR 
           (FA(21) AND D(2))  OR 
		 (FB(5)  AND D(3))  OR 
		 (FB(21) AND D(4))  OR
		 (FC(5)  AND D(5))  OR 
		 (FC(21) AND D(6))  OR 
		 (FD(5)  AND D(7))  OR 
		 (FD(21) AND D(8))  OR
           (FE(5)  AND D(9))  OR 
		 (FE(21) AND D(10)) OR 
		 (FF(5)  AND D(11)) OR 
		 (FF(21) AND D(12)) OR 
           (FG(5)  AND D(13)) OR 
		 (FG(21) AND D(14)) OR
		 (FH(5)  AND D(15)) OR 
		 (FH(21) AND D(16)) OR
		 (FI(5)  AND D(17)) OR
		 (FI(21) AND D(18)));

OUTD(6) <= ((FA(6)  AND D(1))  OR 
           (FA(22) AND D(2))  OR 
		 (FB(6)  AND D(3))  OR 
		 (FB(22) AND D(4))  OR
		 (FC(6)  AND D(5))  OR 
		 (FC(22) AND D(6))  OR 
		 (FD(6)  AND D(7))  OR 
		 (FD(22) AND D(8))  OR
           (FE(6)  AND D(9))  OR 
		 (FE(22) AND D(10)) OR 
		 (FF(6)  AND D(11)) OR 
		 (FF(22) AND D(12)) OR 
           (FG(6)  AND D(13)) OR 
		 (FG(22) AND D(14)) OR
		 (FH(6)  AND D(15)) OR 
		 (FH(22) AND D(16)) OR
		 (FI(6)  AND D(17)) OR
		 (FI(22) AND D(18)));

OUTD(7) <= ((FA(7)  AND D(1))  OR 
           (FA(23) AND D(2))  OR 
		 (FB(7)  AND D(3))  OR 
		 (FB(23) AND D(4))  OR
		 (FC(7)  AND D(5))  OR 
		 (FC(23) AND D(6))  OR 
		 (FD(7)  AND D(7))  OR 
		 (FD(23) AND D(8))  OR
           (FE(7)  AND D(9))  OR 
		 (FE(23) AND D(10)) OR 
		 (FF(7)  AND D(11)) OR 
		 (FF(23) AND D(12)) OR 
           (FG(7)  AND D(13)) OR 
		 (FG(23) AND D(14)) OR
		 (FH(7)  AND D(15)) OR 
		 (FH(23) AND D(16)) OR
		 (FI(7)  AND D(17)) OR
		 (FI(23) AND D(18)));

OUTD(8) <= ((FA(8)  AND D(1))  OR 
           (FA(24) AND D(2))  OR 
		 (FB(8)  AND D(3))  OR 
		 (FB(24) AND D(4))  OR
		 (FC(8)  AND D(5))  OR 
		 (FC(24) AND D(6))  OR 
		 (FD(8)  AND D(7))  OR 
		 (FD(24) AND D(8))  OR
           (FE(8)  AND D(9))  OR 
		 (FE(24) AND D(10)) OR 
		 (FF(8)  AND D(11)) OR 
		 (FF(24) AND D(12)) OR 
           (FG(8)  AND D(13)) OR 
		 (FG(24) AND D(14)) OR
		 (FH(8)  AND D(15)) OR 
		 (FH(24) AND D(16)) OR
		 (FI(8)  AND D(17)) OR
		 (FI(24) AND D(18)));

OUTD(9) <= ((FA(9)  AND D(1))  OR 
           (FA(25) AND D(2))  OR 
		 (FB(9)  AND D(3))  OR 
		 (FB(25) AND D(4))  OR
		 (FC(9)  AND D(5))  OR 
		 (FC(25) AND D(6))  OR 
		 (FD(9)  AND D(7))  OR 
		 (FD(25) AND D(8))  OR
           (FE(9)  AND D(9))  OR 
		 (FE(25) AND D(10)) OR 
		 (FF(9)  AND D(11)) OR 
		 (FF(25) AND D(12)) OR 
           (FG(9)  AND D(13)) OR 
		 (FG(25) AND D(14)) OR
		 (FH(9)  AND D(15)) OR 
		 (FH(25) AND D(16)) OR
		 (FI(9)  AND D(17)) OR
		 (FI(25) AND D(18)));

OUTD(10) <= ((FA(10)  AND D(1))  OR 
           (FA(26) AND D(2))  OR 
		 (FB(10) AND D(3))  OR 
		 (FB(26) AND D(4))  OR
		 (FC(10) AND D(5))  OR 
		 (FC(26) AND D(6))  OR 
		 (FD(10) AND D(7))  OR 
		 (FD(26) AND D(8))  OR
           (FE(10) AND D(9))  OR 
		 (FE(26) AND D(10)) OR 
		 (FF(10) AND D(11)) OR 
		 (FF(26) AND D(12)) OR 
           (FG(10) AND D(13)) OR 
		 (FG(26) AND D(14)) OR
		 (FH(10) AND D(15)) OR 
		 (FH(26) AND D(16)) OR
		 (FI(10) AND D(17)) OR
		 (FI(26) AND D(18)));

OUTD(11) <= ((FA(11)  AND D(1))  OR 
           (FA(27) AND D(2))  OR 
		 (FB(11) AND D(3))  OR 
		 (FB(27) AND D(4))  OR
		 (FC(11) AND D(5))  OR 
		 (FC(27) AND D(6))  OR 
		 (FD(11) AND D(7))  OR 
		 (FD(27) AND D(8))  OR
           (FE(11) AND D(9))  OR 
		 (FE(27) AND D(10)) OR 
		 (FF(11) AND D(11)) OR 
		 (FF(27) AND D(12)) OR 
           (FG(11) AND D(13)) OR 
		 (FG(27) AND D(14)) OR
		 (FH(11) AND D(15)) OR 
		 (FH(27) AND D(16)) OR
		 (FI(11) AND D(17)) OR
		 (FI(27) AND D(18)));

OUTD(12) <= ((FA(12) AND D(1))  OR 
           (FA(28) AND D(2))  OR 
		 (FB(12) AND D(3))  OR 
		 (FB(28) AND D(4))  OR
		 (FC(12) AND D(5))  OR 
		 (FC(28) AND D(6))  OR 
		 (FD(12) AND D(7))  OR 
		 (FD(28) AND D(8))  OR
           (FE(12) AND D(9))  OR 
		 (FE(28) AND D(10)) OR 
		 (FF(12) AND D(11)) OR 
		 (FF(28) AND D(12)) OR 
           (FG(12) AND D(13)) OR 
		 (FG(28) AND D(14)) OR
		 (FH(12) AND D(15)) OR 
		 (FH(28) AND D(16)) OR
		 (FI(12) AND D(17)) OR
		 (FI(28) AND D(18)));

OUTD(13) <= ((FA(13) AND D(1))  OR 
           (FA(29) AND D(2))  OR 
		 (FB(13) AND D(3))  OR 
		 (FB(29) AND D(4))  OR
		 (FC(13) AND D(5))  OR 
		 (FC(29) AND D(6))  OR 
		 (FD(13) AND D(7))  OR 
		 (FD(29) AND D(8))  OR
           (FE(13) AND D(9))  OR 
		 (FE(29) AND D(10)) OR 
		 (FF(13) AND D(11)) OR 
		 (FF(29) AND D(12)) OR 
           (FG(13) AND D(13)) OR 
		 (FG(29) AND D(14)) OR
		 (FH(13) AND D(15)) OR 
		 (FH(29) AND D(16)) OR
		 (FI(13) AND D(17)) OR
		 (FI(29) AND D(18)));

OUTD(14) <= ((FA(14) AND D(1))  OR 
           (FA(30) AND D(2))  OR 
		 (FB(14) AND D(3))  OR 
		 (FB(30) AND D(4))  OR
		 (FC(14) AND D(5))  OR 
		 (FC(30) AND D(6))  OR 
		 (FD(14) AND D(7))  OR 
		 (FD(30) AND D(8))  OR
           (FE(14) AND D(9))  OR 
		 (FE(30) AND D(10)) OR 
		 (FF(14) AND D(11)) OR 
		 (FF(30) AND D(12)) OR 
           (FG(14) AND D(13)) OR 
		 (FG(30) AND D(14)) OR
		 (FH(14) AND D(15)) OR 
		 (FH(30) AND D(16)) OR
		 (FI(14) AND D(17)) OR
		 (FI(30) AND D(18)));
		 
OUTD(15) <= ((FA(15) AND D(1))  OR 
           (FA(31) AND D(2))  OR 
		 (FB(15) AND D(3))  OR 
		 (FB(31) AND D(4))  OR
		 (FC(15) AND D(5))  OR 
		 (FC(31) AND D(6))  OR 
		 (FD(15) AND D(7))  OR 
		 (FD(31) AND D(8))  OR
           (FE(15) AND D(9))  OR 
		 (FE(31) AND D(10)) OR 
		 (FF(15) AND D(11)) OR 
		 (FF(31) AND D(12)) OR 
           (FG(15) AND D(13)) OR 
		 (FG(31) AND D(14)) OR
		 (FH(15) AND D(15)) OR 
		 (FH(31) AND D(16)) OR
		 (FI(15) AND D(17)) OR
		 (FI(31) AND D(18)));
		 
OUTD(16) <= ((SA(0) AND D(1))  OR 
           (SA(16) AND D(2))  OR 
		 (SB(0)  AND D(3))  OR 
		 (SB(16) AND D(4))  OR
		 (SC(0)  AND D(5))  OR 
		 (SC(16) AND D(6))  OR 
		 (SD(0)  AND D(7))  OR 
		 (SD(16) AND D(8))  OR
           (SE(0)  AND D(9))  OR 
		 (SE(16) AND D(10)) OR 
		 (SF(0)  AND D(11)) OR 
		 (SF(16) AND D(12)) OR 
           (SG(0)  AND D(13)) OR 
		 (SG(16) AND D(14)) OR
		 (SH(0)  AND D(15)) OR 
		 (SH(16) AND D(16)) OR
		 (SI(0)  AND D(17)) OR
		 (SI(16) AND D(18)));
		 
OUTD(17) <= ((SA(1)  AND D(1))  OR 
           (SA(17) AND D(2))  OR 
		 (SB(1)  AND D(3))  OR 
		 (SB(17) AND D(4))  OR
		 (SC(1)  AND D(5))  OR 
		 (SC(17) AND D(6))  OR 
		 (SD(1)  AND D(7))  OR 
		 (SD(17) AND D(8))  OR
           (SE(1)  AND D(9))  OR 
		 (SE(17) AND D(10)) OR 
		 (SF(1)  AND D(11)) OR 
		 (SF(17) AND D(12)) OR 
           (SG(1)  AND D(13)) OR 
		 (SG(17) AND D(14)) OR
		 (SH(1)  AND D(15)) OR 
		 (SH(17) AND D(16)) OR
		 (SI(1)  AND D(17)) OR
		 (SI(17) AND D(18)));
		 
OUTD(18) <= ((SA(2)  AND D(1))  OR 
           (SA(18) AND D(2))  OR 
		 (SB(2)  AND D(3))  OR 
		 (SB(18) AND D(4))  OR
		 (SC(2)  AND D(5))  OR 
		 (SC(18) AND D(6))  OR 
		 (SD(2)  AND D(7))  OR 
		 (SD(18) AND D(8))  OR
           (SE(2)  AND D(9))  OR 
		 (SE(18) AND D(10)) OR 
		 (SF(2)  AND D(11)) OR 
		 (SF(18) AND D(12)) OR 
           (SG(2)  AND D(13)) OR 
		 (SG(18) AND D(14)) OR
		 (SH(2)  AND D(15)) OR 
		 (SH(18) AND D(16)) OR
		 (SI(2)  AND D(17)) OR
		 (SI(18) AND D(18)));

OUTD(19) <= ((SA(3)  AND D(1))  OR 
           (SA(19) AND D(2))  OR 
		 (SB(3)  AND D(3))  OR 
		 (SB(19) AND D(4))  OR
		 (SC(3)  AND D(5))  OR 
		 (SC(19) AND D(6))  OR 
		 (SD(3)  AND D(7))  OR 
		 (SD(19) AND D(8))  OR
           (SE(3)  AND D(9))  OR 
		 (SE(19) AND D(10)) OR 
		 (SF(3)  AND D(11)) OR 
		 (SF(19) AND D(12)) OR 
           (SG(3)  AND D(13)) OR 
		 (SG(19) AND D(14)) OR
		 (SH(3)  AND D(15)) OR 
		 (SH(19) AND D(16)) OR
		 (SI(3)  AND D(17)) OR
		 (SI(19) AND D(18)));

OUTD(20) <= ((SA(4)  AND D(1))  OR 
           (SA(20) AND D(2))  OR 
		 (SB(4)  AND D(3))  OR 
		 (SB(20) AND D(4))  OR
		 (SC(4)  AND D(5))  OR 
		 (SC(20) AND D(6))  OR 
		 (SD(4)  AND D(7))  OR 
		 (SD(20) AND D(8))  OR
           (SE(4)  AND D(9))  OR 
		 (SE(20) AND D(10)) OR 
		 (SF(4)  AND D(11)) OR 
		 (SF(20) AND D(12)) OR 
           (SG(4)  AND D(13)) OR 
		 (SG(20) AND D(14)) OR
		 (SH(4)  AND D(15)) OR 
		 (SH(20) AND D(16)) OR
		 (SI(4)  AND D(17)) OR
		 (SI(20) AND D(18)));

OUTD(21) <= ((SA(5)  AND D(1))  OR 
           (SA(21) AND D(2))  OR 
		 (SB(5)  AND D(3))  OR 
		 (SB(21) AND D(4))  OR
		 (SC(5)  AND D(5))  OR 
		 (SC(21) AND D(6))  OR 
		 (SD(5)  AND D(7))  OR 
		 (SD(21) AND D(8))  OR
           (SE(5)  AND D(9))  OR 
		 (SE(21) AND D(10)) OR 
		 (SF(5)  AND D(11)) OR 
		 (SF(21) AND D(12)) OR 
           (SG(5)  AND D(13)) OR 
		 (SG(21) AND D(14)) OR
		 (SH(5)  AND D(15)) OR 
		 (SH(21) AND D(16)) OR
		 (SI(5)  AND D(17)) OR
		 (SI(21) AND D(18)));
		 
OUTD(22) <= ((SA(6)  AND D(1))  OR 
           (SA(22) AND D(2))  OR 
		 (SB(6)  AND D(3))  OR 
		 (SB(22) AND D(4))  OR
		 (SC(6)  AND D(5))  OR 
		 (SC(22) AND D(6))  OR 
		 (SD(6)  AND D(7))  OR 
		 (SD(22) AND D(8))  OR
           (SE(6)  AND D(9))  OR 
		 (SE(22) AND D(10)) OR 
		 (SF(6)  AND D(11)) OR 
		 (SF(22) AND D(12)) OR 
           (SG(6)  AND D(13)) OR 
		 (SG(22) AND D(14)) OR
		 (SH(6)  AND D(15)) OR 
		 (SH(22) AND D(16)) OR
		 (SI(6)  AND D(17)) OR
		 (SI(22) AND D(18)));
		 
OUTD(23) <= ((SA(7)  AND D(1))  OR 
           (SA(23) AND D(2))  OR 
		 (SB(7)  AND D(3))  OR 
		 (SB(23) AND D(4))  OR
		 (SC(7)  AND D(5))  OR 
		 (SC(23) AND D(6))  OR 
		 (SD(7)  AND D(7))  OR 
		 (SD(23) AND D(8))  OR
           (SE(7)  AND D(9))  OR 
		 (SE(23) AND D(10)) OR 
		 (SF(7)  AND D(11)) OR 
		 (SF(23) AND D(12)) OR 
           (SG(7)  AND D(13)) OR 
		 (SG(23) AND D(14)) OR
		 (SH(7)  AND D(15)) OR 
		 (SH(23) AND D(16)) OR
		 (SI(7)  AND D(17)) OR
		 (SI(23) AND D(18)));
		 
OUTD(24) <= ((SA(8)  AND D(1))  OR 
           (SA(24) AND D(2))  OR 
		 (SB(8)  AND D(3))  OR 
		 (SB(24) AND D(4))  OR
		 (SC(8)  AND D(5))  OR 
		 (SC(24) AND D(6))  OR 
		 (SD(8)  AND D(7))  OR 
		 (SD(24) AND D(8))  OR
           (SE(8)  AND D(9))  OR 
		 (SE(24) AND D(10)) OR 
		 (SF(8)  AND D(11)) OR 
		 (SF(24) AND D(12)) OR 
           (SG(8)  AND D(13)) OR 
		 (SG(24) AND D(14)) OR
		 (SH(8)  AND D(15)) OR 
		 (SH(24) AND D(16)) OR
		 (SI(8)  AND D(17)) OR
		 (SI(24) AND D(18)));
		 
OUTD(25) <= ((SA(9)  AND D(1))  OR 
           (SA(25) AND D(2))  OR 
		 (SB(9)  AND D(3))  OR 
		 (SB(25) AND D(4))  OR
		 (SC(9)  AND D(5))  OR 
		 (SC(25) AND D(6))  OR 
		 (SD(9)  AND D(7))  OR 
		 (SD(25) AND D(8))  OR
           (SE(9)  AND D(9))  OR 
		 (SE(25) AND D(10)) OR 
		 (SF(9)  AND D(11)) OR 
		 (SF(25) AND D(12)) OR 
           (SG(9)  AND D(13)) OR 
		 (SG(25) AND D(14)) OR
		 (SH(9)  AND D(15)) OR 
		 (SH(25) AND D(16)) OR
		 (SI(9)  AND D(17)) OR
		 (SI(25) AND D(18)));
		 
OUTD(26) <= ((SA(10)  AND D(1))  OR 
           (SA(26) AND D(2))  OR 
		 (SB(10) AND D(3))  OR 
		 (SB(26) AND D(4))  OR
		 (SC(10) AND D(5))  OR 
		 (SC(26) AND D(6))  OR 
		 (SD(10) AND D(7))  OR 
		 (SD(26) AND D(8))  OR
           (SE(10) AND D(9))  OR 
		 (SE(26) AND D(10)) OR 
		 (SF(10) AND D(11)) OR 
		 (SF(26) AND D(12)) OR 
           (SG(10) AND D(13)) OR 
		 (SG(26) AND D(14)) OR
		 (SH(10) AND D(15)) OR 
		 (SH(26) AND D(16)) OR
		 (SI(10) AND D(17)) OR
		 (SI(26) AND D(18)));
		 
OUTD(27) <= (SA(11)  OR 
       SA(27)   OR 
		 SB(11)   OR 
		 SB(27)   OR
		 SC(11)   OR 
		 SC(27)   OR 
		 SD(11)   OR 
		 SD(27)   OR
       SE(11)   OR 
		 SE(27)   OR 
		 SF(11)   OR 
		 SF(27)   OR 
       SG(11)   OR 
		 SG(27)   OR
		 SH(11)   OR 
		 SH(27)   OR
		 SI(11)   OR
		 SI(27));

OUTD(28) <= ((SA(12)  AND D(1))  OR 
           (SA(28) AND D(2))  OR 
		 (SB(12) AND D(3))  OR 
		 (SB(28) AND D(4))  OR
		 (SC(12) AND D(5))  OR 
		 (SC(28) AND D(6))  OR 
		 (SD(12) AND D(7))  OR 
		 (SD(28) AND D(8))  OR
           (SE(12) AND D(9))  OR 
		 (SE(28) AND D(10)) OR 
		 (SF(12) AND D(11)) OR 
		 (SF(28) AND D(12)) OR 
           (SG(12) AND D(13)) OR 
		 (SG(28) AND D(14)) OR
		 (SH(12) AND D(15)) OR 
		 (SH(28) AND D(16)) OR
		 (SI(12) AND D(17)) OR
		 (SI(28) AND D(18)));
		 
OUTD(29) <= ((SA(13)  AND D(1))  OR 
           (SA(29) AND D(2))  OR 
		 (SB(13) AND D(3))  OR 
		 (SB(29) AND D(4))  OR
		 (SC(13) AND D(5))  OR 
		 (SC(29) AND D(6))  OR 
		 (SD(13) AND D(7))  OR 
		 (SD(29) AND D(8))  OR
           (SE(13) AND D(9))  OR 
		 (SE(29) AND D(10)) OR 
		 (SF(13) AND D(11)) OR 
		 (SF(29) AND D(12)) OR 
           (SG(13) AND D(13)) OR 
		 (SG(29) AND D(14)) OR
		 (SH(13) AND D(15)) OR 
		 (SH(29) AND D(16)) OR
		 (SI(13) AND D(17)) OR
		 (SI(29) AND D(18)));
		 
OUTD(30) <= ((SA(14)  AND D(1))  OR 
           (SA(30) AND D(2))  OR 
		 (SB(14) AND D(3))  OR 
		 (SB(30) AND D(4))  OR
		 (SC(14) AND D(5))  OR 
		 (SC(30) AND D(6))  OR 
		 (SD(14) AND D(7))  OR 
		 (SD(30) AND D(8))  OR
           (SE(14) AND D(9))  OR 
		 (SE(30) AND D(10)) OR 
		 (SF(14) AND D(11)) OR 
		 (SF(30) AND D(12)) OR 
           (SG(14) AND D(13)) OR 
		 (SG(30) AND D(14)) OR
		 (SH(14) AND D(15)) OR 
		 (SH(30) AND D(16)) OR
		 (SI(14) AND D(17)) OR
		 (SI(30) AND D(18)));
		 
OUTD(31) <= ((SA(15)  AND D(1))  OR 
           (SA(31) AND D(2))  OR 
		 (SB(15) AND D(3))  OR 
		 (SB(31) AND D(4))  OR
		 (SC(15) AND D(5))  OR 
		 (SC(31) AND D(6))  OR 
		 (SD(15) AND D(7))  OR 
		 (SD(31) AND D(8))  OR
           (SE(15) AND D(9))  OR 
		 (SE(31) AND D(10)) OR 
		 (SF(15) AND D(11)) OR 
		 (SF(31) AND D(12)) OR 
           (SG(15) AND D(13)) OR 
		 (SG(31) AND D(14)) OR
		 (SH(15) AND D(15)) OR 
		 (SH(31) AND D(16)) OR
		 (SI(15) AND D(17)) OR
		 (SI(31) AND D(18)));	
		 
-- FIFTH BEST 

OUTE(0) <= ((FA(0)  AND E(1))  OR 
           (FA(16) AND E(2))  OR 
		 (FB(0)  AND E(3))  OR 
		 (FB(16) AND E(4))  OR
		 (FC(0)  AND E(5))  OR 
		 (FC(16) AND E(6))  OR 
		 (FD(0)  AND E(7))  OR 
		 (FD(16) AND E(8))  OR
           (FE(0)  AND E(9))  OR 
		 (FE(16) AND E(10)) OR 
		 (FF(0)  AND E(11)) OR 
		 (FF(16) AND E(12)) OR 
           (FG(0)  AND E(13)) OR 
		 (FG(16) AND E(14)) OR
		 (FH(0)  AND E(15)) OR 
		 (FH(16) AND E(16)) OR
		 (FI(0)  AND E(17)) OR
		 (FI(16) AND E(18)));

OUTE(1) <= ((FA(1)  AND E(1))  OR 
           (FA(17) AND E(2))  OR 
		 (FB(1)  AND E(3))  OR 
		 (FB(17) AND E(4))  OR
		 (FC(1)  AND E(5))  OR 
		 (FC(17) AND E(6))  OR 
		 (FD(1)  AND E(7))  OR 
		 (FD(17) AND E(8))  OR
           (FE(1)  AND E(9))  OR 
		 (FE(17) AND E(10)) OR 
		 (FF(1)  AND E(11)) OR 
		 (FF(17) AND E(12)) OR 
           (FG(1)  AND E(13)) OR 
		 (FG(17) AND E(14)) OR
		 (FH(1)  AND E(15)) OR 
		 (FH(17) AND E(16)) OR
		 (FI(1)  AND E(17)) OR
		 (FI(17) AND E(18)));

OUTE(2) <= ((FA(2)  AND E(1))  OR 
           (FA(18) AND E(2))  OR 
		 (FB(2)  AND E(3))  OR 
		 (FB(18) AND E(4))  OR
		 (FC(2)  AND E(5))  OR 
		 (FC(18) AND E(6))  OR 
		 (FD(2)  AND E(7))  OR 
		 (FD(18) AND E(8))  OR
           (FE(2)  AND E(9))  OR 
		 (FE(18) AND E(10)) OR 
		 (FF(2)  AND E(11)) OR 
		 (FF(18) AND E(12)) OR 
           (FG(2)  AND E(13)) OR 
		 (FG(18) AND E(14)) OR
		 (FH(2)  AND E(15)) OR 
		 (FH(18) AND E(16)) OR
		 (FI(2)  AND E(17)) OR
		 (FI(18) AND E(18)));

OUTE(3) <= ((FA(3)  AND E(1))  OR 
           (FA(19) AND E(2))  OR 
		 (FB(3)  AND E(3))  OR 
		 (FB(19) AND E(4))  OR
		 (FC(3)  AND E(5))  OR 
		 (FC(19) AND E(6))  OR 
		 (FD(3)  AND E(7))  OR 
		 (FD(19) AND E(8))  OR
           (FE(3)  AND E(9))  OR 
		 (FE(19) AND E(10)) OR 
		 (FF(3)  AND E(11)) OR 
		 (FF(19) AND E(12)) OR 
           (FG(3)  AND E(13)) OR 
		 (FG(19) AND E(14)) OR
		 (FH(3)  AND E(15)) OR 
		 (FH(19) AND E(16)) OR
		 (FI(3)  AND E(17)) OR
		 (FI(19) AND E(18)));
		 
OUTE(4) <= ((FA(4)  AND E(1))  OR 
           (FA(20) AND E(2))  OR 
		 (FB(4)  AND E(3))  OR 
		 (FB(20) AND E(4))  OR
		 (FC(4)  AND E(5))  OR 
		 (FC(20) AND E(6))  OR 
		 (FD(4)  AND E(7))  OR 
		 (FD(20) AND E(8))  OR
           (FE(4)  AND E(9))  OR 
		 (FE(20) AND E(10)) OR 
		 (FF(4)  AND E(11)) OR 
		 (FF(20) AND E(12)) OR 
           (FG(4)  AND E(13)) OR 
		 (FG(20) AND E(14)) OR
		 (FH(4)  AND E(15)) OR 
		 (FH(20) AND E(16)) OR
		 (FI(4)  AND E(17)) OR
		 (FI(20) AND E(18)));

OUTE(5) <= ((FA(5)  AND E(1))  OR 
           (FA(21) AND E(2))  OR 
		 (FB(5)  AND E(3))  OR 
		 (FB(21) AND E(4))  OR
		 (FC(5)  AND E(5))  OR 
		 (FC(21) AND E(6))  OR 
		 (FD(5)  AND E(7))  OR 
		 (FD(21) AND E(8))  OR
           (FE(5)  AND E(9))  OR 
		 (FE(21) AND E(10)) OR 
		 (FF(5)  AND E(11)) OR 
		 (FF(21) AND E(12)) OR 
           (FG(5)  AND E(13)) OR 
		 (FG(21) AND E(14)) OR
		 (FH(5)  AND E(15)) OR 
		 (FH(21) AND E(16)) OR
		 (FI(5)  AND E(17)) OR
		 (FI(21) AND E(18)));

OUTE(6) <= ((FA(6)  AND E(1))  OR 
           (FA(22) AND E(2))  OR 
		 (FB(6)  AND E(3))  OR 
		 (FB(22) AND E(4))  OR
		 (FC(6)  AND E(5))  OR 
		 (FC(22) AND E(6))  OR 
		 (FD(6)  AND E(7))  OR 
		 (FD(22) AND E(8))  OR
           (FE(6)  AND E(9))  OR 
		 (FE(22) AND E(10)) OR 
		 (FF(6)  AND E(11)) OR 
		 (FF(22) AND E(12)) OR 
           (FG(6)  AND E(13)) OR 
		 (FG(22) AND E(14)) OR
		 (FH(6)  AND E(15)) OR 
		 (FH(22) AND E(16)) OR
		 (FI(6)  AND E(17)) OR
		 (FI(22) AND E(18)));

OUTE(7) <= ((FA(7)  AND E(1))  OR 
           (FA(23) AND E(2))  OR 
		 (FB(7)  AND E(3))  OR 
		 (FB(23) AND E(4))  OR
		 (FC(7)  AND E(5))  OR 
		 (FC(23) AND E(6))  OR 
		 (FD(7)  AND E(7))  OR 
		 (FD(23) AND E(8))  OR
           (FE(7)  AND E(9))  OR 
		 (FE(23) AND E(10)) OR 
		 (FF(7)  AND E(11)) OR 
		 (FF(23) AND E(12)) OR 
           (FG(7)  AND E(13)) OR 
		 (FG(23) AND E(14)) OR
		 (FH(7)  AND E(15)) OR 
		 (FH(23) AND E(16)) OR
		 (FI(7)  AND E(17)) OR
		 (FI(23) AND E(18)));

OUTE(8) <= ((FA(8)  AND E(1))  OR 
           (FA(24) AND E(2))  OR 
		 (FB(8)  AND E(3))  OR 
		 (FB(24) AND E(4))  OR
		 (FC(8)  AND E(5))  OR 
		 (FC(24) AND E(6))  OR 
		 (FD(8)  AND E(7))  OR 
		 (FD(24) AND E(8))  OR
           (FE(8)  AND E(9))  OR 
		 (FE(24) AND E(10)) OR 
		 (FF(8)  AND E(11)) OR 
		 (FF(24) AND E(12)) OR 
           (FG(8)  AND E(13)) OR 
		 (FG(24) AND E(14)) OR
		 (FH(8)  AND E(15)) OR 
		 (FH(24) AND E(16)) OR
		 (FI(8)  AND E(17)) OR
		 (FI(24) AND E(18)));

OUTE(9) <= ((FA(9)  AND E(1))  OR 
           (FA(25) AND E(2))  OR 
		 (FB(9)  AND E(3))  OR 
		 (FB(25) AND E(4))  OR
		 (FC(9)  AND E(5))  OR 
		 (FC(25) AND E(6))  OR 
		 (FD(9)  AND E(7))  OR 
		 (FD(25) AND E(8))  OR
           (FE(9)  AND E(9))  OR 
		 (FE(25) AND E(10)) OR 
		 (FF(9)  AND E(11)) OR 
		 (FF(25) AND E(12)) OR 
           (FG(9)  AND E(13)) OR 
		 (FG(25) AND E(14)) OR
		 (FH(9)  AND E(15)) OR 
		 (FH(25) AND E(16)) OR
		 (FI(9)  AND E(17)) OR
		 (FI(25) AND E(18)));

OUTE(10) <= ((FA(10)  AND E(1))  OR 
           (FA(26) AND E(2))  OR 
		 (FB(10) AND E(3))  OR 
		 (FB(26) AND E(4))  OR
		 (FC(10) AND E(5))  OR 
		 (FC(26) AND E(6))  OR 
		 (FD(10) AND E(7))  OR 
		 (FD(26) AND E(8))  OR
           (FE(10) AND E(9))  OR 
		 (FE(26) AND E(10)) OR 
		 (FF(10) AND E(11)) OR 
		 (FF(26) AND E(12)) OR 
           (FG(10) AND E(13)) OR 
		 (FG(26) AND E(14)) OR
		 (FH(10) AND E(15)) OR 
		 (FH(26) AND E(16)) OR
		 (FI(10) AND E(17)) OR
		 (FI(26) AND E(18)));

OUTE(11) <= ((FA(11)  AND E(1))  OR 
           (FA(27) AND E(2))  OR 
		 (FB(11) AND E(3))  OR 
		 (FB(27) AND E(4))  OR
		 (FC(11) AND E(5))  OR 
		 (FC(27) AND E(6))  OR 
		 (FD(11) AND E(7))  OR 
		 (FD(27) AND E(8))  OR
           (FE(11) AND E(9))  OR 
		 (FE(27) AND E(10)) OR 
		 (FF(11) AND E(11)) OR 
		 (FF(27) AND E(12)) OR 
           (FG(11) AND E(13)) OR 
		 (FG(27) AND E(14)) OR
		 (FH(11) AND E(15)) OR 
		 (FH(27) AND E(16)) OR
		 (FI(11) AND E(17)) OR
		 (FI(27) AND E(18)));

OUTE(12) <= ((FA(12) AND E(1))  OR 
           (FA(28) AND E(2))  OR 
		 (FB(12) AND E(3))  OR 
		 (FB(28) AND E(4))  OR
		 (FC(12) AND E(5))  OR 
		 (FC(28) AND E(6))  OR 
		 (FD(12) AND E(7))  OR 
		 (FD(28) AND E(8))  OR
           (FE(12) AND E(9))  OR 
		 (FE(28) AND E(10)) OR 
		 (FF(12) AND E(11)) OR 
		 (FF(28) AND E(12)) OR 
           (FG(12) AND E(13)) OR 
		 (FG(28) AND E(14)) OR
		 (FH(12) AND E(15)) OR 
		 (FH(28) AND E(16)) OR
		 (FI(12) AND E(17)) OR
		 (FI(28) AND E(18)));

OUTE(13) <= ((FA(13) AND E(1))  OR 
           (FA(29) AND E(2))  OR 
		 (FB(13) AND E(3))  OR 
		 (FB(29) AND E(4))  OR
		 (FC(13) AND E(5))  OR 
		 (FC(29) AND E(6))  OR 
		 (FD(13) AND E(7))  OR 
		 (FD(29) AND E(8))  OR
           (FE(13) AND E(9))  OR 
		 (FE(29) AND E(10)) OR 
		 (FF(13) AND E(11)) OR 
		 (FF(29) AND E(12)) OR 
           (FG(13) AND E(13)) OR 
		 (FG(29) AND E(14)) OR
		 (FH(13) AND E(15)) OR 
		 (FH(29) AND E(16)) OR
		 (FI(13) AND E(17)) OR
		 (FI(29) AND E(18)));

OUTE(14) <= ((FA(14) AND E(1))  OR 
           (FA(30) AND E(2))  OR 
		 (FB(14) AND E(3))  OR 
		 (FB(30) AND E(4))  OR
		 (FC(14) AND E(5))  OR 
		 (FC(30) AND E(6))  OR 
		 (FD(14) AND E(7))  OR 
		 (FD(30) AND E(8))  OR
           (FE(14) AND E(9))  OR 
		 (FE(30) AND E(10)) OR 
		 (FF(14) AND E(11)) OR 
		 (FF(30) AND E(12)) OR 
           (FG(14) AND E(13)) OR 
		 (FG(30) AND E(14)) OR
		 (FH(14) AND E(15)) OR 
		 (FH(30) AND E(16)) OR
		 (FI(14) AND E(17)) OR
		 (FI(30) AND E(18)));
		 
OUTE(15) <= ((FA(15) AND E(1))  OR 
           (FA(31) AND E(2))  OR 
		 (FB(15) AND E(3))  OR 
		 (FB(31) AND E(4))  OR
		 (FC(15) AND E(5))  OR 
		 (FC(31) AND E(6))  OR 
		 (FD(15) AND E(7))  OR 
		 (FD(31) AND E(8))  OR
           (FE(15) AND E(9))  OR 
		 (FE(31) AND E(10)) OR 
		 (FF(15) AND E(11)) OR 
		 (FF(31) AND E(12)) OR 
           (FG(15) AND E(13)) OR 
		 (FG(31) AND E(14)) OR
		 (FH(15) AND E(15)) OR 
		 (FH(31) AND E(16)) OR
		 (FI(15) AND E(17)) OR
		 (FI(31) AND E(18)));
		 
OUTE(16) <= ((SA(0) AND E(1))  OR 
           (SA(16) AND E(2))  OR 
		 (SB(0)  AND E(3))  OR 
		 (SB(16) AND E(4))  OR
		 (SC(0)  AND E(5))  OR 
		 (SC(16) AND E(6))  OR 
		 (SD(0)  AND E(7))  OR 
		 (SD(16) AND E(8))  OR
           (SE(0)  AND E(9))  OR 
		 (SE(16) AND E(10)) OR 
		 (SF(0)  AND E(11)) OR 
		 (SF(16) AND E(12)) OR 
           (SG(0)  AND E(13)) OR 
		 (SG(16) AND E(14)) OR
		 (SH(0)  AND E(15)) OR 
		 (SH(16) AND E(16)) OR
		 (SI(0)  AND E(17)) OR
		 (SI(16) AND E(18)));
		 
OUTE(17) <= ((SA(1)  AND E(1))  OR 
           (SA(17) AND E(2))  OR 
		 (SB(1)  AND E(3))  OR 
		 (SB(17) AND E(4))  OR
		 (SC(1)  AND E(5))  OR 
		 (SC(17) AND E(6))  OR 
		 (SD(1)  AND E(7))  OR 
		 (SD(17) AND E(8))  OR
           (SE(1)  AND E(9))  OR 
		 (SE(17) AND E(10)) OR 
		 (SF(1)  AND E(11)) OR 
		 (SF(17) AND E(12)) OR 
           (SG(1)  AND E(13)) OR 
		 (SG(17) AND E(14)) OR
		 (SH(1)  AND E(15)) OR 
		 (SH(17) AND E(16)) OR
		 (SI(1)  AND E(17)) OR
		 (SI(17) AND E(18)));
		 
OUTE(18) <= ((SA(2)  AND E(1))  OR 
           (SA(18) AND E(2))  OR 
		 (SB(2)  AND E(3))  OR 
		 (SB(18) AND E(4))  OR
		 (SC(2)  AND E(5))  OR 
		 (SC(18) AND E(6))  OR 
		 (SD(2)  AND E(7))  OR 
		 (SD(18) AND E(8))  OR
           (SE(2)  AND E(9))  OR 
		 (SE(18) AND E(10)) OR 
		 (SF(2)  AND E(11)) OR 
		 (SF(18) AND E(12)) OR 
           (SG(2)  AND E(13)) OR 
		 (SG(18) AND E(14)) OR
		 (SH(2)  AND E(15)) OR 
		 (SH(18) AND E(16)) OR
		 (SI(2)  AND E(17)) OR
		 (SI(18) AND E(18)));

OUTE(19) <= ((SA(3)  AND E(1))  OR 
           (SA(19) AND E(2))  OR 
		 (SB(3)  AND E(3))  OR 
		 (SB(19) AND E(4))  OR
		 (SC(3)  AND E(5))  OR 
		 (SC(19) AND E(6))  OR 
		 (SD(3)  AND E(7))  OR 
		 (SD(19) AND E(8))  OR
           (SE(3)  AND E(9))  OR 
		 (SE(19) AND E(10)) OR 
		 (SF(3)  AND E(11)) OR 
		 (SF(19) AND E(12)) OR 
           (SG(3)  AND E(13)) OR 
		 (SG(19) AND E(14)) OR
		 (SH(3)  AND E(15)) OR 
		 (SH(19) AND E(16)) OR
		 (SI(3)  AND E(17)) OR
		 (SI(19) AND E(18)));

OUTE(20) <= ((SA(4)  AND E(1))  OR 
           (SA(20) AND E(2))  OR 
		 (SB(4)  AND E(3))  OR 
		 (SB(20) AND E(4))  OR
		 (SC(4)  AND E(5))  OR 
		 (SC(20) AND E(6))  OR 
		 (SD(4)  AND E(7))  OR 
		 (SD(20) AND E(8))  OR
           (SE(4)  AND E(9))  OR 
		 (SE(20) AND E(10)) OR 
		 (SF(4)  AND E(11)) OR 
		 (SF(20) AND E(12)) OR 
           (SG(4)  AND E(13)) OR 
		 (SG(20) AND E(14)) OR
		 (SH(4)  AND E(15)) OR 
		 (SH(20) AND E(16)) OR
		 (SI(4)  AND E(17)) OR
		 (SI(20) AND E(18)));

OUTE(21) <= ((SA(5)  AND E(1))  OR 
           (SA(21) AND E(2))  OR 
		 (SB(5)  AND E(3))  OR 
		 (SB(21) AND E(4))  OR
		 (SC(5)  AND E(5))  OR 
		 (SC(21) AND E(6))  OR 
		 (SD(5)  AND E(7))  OR 
		 (SD(21) AND E(8))  OR
           (SE(5)  AND E(9))  OR 
		 (SE(21) AND E(10)) OR 
		 (SF(5)  AND E(11)) OR 
		 (SF(21) AND E(12)) OR 
           (SG(5)  AND E(13)) OR 
		 (SG(21) AND E(14)) OR
		 (SH(5)  AND E(15)) OR 
		 (SH(21) AND E(16)) OR
		 (SI(5)  AND E(17)) OR
		 (SI(21) AND E(18)));
		 
OUTE(22) <= ((SA(6)  AND E(1))  OR 
           (SA(22) AND E(2))  OR 
		 (SB(6)  AND E(3))  OR 
		 (SB(22) AND E(4))  OR
		 (SC(6)  AND E(5))  OR 
		 (SC(22) AND E(6))  OR 
		 (SD(6)  AND E(7))  OR 
		 (SD(22) AND E(8))  OR
           (SE(6)  AND E(9))  OR 
		 (SE(22) AND E(10)) OR 
		 (SF(6)  AND E(11)) OR 
		 (SF(22) AND E(12)) OR 
           (SG(6)  AND E(13)) OR 
		 (SG(22) AND E(14)) OR
		 (SH(6)  AND E(15)) OR 
		 (SH(22) AND E(16)) OR
		 (SI(6)  AND E(17)) OR
		 (SI(22) AND E(18)));
		 
OUTE(23) <= ((SA(7)  AND E(1))  OR 
           (SA(23) AND E(2))  OR 
		 (SB(7)  AND E(3))  OR 
		 (SB(23) AND E(4))  OR
		 (SC(7)  AND E(5))  OR 
		 (SC(23) AND E(6))  OR 
		 (SD(7)  AND E(7))  OR 
		 (SD(23) AND E(8))  OR
           (SE(7)  AND E(9))  OR 
		 (SE(23) AND E(10)) OR 
		 (SF(7)  AND E(11)) OR 
		 (SF(23) AND E(12)) OR 
           (SG(7)  AND E(13)) OR 
		 (SG(23) AND E(14)) OR
		 (SH(7)  AND E(15)) OR 
		 (SH(23) AND E(16)) OR
		 (SI(7)  AND E(17)) OR
		 (SI(23) AND E(18)));
		 
OUTE(24) <= ((SA(8)  AND E(1))  OR 
           (SA(24) AND E(2))  OR 
		 (SB(8)  AND E(3))  OR 
		 (SB(24) AND E(4))  OR
		 (SC(8)  AND E(5))  OR 
		 (SC(24) AND E(6))  OR 
		 (SD(8)  AND E(7))  OR 
		 (SD(24) AND E(8))  OR
           (SE(8)  AND E(9))  OR 
		 (SE(24) AND E(10)) OR 
		 (SF(8)  AND E(11)) OR 
		 (SF(24) AND E(12)) OR 
           (SG(8)  AND E(13)) OR 
		 (SG(24) AND E(14)) OR
		 (SH(8)  AND E(15)) OR 
		 (SH(24) AND E(16)) OR
		 (SI(8)  AND E(17)) OR
		 (SI(24) AND E(18)));
		 
OUTE(25) <= ((SA(9)  AND E(1))  OR 
           (SA(25) AND E(2))  OR 
		 (SB(9)  AND E(3))  OR 
		 (SB(25) AND E(4))  OR
		 (SC(9)  AND E(5))  OR 
		 (SC(25) AND E(6))  OR 
		 (SD(9)  AND E(7))  OR 
		 (SD(25) AND E(8))  OR
           (SE(9)  AND E(9))  OR 
		 (SE(25) AND E(10)) OR 
		 (SF(9)  AND E(11)) OR 
		 (SF(25) AND E(12)) OR 
           (SG(9)  AND E(13)) OR 
		 (SG(25) AND E(14)) OR
		 (SH(9)  AND E(15)) OR 
		 (SH(25) AND E(16)) OR
		 (SI(9)  AND E(17)) OR
		 (SI(25) AND E(18)));
		 
OUTE(26) <= ((SA(10)  AND E(1))  OR 
           (SA(26) AND E(2))  OR 
		 (SB(10) AND E(3))  OR 
		 (SB(26) AND E(4))  OR
		 (SC(10) AND E(5))  OR 
		 (SC(26) AND E(6))  OR 
		 (SD(10) AND E(7))  OR 
		 (SD(26) AND E(8))  OR
           (SE(10) AND E(9))  OR 
		 (SE(26) AND E(10)) OR 
		 (SF(10) AND E(11)) OR 
		 (SF(26) AND E(12)) OR 
           (SG(10) AND E(13)) OR 
		 (SG(26) AND E(14)) OR
		 (SH(10) AND E(15)) OR 
		 (SH(26) AND E(16)) OR
		 (SI(10) AND E(17)) OR
		 (SI(26) AND E(18)));
		 
OUTE(27) <= (SA(11)  OR 
       SA(27)   OR 
		 SB(11)   OR 
		 SB(27)   OR
		 SC(11)   OR 
		 SC(27)   OR 
		 SD(11)   OR 
		 SD(27)   OR
       SE(11)   OR 
		 SE(27)   OR 
		 SF(11)   OR 
		 SF(27)   OR 
       SG(11)   OR 
		 SG(27)   OR
		 SH(11)   OR 
		 SH(27)   OR
		 SI(11)   OR
		 SI(27));

OUTE(28) <= ((SA(12)  AND E(1))  OR 
           (SA(28) AND E(2))  OR 
		 (SB(12) AND E(3))  OR 
		 (SB(28) AND E(4))  OR
		 (SC(12) AND E(5))  OR 
		 (SC(28) AND E(6))  OR 
		 (SD(12) AND E(7))  OR 
		 (SD(28) AND E(8))  OR
           (SE(12) AND E(9))  OR 
		 (SE(28) AND E(10)) OR 
		 (SF(12) AND E(11)) OR 
		 (SF(28) AND E(12)) OR 
           (SG(12) AND E(13)) OR 
		 (SG(28) AND E(14)) OR
		 (SH(12) AND E(15)) OR 
		 (SH(28) AND E(16)) OR
		 (SI(12) AND E(17)) OR
		 (SI(28) AND E(18)));
		 
OUTE(29) <= ((SA(13)  AND E(1))  OR 
           (SA(29) AND E(2))  OR 
		 (SB(13) AND E(3))  OR 
		 (SB(29) AND E(4))  OR
		 (SC(13) AND E(5))  OR 
		 (SC(29) AND E(6))  OR 
		 (SD(13) AND E(7))  OR 
		 (SD(29) AND E(8))  OR
           (SE(13) AND E(9))  OR 
		 (SE(29) AND E(10)) OR 
		 (SF(13) AND E(11)) OR 
		 (SF(29) AND E(12)) OR 
           (SG(13) AND E(13)) OR 
		 (SG(29) AND E(14)) OR
		 (SH(13) AND E(15)) OR 
		 (SH(29) AND E(16)) OR
		 (SI(13) AND E(17)) OR
		 (SI(29) AND E(18)));
		 
OUTE(30) <= ((SA(14)  AND E(1))  OR 
           (SA(30) AND E(2))  OR 
		 (SB(14) AND E(3))  OR 
		 (SB(30) AND E(4))  OR
		 (SC(14) AND E(5))  OR 
		 (SC(30) AND E(6))  OR 
		 (SD(14) AND E(7))  OR 
		 (SD(30) AND E(8))  OR
           (SE(14) AND E(9))  OR 
		 (SE(30) AND E(10)) OR 
		 (SF(14) AND E(11)) OR 
		 (SF(30) AND E(12)) OR 
           (SG(14) AND E(13)) OR 
		 (SG(30) AND E(14)) OR
		 (SH(14) AND E(15)) OR 
		 (SH(30) AND E(16)) OR
		 (SI(14) AND E(17)) OR
		 (SI(30) AND E(18)));
		 
OUTE(31) <= ((SA(15)  AND E(1))  OR 
           (SA(31) AND E(2))  OR 
		 (SB(15) AND E(3))  OR 
		 (SB(31) AND E(4))  OR
		 (SC(15) AND E(5))  OR 
		 (SC(31) AND E(6))  OR 
		 (SD(15) AND E(7))  OR 
		 (SD(31) AND E(8))  OR
           (SE(15) AND E(9))  OR 
		 (SE(31) AND E(10)) OR 
		 (SF(15) AND E(11)) OR 
		 (SF(31) AND E(12)) OR 
           (SG(15) AND E(13)) OR 
		 (SG(31) AND E(14)) OR
		 (SH(15) AND E(15)) OR 
		 (SH(31) AND E(16)) OR
		 (SI(15) AND E(17)) OR
		 (SI(31) AND E(18)));
		 			 	 
-- SIXTH BEST 

OUTF(0) <= ((FA(0)  AND F(1))  OR 
           (FA(16) AND F(2))  OR 
		 (FB(0)  AND F(3))  OR 
		 (FB(16) AND F(4))  OR
		 (FC(0)  AND F(5))  OR 
		 (FC(16) AND F(6))  OR 
		 (FD(0)  AND F(7))  OR 
		 (FD(16) AND F(8))  OR
           (FE(0)  AND F(9))  OR 
		 (FE(16) AND F(10)) OR 
		 (FF(0)  AND F(11)) OR 
		 (FF(16) AND F(12)) OR 
           (FG(0)  AND F(13)) OR 
		 (FG(16) AND F(14)) OR
		 (FH(0)  AND F(15)) OR 
		 (FH(16) AND F(16)) OR
		 (FI(0)  AND F(17)) OR
		 (FI(16) AND F(18)));

OUTF(1) <= ((FA(1)  AND F(1))  OR 
           (FA(17) AND F(2))  OR 
		 (FB(1)  AND F(3))  OR 
		 (FB(17) AND F(4))  OR
		 (FC(1)  AND F(5))  OR 
		 (FC(17) AND F(6))  OR 
		 (FD(1)  AND F(7))  OR 
		 (FD(17) AND F(8))  OR
           (FE(1)  AND F(9))  OR 
		 (FE(17) AND F(10)) OR 
		 (FF(1)  AND F(11)) OR 
		 (FF(17) AND F(12)) OR 
           (FG(1)  AND F(13)) OR 
		 (FG(17) AND F(14)) OR
		 (FH(1)  AND F(15)) OR 
		 (FH(17) AND F(16)) OR
		 (FI(1)  AND F(17)) OR
		 (FI(17) AND F(18)));

OUTF(2) <= ((FA(2)  AND F(1))  OR 
           (FA(18) AND F(2))  OR 
		 (FB(2)  AND F(3))  OR 
		 (FB(18) AND F(4))  OR
		 (FC(2)  AND F(5))  OR 
		 (FC(18) AND F(6))  OR 
		 (FD(2)  AND F(7))  OR 
		 (FD(18) AND F(8))  OR
           (FE(2)  AND F(9))  OR 
		 (FE(18) AND F(10)) OR 
		 (FF(2)  AND F(11)) OR 
		 (FF(18) AND F(12)) OR 
           (FG(2)  AND F(13)) OR 
		 (FG(18) AND F(14)) OR
		 (FH(2)  AND F(15)) OR 
		 (FH(18) AND F(16)) OR
		 (FI(2)  AND F(17)) OR
		 (FI(18) AND F(18)));

OUTF(3) <= ((FA(3)  AND F(1))  OR 
           (FA(19) AND F(2))  OR 
		 (FB(3)  AND F(3))  OR 
		 (FB(19) AND F(4))  OR
		 (FC(3)  AND F(5))  OR 
		 (FC(19) AND F(6))  OR 
		 (FD(3)  AND F(7))  OR 
		 (FD(19) AND F(8))  OR
           (FE(3)  AND F(9))  OR 
		 (FE(19) AND F(10)) OR 
		 (FF(3)  AND F(11)) OR 
		 (FF(19) AND F(12)) OR 
           (FG(3)  AND F(13)) OR 
		 (FG(19) AND F(14)) OR
		 (FH(3)  AND F(15)) OR 
		 (FH(19) AND F(16)) OR
		 (FI(3)  AND F(17)) OR
		 (FI(19) AND F(18)));
		 
OUTF(4) <= ((FA(4)  AND F(1))  OR 
           (FA(20) AND F(2))  OR 
		 (FB(4)  AND F(3))  OR 
		 (FB(20) AND F(4))  OR
		 (FC(4)  AND F(5))  OR 
		 (FC(20) AND F(6))  OR 
		 (FD(4)  AND F(7))  OR 
		 (FD(20) AND F(8))  OR
           (FE(4)  AND F(9))  OR 
		 (FE(20) AND F(10)) OR 
		 (FF(4)  AND F(11)) OR 
		 (FF(20) AND F(12)) OR 
           (FG(4)  AND F(13)) OR 
		 (FG(20) AND F(14)) OR
		 (FH(4)  AND F(15)) OR 
		 (FH(20) AND F(16)) OR
		 (FI(4)  AND F(17)) OR
		 (FI(20) AND F(18)));

OUTF(5) <= ((FA(5)  AND F(1))  OR 
           (FA(21) AND F(2))  OR 
		 (FB(5)  AND F(3))  OR 
		 (FB(21) AND F(4))  OR
		 (FC(5)  AND F(5))  OR 
		 (FC(21) AND F(6))  OR 
		 (FD(5)  AND F(7))  OR 
		 (FD(21) AND F(8))  OR
           (FE(5)  AND F(9))  OR 
		 (FE(21) AND F(10)) OR 
		 (FF(5)  AND F(11)) OR 
		 (FF(21) AND F(12)) OR 
           (FG(5)  AND F(13)) OR 
		 (FG(21) AND F(14)) OR
		 (FH(5)  AND F(15)) OR 
		 (FH(21) AND F(16)) OR
		 (FI(5)  AND F(17)) OR
		 (FI(21) AND F(18)));

OUTF(6) <= ((FA(6)  AND F(1))  OR 
           (FA(22) AND F(2))  OR 
		 (FB(6)  AND F(3))  OR 
		 (FB(22) AND F(4))  OR
		 (FC(6)  AND F(5))  OR 
		 (FC(22) AND F(6))  OR 
		 (FD(6)  AND F(7))  OR 
		 (FD(22) AND F(8))  OR
           (FE(6)  AND F(9))  OR 
		 (FE(22) AND F(10)) OR 
		 (FF(6)  AND F(11)) OR 
		 (FF(22) AND F(12)) OR 
           (FG(6)  AND F(13)) OR 
		 (FG(22) AND F(14)) OR
		 (FH(6)  AND F(15)) OR 
		 (FH(22) AND F(16)) OR
		 (FI(6)  AND F(17)) OR
		 (FI(22) AND F(18)));

OUTF(7) <= ((FA(7)  AND F(1))  OR 
           (FA(23) AND F(2))  OR 
		 (FB(7)  AND F(3))  OR 
		 (FB(23) AND F(4))  OR
		 (FC(7)  AND F(5))  OR 
		 (FC(23) AND F(6))  OR 
		 (FD(7)  AND F(7))  OR 
		 (FD(23) AND F(8))  OR
           (FE(7)  AND F(9))  OR 
		 (FE(23) AND F(10)) OR 
		 (FF(7)  AND F(11)) OR 
		 (FF(23) AND F(12)) OR 
           (FG(7)  AND F(13)) OR 
		 (FG(23) AND F(14)) OR
		 (FH(7)  AND F(15)) OR 
		 (FH(23) AND F(16)) OR
		 (FI(7)  AND F(17)) OR
		 (FI(23) AND F(18)));

OUTF(8) <= ((FA(8)  AND F(1))  OR 
           (FA(24) AND F(2))  OR 
		 (FB(8)  AND F(3))  OR 
		 (FB(24) AND F(4))  OR
		 (FC(8)  AND F(5))  OR 
		 (FC(24) AND F(6))  OR 
		 (FD(8)  AND F(7))  OR 
		 (FD(24) AND F(8))  OR
           (FE(8)  AND F(9))  OR 
		 (FE(24) AND F(10)) OR 
		 (FF(8)  AND F(11)) OR 
		 (FF(24) AND F(12)) OR 
           (FG(8)  AND F(13)) OR 
		 (FG(24) AND F(14)) OR
		 (FH(8)  AND F(15)) OR 
		 (FH(24) AND F(16)) OR
		 (FI(8)  AND F(17)) OR
		 (FI(24) AND F(18)));

OUTF(9) <= ((FA(9)  AND F(1))  OR 
           (FA(25) AND F(2))  OR 
		 (FB(9)  AND F(3))  OR 
		 (FB(25) AND F(4))  OR
		 (FC(9)  AND F(5))  OR 
		 (FC(25) AND F(6))  OR 
		 (FD(9)  AND F(7))  OR 
		 (FD(25) AND F(8))  OR
           (FE(9)  AND F(9))  OR 
		 (FE(25) AND F(10)) OR 
		 (FF(9)  AND F(11)) OR 
		 (FF(25) AND F(12)) OR 
           (FG(9)  AND F(13)) OR 
		 (FG(25) AND F(14)) OR
		 (FH(9)  AND F(15)) OR 
		 (FH(25) AND F(16)) OR
		 (FI(9)  AND F(17)) OR
		 (FI(25) AND F(18)));

OUTF(10) <= ((FA(10)  AND F(1))  OR 
           (FA(26) AND F(2))  OR 
		 (FB(10) AND F(3))  OR 
		 (FB(26) AND F(4))  OR
		 (FC(10) AND F(5))  OR 
		 (FC(26) AND F(6))  OR 
		 (FD(10) AND F(7))  OR 
		 (FD(26) AND F(8))  OR
           (FE(10) AND F(9))  OR 
		 (FE(26) AND F(10)) OR 
		 (FF(10) AND F(11)) OR 
		 (FF(26) AND F(12)) OR 
           (FG(10) AND F(13)) OR 
		 (FG(26) AND F(14)) OR
		 (FH(10) AND F(15)) OR 
		 (FH(26) AND F(16)) OR
		 (FI(10) AND F(17)) OR
		 (FI(26) AND F(18)));

OUTF(11) <= ((FA(11)  AND F(1))  OR 
           (FA(27) AND F(2))  OR 
		 (FB(11) AND F(3))  OR 
		 (FB(27) AND F(4))  OR
		 (FC(11) AND F(5))  OR 
		 (FC(27) AND F(6))  OR 
		 (FD(11) AND F(7))  OR 
		 (FD(27) AND F(8))  OR
           (FE(11) AND F(9))  OR 
		 (FE(27) AND F(10)) OR 
		 (FF(11) AND F(11)) OR 
		 (FF(27) AND F(12)) OR 
           (FG(11) AND F(13)) OR 
		 (FG(27) AND F(14)) OR
		 (FH(11) AND F(15)) OR 
		 (FH(27) AND F(16)) OR
		 (FI(11) AND F(17)) OR
		 (FI(27) AND F(18)));

OUTF(12) <= ((FA(12) AND F(1))  OR 
           (FA(28) AND F(2))  OR 
		 (FB(12) AND F(3))  OR 
		 (FB(28) AND F(4))  OR
		 (FC(12) AND F(5))  OR 
		 (FC(28) AND F(6))  OR 
		 (FD(12) AND F(7))  OR 
		 (FD(28) AND F(8))  OR
           (FE(12) AND F(9))  OR 
		 (FE(28) AND F(10)) OR 
		 (FF(12) AND F(11)) OR 
		 (FF(28) AND F(12)) OR 
           (FG(12) AND F(13)) OR 
		 (FG(28) AND F(14)) OR
		 (FH(12) AND F(15)) OR 
		 (FH(28) AND F(16)) OR
		 (FI(12) AND F(17)) OR
		 (FI(28) AND F(18)));

OUTF(13) <= ((FA(13) AND F(1))  OR 
           (FA(29) AND F(2))  OR 
		 (FB(13) AND F(3))  OR 
		 (FB(29) AND F(4))  OR
		 (FC(13) AND F(5))  OR 
		 (FC(29) AND F(6))  OR 
		 (FD(13) AND F(7))  OR 
		 (FD(29) AND F(8))  OR
           (FE(13) AND F(9))  OR 
		 (FE(29) AND F(10)) OR 
		 (FF(13) AND F(11)) OR 
		 (FF(29) AND F(12)) OR 
           (FG(13) AND F(13)) OR 
		 (FG(29) AND F(14)) OR
		 (FH(13) AND F(15)) OR 
		 (FH(29) AND F(16)) OR
		 (FI(13) AND F(17)) OR
		 (FI(29) AND F(18)));

OUTF(14) <= ((FA(14) AND F(1))  OR 
           (FA(30) AND F(2))  OR 
		 (FB(14) AND F(3))  OR 
		 (FB(30) AND F(4))  OR
		 (FC(14) AND F(5))  OR 
		 (FC(30) AND F(6))  OR 
		 (FD(14) AND F(7))  OR 
		 (FD(30) AND F(8))  OR
           (FE(14) AND F(9))  OR 
		 (FE(30) AND F(10)) OR 
		 (FF(14) AND F(11)) OR 
		 (FF(30) AND F(12)) OR 
           (FG(14) AND F(13)) OR 
		 (FG(30) AND F(14)) OR
		 (FH(14) AND F(15)) OR 
		 (FH(30) AND F(16)) OR
		 (FI(14) AND F(17)) OR
		 (FI(30) AND F(18)));
		 
OUTF(15) <= ((FA(15) AND F(1))  OR 
           (FA(31) AND F(2))  OR 
		 (FB(15) AND F(3))  OR 
		 (FB(31) AND F(4))  OR
		 (FC(15) AND F(5))  OR 
		 (FC(31) AND F(6))  OR 
		 (FD(15) AND F(7))  OR 
		 (FD(31) AND F(8))  OR
           (FE(15) AND F(9))  OR 
		 (FE(31) AND F(10)) OR 
		 (FF(15) AND F(11)) OR 
		 (FF(31) AND F(12)) OR 
           (FG(15) AND F(13)) OR 
		 (FG(31) AND F(14)) OR
		 (FH(15) AND F(15)) OR 
		 (FH(31) AND F(16)) OR
		 (FI(15) AND F(17)) OR
		 (FI(31) AND F(18)));
		 
OUTF(16) <= ((SA(0) AND F(1))  OR 
           (SA(16) AND F(2))  OR 
		 (SB(0)  AND F(3))  OR 
		 (SB(16) AND F(4))  OR
		 (SC(0)  AND F(5))  OR 
		 (SC(16) AND F(6))  OR 
		 (SD(0)  AND F(7))  OR 
		 (SD(16) AND F(8))  OR
           (SE(0)  AND F(9))  OR 
		 (SE(16) AND F(10)) OR 
		 (SF(0)  AND F(11)) OR 
		 (SF(16) AND F(12)) OR 
           (SG(0)  AND F(13)) OR 
		 (SG(16) AND F(14)) OR
		 (SH(0)  AND F(15)) OR 
		 (SH(16) AND F(16)) OR
		 (SI(0)  AND F(17)) OR
		 (SI(16) AND F(18)));
		 
OUTF(17) <= ((SA(1)  AND F(1))  OR 
           (SA(17) AND F(2))  OR 
		 (SB(1)  AND F(3))  OR 
		 (SB(17) AND F(4))  OR
		 (SC(1)  AND F(5))  OR 
		 (SC(17) AND F(6))  OR 
		 (SD(1)  AND F(7))  OR 
		 (SD(17) AND F(8))  OR
           (SE(1)  AND F(9))  OR 
		 (SE(17) AND F(10)) OR 
		 (SF(1)  AND F(11)) OR 
		 (SF(17) AND F(12)) OR 
           (SG(1)  AND F(13)) OR 
		 (SG(17) AND F(14)) OR
		 (SH(1)  AND F(15)) OR 
		 (SH(17) AND F(16)) OR
		 (SI(1)  AND F(17)) OR
		 (SI(17) AND F(18)));
		 
OUTF(18) <= ((SA(2)  AND F(1))  OR 
           (SA(18) AND F(2))  OR 
		 (SB(2)  AND F(3))  OR 
		 (SB(18) AND F(4))  OR
		 (SC(2)  AND F(5))  OR 
		 (SC(18) AND F(6))  OR 
		 (SD(2)  AND F(7))  OR 
		 (SD(18) AND F(8))  OR
           (SE(2)  AND F(9))  OR 
		 (SE(18) AND F(10)) OR 
		 (SF(2)  AND F(11)) OR 
		 (SF(18) AND F(12)) OR 
           (SG(2)  AND F(13)) OR 
		 (SG(18) AND F(14)) OR
		 (SH(2)  AND F(15)) OR 
		 (SH(18) AND F(16)) OR
		 (SI(2)  AND F(17)) OR
		 (SI(18) AND F(18)));

OUTF(19) <= ((SA(3)  AND F(1))  OR 
           (SA(19) AND F(2))  OR 
		 (SB(3)  AND F(3))  OR 
		 (SB(19) AND F(4))  OR
		 (SC(3)  AND F(5))  OR 
		 (SC(19) AND F(6))  OR 
		 (SD(3)  AND F(7))  OR 
		 (SD(19) AND F(8))  OR
           (SE(3)  AND F(9))  OR 
		 (SE(19) AND F(10)) OR 
		 (SF(3)  AND F(11)) OR 
		 (SF(19) AND F(12)) OR 
           (SG(3)  AND F(13)) OR 
		 (SG(19) AND F(14)) OR
		 (SH(3)  AND F(15)) OR 
		 (SH(19) AND F(16)) OR
		 (SI(3)  AND F(17)) OR
		 (SI(19) AND F(18)));

OUTF(20) <= ((SA(4)  AND F(1))  OR 
           (SA(20) AND F(2))  OR 
		 (SB(4)  AND F(3))  OR 
		 (SB(20) AND F(4))  OR
		 (SC(4)  AND F(5))  OR 
		 (SC(20) AND F(6))  OR 
		 (SD(4)  AND F(7))  OR 
		 (SD(20) AND F(8))  OR
           (SE(4)  AND F(9))  OR 
		 (SE(20) AND F(10)) OR 
		 (SF(4)  AND F(11)) OR 
		 (SF(20) AND F(12)) OR 
           (SG(4)  AND F(13)) OR 
		 (SG(20) AND F(14)) OR
		 (SH(4)  AND F(15)) OR 
		 (SH(20) AND F(16)) OR
		 (SI(4)  AND F(17)) OR
		 (SI(20) AND F(18)));

OUTF(21) <= ((SA(5)  AND F(1))  OR 
           (SA(21) AND F(2))  OR 
		 (SB(5)  AND F(3))  OR 
		 (SB(21) AND F(4))  OR
		 (SC(5)  AND F(5))  OR 
		 (SC(21) AND F(6))  OR 
		 (SD(5)  AND F(7))  OR 
		 (SD(21) AND F(8))  OR
           (SE(5)  AND F(9))  OR 
		 (SE(21) AND F(10)) OR 
		 (SF(5)  AND F(11)) OR 
		 (SF(21) AND F(12)) OR 
           (SG(5)  AND F(13)) OR 
		 (SG(21) AND F(14)) OR
		 (SH(5)  AND F(15)) OR 
		 (SH(21) AND F(16)) OR
		 (SI(5)  AND F(17)) OR
		 (SI(21) AND F(18)));
		 
OUTF(22) <= ((SA(6)  AND F(1))  OR 
           (SA(22) AND F(2))  OR 
		 (SB(6)  AND F(3))  OR 
		 (SB(22) AND F(4))  OR
		 (SC(6)  AND F(5))  OR 
		 (SC(22) AND F(6))  OR 
		 (SD(6)  AND F(7))  OR 
		 (SD(22) AND F(8))  OR
           (SE(6)  AND F(9))  OR 
		 (SE(22) AND F(10)) OR 
		 (SF(6)  AND F(11)) OR 
		 (SF(22) AND F(12)) OR 
           (SG(6)  AND F(13)) OR 
		 (SG(22) AND F(14)) OR
		 (SH(6)  AND F(15)) OR 
		 (SH(22) AND F(16)) OR
		 (SI(6)  AND F(17)) OR
		 (SI(22) AND F(18)));
		 
OUTF(23) <= ((SA(7)  AND F(1))  OR 
           (SA(23) AND F(2))  OR 
		 (SB(7)  AND F(3))  OR 
		 (SB(23) AND F(4))  OR
		 (SC(7)  AND F(5))  OR 
		 (SC(23) AND F(6))  OR 
		 (SD(7)  AND F(7))  OR 
		 (SD(23) AND F(8))  OR
           (SE(7)  AND F(9))  OR 
		 (SE(23) AND F(10)) OR 
		 (SF(7)  AND F(11)) OR 
		 (SF(23) AND F(12)) OR 
           (SG(7)  AND F(13)) OR 
		 (SG(23) AND F(14)) OR
		 (SH(7)  AND F(15)) OR 
		 (SH(23) AND F(16)) OR
		 (SI(7)  AND F(17)) OR
		 (SI(23) AND F(18)));
		 
OUTF(24) <= ((SA(8)  AND F(1))  OR 
           (SA(24) AND F(2))  OR 
		 (SB(8)  AND F(3))  OR 
		 (SB(24) AND F(4))  OR
		 (SC(8)  AND F(5))  OR 
		 (SC(24) AND F(6))  OR 
		 (SD(8)  AND F(7))  OR 
		 (SD(24) AND F(8))  OR
           (SE(8)  AND F(9))  OR 
		 (SE(24) AND F(10)) OR 
		 (SF(8)  AND F(11)) OR 
		 (SF(24) AND F(12)) OR 
           (SG(8)  AND F(13)) OR 
		 (SG(24) AND F(14)) OR
		 (SH(8)  AND F(15)) OR 
		 (SH(24) AND F(16)) OR
		 (SI(8)  AND F(17)) OR
		 (SI(24) AND F(18)));
		 
OUTF(25) <= ((SA(9)  AND F(1))  OR 
           (SA(25) AND F(2))  OR 
		 (SB(9)  AND F(3))  OR 
		 (SB(25) AND F(4))  OR
		 (SC(9)  AND F(5))  OR 
		 (SC(25) AND F(6))  OR 
		 (SD(9)  AND F(7))  OR 
		 (SD(25) AND F(8))  OR
           (SE(9)  AND F(9))  OR 
		 (SE(25) AND F(10)) OR 
		 (SF(9)  AND F(11)) OR 
		 (SF(25) AND F(12)) OR 
           (SG(9)  AND F(13)) OR 
		 (SG(25) AND F(14)) OR
		 (SH(9)  AND F(15)) OR 
		 (SH(25) AND F(16)) OR
		 (SI(9)  AND F(17)) OR
		 (SI(25) AND F(18)));
		 
OUTF(26) <= ((SA(10)  AND F(1))  OR 
           (SA(26) AND F(2))  OR 
		 (SB(10) AND F(3))  OR 
		 (SB(26) AND F(4))  OR
		 (SC(10) AND F(5))  OR 
		 (SC(26) AND F(6))  OR 
		 (SD(10) AND F(7))  OR 
		 (SD(26) AND F(8))  OR
           (SE(10) AND F(9))  OR 
		 (SE(26) AND F(10)) OR 
		 (SF(10) AND F(11)) OR 
		 (SF(26) AND F(12)) OR 
           (SG(10) AND F(13)) OR 
		 (SG(26) AND F(14)) OR
		 (SH(10) AND F(15)) OR 
		 (SH(26) AND F(16)) OR
		 (SI(10) AND F(17)) OR
		 (SI(26) AND F(18)));
		 
OUTF(27) <= (SA(11)  OR 
       SA(27)   OR 
		 SB(11)   OR 
		 SB(27)   OR
		 SC(11)   OR 
		 SC(27)   OR 
		 SD(11)   OR 
		 SD(27)   OR
       SE(11)   OR 
		 SE(27)   OR 
		 SF(11)   OR 
		 SF(27)   OR 
       SG(11)   OR 
		 SG(27)   OR
		 SH(11)   OR 
		 SH(27)   OR
		 SI(11)   OR
		 SI(27));

OUTF(28) <= ((SA(12)  AND F(1))  OR 
           (SA(28) AND F(2))  OR 
		 (SB(12) AND F(3))  OR 
		 (SB(28) AND F(4))  OR
		 (SC(12) AND F(5))  OR 
		 (SC(28) AND F(6))  OR 
		 (SD(12) AND F(7))  OR 
		 (SD(28) AND F(8))  OR
           (SE(12) AND F(9))  OR 
		 (SE(28) AND F(10)) OR 
		 (SF(12) AND F(11)) OR 
		 (SF(28) AND F(12)) OR 
           (SG(12) AND F(13)) OR 
		 (SG(28) AND F(14)) OR
		 (SH(12) AND F(15)) OR 
		 (SH(28) AND F(16)) OR
		 (SI(12) AND F(17)) OR
		 (SI(28) AND F(18)));
		 
OUTF(29) <= ((SA(13)  AND F(1))  OR 
           (SA(29) AND F(2))  OR 
		 (SB(13) AND F(3))  OR 
		 (SB(29) AND F(4))  OR
		 (SC(13) AND F(5))  OR 
		 (SC(29) AND F(6))  OR 
		 (SD(13) AND F(7))  OR 
		 (SD(29) AND F(8))  OR
           (SE(13) AND F(9))  OR 
		 (SE(29) AND F(10)) OR 
		 (SF(13) AND F(11)) OR 
		 (SF(29) AND F(12)) OR 
           (SG(13) AND F(13)) OR 
		 (SG(29) AND F(14)) OR
		 (SH(13) AND F(15)) OR 
		 (SH(29) AND F(16)) OR
		 (SI(13) AND F(17)) OR
		 (SI(29) AND F(18)));
		 
OUTF(30) <= ((SA(14)  AND F(1))  OR 
           (SA(30) AND F(2))  OR 
		 (SB(14) AND F(3))  OR 
		 (SB(30) AND F(4))  OR
		 (SC(14) AND F(5))  OR 
		 (SC(30) AND F(6))  OR 
		 (SD(14) AND F(7))  OR 
		 (SD(30) AND F(8))  OR
           (SE(14) AND F(9))  OR 
		 (SE(30) AND F(10)) OR 
		 (SF(14) AND F(11)) OR 
		 (SF(30) AND F(12)) OR 
           (SG(14) AND F(13)) OR 
		 (SG(30) AND F(14)) OR
		 (SH(14) AND F(15)) OR 
		 (SH(30) AND F(16)) OR
		 (SI(14) AND F(17)) OR
		 (SI(30) AND F(18)));
		 
OUTF(31) <= ((SA(15)  AND F(1))  OR 
           (SA(31) AND F(2))  OR 
		 (SB(15) AND F(3))  OR 
		 (SB(31) AND F(4))  OR
		 (SC(15) AND F(5))  OR 
		 (SC(31) AND F(6))  OR 
		 (SD(15) AND F(7))  OR 
		 (SD(31) AND F(8))  OR
           (SE(15) AND F(9))  OR 
		 (SE(31) AND F(10)) OR 
		 (SF(15) AND F(11)) OR 
		 (SF(31) AND F(12)) OR 
           (SG(15) AND F(13)) OR 
		 (SG(31) AND F(14)) OR
		 (SH(15) AND F(15)) OR 
		 (SH(31) AND F(16)) OR
		 (SI(15) AND F(17)) OR
		 (SI(31) AND F(18)));
		 
-- SEVENTH BEST 

OUTG(0) <= ((FA(0)  AND G(1))  OR 
           (FA(16) AND G(2))  OR 
		 (FB(0)  AND G(3))  OR 
		 (FB(16) AND G(4))  OR
		 (FC(0)  AND G(5))  OR 
		 (FC(16) AND G(6))  OR 
		 (FD(0)  AND G(7))  OR 
		 (FD(16) AND G(8))  OR
           (FE(0)  AND G(9))  OR 
		 (FE(16) AND G(10)) OR 
		 (FF(0)  AND G(11)) OR 
		 (FF(16) AND G(12)) OR 
           (FG(0)  AND G(13)) OR 
		 (FG(16) AND G(14)) OR
		 (FH(0)  AND G(15)) OR 
		 (FH(16) AND G(16)) OR
		 (FI(0)  AND G(17)) OR
		 (FI(16) AND G(18)));

OUTG(1) <= ((FA(1)  AND G(1))  OR 
           (FA(17) AND G(2))  OR 
		 (FB(1)  AND G(3))  OR 
		 (FB(17) AND G(4))  OR
		 (FC(1)  AND G(5))  OR 
		 (FC(17) AND G(6))  OR 
		 (FD(1)  AND G(7))  OR 
		 (FD(17) AND G(8))  OR
           (FE(1)  AND G(9))  OR 
		 (FE(17) AND G(10)) OR 
		 (FF(1)  AND G(11)) OR 
		 (FF(17) AND G(12)) OR 
           (FG(1)  AND G(13)) OR 
		 (FG(17) AND G(14)) OR
		 (FH(1)  AND G(15)) OR 
		 (FH(17) AND G(16)) OR
		 (FI(1)  AND G(17)) OR
		 (FI(17) AND G(18)));

OUTG(2) <= ((FA(2)  AND G(1))  OR 
           (FA(18) AND G(2))  OR 
		 (FB(2)  AND G(3))  OR 
		 (FB(18) AND G(4))  OR
		 (FC(2)  AND G(5))  OR 
		 (FC(18) AND G(6))  OR 
		 (FD(2)  AND G(7))  OR 
		 (FD(18) AND G(8))  OR
           (FE(2)  AND G(9))  OR 
		 (FE(18) AND G(10)) OR 
		 (FF(2)  AND G(11)) OR 
		 (FF(18) AND G(12)) OR 
           (FG(2)  AND G(13)) OR 
		 (FG(18) AND G(14)) OR
		 (FH(2)  AND G(15)) OR 
		 (FH(18) AND G(16)) OR
		 (FI(2)  AND G(17)) OR
		 (FI(18) AND G(18)));

OUTG(3) <= ((FA(3)  AND G(1))  OR 
           (FA(19) AND G(2))  OR 
		 (FB(3)  AND G(3))  OR 
		 (FB(19) AND G(4))  OR
		 (FC(3)  AND G(5))  OR 
		 (FC(19) AND G(6))  OR 
		 (FD(3)  AND G(7))  OR 
		 (FD(19) AND G(8))  OR
           (FE(3)  AND G(9))  OR 
		 (FE(19) AND G(10)) OR 
		 (FF(3)  AND G(11)) OR 
		 (FF(19) AND G(12)) OR 
           (FG(3)  AND G(13)) OR 
		 (FG(19) AND G(14)) OR
		 (FH(3)  AND G(15)) OR 
		 (FH(19) AND G(16)) OR
		 (FI(3)  AND G(17)) OR
		 (FI(19) AND G(18)));
		 
OUTG(4) <= ((FA(4)  AND G(1))  OR 
           (FA(20) AND G(2))  OR 
		 (FB(4)  AND G(3))  OR 
		 (FB(20) AND G(4))  OR
		 (FC(4)  AND G(5))  OR 
		 (FC(20) AND G(6))  OR 
		 (FD(4)  AND G(7))  OR 
		 (FD(20) AND G(8))  OR
           (FE(4)  AND G(9))  OR 
		 (FE(20) AND G(10)) OR 
		 (FF(4)  AND G(11)) OR 
		 (FF(20) AND G(12)) OR 
           (FG(4)  AND G(13)) OR 
		 (FG(20) AND G(14)) OR
		 (FH(4)  AND G(15)) OR 
		 (FH(20) AND G(16)) OR
		 (FI(4)  AND G(17)) OR
		 (FI(20) AND G(18)));

OUTG(5) <= ((FA(5)  AND G(1))  OR 
           (FA(21) AND G(2))  OR 
		 (FB(5)  AND G(3))  OR 
		 (FB(21) AND G(4))  OR
		 (FC(5)  AND G(5))  OR 
		 (FC(21) AND G(6))  OR 
		 (FD(5)  AND G(7))  OR 
		 (FD(21) AND G(8))  OR
           (FE(5)  AND G(9))  OR 
		 (FE(21) AND G(10)) OR 
		 (FF(5)  AND G(11)) OR 
		 (FF(21) AND G(12)) OR 
           (FG(5)  AND G(13)) OR 
		 (FG(21) AND G(14)) OR
		 (FH(5)  AND G(15)) OR 
		 (FH(21) AND G(16)) OR
		 (FI(5)  AND G(17)) OR
		 (FI(21) AND G(18)));

OUTG(6) <= ((FA(6)  AND G(1))  OR 
           (FA(22) AND G(2))  OR 
		 (FB(6)  AND G(3))  OR 
		 (FB(22) AND G(4))  OR
		 (FC(6)  AND G(5))  OR 
		 (FC(22) AND G(6))  OR 
		 (FD(6)  AND G(7))  OR 
		 (FD(22) AND G(8))  OR
           (FE(6)  AND G(9))  OR 
		 (FE(22) AND G(10)) OR 
		 (FF(6)  AND G(11)) OR 
		 (FF(22) AND G(12)) OR 
           (FG(6)  AND G(13)) OR 
		 (FG(22) AND G(14)) OR
		 (FH(6)  AND G(15)) OR 
		 (FH(22) AND G(16)) OR
		 (FI(6)  AND G(17)) OR
		 (FI(22) AND G(18)));

OUTG(7) <= ((FA(7)  AND G(1))  OR 
           (FA(23) AND G(2))  OR 
		 (FB(7)  AND G(3))  OR 
		 (FB(23) AND G(4))  OR
		 (FC(7)  AND G(5))  OR 
		 (FC(23) AND G(6))  OR 
		 (FD(7)  AND G(7))  OR 
		 (FD(23) AND G(8))  OR
           (FE(7)  AND G(9))  OR 
		 (FE(23) AND G(10)) OR 
		 (FF(7)  AND G(11)) OR 
		 (FF(23) AND G(12)) OR 
           (FG(7)  AND G(13)) OR 
		 (FG(23) AND G(14)) OR
		 (FH(7)  AND G(15)) OR 
		 (FH(23) AND G(16)) OR
		 (FI(7)  AND G(17)) OR
		 (FI(23) AND G(18)));

OUTG(8) <= ((FA(8)  AND G(1))  OR 
           (FA(24) AND G(2))  OR 
		 (FB(8)  AND G(3))  OR 
		 (FB(24) AND G(4))  OR
		 (FC(8)  AND G(5))  OR 
		 (FC(24) AND G(6))  OR 
		 (FD(8)  AND G(7))  OR 
		 (FD(24) AND G(8))  OR
           (FE(8)  AND G(9))  OR 
		 (FE(24) AND G(10)) OR 
		 (FF(8)  AND G(11)) OR 
		 (FF(24) AND G(12)) OR 
           (FG(8)  AND G(13)) OR 
		 (FG(24) AND G(14)) OR
		 (FH(8)  AND G(15)) OR 
		 (FH(24) AND G(16)) OR
		 (FI(8)  AND G(17)) OR
		 (FI(24) AND G(18)));

OUTG(9) <= ((FA(9)  AND G(1))  OR 
           (FA(25) AND G(2))  OR 
		 (FB(9)  AND G(3))  OR 
		 (FB(25) AND G(4))  OR
		 (FC(9)  AND G(5))  OR 
		 (FC(25) AND G(6))  OR 
		 (FD(9)  AND G(7))  OR 
		 (FD(25) AND G(8))  OR
           (FE(9)  AND G(9))  OR 
		 (FE(25) AND G(10)) OR 
		 (FF(9)  AND G(11)) OR 
		 (FF(25) AND G(12)) OR 
           (FG(9)  AND G(13)) OR 
		 (FG(25) AND G(14)) OR
		 (FH(9)  AND G(15)) OR 
		 (FH(25) AND G(16)) OR
		 (FI(9)  AND G(17)) OR
		 (FI(25) AND G(18)));

OUTG(10) <= ((FA(10)  AND G(1))  OR 
           (FA(26) AND G(2))  OR 
		 (FB(10) AND G(3))  OR 
		 (FB(26) AND G(4))  OR
		 (FC(10) AND G(5))  OR 
		 (FC(26) AND G(6))  OR 
		 (FD(10) AND G(7))  OR 
		 (FD(26) AND G(8))  OR
           (FE(10) AND G(9))  OR 
		 (FE(26) AND G(10)) OR 
		 (FF(10) AND G(11)) OR 
		 (FF(26) AND G(12)) OR 
           (FG(10) AND G(13)) OR 
		 (FG(26) AND G(14)) OR
		 (FH(10) AND G(15)) OR 
		 (FH(26) AND G(16)) OR
		 (FI(10) AND G(17)) OR
		 (FI(26) AND G(18)));

OUTG(11) <= ((FA(11)  AND G(1))  OR 
           (FA(27) AND G(2))  OR 
		 (FB(11) AND G(3))  OR 
		 (FB(27) AND G(4))  OR
		 (FC(11) AND G(5))  OR 
		 (FC(27) AND G(6))  OR 
		 (FD(11) AND G(7))  OR 
		 (FD(27) AND G(8))  OR
           (FE(11) AND G(9))  OR 
		 (FE(27) AND G(10)) OR 
		 (FF(11) AND G(11)) OR 
		 (FF(27) AND G(12)) OR 
           (FG(11) AND G(13)) OR 
		 (FG(27) AND G(14)) OR
		 (FH(11) AND G(15)) OR 
		 (FH(27) AND G(16)) OR
		 (FI(11) AND G(17)) OR
		 (FI(27) AND G(18)));

OUTG(12) <= ((FA(12) AND G(1))  OR 
           (FA(28) AND G(2))  OR 
		 (FB(12) AND G(3))  OR 
		 (FB(28) AND G(4))  OR
		 (FC(12) AND G(5))  OR 
		 (FC(28) AND G(6))  OR 
		 (FD(12) AND G(7))  OR 
		 (FD(28) AND G(8))  OR
           (FE(12) AND G(9))  OR 
		 (FE(28) AND G(10)) OR 
		 (FF(12) AND G(11)) OR 
		 (FF(28) AND G(12)) OR 
           (FG(12) AND G(13)) OR 
		 (FG(28) AND G(14)) OR
		 (FH(12) AND G(15)) OR 
		 (FH(28) AND G(16)) OR
		 (FI(12) AND G(17)) OR
		 (FI(28) AND G(18)));

OUTG(13) <= ((FA(13) AND G(1))  OR 
           (FA(29) AND G(2))  OR 
		 (FB(13) AND G(3))  OR 
		 (FB(29) AND G(4))  OR
		 (FC(13) AND G(5))  OR 
		 (FC(29) AND G(6))  OR 
		 (FD(13) AND G(7))  OR 
		 (FD(29) AND G(8))  OR
           (FE(13) AND G(9))  OR 
		 (FE(29) AND G(10)) OR 
		 (FF(13) AND G(11)) OR 
		 (FF(29) AND G(12)) OR 
           (FG(13) AND G(13)) OR 
		 (FG(29) AND G(14)) OR
		 (FH(13) AND G(15)) OR 
		 (FH(29) AND G(16)) OR
		 (FI(13) AND G(17)) OR
		 (FI(29) AND G(18)));

OUTG(14) <= ((FA(14) AND G(1))  OR 
           (FA(30) AND G(2))  OR 
		 (FB(14) AND G(3))  OR 
		 (FB(30) AND G(4))  OR
		 (FC(14) AND G(5))  OR 
		 (FC(30) AND G(6))  OR 
		 (FD(14) AND G(7))  OR 
		 (FD(30) AND G(8))  OR
           (FE(14) AND G(9))  OR 
		 (FE(30) AND G(10)) OR 
		 (FF(14) AND G(11)) OR 
		 (FF(30) AND G(12)) OR 
           (FG(14) AND G(13)) OR 
		 (FG(30) AND G(14)) OR
		 (FH(14) AND G(15)) OR 
		 (FH(30) AND G(16)) OR
		 (FI(14) AND G(17)) OR
		 (FI(30) AND G(18)));
		 
OUTG(15) <= ((FA(15) AND G(1))  OR 
           (FA(31) AND G(2))  OR 
		 (FB(15) AND G(3))  OR 
		 (FB(31) AND G(4))  OR
		 (FC(15) AND G(5))  OR 
		 (FC(31) AND G(6))  OR 
		 (FD(15) AND G(7))  OR 
		 (FD(31) AND G(8))  OR
           (FE(15) AND G(9))  OR 
		 (FE(31) AND G(10)) OR 
		 (FF(15) AND G(11)) OR 
		 (FF(31) AND G(12)) OR 
           (FG(15) AND G(13)) OR 
		 (FG(31) AND G(14)) OR
		 (FH(15) AND G(15)) OR 
		 (FH(31) AND G(16)) OR
		 (FI(15) AND G(17)) OR
		 (FI(31) AND G(18)));
		 
OUTG(16) <= ((SA(0) AND G(1))  OR 
           (SA(16) AND G(2))  OR 
		 (SB(0)  AND G(3))  OR 
		 (SB(16) AND G(4))  OR
		 (SC(0)  AND G(5))  OR 
		 (SC(16) AND G(6))  OR 
		 (SD(0)  AND G(7))  OR 
		 (SD(16) AND G(8))  OR
           (SE(0)  AND G(9))  OR 
		 (SE(16) AND G(10)) OR 
		 (SF(0)  AND G(11)) OR 
		 (SF(16) AND G(12)) OR 
           (SG(0)  AND G(13)) OR 
		 (SG(16) AND G(14)) OR
		 (SH(0)  AND G(15)) OR 
		 (SH(16) AND G(16)) OR
		 (SI(0)  AND G(17)) OR
		 (SI(16) AND G(18)));
		 
OUTG(17) <= ((SA(1)  AND G(1))  OR 
           (SA(17) AND G(2))  OR 
		 (SB(1)  AND G(3))  OR 
		 (SB(17) AND G(4))  OR
		 (SC(1)  AND G(5))  OR 
		 (SC(17) AND G(6))  OR 
		 (SD(1)  AND G(7))  OR 
		 (SD(17) AND G(8))  OR
           (SE(1)  AND G(9))  OR 
		 (SE(17) AND G(10)) OR 
		 (SF(1)  AND G(11)) OR 
		 (SF(17) AND G(12)) OR 
           (SG(1)  AND G(13)) OR 
		 (SG(17) AND G(14)) OR
		 (SH(1)  AND G(15)) OR 
		 (SH(17) AND G(16)) OR
		 (SI(1)  AND G(17)) OR
		 (SI(17) AND G(18)));
		 
OUTG(18) <= ((SA(2)  AND G(1))  OR 
           (SA(18) AND G(2))  OR 
		 (SB(2)  AND G(3))  OR 
		 (SB(18) AND G(4))  OR
		 (SC(2)  AND G(5))  OR 
		 (SC(18) AND G(6))  OR 
		 (SD(2)  AND G(7))  OR 
		 (SD(18) AND G(8))  OR
           (SE(2)  AND G(9))  OR 
		 (SE(18) AND G(10)) OR 
		 (SF(2)  AND G(11)) OR 
		 (SF(18) AND G(12)) OR 
           (SG(2)  AND G(13)) OR 
		 (SG(18) AND G(14)) OR
		 (SH(2)  AND G(15)) OR 
		 (SH(18) AND G(16)) OR
		 (SI(2)  AND G(17)) OR
		 (SI(18) AND G(18)));

OUTG(19) <= ((SA(3)  AND G(1))  OR 
           (SA(19) AND G(2))  OR 
		 (SB(3)  AND G(3))  OR 
		 (SB(19) AND G(4))  OR
		 (SC(3)  AND G(5))  OR 
		 (SC(19) AND G(6))  OR 
		 (SD(3)  AND G(7))  OR 
		 (SD(19) AND G(8))  OR
           (SE(3)  AND G(9))  OR 
		 (SE(19) AND G(10)) OR 
		 (SF(3)  AND G(11)) OR 
		 (SF(19) AND G(12)) OR 
           (SG(3)  AND G(13)) OR 
		 (SG(19) AND G(14)) OR
		 (SH(3)  AND G(15)) OR 
		 (SH(19) AND G(16)) OR
		 (SI(3)  AND G(17)) OR
		 (SI(19) AND G(18)));

OUTG(20) <= ((SA(4)  AND G(1))  OR 
           (SA(20) AND G(2))  OR 
		 (SB(4)  AND G(3))  OR 
		 (SB(20) AND G(4))  OR
		 (SC(4)  AND G(5))  OR 
		 (SC(20) AND G(6))  OR 
		 (SD(4)  AND G(7))  OR 
		 (SD(20) AND G(8))  OR
           (SE(4)  AND G(9))  OR 
		 (SE(20) AND G(10)) OR 
		 (SF(4)  AND G(11)) OR 
		 (SF(20) AND G(12)) OR 
           (SG(4)  AND G(13)) OR 
		 (SG(20) AND G(14)) OR
		 (SH(4)  AND G(15)) OR 
		 (SH(20) AND G(16)) OR
		 (SI(4)  AND G(17)) OR
		 (SI(20) AND G(18)));

OUTG(21) <= ((SA(5)  AND G(1))  OR 
           (SA(21) AND G(2))  OR 
		 (SB(5)  AND G(3))  OR 
		 (SB(21) AND G(4))  OR
		 (SC(5)  AND G(5))  OR 
		 (SC(21) AND G(6))  OR 
		 (SD(5)  AND G(7))  OR 
		 (SD(21) AND G(8))  OR
           (SE(5)  AND G(9))  OR 
		 (SE(21) AND G(10)) OR 
		 (SF(5)  AND G(11)) OR 
		 (SF(21) AND G(12)) OR 
           (SG(5)  AND G(13)) OR 
		 (SG(21) AND G(14)) OR
		 (SH(5)  AND G(15)) OR 
		 (SH(21) AND G(16)) OR
		 (SI(5)  AND G(17)) OR
		 (SI(21) AND G(18)));
		 
OUTG(22) <= ((SA(6)  AND G(1))  OR 
           (SA(22) AND G(2))  OR 
		 (SB(6)  AND G(3))  OR 
		 (SB(22) AND G(4))  OR
		 (SC(6)  AND G(5))  OR 
		 (SC(22) AND G(6))  OR 
		 (SD(6)  AND G(7))  OR 
		 (SD(22) AND G(8))  OR
           (SE(6)  AND G(9))  OR 
		 (SE(22) AND G(10)) OR 
		 (SF(6)  AND G(11)) OR 
		 (SF(22) AND G(12)) OR 
           (SG(6)  AND G(13)) OR 
		 (SG(22) AND G(14)) OR
		 (SH(6)  AND G(15)) OR 
		 (SH(22) AND G(16)) OR
		 (SI(6)  AND G(17)) OR
		 (SI(22) AND G(18)));
		 
OUTG(23) <= ((SA(7)  AND G(1))  OR 
           (SA(23) AND G(2))  OR 
		 (SB(7)  AND G(3))  OR 
		 (SB(23) AND G(4))  OR
		 (SC(7)  AND G(5))  OR 
		 (SC(23) AND G(6))  OR 
		 (SD(7)  AND G(7))  OR 
		 (SD(23) AND G(8))  OR
           (SE(7)  AND G(9))  OR 
		 (SE(23) AND G(10)) OR 
		 (SF(7)  AND G(11)) OR 
		 (SF(23) AND G(12)) OR 
           (SG(7)  AND G(13)) OR 
		 (SG(23) AND G(14)) OR
		 (SH(7)  AND G(15)) OR 
		 (SH(23) AND G(16)) OR
		 (SI(7)  AND G(17)) OR
		 (SI(23) AND G(18)));
		 
OUTG(24) <= ((SA(8)  AND G(1))  OR 
           (SA(24) AND G(2))  OR 
		 (SB(8)  AND G(3))  OR 
		 (SB(24) AND G(4))  OR
		 (SC(8)  AND G(5))  OR 
		 (SC(24) AND G(6))  OR 
		 (SD(8)  AND G(7))  OR 
		 (SD(24) AND G(8))  OR
           (SE(8)  AND G(9))  OR 
		 (SE(24) AND G(10)) OR 
		 (SF(8)  AND G(11)) OR 
		 (SF(24) AND G(12)) OR 
           (SG(8)  AND G(13)) OR 
		 (SG(24) AND G(14)) OR
		 (SH(8)  AND G(15)) OR 
		 (SH(24) AND G(16)) OR
		 (SI(8)  AND G(17)) OR
		 (SI(24) AND G(18)));
		 
OUTG(25) <= ((SA(9)  AND G(1))  OR 
           (SA(25) AND G(2))  OR 
		 (SB(9)  AND G(3))  OR 
		 (SB(25) AND G(4))  OR
		 (SC(9)  AND G(5))  OR 
		 (SC(25) AND G(6))  OR 
		 (SD(9)  AND G(7))  OR 
		 (SD(25) AND G(8))  OR
           (SE(9)  AND G(9))  OR 
		 (SE(25) AND G(10)) OR 
		 (SF(9)  AND G(11)) OR 
		 (SF(25) AND G(12)) OR 
           (SG(9)  AND G(13)) OR 
		 (SG(25) AND G(14)) OR
		 (SH(9)  AND G(15)) OR 
		 (SH(25) AND G(16)) OR
		 (SI(9)  AND G(17)) OR
		 (SI(25) AND G(18)));
		 
OUTG(26) <= ((SA(10)  AND G(1))  OR 
           (SA(26) AND G(2))  OR 
		 (SB(10) AND G(3))  OR 
		 (SB(26) AND G(4))  OR
		 (SC(10) AND G(5))  OR 
		 (SC(26) AND G(6))  OR 
		 (SD(10) AND G(7))  OR 
		 (SD(26) AND G(8))  OR
           (SE(10) AND G(9))  OR 
		 (SE(26) AND G(10)) OR 
		 (SF(10) AND G(11)) OR 
		 (SF(26) AND G(12)) OR 
           (SG(10) AND G(13)) OR 
		 (SG(26) AND G(14)) OR
		 (SH(10) AND G(15)) OR 
		 (SH(26) AND G(16)) OR
		 (SI(10) AND G(17)) OR
		 (SI(26) AND G(18)));
		 
OUTG(27) <= (SA(11)  OR 
           SA(27)   OR 
		 SB(11)   OR 
		 SB(27)   OR
		 SC(11)   OR 
		 SC(27)   OR 
		 SD(11)   OR 
		 SD(27)   OR
           SE(11)   OR 
		 SE(27)   OR 
		 SF(11)   OR 
		 SF(27)   OR 
           SG(11)   OR 
		 SG(27)   OR
		 SH(11)   OR 
		 SH(27)   OR
		 SI(11)   OR
		 SI(27));

OUTG(28) <= ((SA(12)  AND G(1))  OR 
           (SA(28) AND G(2))  OR 
		 (SB(12) AND G(3))  OR 
		 (SB(28) AND G(4))  OR
		 (SC(12) AND G(5))  OR 
		 (SC(28) AND G(6))  OR 
		 (SD(12) AND G(7))  OR 
		 (SD(28) AND G(8))  OR
           (SE(12) AND G(9))  OR 
		 (SE(28) AND G(10)) OR 
		 (SF(12) AND G(11)) OR 
		 (SF(28) AND G(12)) OR 
           (SG(12) AND G(13)) OR 
		 (SG(28) AND G(14)) OR
		 (SH(12) AND G(15)) OR 
		 (SH(28) AND G(16)) OR
		 (SI(12) AND G(17)) OR
		 (SI(28) AND G(18)));
		 
OUTG(29) <= ((SA(13)  AND G(1))  OR 
           (SA(29) AND G(2))  OR 
		 (SB(13) AND G(3))  OR 
		 (SB(29) AND G(4))  OR
		 (SC(13) AND G(5))  OR 
		 (SC(29) AND G(6))  OR 
		 (SD(13) AND G(7))  OR 
		 (SD(29) AND G(8))  OR
           (SE(13) AND G(9))  OR 
		 (SE(29) AND G(10)) OR 
		 (SF(13) AND G(11)) OR 
		 (SF(29) AND G(12)) OR 
           (SG(13) AND G(13)) OR 
		 (SG(29) AND G(14)) OR
		 (SH(13) AND G(15)) OR 
		 (SH(29) AND G(16)) OR
		 (SI(13) AND G(17)) OR
		 (SI(29) AND G(18)));
		 
OUTG(30) <= ((SA(14)  AND G(1))  OR 
           (SA(30) AND G(2))  OR 
		 (SB(14) AND G(3))  OR 
		 (SB(30) AND G(4))  OR
		 (SC(14) AND G(5))  OR 
		 (SC(30) AND G(6))  OR 
		 (SD(14) AND G(7))  OR 
		 (SD(30) AND G(8))  OR
           (SE(14) AND G(9))  OR 
		 (SE(30) AND G(10)) OR 
		 (SF(14) AND G(11)) OR 
		 (SF(30) AND G(12)) OR 
           (SG(14) AND G(13)) OR 
		 (SG(30) AND G(14)) OR
		 (SH(14) AND G(15)) OR 
		 (SH(30) AND G(16)) OR
		 (SI(14) AND G(17)) OR
		 (SI(30) AND G(18)));
		 
OUTG(31) <= ((SA(15)  AND G(1))  OR 
           (SA(31) AND G(2))  OR 
		 (SB(15) AND G(3))  OR 
		 (SB(31) AND G(4))  OR
		 (SC(15) AND G(5))  OR 
		 (SC(31) AND G(6))  OR 
		 (SD(15) AND G(7))  OR 
		 (SD(31) AND G(8))  OR
           (SE(15) AND G(9))  OR 
		 (SE(31) AND G(10)) OR 
		 (SF(15) AND G(11)) OR 
		 (SF(31) AND G(12)) OR 
           (SG(15) AND G(13)) OR 
		 (SG(31) AND G(14)) OR
		 (SH(15) AND G(15)) OR 
		 (SH(31) AND G(16)) OR
		 (SI(15) AND G(17)) OR
		 (SI(31) AND G(18)));		 

-- EIGHTH BEST 

OUTH(0) <= ((FA(0)  AND H(1))  OR 
            (FA(16) AND H(2))  OR 
		      (FB(0)  AND H(3))  OR 
		      (FB(16) AND H(4))  OR
		      (FC(0)  AND H(5))  OR 
		      (FC(16) AND H(6))  OR 
		      (FD(0)  AND H(7))  OR 
		      (FD(16) AND H(8))  OR
            (FE(0)  AND H(9))  OR 
		      (FE(16) AND H(10)) OR 
		      (FF(0)  AND H(11)) OR 
		      (FF(16) AND H(12)) OR 
            (FG(0)  AND H(13)) OR 
		      (FG(16) AND H(14)) OR
		      (FH(0)  AND H(15)) OR 
		      (FH(16) AND H(16)) OR
		      (FI(0)  AND H(17)) OR
		      (FI(16) AND H(18)));

OUTH(1) <= ((FA(1)  AND H(1))  OR 
            (FA(17) AND H(2))  OR 
		      (FB(1)  AND H(3))  OR 
		      (FB(17) AND H(4))  OR
		      (FC(1)  AND H(5))  OR 
		      (FC(17) AND H(6))  OR 
		      (FD(1)  AND H(7))  OR 
		      (FD(17) AND H(8))  OR
            (FE(1)  AND H(9))  OR 
		      (FE(17) AND H(10)) OR 
		      (FF(1)  AND H(11)) OR 
		      (FF(17) AND H(12)) OR 
            (FG(1)  AND H(13)) OR 
		      (FG(17) AND H(14)) OR
		      (FH(1)  AND H(15)) OR 
		      (FH(17) AND H(16)) OR
		      (FI(1)  AND H(17)) OR
		      (FI(17) AND H(18)));

OUTH(2) <= ((FA(2)  AND H(1))  OR 
            (FA(18) AND H(2))  OR 
		      (FB(2)  AND H(3))  OR 
		      (FB(18) AND H(4))  OR
		      (FC(2)  AND H(5))  OR 
		      (FC(18) AND H(6))  OR 
		      (FD(2)  AND H(7))  OR 
		      (FD(18) AND H(8))  OR
            (FE(2)  AND H(9))  OR 
		      (FE(18) AND H(10)) OR 
		      (FF(2)  AND H(11)) OR 
		      (FF(18) AND H(12)) OR 
            (FG(2)  AND H(13)) OR 
		      (FG(18) AND H(14)) OR
		      (FH(2)  AND H(15)) OR 
		      (FH(18) AND H(16)) OR
		      (FI(2)  AND H(17)) OR
		      (FI(18) AND H(18)));

OUTH(3) <= ((FA(3)  AND H(1))  OR 
            (FA(19) AND H(2))  OR 
		      (FB(3)  AND H(3))  OR 
		      (FB(19) AND H(4))  OR
		      (FC(3)  AND H(5))  OR 
		      (FC(19) AND H(6))  OR 
		      (FD(3)  AND H(7))  OR 
		      (FD(19) AND H(8))  OR
            (FE(3)  AND H(9))  OR 
		      (FE(19) AND H(10)) OR 
		      (FF(3)  AND H(11)) OR 
		      (FF(19) AND H(12)) OR 
            (FG(3)  AND H(13)) OR 
		      (FG(19) AND H(14)) OR
		      (FH(3)  AND H(15)) OR 
		      (FH(19) AND H(16)) OR
		      (FI(3)  AND H(17)) OR
		      (FI(19) AND H(18)));
		 
OUTH(4) <= ((FA(4)  AND H(1))  OR 
            (FA(20) AND H(2))  OR 
		      (FB(4)  AND H(3))  OR 
		      (FB(20) AND H(4))  OR
		      (FC(4)  AND H(5))  OR 
		      (FC(20) AND H(6))  OR 
		      (FD(4)  AND H(7))  OR 
		      (FD(20) AND H(8))  OR
            (FE(4)  AND H(9))  OR 
		      (FE(20) AND H(10)) OR 
		      (FF(4)  AND H(11)) OR 
		      (FF(20) AND H(12)) OR 
            (FG(4)  AND H(13)) OR 
		      (FG(20) AND H(14)) OR
		      (FH(4)  AND H(15)) OR 
		      (FH(20) AND H(16)) OR
		      (FI(4)  AND H(17)) OR
		      (FI(20) AND H(18)));

OUTH(5) <= ((FA(5)  AND H(1))  OR 
            (FA(21) AND H(2))  OR 
		      (FB(5)  AND H(3))  OR 
		      (FB(21) AND H(4))  OR
		      (FC(5)  AND H(5))  OR 
		      (FC(21) AND H(6))  OR 
		      (FD(5)  AND H(7))  OR 
		      (FD(21) AND H(8))  OR
            (FE(5)  AND H(9))  OR 
		      (FE(21) AND H(10)) OR 
		      (FF(5)  AND H(11)) OR 
		      (FF(21) AND H(12)) OR 
            (FG(5)  AND H(13)) OR 
		      (FG(21) AND H(14)) OR
		      (FH(5)  AND H(15)) OR 
		      (FH(21) AND H(16)) OR
		      (FI(5)  AND H(17)) OR
		      (FI(21) AND H(18)));

OUTH(6) <= ((FA(6)  AND H(1))  OR 
            (FA(22) AND H(2))  OR 
		      (FB(6)  AND H(3))  OR 
		      (FB(22) AND H(4))  OR
		      (FC(6)  AND H(5))  OR 
		      (FC(22) AND H(6))  OR 
		      (FD(6)  AND H(7))  OR 
		      (FD(22) AND H(8))  OR
            (FE(6)  AND H(9))  OR 
		      (FE(22) AND H(10)) OR 
		      (FF(6)  AND H(11)) OR 
		      (FF(22) AND H(12)) OR 
            (FG(6)  AND H(13)) OR 
		      (FG(22) AND H(14)) OR
		      (FH(6)  AND H(15)) OR 
		      (FH(22) AND H(16)) OR
		      (FI(6)  AND H(17)) OR
		      (FI(22) AND H(18)));

OUTH(7) <= ((FA(7)  AND H(1))  OR 
            (FA(23) AND H(2))  OR 
		      (FB(7)  AND H(3))  OR 
		      (FB(23) AND H(4))  OR
		      (FC(7)  AND H(5))  OR 
		      (FC(23) AND H(6))  OR 
		      (FD(7)  AND H(7))  OR 
		      (FD(23) AND H(8))  OR
            (FE(7)  AND H(9))  OR 
		      (FE(23) AND H(10)) OR 
		      (FF(7)  AND H(11)) OR 
		      (FF(23) AND H(12)) OR 
            (FG(7)  AND H(13)) OR 
		      (FG(23) AND H(14)) OR
		      (FH(7)  AND H(15)) OR 
		      (FH(23) AND H(16)) OR
		      (FI(7)  AND H(17)) OR
		      (FI(23) AND H(18)));

OUTH(8) <= ((FA(8)  AND H(1))  OR 
            (FA(24) AND H(2))  OR 
		      (FB(8)  AND H(3))  OR 
		      (FB(24) AND H(4))  OR
		      (FC(8)  AND H(5))  OR 
		      (FC(24) AND H(6))  OR 
		      (FD(8)  AND H(7))  OR 
		      (FD(24) AND H(8))  OR
            (FE(8)  AND H(9))  OR 
		      (FE(24) AND H(10)) OR 
		      (FF(8)  AND H(11)) OR 
		      (FF(24) AND H(12)) OR 
            (FG(8)  AND H(13)) OR 
		      (FG(24) AND H(14)) OR
		      (FH(8)  AND H(15)) OR 
		      (FH(24) AND H(16)) OR
		      (FI(8)  AND H(17)) OR
		      (FI(24) AND H(18)));

OUTH(9) <= ((FA(9)  AND H(1))  OR 
            (FA(25) AND H(2))  OR 
		      (FB(9)  AND H(3))  OR 
		      (FB(25) AND H(4))  OR
		      (FC(9)  AND H(5))  OR 
		      (FC(25) AND H(6))  OR 
		      (FD(9)  AND H(7))  OR 
		      (FD(25) AND H(8))  OR
            (FE(9)  AND H(9))  OR 
		      (FE(25) AND H(10)) OR 
		      (FF(9)  AND H(11)) OR 
		      (FF(25) AND H(12)) OR 
            (FG(9)  AND H(13)) OR 
		      (FG(25) AND H(14)) OR
		      (FH(9)  AND H(15)) OR 
		      (FH(25) AND H(16)) OR
		      (FI(9)  AND H(17)) OR
		      (FI(25) AND H(18)));

OUTH(10) <= ((FA(10) AND H(1)) OR 
             (FA(26) AND H(2)) OR 
		       (FB(10) AND H(3))  OR 
		       (FB(26) AND H(4))  OR
		       (FC(10) AND H(5))  OR 
		       (FC(26) AND H(6))  OR 
		       (FD(10) AND H(7))  OR 
		       (FD(26) AND H(8))  OR
             (FE(10) AND H(9))  OR 
		       (FE(26) AND H(10)) OR 
		       (FF(10) AND H(11)) OR 
		       (FF(26) AND H(12)) OR 
             (FG(10) AND H(13)) OR 
		       (FG(26) AND H(14)) OR
		       (FH(10) AND H(15)) OR 
		       (FH(26) AND H(16)) OR
		       (FI(10) AND H(17)) OR
		       (FI(26) AND H(18)));

OUTH(11) <= ((FA(11) AND H(1))  OR 
             (FA(27) AND H(2))  OR 
		       (FB(11) AND H(3))  OR 
		       (FB(27) AND H(4))  OR
		       (FC(11) AND H(5))  OR 
		       (FC(27) AND H(6))  OR 
		       (FD(11) AND H(7))  OR 
		       (FD(27) AND H(8))  OR
             (FE(11) AND H(9))  OR 
	      	 (FE(27) AND H(10)) OR 
	      	 (FF(11) AND H(11)) OR 
	      	 (FF(27) AND H(12)) OR 
             (FG(11) AND H(13)) OR 
		       (FG(27) AND H(14)) OR
		       (FH(11) AND H(15)) OR 
		       (FH(27) AND H(16)) OR
		       (FI(11) AND H(17)) OR
		       (FI(27) AND H(18)));

OUTH(12) <= ((FA(12) AND H(1))  OR 
             (FA(28) AND H(2))  OR 
		       (FB(12) AND H(3))  OR 
		       (FB(28) AND H(4))  OR
		       (FC(12) AND H(5))  OR 
		       (FC(28) AND H(6))  OR 
		       (FD(12) AND H(7))  OR 
		       (FD(28) AND H(8))  OR
             (FE(12) AND H(9))  OR 
	      	 (FE(28) AND H(10)) OR 
	      	 (FF(12) AND H(11)) OR 
	       	 (FF(28) AND H(12)) OR 
             (FG(12) AND H(13)) OR 
		       (FG(28) AND H(14)) OR
		       (FH(12) AND H(15)) OR 
		       (FH(28) AND H(16)) OR
		       (FI(12) AND H(17)) OR
		       (FI(28) AND H(18)));

OUTH(13) <= ((FA(13) AND H(1))  OR 
             (FA(29) AND H(2))  OR 
		       (FB(13) AND H(3))  OR 
		       (FB(29) AND H(4))  OR
		       (FC(13) AND H(5))  OR 
		       (FC(29) AND H(6))  OR 
		       (FD(13) AND H(7))  OR 
		       (FD(29) AND H(8))  OR
             (FE(13) AND H(9))  OR 
	       	 (FE(29) AND H(10)) OR 
	      	 (FF(13) AND H(11)) OR 
	      	 (FF(29) AND H(12)) OR 
             (FG(13) AND H(13)) OR 
	      	 (FG(29) AND H(14)) OR
	       	 (FH(13) AND H(15)) OR 
	      	 (FH(29) AND H(16)) OR
	      	 (FI(13) AND H(17)) OR
	      	 (FI(29) AND H(18)));

OUTH(14) <= ((FA(14) AND H(1))  OR 
             (FA(30) AND H(2))  OR 
	      	 (FB(14) AND H(3))  OR 
	      	 (FB(30) AND H(4))  OR
	      	 (FC(14) AND H(5))  OR 
	      	 (FC(30) AND H(6))  OR 
	      	 (FD(14) AND H(7))  OR 
	      	 (FD(30) AND H(8))  OR
             (FE(14) AND H(9))  OR 
		       (FE(30) AND H(10)) OR 
		       (FF(14) AND H(11)) OR 
		       (FF(30) AND H(12)) OR 
             (FG(14) AND H(13)) OR 
	      	 (FG(30) AND H(14)) OR
	      	 (FH(14) AND H(15)) OR 
	      	 (FH(30) AND H(16)) OR
	      	 (FI(14) AND H(17)) OR
	      	 (FI(30) AND H(18)));
		 
OUTH(15) <= ((FA(15) AND H(1))  OR 
             (FA(31) AND H(2))  OR 
		       (FB(15) AND H(3))  OR 
		       (FB(31) AND H(4))  OR
	      	 (FC(15) AND H(5))  OR 
	       	 (FC(31) AND H(6))  OR 
	      	 (FD(15) AND H(7))  OR 
      		 (FD(31) AND H(8))  OR
             (FE(15) AND H(9))  OR 
	      	 (FE(31) AND H(10)) OR 
	      	 (FF(15) AND H(11)) OR 
	      	 (FF(31) AND H(12)) OR 
             (FG(15) AND H(13)) OR 
	      	 (FG(31) AND H(14)) OR
	      	 (FH(15) AND H(15)) OR 
	       	 (FH(31) AND H(16)) OR
	      	 (FI(15) AND H(17)) OR
	      	 (FI(31) AND H(18)));
		 
OUTH(16) <= ((SA(0) AND H(1))  OR 
            (SA(16) AND H(2))  OR 
		      (SB(0)  AND H(3))  OR 
	      	(SB(16) AND H(4))  OR
	      	(SC(0)  AND H(5))  OR 
		      (SC(16) AND H(6))  OR 
		      (SD(0)  AND H(7))  OR 
		      (SD(16) AND H(8))  OR
            (SE(0)  AND H(9))  OR 
		      (SE(16) AND H(10)) OR 
		      (SF(0)  AND H(11)) OR 
		      (SF(16) AND H(12)) OR 
            (SG(0)  AND H(13)) OR 
		      (SG(16) AND H(14)) OR
		      (SH(0)  AND H(15)) OR 
		      (SH(16) AND H(16)) OR
		      (SI(0)  AND H(17)) OR
		      (SI(16) AND H(18)));
		 
OUTH(17) <= ((SA(1) AND H(1))  OR 
            (SA(17) AND H(2))  OR 
	     	   (SB(1)  AND H(3))  OR 
		      (SB(17) AND H(4))  OR
		      (SC(1)  AND H(5))  OR 
		      (SC(17) AND H(6))  OR 
		      (SD(1)  AND H(7))  OR 
		      (SD(17) AND H(8))  OR
            (SE(1)  AND H(9))  OR 
		      (SE(17) AND H(10)) OR 
		      (SF(1)  AND H(11)) OR 
		      (SF(17) AND H(12)) OR 
            (SG(1)  AND H(13)) OR 
		      (SG(17) AND H(14)) OR
		      (SH(1)  AND H(15)) OR 
		      (SH(17) AND H(16)) OR
		      (SI(1)  AND H(17)) OR
		      (SI(17) AND H(18)));
		 
OUTH(18) <= ((SA(2) AND H(1))  OR 
            (SA(18) AND H(2))  OR 
		      (SB(2)  AND H(3))  OR 
		      (SB(18) AND H(4))  OR
		      (SC(2)  AND H(5))  OR 
		      (SC(18) AND H(6))  OR 
		      (SD(2)  AND H(7))  OR 
		      (SD(18) AND H(8))  OR
            (SE(2)  AND H(9))  OR 
		      (SE(18) AND H(10)) OR 
		      (SF(2)  AND H(11)) OR 
		      (SF(18) AND H(12)) OR 
            (SG(2)  AND H(13)) OR 
		      (SG(18) AND H(14)) OR
		      (SH(2)  AND H(15)) OR 
		      (SH(18) AND H(16)) OR
		      (SI(2)  AND H(17)) OR
		      (SI(18) AND H(18)));

OUTH(19) <= ((SA(3) AND H(1))  OR 
            (SA(19) AND H(2))  OR 
		      (SB(3)  AND H(3))  OR 
		      (SB(19) AND H(4))  OR
		      (SC(3)  AND H(5))  OR 
		      (SC(19) AND H(6))  OR 
		      (SD(3)  AND H(7))  OR 
		      (SD(19) AND H(8))  OR
            (SE(3)  AND H(9))  OR 
		      (SE(19) AND H(10)) OR 
		      (SF(3)  AND H(11)) OR 
		      (SF(19) AND H(12)) OR 
            (SG(3)  AND H(13)) OR 
		      (SG(19) AND H(14)) OR
		      (SH(3)  AND H(15)) OR 
		      (SH(19) AND H(16)) OR
		      (SI(3)  AND H(17)) OR
		      (SI(19) AND H(18)));

OUTH(20) <= ((SA(4) AND H(1))  OR 
            (SA(20) AND H(2))  OR 
		      (SB(4)  AND H(3))  OR 
		      (SB(20) AND H(4))  OR
		      (SC(4)  AND H(5))  OR 
		      (SC(20) AND H(6))  OR 
		      (SD(4)  AND H(7))  OR 
		      (SD(20) AND H(8))  OR
            (SE(4)  AND H(9))  OR 
		      (SE(20) AND H(10)) OR 
		      (SF(4)  AND H(11)) OR 
		      (SF(20) AND H(12)) OR 
            (SG(4)  AND H(13)) OR 
		      (SG(20) AND H(14)) OR
		      (SH(4)  AND H(15)) OR 
		      (SH(20) AND H(16)) OR
		      (SI(4)  AND H(17)) OR
		      (SI(20) AND H(18)));

OUTH(21) <= ((SA(5) AND H(1))  OR 
            (SA(21) AND H(2))  OR 
		      (SB(5)  AND H(3))  OR 
		      (SB(21) AND H(4))  OR
		      (SC(5)  AND H(5))  OR 
		      (SC(21) AND H(6))  OR 
		      (SD(5)  AND H(7))  OR 
		      (SD(21) AND H(8))  OR
            (SE(5)  AND H(9))  OR 
	      	(SE(21) AND H(10)) OR 
		      (SF(5)  AND H(11)) OR 
		      (SF(21) AND H(12)) OR 
            (SG(5)  AND H(13)) OR 
		      (SG(21) AND H(14)) OR
		      (SH(5)  AND H(15)) OR 
		      (SH(21) AND H(16)) OR
		      (SI(5)  AND H(17)) OR
		      (SI(21) AND H(18)));
		 
OUTH(22) <= ((SA(6) AND H(1))  OR 
            (SA(22) AND H(2))  OR 
		      (SB(6)  AND H(3))  OR 
		      (SB(22) AND H(4))  OR
		      (SC(6)  AND H(5))  OR 
		      (SC(22) AND H(6))  OR 
		      (SD(6)  AND H(7))  OR 
		      (SD(22) AND H(8))  OR
            (SE(6)  AND H(9))  OR 
		      (SE(22) AND H(10)) OR 
		      (SF(6)  AND H(11)) OR 
		      (SF(22) AND H(12)) OR 
            (SG(6)  AND H(13)) OR 
		      (SG(22) AND H(14)) OR
		      (SH(6)  AND H(15)) OR 
		      (SH(22) AND H(16)) OR
		      (SI(6)  AND H(17)) OR
		      (SI(22) AND H(18)));
		 
OUTH(23) <= ((SA(7) AND H(1))  OR 
            (SA(23) AND H(2))  OR 
		      (SB(7)  AND H(3))  OR 
		      (SB(23) AND H(4))  OR
		      (SC(7)  AND H(5))  OR 
		      (SC(23) AND H(6))  OR 
		      (SD(7)  AND H(7))  OR 
		      (SD(23) AND H(8))  OR
            (SE(7)  AND H(9))  OR 
		      (SE(23) AND H(10)) OR 
		      (SF(7)  AND H(11)) OR 
		      (SF(23) AND H(12)) OR 
            (SG(7)  AND H(13)) OR 
		      (SG(23) AND H(14)) OR
		      (SH(7)  AND H(15)) OR 
		      (SH(23) AND H(16)) OR
		      (SI(7)  AND H(17)) OR
		      (SI(23) AND H(18)));
		 
OUTH(24) <= ((SA(8) AND H(1))  OR 
            (SA(24) AND H(2))  OR 
		      (SB(8)  AND H(3))  OR 
		      (SB(24) AND H(4))  OR
		      (SC(8)  AND H(5))  OR 
		      (SC(24) AND H(6))  OR 
		      (SD(8)  AND H(7))  OR 
		      (SD(24) AND H(8))  OR
            (SE(8)  AND H(9))  OR 
		      (SE(24) AND H(10)) OR 
		      (SF(8)  AND H(11)) OR 
		      (SF(24) AND H(12)) OR 
            (SG(8)  AND H(13)) OR 
		      (SG(24) AND H(14)) OR
		      (SH(8)  AND H(15)) OR 
		      (SH(24) AND H(16)) OR
		      (SI(8)  AND H(17)) OR
		      (SI(24) AND H(18)));
		 
OUTH(25) <= ((SA(9) AND H(1))  OR 
            (SA(25) AND H(2))  OR 
		      (SB(9)  AND H(3))  OR 
		      (SB(25) AND H(4))  OR
		      (SC(9)  AND H(5))  OR 
		      (SC(25) AND H(6))  OR 
		      (SD(9)  AND H(7))  OR 
		      (SD(25) AND H(8))  OR
            (SE(9)  AND H(9))  OR 
		      (SE(25) AND H(10)) OR 
		      (SF(9)  AND H(11)) OR 
		      (SF(25) AND H(12)) OR 
            (SG(9)  AND H(13)) OR 
		      (SG(25) AND H(14)) OR
	     	   (SH(9)  AND H(15)) OR 
		      (SH(25) AND H(16)) OR
		      (SI(9)  AND H(17)) OR
		      (SI(25) AND H(18)));
		 
OUTH(26) <= ((SA(10) AND H(1))  OR 
             (SA(26) AND H(2))  OR 
		       (SB(10) AND H(3))  OR 
		       (SB(26) AND H(4))  OR
		       (SC(10) AND H(5))  OR 
		       (SC(26) AND H(6))  OR 
		       (SD(10) AND H(7))  OR 
		       (SD(26) AND H(8))  OR
             (SE(10) AND H(9))  OR 
		       (SE(26) AND H(10)) OR 
		       (SF(10) AND H(11)) OR 
		       (SF(26) AND H(12)) OR 
             (SG(10) AND H(13)) OR 
		       (SG(26) AND H(14)) OR
		       (SH(10) AND H(15)) OR 
		       (SH(26) AND H(16)) OR
		       (SI(10) AND H(17)) OR
		       (SI(26) AND H(18)));
		 
OUTH(27) <= (SA(11)  OR 
            SA(27)   OR 
		      SB(11)   OR 
		      SB(27)   OR
		      SC(11)   OR 
		      SC(27)   OR 
		      SD(11)   OR 
		      SD(27)   OR
            SE(11)   OR 
		      SE(27)   OR 
		      SF(11)   OR 
		      SF(27)   OR 
            SG(11)   OR 
		      SG(27)   OR
		      SH(11)   OR 
		      SH(27)   OR
		      SI(11)   OR
		      SI(27));

OUTH(28) <= ((SA(12)  AND H(1))  OR 
              (SA(28) AND H(2))  OR 
		        (SB(12) AND H(3))  OR 
		        (SB(28) AND H(4))  OR
		        (SC(12) AND H(5))  OR 
		        (SC(28) AND H(6))  OR 
		        (SD(12) AND H(7))  OR 
	        	  (SD(28) AND H(8))  OR
              (SE(12) AND H(9))  OR 
		        (SE(28) AND H(10)) OR 
		        (SF(12) AND H(11)) OR 
		        (SF(28) AND H(12)) OR 
              (SG(12) AND H(13)) OR 
		        (SG(28) AND H(14)) OR
		        (SH(12) AND H(15)) OR 
		        (SH(28) AND H(16)) OR
		        (SI(12) AND H(17)) OR
		        (SI(28) AND H(18)));
		 
OUTH(29) <= ((SA(13)  AND H(1))  OR 
              (SA(29) AND H(2))  OR 
		        (SB(13) AND H(3))  OR 
		        (SB(29) AND H(4))  OR
		        (SC(13) AND H(5))  OR 
		        (SC(29) AND H(6))  OR 
		        (SD(13) AND H(7))  OR 
		        (SD(29) AND H(8))  OR
              (SE(13) AND H(9))  OR 
	           (SE(29) AND H(10)) OR 
		        (SF(13) AND H(11)) OR 
		        (SF(29) AND H(12)) OR 
              (SG(13) AND H(13)) OR 
		        (SG(29) AND H(14)) OR
		        (SH(13) AND H(15)) OR 
		        (SH(29) AND H(16)) OR
		        (SI(13) AND H(17)) OR
		        (SI(29) AND H(18)));
		 
OUTH(30) <= ((SA(14)  AND H(1))  OR 
              (SA(30) AND H(2))  OR 
		        (SB(14) AND H(3))  OR 
		        (SB(30) AND H(4))  OR
	           (SC(14) AND H(5))  OR 
		        (SC(30) AND H(6))  OR 
		        (SD(14) AND H(7))  OR 
		        (SD(30) AND H(8))  OR
              (SE(14) AND H(9))  OR 
		        (SE(30) AND H(10)) OR 
		        (SF(14) AND H(11)) OR 
		        (SF(30) AND H(12)) OR 
              (SG(14) AND H(13)) OR 
		        (SG(30) AND H(14)) OR
		        (SH(14) AND H(15)) OR 
		        (SH(30) AND H(16)) OR
		        (SI(14) AND H(17)) OR
	           (SI(30) AND H(18)));
		 
OUTH(31) <= ((SA(15)  AND H(1))  OR 
              (SA(31) AND H(2))  OR 
		        (SB(15) AND H(3))  OR 
		        (SB(31) AND H(4))  OR
		        (SC(15) AND H(5))  OR 
		        (SC(31) AND H(6))  OR 
		        (SD(15) AND H(7))  OR 
		        (SD(31) AND H(8))  OR
              (SE(15) AND H(9))  OR 
		        (SE(31) AND H(10)) OR 
		        (SF(15) AND H(11)) OR 
		        (SF(31) AND H(12)) OR 
              (SG(15) AND H(13)) OR 
		        (SG(31) AND H(14)) OR
		        (SH(15) AND H(15)) OR 
		        (SH(31) AND H(16)) OR
		        (SI(15) AND H(17)) OR
		        (SI(31) AND H(18)));		 

-- NINTH BEST 

OUTI(0) <= ((FA(0)  AND I(1))  OR 
            (FA(16) AND I(2))  OR 
		      (FB(0)  AND I(3))  OR 
		      (FB(16) AND I(4))  OR
		      (FC(0)  AND I(5))  OR 
		      (FC(16) AND I(6))  OR 
		      (FD(0)  AND I(7))  OR 
		      (FD(16) AND I(8))  OR
            (FE(0)  AND I(9))  OR 
		      (FE(16) AND I(10)) OR 
		      (FF(0)  AND I(11)) OR 
		      (FF(16) AND I(12)) OR 
            (FG(0)  AND I(13)) OR 
		      (FG(16) AND I(14)) OR
		      (FH(0)  AND I(15)) OR 
		      (FH(16) AND I(16)) OR
		      (FI(0)  AND I(17)) OR
		      (FI(16) AND I(18)));

OUTI(1) <= ((FA(1)  AND I(1))  OR 
            (FA(17) AND I(2))  OR 
		      (FB(1)  AND I(3))  OR 
		      (FB(17) AND I(4))  OR
		      (FC(1)  AND I(5))  OR 
		      (FC(17) AND I(6))  OR 
		      (FD(1)  AND I(7))  OR 
		      (FD(17) AND I(8))  OR
            (FE(1)  AND I(9))  OR 
		      (FE(17) AND I(10)) OR 
		      (FF(1)  AND I(11)) OR 
		      (FF(17) AND I(12)) OR 
            (FG(1)  AND I(13)) OR 
		      (FG(17) AND I(14)) OR
		      (FH(1)  AND I(15)) OR 
		      (FH(17) AND I(16)) OR
		      (FI(1)  AND I(17)) OR
		      (FI(17) AND I(18)));

OUTI(2) <= ((FA(2)  AND I(1))  OR 
            (FA(18) AND I(2))  OR 
		      (FB(2)  AND I(3))  OR 
		      (FB(18) AND I(4))  OR
		      (FC(2)  AND I(5))  OR 
		      (FC(18) AND I(6))  OR 
		      (FD(2)  AND I(7))  OR 
		      (FD(18) AND I(8))  OR
            (FE(2)  AND I(9))  OR 
		      (FE(18) AND I(10)) OR 
		      (FF(2)  AND I(11)) OR 
		      (FF(18) AND I(12)) OR 
            (FG(2)  AND I(13)) OR 
		      (FG(18) AND I(14)) OR
		      (FH(2)  AND I(15)) OR 
		      (FH(18) AND I(16)) OR
		      (FI(2)  AND I(17)) OR
		      (FI(18) AND I(18)));

OUTI(3) <= ((FA(3)  AND I(1))  OR 
            (FA(19) AND I(2))  OR 
		      (FB(3)  AND I(3))  OR 
		      (FB(19) AND I(4))  OR
		      (FC(3)  AND I(5))  OR 
		      (FC(19) AND I(6))  OR 
		      (FD(3)  AND I(7))  OR 
		      (FD(19) AND I(8))  OR
            (FE(3)  AND I(9))  OR 
		      (FE(19) AND I(10)) OR 
		      (FF(3)  AND I(11)) OR 
		      (FF(19) AND I(12)) OR 
            (FG(3)  AND I(13)) OR 
		      (FG(19) AND I(14)) OR
		      (FH(3)  AND I(15)) OR 
		      (FH(19) AND I(16)) OR
		      (FI(3)  AND I(17)) OR
		      (FI(19) AND I(18)));
		 
OUTI(4) <= ((FA(4)  AND I(1))  OR 
            (FA(20) AND I(2))  OR 
		      (FB(4)  AND I(3))  OR 
		      (FB(20) AND I(4))  OR
		      (FC(4)  AND I(5))  OR 
		      (FC(20) AND I(6))  OR 
		      (FD(4)  AND I(7))  OR 
		      (FD(20) AND I(8))  OR
            (FE(4)  AND I(9))  OR 
		      (FE(20) AND I(10)) OR 
		      (FF(4)  AND I(11)) OR 
		      (FF(20) AND I(12)) OR 
            (FG(4)  AND I(13)) OR 
		      (FG(20) AND I(14)) OR
		      (FH(4)  AND I(15)) OR 
		      (FH(20) AND I(16)) OR
		      (FI(4)  AND I(17)) OR
		      (FI(20) AND I(18)));

OUTI(5) <= ((FA(5)  AND I(1))  OR 
            (FA(21) AND I(2))  OR 
		      (FB(5)  AND I(3))  OR 
		      (FB(21) AND I(4))  OR
		      (FC(5)  AND I(5))  OR 
		      (FC(21) AND I(6))  OR 
		      (FD(5)  AND I(7))  OR 
		      (FD(21) AND I(8))  OR
            (FE(5)  AND I(9))  OR 
		      (FE(21) AND I(10)) OR 
		      (FF(5)  AND I(11)) OR 
		      (FF(21) AND I(12)) OR 
            (FG(5)  AND I(13)) OR 
		      (FG(21) AND I(14)) OR
		      (FH(5)  AND I(15)) OR 
		      (FH(21) AND I(16)) OR
		      (FI(5)  AND I(17)) OR
		      (FI(21) AND I(18)));

OUTI(6) <= ((FA(6)  AND I(1))  OR 
            (FA(22) AND I(2))  OR 
		      (FB(6)  AND I(3))  OR 
		      (FB(22) AND I(4))  OR
		      (FC(6)  AND I(5))  OR 
		      (FC(22) AND I(6))  OR 
		      (FD(6)  AND I(7))  OR 
		      (FD(22) AND I(8))  OR
            (FE(6)  AND I(9))  OR 
		      (FE(22) AND I(10)) OR 
		      (FF(6)  AND I(11)) OR 
		      (FF(22) AND I(12)) OR 
            (FG(6)  AND I(13)) OR 
		      (FG(22) AND I(14)) OR
		      (FH(6)  AND I(15)) OR 
		      (FH(22) AND I(16)) OR
		      (FI(6)  AND I(17)) OR
		      (FI(22) AND I(18)));

OUTI(7) <= ((FA(7)  AND I(1))  OR 
            (FA(23) AND I(2))  OR 
		      (FB(7)  AND I(3))  OR 
		      (FB(23) AND I(4))  OR
		      (FC(7)  AND I(5))  OR 
		      (FC(23) AND I(6))  OR 
		      (FD(7)  AND I(7))  OR 
		      (FD(23) AND I(8))  OR
            (FE(7)  AND I(9))  OR 
		      (FE(23) AND I(10)) OR 
		      (FF(7)  AND I(11)) OR 
		      (FF(23) AND I(12)) OR 
            (FG(7)  AND I(13)) OR 
		      (FG(23) AND I(14)) OR
		      (FH(7)  AND I(15)) OR 
		      (FH(23) AND I(16)) OR
		      (FI(7)  AND I(17)) OR
		      (FI(23) AND I(18)));

OUTI(8) <= ((FA(8)  AND I(1))  OR 
            (FA(24) AND I(2))  OR 
		      (FB(8)  AND I(3))  OR 
		      (FB(24) AND I(4))  OR
		      (FC(8)  AND I(5))  OR 
		      (FC(24) AND I(6))  OR 
		      (FD(8)  AND I(7))  OR 
		      (FD(24) AND I(8))  OR
            (FE(8)  AND I(9))  OR 
		      (FE(24) AND I(10)) OR 
		      (FF(8)  AND I(11)) OR 
		      (FF(24) AND I(12)) OR 
            (FG(8)  AND I(13)) OR 
		      (FG(24) AND I(14)) OR
		      (FH(8)  AND I(15)) OR 
		      (FH(24) AND I(16)) OR
		      (FI(8)  AND I(17)) OR
		      (FI(24) AND I(18)));

OUTI(9) <= ((FA(9)  AND I(1))  OR 
            (FA(25) AND I(2))  OR 
		      (FB(9)  AND I(3))  OR 
		      (FB(25) AND I(4))  OR
		      (FC(9)  AND I(5))  OR 
		      (FC(25) AND I(6))  OR 
		      (FD(9)  AND I(7))  OR 
		      (FD(25) AND I(8))  OR
            (FE(9)  AND I(9))  OR 
		      (FE(25) AND I(10)) OR 
		      (FF(9)  AND I(11)) OR 
		      (FF(25) AND I(12)) OR 
            (FG(9)  AND I(13)) OR 
		      (FG(25) AND I(14)) OR
		      (FH(9)  AND I(15)) OR 
		      (FH(25) AND I(16)) OR
		      (FI(9)  AND I(17)) OR
		      (FI(25) AND I(18)));

OUTI(10) <= ((FA(10) AND I(1)) OR 
             (FA(26) AND I(2)) OR 
		       (FB(10) AND I(3))  OR 
		       (FB(26) AND I(4))  OR
		       (FC(10) AND I(5))  OR 
		       (FC(26) AND I(6))  OR 
		       (FD(10) AND I(7))  OR 
		       (FD(26) AND I(8))  OR
             (FE(10) AND I(9))  OR 
		       (FE(26) AND I(10)) OR 
		       (FF(10) AND I(11)) OR 
		       (FF(26) AND I(12)) OR 
             (FG(10) AND I(13)) OR 
		       (FG(26) AND I(14)) OR
		       (FH(10) AND I(15)) OR 
		       (FH(26) AND I(16)) OR
		       (FI(10) AND I(17)) OR
		       (FI(26) AND I(18)));

OUTI(11) <= ((FA(11) AND I(1))  OR 
             (FA(27) AND I(2))  OR 
		       (FB(11) AND I(3))  OR 
		       (FB(27) AND I(4))  OR
		       (FC(11) AND I(5))  OR 
		       (FC(27) AND I(6))  OR 
		       (FD(11) AND I(7))  OR 
		       (FD(27) AND I(8))  OR
             (FE(11) AND I(9))  OR 
	      	 (FE(27) AND I(10)) OR 
	      	 (FF(11) AND I(11)) OR 
	      	 (FF(27) AND I(12)) OR 
             (FG(11) AND I(13)) OR 
		       (FG(27) AND I(14)) OR
		       (FH(11) AND I(15)) OR 
		       (FH(27) AND I(16)) OR
		       (FI(11) AND I(17)) OR
		       (FI(27) AND I(18)));

OUTI(12) <= ((FA(12) AND I(1))  OR 
             (FA(28) AND I(2))  OR 
		       (FB(12) AND I(3))  OR 
		       (FB(28) AND I(4))  OR
		       (FC(12) AND I(5))  OR 
		       (FC(28) AND I(6))  OR 
		       (FD(12) AND I(7))  OR 
		       (FD(28) AND I(8))  OR
             (FE(12) AND I(9))  OR 
	      	 (FE(28) AND I(10)) OR 
	      	 (FF(12) AND I(11)) OR 
	       	 (FF(28) AND I(12)) OR 
             (FG(12) AND I(13)) OR 
		       (FG(28) AND I(14)) OR
		       (FH(12) AND I(15)) OR 
		       (FH(28) AND I(16)) OR
		       (FI(12) AND I(17)) OR
		       (FI(28) AND I(18)));

OUTI(13) <= ((FA(13) AND I(1))  OR 
             (FA(29) AND I(2))  OR 
		       (FB(13) AND I(3))  OR 
		       (FB(29) AND I(4))  OR
		       (FC(13) AND I(5))  OR 
		       (FC(29) AND I(6))  OR 
		       (FD(13) AND I(7))  OR 
		       (FD(29) AND I(8))  OR
             (FE(13) AND I(9))  OR 
	       	 (FE(29) AND I(10)) OR 
	      	 (FF(13) AND I(11)) OR 
	      	 (FF(29) AND I(12)) OR 
             (FG(13) AND I(13)) OR 
	      	 (FG(29) AND I(14)) OR
	       	 (FH(13) AND I(15)) OR 
	      	 (FH(29) AND I(16)) OR
	      	 (FI(13) AND I(17)) OR
	      	 (FI(29) AND I(18)));

OUTI(14) <= ((FA(14) AND I(1))  OR 
             (FA(30) AND I(2))  OR 
	      	 (FB(14) AND I(3))  OR 
	      	 (FB(30) AND I(4))  OR
	      	 (FC(14) AND I(5))  OR 
	      	 (FC(30) AND I(6))  OR 
	      	 (FD(14) AND I(7))  OR 
	      	 (FD(30) AND I(8))  OR
             (FE(14) AND I(9))  OR 
		       (FE(30) AND I(10)) OR 
		       (FF(14) AND I(11)) OR 
		       (FF(30) AND I(12)) OR 
             (FG(14) AND I(13)) OR 
	      	 (FG(30) AND I(14)) OR
	      	 (FH(14) AND I(15)) OR 
	      	 (FH(30) AND I(16)) OR
	      	 (FI(14) AND I(17)) OR
	      	 (FI(30) AND I(18)));
		 
OUTI(15) <= ((FA(15) AND I(1))  OR 
             (FA(31) AND I(2))  OR 
		       (FB(15) AND I(3))  OR 
		       (FB(31) AND I(4))  OR
	      	 (FC(15) AND I(5))  OR 
	       	 (FC(31) AND I(6))  OR 
	      	 (FD(15) AND I(7))  OR 
      		 (FD(31) AND I(8))  OR
             (FE(15) AND I(9))  OR 
	      	 (FE(31) AND I(10)) OR 
	      	 (FF(15) AND I(11)) OR 
	      	 (FF(31) AND I(12)) OR 
             (FG(15) AND I(13)) OR 
	      	 (FG(31) AND I(14)) OR
	      	 (FH(15) AND I(15)) OR 
	       	 (FH(31) AND I(16)) OR
	      	 (FI(15) AND I(17)) OR
	      	 (FI(31) AND I(18)));
		 
OUTI(16) <= ((SA(0) AND I(1))  OR 
            (SA(16) AND I(2))  OR 
		      (SB(0)  AND I(3))  OR 
	      	(SB(16) AND I(4))  OR
	      	(SC(0)  AND I(5))  OR 
		      (SC(16) AND I(6))  OR 
		      (SD(0)  AND I(7))  OR 
		      (SD(16) AND I(8))  OR
            (SE(0)  AND I(9))  OR 
		      (SE(16) AND I(10)) OR 
		      (SF(0)  AND I(11)) OR 
		      (SF(16) AND I(12)) OR 
            (SG(0)  AND I(13)) OR 
		      (SG(16) AND I(14)) OR
		      (SH(0)  AND I(15)) OR 
		      (SH(16) AND I(16)) OR
		      (SI(0)  AND I(17)) OR
		      (SI(16) AND I(18)));
		 
OUTI(17) <= ((SA(1) AND I(1))  OR 
            (SA(17) AND I(2))  OR 
	     	   (SB(1)  AND I(3))  OR 
		      (SB(17) AND I(4))  OR
		      (SC(1)  AND I(5))  OR 
		      (SC(17) AND I(6))  OR 
		      (SD(1)  AND I(7))  OR 
		      (SD(17) AND I(8))  OR
            (SE(1)  AND I(9))  OR 
		      (SE(17) AND I(10)) OR 
		      (SF(1)  AND I(11)) OR 
		      (SF(17) AND I(12)) OR 
            (SG(1)  AND I(13)) OR 
		      (SG(17) AND I(14)) OR
		      (SH(1)  AND I(15)) OR 
		      (SH(17) AND I(16)) OR
		      (SI(1)  AND I(17)) OR
		      (SI(17) AND I(18)));
		 
OUTI(18) <= ((SA(2) AND I(1))  OR 
            (SA(18) AND I(2))  OR 
		      (SB(2)  AND I(3))  OR 
		      (SB(18) AND I(4))  OR
		      (SC(2)  AND I(5))  OR 
		      (SC(18) AND I(6))  OR 
		      (SD(2)  AND I(7))  OR 
		      (SD(18) AND I(8))  OR
            (SE(2)  AND I(9))  OR 
		      (SE(18) AND I(10)) OR 
		      (SF(2)  AND I(11)) OR 
		      (SF(18) AND I(12)) OR 
            (SG(2)  AND I(13)) OR 
		      (SG(18) AND I(14)) OR
		      (SH(2)  AND I(15)) OR 
		      (SH(18) AND I(16)) OR
		      (SI(2)  AND I(17)) OR
		      (SI(18) AND I(18)));

OUTI(19) <= ((SA(3) AND I(1))  OR 
            (SA(19) AND I(2))  OR 
		      (SB(3)  AND I(3))  OR 
		      (SB(19) AND I(4))  OR
		      (SC(3)  AND I(5))  OR 
		      (SC(19) AND I(6))  OR 
		      (SD(3)  AND I(7))  OR 
		      (SD(19) AND I(8))  OR
            (SE(3)  AND I(9))  OR 
		      (SE(19) AND I(10)) OR 
		      (SF(3)  AND I(11)) OR 
		      (SF(19) AND I(12)) OR 
            (SG(3)  AND I(13)) OR 
		      (SG(19) AND I(14)) OR
		      (SH(3)  AND I(15)) OR 
		      (SH(19) AND I(16)) OR
		      (SI(3)  AND I(17)) OR
		      (SI(19) AND I(18)));

OUTI(20) <= ((SA(4) AND I(1))  OR 
            (SA(20) AND I(2))  OR 
		      (SB(4)  AND I(3))  OR 
		      (SB(20) AND I(4))  OR
		      (SC(4)  AND I(5))  OR 
		      (SC(20) AND I(6))  OR 
		      (SD(4)  AND I(7))  OR 
		      (SD(20) AND I(8))  OR
            (SE(4)  AND I(9))  OR 
		      (SE(20) AND I(10)) OR 
		      (SF(4)  AND I(11)) OR 
		      (SF(20) AND I(12)) OR 
            (SG(4)  AND I(13)) OR 
		      (SG(20) AND I(14)) OR
		      (SH(4)  AND I(15)) OR 
		      (SH(20) AND I(16)) OR
		      (SI(4)  AND I(17)) OR
		      (SI(20) AND I(18)));

OUTI(21) <= ((SA(5) AND I(1))  OR 
            (SA(21) AND I(2))  OR 
		      (SB(5)  AND I(3))  OR 
		      (SB(21) AND I(4))  OR
		      (SC(5)  AND I(5))  OR 
		      (SC(21) AND I(6))  OR 
		      (SD(5)  AND I(7))  OR 
		      (SD(21) AND I(8))  OR
            (SE(5)  AND I(9))  OR 
	      	(SE(21) AND I(10)) OR 
		      (SF(5)  AND I(11)) OR 
		      (SF(21) AND I(12)) OR 
            (SG(5)  AND I(13)) OR 
		      (SG(21) AND I(14)) OR
		      (SH(5)  AND I(15)) OR 
		      (SH(21) AND I(16)) OR
		      (SI(5)  AND I(17)) OR
		      (SI(21) AND I(18)));
		 
OUTI(22) <= ((SA(6) AND I(1))  OR 
            (SA(22) AND I(2))  OR 
		      (SB(6)  AND I(3))  OR 
		      (SB(22) AND I(4))  OR
		      (SC(6)  AND I(5))  OR 
		      (SC(22) AND I(6))  OR 
		      (SD(6)  AND I(7))  OR 
		      (SD(22) AND I(8))  OR
            (SE(6)  AND I(9))  OR 
		      (SE(22) AND I(10)) OR 
		      (SF(6)  AND I(11)) OR 
		      (SF(22) AND I(12)) OR 
            (SG(6)  AND I(13)) OR 
		      (SG(22) AND I(14)) OR
		      (SH(6)  AND I(15)) OR 
		      (SH(22) AND I(16)) OR
		      (SI(6)  AND I(17)) OR
		      (SI(22) AND I(18)));
		 
OUTI(23) <= ((SA(7) AND I(1))  OR 
            (SA(23) AND I(2))  OR 
		      (SB(7)  AND I(3))  OR 
		      (SB(23) AND I(4))  OR
		      (SC(7)  AND I(5))  OR 
		      (SC(23) AND I(6))  OR 
		      (SD(7)  AND I(7))  OR 
		      (SD(23) AND I(8))  OR
            (SE(7)  AND I(9))  OR 
		      (SE(23) AND I(10)) OR 
		      (SF(7)  AND I(11)) OR 
		      (SF(23) AND I(12)) OR 
            (SG(7)  AND I(13)) OR 
		      (SG(23) AND I(14)) OR
		      (SH(7)  AND I(15)) OR 
		      (SH(23) AND I(16)) OR
		      (SI(7)  AND I(17)) OR
		      (SI(23) AND I(18)));
		 
OUTI(24) <= ((SA(8) AND I(1))  OR 
            (SA(24) AND I(2))  OR 
		      (SB(8)  AND I(3))  OR 
		      (SB(24) AND I(4))  OR
		      (SC(8)  AND I(5))  OR 
		      (SC(24) AND I(6))  OR 
		      (SD(8)  AND I(7))  OR 
		      (SD(24) AND I(8))  OR
            (SE(8)  AND I(9))  OR 
		      (SE(24) AND I(10)) OR 
		      (SF(8)  AND I(11)) OR 
		      (SF(24) AND I(12)) OR 
            (SG(8)  AND I(13)) OR 
		      (SG(24) AND I(14)) OR
		      (SH(8)  AND I(15)) OR 
		      (SH(24) AND I(16)) OR
		      (SI(8)  AND I(17)) OR
		      (SI(24) AND I(18)));
		 
OUTI(25) <= ((SA(9) AND I(1))  OR 
            (SA(25) AND I(2))  OR 
		      (SB(9)  AND I(3))  OR 
		      (SB(25) AND I(4))  OR
		      (SC(9)  AND I(5))  OR 
		      (SC(25) AND I(6))  OR 
		      (SD(9)  AND I(7))  OR 
		      (SD(25) AND I(8))  OR
            (SE(9)  AND I(9))  OR 
		      (SE(25) AND I(10)) OR 
		      (SF(9)  AND I(11)) OR 
		      (SF(25) AND I(12)) OR 
            (SG(9)  AND I(13)) OR 
		      (SG(25) AND I(14)) OR
	     	   (SH(9)  AND I(15)) OR 
		      (SH(25) AND I(16)) OR
		      (SI(9)  AND I(17)) OR
		      (SI(25) AND I(18)));
		 
OUTI(26) <= ((SA(10) AND I(1))  OR 
             (SA(26) AND I(2))  OR 
		       (SB(10) AND I(3))  OR 
		       (SB(26) AND I(4))  OR
		       (SC(10) AND I(5))  OR 
		       (SC(26) AND I(6))  OR 
		       (SD(10) AND I(7))  OR 
		       (SD(26) AND I(8))  OR
             (SE(10) AND I(9))  OR 
		       (SE(26) AND I(10)) OR 
		       (SF(10) AND I(11)) OR 
		       (SF(26) AND I(12)) OR 
             (SG(10) AND I(13)) OR 
		       (SG(26) AND I(14)) OR
		       (SH(10) AND I(15)) OR 
		       (SH(26) AND I(16)) OR
		       (SI(10) AND I(17)) OR
		       (SI(26) AND I(18)));
		 
OUTI(27) <= (SA(11)  OR 
            SA(27)   OR 
		      SB(11)   OR 
		      SB(27)   OR
		      SC(11)   OR 
		      SC(27)   OR 
		      SD(11)   OR 
		      SD(27)   OR
            SE(11)   OR 
		      SE(27)   OR 
		      SF(11)   OR 
		      SF(27)   OR 
            SG(11)   OR 
		      SG(27)   OR
		      SH(11)   OR 
		      SH(27)   OR
		      SI(11)   OR
		      SI(27));

OUTI(28) <= ((SA(12)  AND I(1))  OR 
              (SA(28) AND I(2))  OR 
		        (SB(12) AND I(3))  OR 
		        (SB(28) AND I(4))  OR
		        (SC(12) AND I(5))  OR 
		        (SC(28) AND I(6))  OR 
		        (SD(12) AND I(7))  OR 
	        	  (SD(28) AND I(8))  OR
              (SE(12) AND I(9))  OR 
		        (SE(28) AND I(10)) OR 
		        (SF(12) AND I(11)) OR 
		        (SF(28) AND I(12)) OR 
              (SG(12) AND I(13)) OR 
		        (SG(28) AND I(14)) OR
		        (SH(12) AND I(15)) OR 
		        (SH(28) AND I(16)) OR
		        (SI(12) AND I(17)) OR
		        (SI(28) AND I(18)));
		 
OUTI(29) <= ((SA(13)  AND I(1))  OR 
              (SA(29) AND I(2))  OR 
		        (SB(13) AND I(3))  OR 
		        (SB(29) AND I(4))  OR
		        (SC(13) AND I(5))  OR 
		        (SC(29) AND I(6))  OR 
		        (SD(13) AND I(7))  OR 
		        (SD(29) AND I(8))  OR
              (SE(13) AND I(9))  OR 
	           (SE(29) AND I(10)) OR 
		        (SF(13) AND I(11)) OR 
		        (SF(29) AND I(12)) OR 
              (SG(13) AND I(13)) OR 
		        (SG(29) AND I(14)) OR
		        (SH(13) AND I(15)) OR 
		        (SH(29) AND I(16)) OR
		        (SI(13) AND I(17)) OR
		        (SI(29) AND I(18)));
		 
OUTI(30) <= ((SA(14)  AND I(1))  OR 
              (SA(30) AND I(2))  OR 
		        (SB(14) AND I(3))  OR 
		        (SB(30) AND I(4))  OR
	           (SC(14) AND I(5))  OR 
		        (SC(30) AND I(6))  OR 
		        (SD(14) AND I(7))  OR 
		        (SD(30) AND I(8))  OR
              (SE(14) AND I(9))  OR 
		        (SE(30) AND I(10)) OR 
		        (SF(14) AND I(11)) OR 
		        (SF(30) AND I(12)) OR 
              (SG(14) AND I(13)) OR 
		        (SG(30) AND I(14)) OR
		        (SH(14) AND I(15)) OR 
		        (SH(30) AND I(16)) OR
		        (SI(14) AND I(17)) OR
	           (SI(30) AND I(18)));
		 
OUTI(31) <= ((SA(15)  AND I(1))  OR 
              (SA(31) AND I(2))  OR 
		        (SB(15) AND I(3))  OR 
		        (SB(31) AND I(4))  OR
		        (SC(15) AND I(5))  OR 
		        (SC(31) AND I(6))  OR 
		        (SD(15) AND I(7))  OR 
		        (SD(31) AND I(8))  OR
              (SE(15) AND I(9))  OR 
		        (SE(31) AND I(10)) OR 
		        (SF(15) AND I(11)) OR 
		        (SF(31) AND I(12)) OR 
              (SG(15) AND I(13)) OR 
		        (SG(31) AND I(14)) OR
		        (SH(15) AND I(15)) OR 
		        (SH(31) AND I(16)) OR
		        (SI(15) AND I(17)) OR
		        (SI(31) AND I(18)));		 

-- TENTH BEST 

OUTJ(0) <= ((FA(0)  AND J(1))  OR 
            (FA(16) AND J(2))  OR 
		      (FB(0)  AND J(3))  OR 
		      (FB(16) AND J(4))  OR
		      (FC(0)  AND J(5))  OR 
		      (FC(16) AND J(6))  OR 
		      (FD(0)  AND J(7))  OR 
		      (FD(16) AND J(8))  OR
            (FE(0)  AND J(9))  OR 
		      (FE(16) AND J(10)) OR 
		      (FF(0)  AND J(11)) OR 
		      (FF(16) AND J(12)) OR 
            (FG(0)  AND J(13)) OR 
		      (FG(16) AND J(14)) OR
		      (FH(0)  AND J(15)) OR 
		      (FH(16) AND J(16)) OR
		      (FI(0)  AND J(17)) OR
		      (FI(16) AND J(18)));

OUTJ(1) <= ((FA(1)  AND J(1))  OR 
            (FA(17) AND J(2))  OR 
		      (FB(1)  AND J(3))  OR 
		      (FB(17) AND J(4))  OR
		      (FC(1)  AND J(5))  OR 
		      (FC(17) AND J(6))  OR 
		      (FD(1)  AND J(7))  OR 
		      (FD(17) AND J(8))  OR
            (FE(1)  AND J(9))  OR 
		      (FE(17) AND J(10)) OR 
		      (FF(1)  AND J(11)) OR 
		      (FF(17) AND J(12)) OR 
            (FG(1)  AND J(13)) OR 
		      (FG(17) AND J(14)) OR
		      (FH(1)  AND J(15)) OR 
		      (FH(17) AND J(16)) OR
		      (FI(1)  AND J(17)) OR
		      (FI(17) AND J(18)));

OUTJ(2) <= ((FA(2)  AND J(1))  OR 
            (FA(18) AND J(2))  OR 
		      (FB(2)  AND J(3))  OR 
		      (FB(18) AND J(4))  OR
		      (FC(2)  AND J(5))  OR 
		      (FC(18) AND J(6))  OR 
		      (FD(2)  AND J(7))  OR 
		      (FD(18) AND J(8))  OR
            (FE(2)  AND J(9))  OR 
		      (FE(18) AND J(10)) OR 
		      (FF(2)  AND J(11)) OR 
		      (FF(18) AND J(12)) OR 
            (FG(2)  AND J(13)) OR 
		      (FG(18) AND J(14)) OR
		      (FH(2)  AND J(15)) OR 
		      (FH(18) AND J(16)) OR
		      (FI(2)  AND J(17)) OR
		      (FI(18) AND J(18)));

OUTJ(3) <= ((FA(3)  AND J(1))  OR 
            (FA(19) AND J(2))  OR 
		      (FB(3)  AND J(3))  OR 
		      (FB(19) AND J(4))  OR
		      (FC(3)  AND J(5))  OR 
		      (FC(19) AND J(6))  OR 
		      (FD(3)  AND J(7))  OR 
		      (FD(19) AND J(8))  OR
            (FE(3)  AND J(9))  OR 
		      (FE(19) AND J(10)) OR 
		      (FF(3)  AND J(11)) OR 
		      (FF(19) AND J(12)) OR 
            (FG(3)  AND J(13)) OR 
		      (FG(19) AND J(14)) OR
		      (FH(3)  AND J(15)) OR 
		      (FH(19) AND J(16)) OR
		      (FI(3)  AND J(17)) OR
		      (FI(19) AND J(18)));
		 
OUTJ(4) <= ((FA(4)  AND J(1))  OR 
            (FA(20) AND J(2))  OR 
		      (FB(4)  AND J(3))  OR 
		      (FB(20) AND J(4))  OR
		      (FC(4)  AND J(5))  OR 
		      (FC(20) AND J(6))  OR 
		      (FD(4)  AND J(7))  OR 
		      (FD(20) AND J(8))  OR
            (FE(4)  AND J(9))  OR 
		      (FE(20) AND J(10)) OR 
		      (FF(4)  AND J(11)) OR 
		      (FF(20) AND J(12)) OR 
            (FG(4)  AND J(13)) OR 
		      (FG(20) AND J(14)) OR
		      (FH(4)  AND J(15)) OR 
		      (FH(20) AND J(16)) OR
		      (FI(4)  AND J(17)) OR
		      (FI(20) AND J(18)));

OUTJ(5) <= ((FA(5)  AND J(1))  OR 
            (FA(21) AND J(2))  OR 
		      (FB(5)  AND J(3))  OR 
		      (FB(21) AND J(4))  OR
		      (FC(5)  AND J(5))  OR 
		      (FC(21) AND J(6))  OR 
		      (FD(5)  AND J(7))  OR 
		      (FD(21) AND J(8))  OR
            (FE(5)  AND J(9))  OR 
		      (FE(21) AND J(10)) OR 
		      (FF(5)  AND J(11)) OR 
		      (FF(21) AND J(12)) OR 
            (FG(5)  AND J(13)) OR 
		      (FG(21) AND J(14)) OR
		      (FH(5)  AND J(15)) OR 
		      (FH(21) AND J(16)) OR
		      (FI(5)  AND J(17)) OR
		      (FI(21) AND J(18)));

OUTJ(6) <= ((FA(6)  AND J(1))  OR 
            (FA(22) AND J(2))  OR 
		      (FB(6)  AND J(3))  OR 
		      (FB(22) AND J(4))  OR
		      (FC(6)  AND J(5))  OR 
		      (FC(22) AND J(6))  OR 
		      (FD(6)  AND J(7))  OR 
		      (FD(22) AND J(8))  OR
            (FE(6)  AND J(9))  OR 
		      (FE(22) AND J(10)) OR 
		      (FF(6)  AND J(11)) OR 
		      (FF(22) AND J(12)) OR 
            (FG(6)  AND J(13)) OR 
		      (FG(22) AND J(14)) OR
		      (FH(6)  AND J(15)) OR 
		      (FH(22) AND J(16)) OR
		      (FI(6)  AND J(17)) OR
		      (FI(22) AND J(18)));

OUTJ(7) <= ((FA(7)  AND J(1))  OR 
            (FA(23) AND J(2))  OR 
		      (FB(7)  AND J(3))  OR 
		      (FB(23) AND J(4))  OR
		      (FC(7)  AND J(5))  OR 
		      (FC(23) AND J(6))  OR 
		      (FD(7)  AND J(7))  OR 
		      (FD(23) AND J(8))  OR
            (FE(7)  AND J(9))  OR 
		      (FE(23) AND J(10)) OR 
		      (FF(7)  AND J(11)) OR 
		      (FF(23) AND J(12)) OR 
            (FG(7)  AND J(13)) OR 
		      (FG(23) AND J(14)) OR
		      (FH(7)  AND J(15)) OR 
		      (FH(23) AND J(16)) OR
		      (FI(7)  AND J(17)) OR
		      (FI(23) AND J(18)));
			
OUTJ(8) <= ((FA(8)  AND J(1))  OR 
            (FA(24) AND J(2))  OR 
		      (FB(8)  AND J(3))  OR 
		      (FB(24) AND J(4))  OR
		      (FC(8)  AND J(5))  OR 
		      (FC(24) AND J(6))  OR 
		      (FD(8)  AND J(7))  OR 
		      (FD(24) AND J(8))  OR
            (FE(8)  AND J(9))  OR 
		      (FE(24) AND J(10)) OR 
		      (FF(8)  AND J(11)) OR 
		      (FF(24) AND J(12)) OR 
            (FG(8)  AND J(13)) OR 
		      (FG(24) AND J(14)) OR
		      (FH(8)  AND J(15)) OR 
		      (FH(24) AND J(16)) OR
		      (FI(8)  AND J(17)) OR
		      (FI(24) AND J(18)));

OUTJ(9) <= ((FA(9)  AND J(1))  OR 
            (FA(25) AND J(2))  OR 
		      (FB(9)  AND J(3))  OR 
		      (FB(25) AND J(4))  OR
		      (FC(9)  AND J(5))  OR 
		      (FC(25) AND J(6))  OR 
		      (FD(9)  AND J(7))  OR 
		      (FD(25) AND J(8))  OR
            (FE(9)  AND J(9))  OR 
		      (FE(25) AND J(10)) OR 
		      (FF(9)  AND J(11)) OR 
		      (FF(25) AND J(12)) OR 
            (FG(9)  AND J(13)) OR 
		      (FG(25) AND J(14)) OR
		      (FH(9)  AND J(15)) OR 
		      (FH(25) AND J(16)) OR
		      (FI(9)  AND J(17)) OR
		      (FI(25) AND J(18)));

OUTJ(10) <= ((FA(10) AND J(1)) OR 
             (FA(26) AND J(2)) OR 
		       (FB(10) AND J(3))  OR 
		       (FB(26) AND J(4))  OR
		       (FC(10) AND J(5))  OR 
		       (FC(26) AND J(6))  OR 
		       (FD(10) AND J(7))  OR 
		       (FD(26) AND J(8))  OR
             (FE(10) AND J(9))  OR 
		       (FE(26) AND J(10)) OR 
		       (FF(10) AND J(11)) OR 
		       (FF(26) AND J(12)) OR 
             (FG(10) AND J(13)) OR 
		       (FG(26) AND J(14)) OR
		       (FH(10) AND J(15)) OR 
		       (FH(26) AND J(16)) OR
		       (FI(10) AND J(17)) OR
		       (FI(26) AND J(18)));

OUTJ(11) <= ((FA(11) AND J(1))  OR 
             (FA(27) AND J(2))  OR 
		       (FB(11) AND J(3))  OR 
		       (FB(27) AND J(4))  OR
		       (FC(11) AND J(5))  OR 
		       (FC(27) AND J(6))  OR 
		       (FD(11) AND J(7))  OR 
		       (FD(27) AND J(8))  OR
             (FE(11) AND J(9))  OR 
	      	 (FE(27) AND J(10)) OR 
	      	 (FF(11) AND J(11)) OR 
	      	 (FF(27) AND J(12)) OR 
             (FG(11) AND J(13)) OR 
		       (FG(27) AND J(14)) OR
		       (FH(11) AND J(15)) OR 
		       (FH(27) AND J(16)) OR
		       (FI(11) AND J(17)) OR
		       (FI(27) AND J(18)));

OUTJ(12) <= ((FA(12) AND J(1))  OR 
             (FA(28) AND J(2))  OR 
		       (FB(12) AND J(3))  OR 
		       (FB(28) AND J(4))  OR
		       (FC(12) AND J(5))  OR 
		       (FC(28) AND J(6))  OR 
		       (FD(12) AND J(7))  OR 
		       (FD(28) AND J(8))  OR
             (FE(12) AND J(9))  OR 
	      	 (FE(28) AND J(10)) OR 
	      	 (FF(12) AND J(11)) OR 
	       	 (FF(28) AND J(12)) OR 
             (FG(12) AND J(13)) OR 
		       (FG(28) AND J(14)) OR
		       (FH(12) AND J(15)) OR 
		       (FH(28) AND J(16)) OR
		       (FI(12) AND J(17)) OR
		       (FI(28) AND J(18)));

OUTJ(13) <= ((FA(13) AND J(1))  OR 
             (FA(29) AND J(2))  OR 
		       (FB(13) AND J(3))  OR 
		       (FB(29) AND J(4))  OR
		       (FC(13) AND J(5))  OR 
		       (FC(29) AND J(6))  OR 
		       (FD(13) AND J(7))  OR 
		       (FD(29) AND J(8))  OR
             (FE(13) AND J(9))  OR 
	       	 (FE(29) AND J(10)) OR 
	      	 (FF(13) AND J(11)) OR 
	      	 (FF(29) AND J(12)) OR 
             (FG(13) AND J(13)) OR 
	      	 (FG(29) AND J(14)) OR
	       	 (FH(13) AND J(15)) OR 
	      	 (FH(29) AND J(16)) OR
	      	 (FI(13) AND J(17)) OR
	      	 (FI(29) AND J(18)));

OUTJ(14) <= ((FA(14) AND J(1))  OR 
             (FA(30) AND J(2))  OR 
	      	 (FB(14) AND J(3))  OR 
	      	 (FB(30) AND J(4))  OR
	      	 (FC(14) AND J(5))  OR 
	      	 (FC(30) AND J(6))  OR 
	      	 (FD(14) AND J(7))  OR 
	      	 (FD(30) AND J(8))  OR
             (FE(14) AND J(9))  OR 
		       (FE(30) AND J(10)) OR 
		       (FF(14) AND J(11)) OR 
		       (FF(30) AND J(12)) OR 
             (FG(14) AND J(13)) OR 
	      	 (FG(30) AND J(14)) OR
	      	 (FH(14) AND J(15)) OR 
	      	 (FH(30) AND J(16)) OR
	      	 (FI(14) AND J(17)) OR
	      	 (FI(30) AND J(18)));
		 
OUTJ(15) <= ((FA(15) AND J(1))  OR 
             (FA(31) AND J(2))  OR 
		       (FB(15) AND J(3))  OR 
		       (FB(31) AND J(4))  OR
	      	 (FC(15) AND J(5))  OR 
	       	 (FC(31) AND J(6))  OR 
	      	 (FD(15) AND J(7))  OR 
      		 (FD(31) AND J(8))  OR
             (FE(15) AND J(9))  OR 
	      	 (FE(31) AND J(10)) OR 
	      	 (FF(15) AND J(11)) OR 
	      	 (FF(31) AND J(12)) OR 
             (FG(15) AND J(13)) OR 
	      	 (FG(31) AND J(14)) OR
	      	 (FH(15) AND J(15)) OR 
	       	 (FH(31) AND J(16)) OR
	      	 (FI(15) AND J(17)) OR
	      	 (FI(31) AND J(18)));
		 
OUTJ(16) <= ((SA(0) AND J(1))  OR 
            (SA(16) AND J(2))  OR 
		      (SB(0)  AND J(3))  OR 
	      	(SB(16) AND J(4))  OR
	      	(SC(0)  AND J(5))  OR 
		      (SC(16) AND J(6))  OR 
		      (SD(0)  AND J(7))  OR 
		      (SD(16) AND J(8))  OR
            (SE(0)  AND J(9))  OR 
		      (SE(16) AND J(10)) OR 
		      (SF(0)  AND J(11)) OR 
		      (SF(16) AND J(12)) OR 
            (SG(0)  AND J(13)) OR 
		      (SG(16) AND J(14)) OR
		      (SH(0)  AND J(15)) OR 
		      (SH(16) AND J(16)) OR
		      (SI(0)  AND J(17)) OR
		      (SI(16) AND J(18)));
		 
OUTJ(17) <= ((SA(1) AND J(1))  OR 
            (SA(17) AND J(2))  OR 
	     	   (SB(1)  AND J(3))  OR 
		      (SB(17) AND J(4))  OR
		      (SC(1)  AND J(5))  OR 
		      (SC(17) AND J(6))  OR 
		      (SD(1)  AND J(7))  OR 
		      (SD(17) AND J(8))  OR
            (SE(1)  AND J(9))  OR 
		      (SE(17) AND J(10)) OR 
		      (SF(1)  AND J(11)) OR 
		      (SF(17) AND J(12)) OR 
            (SG(1)  AND J(13)) OR 
		      (SG(17) AND J(14)) OR
		      (SH(1)  AND J(15)) OR 
		      (SH(17) AND J(16)) OR
		      (SI(1)  AND J(17)) OR
		      (SI(17) AND J(18)));
		 
OUTJ(18) <= ((SA(2) AND J(1))  OR 
            (SA(18) AND J(2))  OR 
		      (SB(2)  AND J(3))  OR 
		      (SB(18) AND J(4))  OR
		      (SC(2)  AND J(5))  OR 
		      (SC(18) AND J(6))  OR 
		      (SD(2)  AND J(7))  OR 
		      (SD(18) AND J(8))  OR
            (SE(2)  AND J(9))  OR 
		      (SE(18) AND J(10)) OR 
		      (SF(2)  AND J(11)) OR 
		      (SF(18) AND J(12)) OR 
            (SG(2)  AND J(13)) OR 
		      (SG(18) AND J(14)) OR
		      (SH(2)  AND J(15)) OR 
		      (SH(18) AND J(16)) OR
		      (SI(2)  AND J(17)) OR
		      (SI(18) AND J(18)));

OUTJ(19) <= ((SA(3) AND J(1))  OR 
            (SA(19) AND J(2))  OR 
		      (SB(3)  AND J(3))  OR 
		      (SB(19) AND J(4))  OR
		      (SC(3)  AND J(5))  OR 
		      (SC(19) AND J(6))  OR 
		      (SD(3)  AND J(7))  OR 
		      (SD(19) AND J(8))  OR
            (SE(3)  AND J(9))  OR 
		      (SE(19) AND J(10)) OR 
		      (SF(3)  AND J(11)) OR 
		      (SF(19) AND J(12)) OR 
            (SG(3)  AND J(13)) OR 
		      (SG(19) AND J(14)) OR
		      (SH(3)  AND J(15)) OR 
		      (SH(19) AND J(16)) OR
		      (SI(3)  AND J(17)) OR
		      (SI(19) AND J(18)));

OUTJ(20) <= ((SA(4) AND J(1))  OR 
            (SA(20) AND J(2))  OR 
		      (SB(4)  AND J(3))  OR 
		      (SB(20) AND J(4))  OR
		      (SC(4)  AND J(5))  OR 
		      (SC(20) AND J(6))  OR 
		      (SD(4)  AND J(7))  OR 
		      (SD(20) AND J(8))  OR
            (SE(4)  AND J(9))  OR 
		      (SE(20) AND J(10)) OR 
		      (SF(4)  AND J(11)) OR 
		      (SF(20) AND J(12)) OR 
            (SG(4)  AND J(13)) OR 
		      (SG(20) AND J(14)) OR
		      (SH(4)  AND J(15)) OR 
		      (SH(20) AND J(16)) OR
		      (SI(4)  AND J(17)) OR
		      (SI(20) AND J(18)));

OUTJ(21) <= ((SA(5) AND J(1))  OR 
            (SA(21) AND J(2))  OR 
		      (SB(5)  AND J(3))  OR 
		      (SB(21) AND J(4))  OR
		      (SC(5)  AND J(5))  OR 
		      (SC(21) AND J(6))  OR 
		      (SD(5)  AND J(7))  OR 
		      (SD(21) AND J(8))  OR
            (SE(5)  AND J(9))  OR 
	      	(SE(21) AND J(10)) OR 
		      (SF(5)  AND J(11)) OR 
		      (SF(21) AND J(12)) OR 
            (SG(5)  AND J(13)) OR 
		      (SG(21) AND J(14)) OR
		      (SH(5)  AND J(15)) OR 
		      (SH(21) AND J(16)) OR
		      (SI(5)  AND J(17)) OR
		      (SI(21) AND J(18)));
		 
OUTJ(22) <= ((SA(6) AND J(1))  OR 
            (SA(22) AND J(2))  OR 
		      (SB(6)  AND J(3))  OR 
		      (SB(22) AND J(4))  OR
		      (SC(6)  AND J(5))  OR 
		      (SC(22) AND J(6))  OR 
		      (SD(6)  AND J(7))  OR 
		      (SD(22) AND J(8))  OR
            (SE(6)  AND J(9))  OR 
		      (SE(22) AND J(10)) OR 
		      (SF(6)  AND J(11)) OR 
		      (SF(22) AND J(12)) OR 
            (SG(6)  AND J(13)) OR 
		      (SG(22) AND J(14)) OR
		      (SH(6)  AND J(15)) OR 
		      (SH(22) AND J(16)) OR
		      (SI(6)  AND J(17)) OR
		      (SI(22) AND J(18)));
		 
OUTJ(23) <= ((SA(7) AND J(1))  OR 
            (SA(23) AND J(2))  OR 
		      (SB(7)  AND J(3))  OR 
		      (SB(23) AND J(4))  OR
		      (SC(7)  AND J(5))  OR 
		      (SC(23) AND J(6))  OR 
		      (SD(7)  AND J(7))  OR 
		      (SD(23) AND J(8))  OR
            (SE(7)  AND J(9))  OR 
		      (SE(23) AND J(10)) OR 
		      (SF(7)  AND J(11)) OR 
		      (SF(23) AND J(12)) OR 
            (SG(7)  AND J(13)) OR 
		      (SG(23) AND J(14)) OR
		      (SH(7)  AND J(15)) OR 
		      (SH(23) AND J(16)) OR
		      (SI(7)  AND J(17)) OR
		      (SI(23) AND J(18)));
		 
OUTJ(24) <= ((SA(8) AND J(1))  OR 
            (SA(24) AND J(2))  OR 
		      (SB(8)  AND J(3))  OR 
		      (SB(24) AND J(4))  OR
		      (SC(8)  AND J(5))  OR 
		      (SC(24) AND J(6))  OR 
		      (SD(8)  AND J(7))  OR 
		      (SD(24) AND J(8))  OR
            (SE(8)  AND J(9))  OR 
		      (SE(24) AND J(10)) OR 
		      (SF(8)  AND J(11)) OR 
		      (SF(24) AND J(12)) OR 
            (SG(8)  AND J(13)) OR 
		      (SG(24) AND J(14)) OR
		      (SH(8)  AND J(15)) OR 
		      (SH(24) AND J(16)) OR
		      (SI(8)  AND J(17)) OR
		      (SI(24) AND J(18)));
		 
OUTJ(25) <= ((SA(9) AND J(1))  OR 
            (SA(25) AND J(2))  OR 
		      (SB(9)  AND J(3))  OR 
		      (SB(25) AND J(4))  OR
		      (SC(9)  AND J(5))  OR 
		      (SC(25) AND J(6))  OR 
		      (SD(9)  AND J(7))  OR 
		      (SD(25) AND J(8))  OR
            (SE(9)  AND J(9))  OR 
		      (SE(25) AND J(10)) OR 
		      (SF(9)  AND J(11)) OR 
		      (SF(25) AND J(12)) OR 
            (SG(9)  AND J(13)) OR 
		      (SG(25) AND J(14)) OR
	     	   (SH(9)  AND J(15)) OR 
		      (SH(25) AND J(16)) OR
		      (SI(9)  AND J(17)) OR
		      (SI(25) AND J(18)));
		 
OUTJ(26) <= ((SA(10) AND J(1))  OR 
             (SA(26) AND J(2))  OR 
		       (SB(10) AND J(3))  OR 
		       (SB(26) AND J(4))  OR
		       (SC(10) AND J(5))  OR 
		       (SC(26) AND J(6))  OR 
		       (SD(10) AND J(7))  OR 
		       (SD(26) AND J(8))  OR
             (SE(10) AND J(9))  OR 
		       (SE(26) AND J(10)) OR 
		       (SF(10) AND J(11)) OR 
		       (SF(26) AND J(12)) OR 
             (SG(10) AND J(13)) OR 
		       (SG(26) AND J(14)) OR
		       (SH(10) AND J(15)) OR 
		       (SH(26) AND J(16)) OR
		       (SI(10) AND J(17)) OR
		       (SI(26) AND J(18)));
		 
OUTJ(27) <= (SA(11)  OR 
            SA(27)   OR 
		      SB(11)   OR 
		      SB(27)   OR
		      SC(11)   OR 
		      SC(27)   OR 
		      SD(11)   OR 
		      SD(27)   OR
            SE(11)   OR 
		      SE(27)   OR 
		      SF(11)   OR 
		      SF(27)   OR 
            SG(11)   OR 
		      SG(27)   OR
		      SH(11)   OR 
		      SH(27)   OR
		      SI(11)   OR
		      SI(27));

OUTJ(28) <= ((SA(12)  AND J(1))  OR 
              (SA(28) AND J(2))  OR 
		        (SB(12) AND J(3))  OR 
		        (SB(28) AND J(4))  OR
		        (SC(12) AND J(5))  OR 
		        (SC(28) AND J(6))  OR 
		        (SD(12) AND J(7))  OR 
	        	  (SD(28) AND J(8))  OR
              (SE(12) AND J(9))  OR 
		        (SE(28) AND J(10)) OR 
		        (SF(12) AND J(11)) OR 
		        (SF(28) AND J(12)) OR 
              (SG(12) AND J(13)) OR 
		        (SG(28) AND J(14)) OR
		        (SH(12) AND J(15)) OR 
		        (SH(28) AND J(16)) OR
		        (SI(12) AND J(17)) OR
		        (SI(28) AND J(18)));
		 
OUTJ(29) <= ((SA(13)  AND J(1))  OR 
              (SA(29) AND J(2))  OR 
		        (SB(13) AND J(3))  OR 
		        (SB(29) AND J(4))  OR
		        (SC(13) AND J(5))  OR 
		        (SC(29) AND J(6))  OR 
		        (SD(13) AND J(7))  OR 
		        (SD(29) AND J(8))  OR
              (SE(13) AND J(9))  OR 
	           (SE(29) AND J(10)) OR 
		        (SF(13) AND J(11)) OR 
		        (SF(29) AND J(12)) OR 
              (SG(13) AND J(13)) OR 
		        (SG(29) AND J(14)) OR
		        (SH(13) AND J(15)) OR 
		        (SH(29) AND J(16)) OR
		        (SI(13) AND J(17)) OR
		        (SI(29) AND J(18)));
		 
OUTJ(30) <= ((SA(14)  AND J(1))  OR 
              (SA(30) AND J(2))  OR 
		        (SB(14) AND J(3))  OR 
		        (SB(30) AND J(4))  OR
	           (SC(14) AND J(5))  OR 
		        (SC(30) AND J(6))  OR 
		        (SD(14) AND J(7))  OR 
		        (SD(30) AND J(8))  OR
              (SE(14) AND J(9))  OR 
		        (SE(30) AND J(10)) OR 
		        (SF(14) AND J(11)) OR 
		        (SF(30) AND J(12)) OR 
              (SG(14) AND J(13)) OR 
		        (SG(30) AND J(14)) OR
		        (SH(14) AND J(15)) OR 
		        (SH(30) AND J(16)) OR
		        (SI(14) AND J(17)) OR
	           (SI(30) AND J(18)));
		 
OUTJ(31) <= ((SA(15)  AND J(1))  OR 
              (SA(31) AND J(2))  OR 
		        (SB(15) AND J(3))  OR 
		        (SB(31) AND J(4))  OR
		        (SC(15) AND J(5))  OR 
		        (SC(31) AND J(6))  OR 
		        (SD(15) AND J(7))  OR 
		        (SD(31) AND J(8))  OR
              (SE(15) AND J(9))  OR 
		        (SE(31) AND J(10)) OR 
		        (SF(15) AND J(11)) OR 
		        (SF(31) AND J(12)) OR 
              (SG(15) AND J(13)) OR 
		        (SG(31) AND J(14)) OR
		        (SH(15) AND J(15)) OR 
		        (SH(31) AND J(16)) OR
		        (SI(15) AND J(17)) OR
		        (SI(31) AND J(18)));		 

-- ELEVENTH BEST 

OUTK(0) <= ((FA(0)  AND K(1))  OR 
            (FA(16) AND K(2))  OR 
		      (FB(0)  AND K(3))  OR 
		      (FB(16) AND K(4))  OR
		      (FC(0)  AND K(5))  OR 
		      (FC(16) AND K(6))  OR 
		      (FD(0)  AND K(7))  OR 
		      (FD(16) AND K(8))  OR
            (FE(0)  AND K(9))  OR 
		      (FE(16) AND K(10)) OR 
		      (FF(0)  AND K(11)) OR 
		      (FF(16) AND K(12)) OR 
            (FG(0)  AND K(13)) OR 
		      (FG(16) AND K(14)) OR
		      (FH(0)  AND K(15)) OR 
		      (FH(16) AND K(16)) OR
		      (FI(0)  AND K(17)) OR
		      (FI(16) AND K(18)));

OUTK(1) <= ((FA(1)  AND K(1))  OR 
            (FA(17) AND K(2))  OR 
		      (FB(1)  AND K(3))  OR 
		      (FB(17) AND K(4))  OR
		      (FC(1)  AND K(5))  OR 
		      (FC(17) AND K(6))  OR 
		      (FD(1)  AND K(7))  OR 
		      (FD(17) AND K(8))  OR
            (FE(1)  AND K(9))  OR 
		      (FE(17) AND K(10)) OR 
		      (FF(1)  AND K(11)) OR 
		      (FF(17) AND K(12)) OR 
            (FG(1)  AND K(13)) OR 
		      (FG(17) AND K(14)) OR
		      (FH(1)  AND K(15)) OR 
		      (FH(17) AND K(16)) OR
		      (FI(1)  AND K(17)) OR
		      (FI(17) AND K(18)));

OUTK(2) <= ((FA(2)  AND K(1))  OR 
            (FA(18) AND K(2))  OR 
		      (FB(2)  AND K(3))  OR 
		      (FB(18) AND K(4))  OR
		      (FC(2)  AND K(5))  OR 
		      (FC(18) AND K(6))  OR 
		      (FD(2)  AND K(7))  OR 
		      (FD(18) AND K(8))  OR
            (FE(2)  AND K(9))  OR 
		      (FE(18) AND K(10)) OR 
		      (FF(2)  AND K(11)) OR 
		      (FF(18) AND K(12)) OR 
            (FG(2)  AND K(13)) OR 
		      (FG(18) AND K(14)) OR
		      (FH(2)  AND K(15)) OR 
		      (FH(18) AND K(16)) OR
		      (FI(2)  AND K(17)) OR
		      (FI(18) AND K(18)));

OUTK(3) <= ((FA(3)  AND K(1))  OR 
            (FA(19) AND K(2))  OR 
		      (FB(3)  AND K(3))  OR 
		      (FB(19) AND K(4))  OR
		      (FC(3)  AND K(5))  OR 
		      (FC(19) AND K(6))  OR 
		      (FD(3)  AND K(7))  OR 
		      (FD(19) AND K(8))  OR
            (FE(3)  AND K(9))  OR 
		      (FE(19) AND K(10)) OR 
		      (FF(3)  AND K(11)) OR 
		      (FF(19) AND K(12)) OR 
            (FG(3)  AND K(13)) OR 
		      (FG(19) AND K(14)) OR
		      (FH(3)  AND K(15)) OR 
		      (FH(19) AND K(16)) OR
		      (FI(3)  AND K(17)) OR
		      (FI(19) AND K(18)));
		 
OUTK(4) <= ((FA(4)  AND K(1))  OR 
            (FA(20) AND K(2))  OR 
		      (FB(4)  AND K(3))  OR 
		      (FB(20) AND K(4))  OR
		      (FC(4)  AND K(5))  OR 
		      (FC(20) AND K(6))  OR 
		      (FD(4)  AND K(7))  OR 
		      (FD(20) AND K(8))  OR
            (FE(4)  AND K(9))  OR 
		      (FE(20) AND K(10)) OR 
		      (FF(4)  AND K(11)) OR 
		      (FF(20) AND K(12)) OR 
            (FG(4)  AND K(13)) OR 
		      (FG(20) AND K(14)) OR
		      (FH(4)  AND K(15)) OR 
		      (FH(20) AND K(16)) OR
		      (FI(4)  AND K(17)) OR
		      (FI(20) AND K(18)));

OUTK(5) <= ((FA(5)  AND K(1))  OR 
            (FA(21) AND K(2))  OR 
		      (FB(5)  AND K(3))  OR 
		      (FB(21) AND K(4))  OR
		      (FC(5)  AND K(5))  OR 
		      (FC(21) AND K(6))  OR 
		      (FD(5)  AND K(7))  OR 
		      (FD(21) AND K(8))  OR
            (FE(5)  AND K(9))  OR 
		      (FE(21) AND K(10)) OR 
		      (FF(5)  AND K(11)) OR 
		      (FF(21) AND K(12)) OR 
            (FG(5)  AND K(13)) OR 
		      (FG(21) AND K(14)) OR
		      (FH(5)  AND K(15)) OR 
		      (FH(21) AND K(16)) OR
		      (FI(5)  AND K(17)) OR
		      (FI(21) AND K(18)));

OUTK(6) <= ((FA(6)  AND K(1))  OR 
            (FA(22) AND K(2))  OR 
		      (FB(6)  AND K(3))  OR 
		      (FB(22) AND K(4))  OR
		      (FC(6)  AND K(5))  OR 
		      (FC(22) AND K(6))  OR 
		      (FD(6)  AND K(7))  OR 
		      (FD(22) AND K(8))  OR
            (FE(6)  AND K(9))  OR 
		      (FE(22) AND K(10)) OR 
		      (FF(6)  AND K(11)) OR 
		      (FF(22) AND K(12)) OR 
            (FG(6)  AND K(13)) OR 
		      (FG(22) AND K(14)) OR
		      (FH(6)  AND K(15)) OR 
		      (FH(22) AND K(16)) OR
		      (FI(6)  AND K(17)) OR
		      (FI(22) AND K(18)));

OUTK(7) <= ((FA(7)  AND K(1))  OR 
            (FA(23) AND K(2))  OR 
		      (FB(7)  AND K(3))  OR 
		      (FB(23) AND K(4))  OR
		      (FC(7)  AND K(5))  OR 
		      (FC(23) AND K(6))  OR 
		      (FD(7)  AND K(7))  OR 
		      (FD(23) AND K(8))  OR
            (FE(7)  AND K(9))  OR 
		      (FE(23) AND K(10)) OR 
		      (FF(7)  AND K(11)) OR 
		      (FF(23) AND K(12)) OR 
            (FG(7)  AND K(13)) OR 
		      (FG(23) AND K(14)) OR
		      (FH(7)  AND K(15)) OR 
		      (FH(23) AND K(16)) OR
		      (FI(7)  AND K(17)) OR
		      (FI(23) AND K(18)));
			
OUTK(8) <= ((FA(8)  AND K(1))  OR 
            (FA(24) AND K(2))  OR 
		      (FB(8)  AND K(3))  OR 
		      (FB(24) AND K(4))  OR
		      (FC(8)  AND K(5))  OR 
		      (FC(24) AND K(6))  OR 
		      (FD(8)  AND K(7))  OR 
		      (FD(24) AND K(8))  OR
            (FE(8)  AND K(9))  OR 
		      (FE(24) AND K(10)) OR 
		      (FF(8)  AND K(11)) OR 
		      (FF(24) AND K(12)) OR 
            (FG(8)  AND K(13)) OR 
		      (FG(24) AND K(14)) OR
		      (FH(8)  AND K(15)) OR 
		      (FH(24) AND K(16)) OR
		      (FI(8)  AND K(17)) OR
		      (FI(24) AND K(18)));

OUTK(9) <= ((FA(9)  AND K(1))  OR 
            (FA(25) AND K(2))  OR 
		      (FB(9)  AND K(3))  OR 
		      (FB(25) AND K(4))  OR
		      (FC(9)  AND K(5))  OR 
		      (FC(25) AND K(6))  OR 
		      (FD(9)  AND K(7))  OR 
		      (FD(25) AND K(8))  OR
            (FE(9)  AND K(9))  OR 
		      (FE(25) AND K(10)) OR 
		      (FF(9)  AND K(11)) OR 
		      (FF(25) AND K(12)) OR 
            (FG(9)  AND K(13)) OR 
		      (FG(25) AND K(14)) OR
		      (FH(9)  AND K(15)) OR 
		      (FH(25) AND K(16)) OR
		      (FI(9)  AND K(17)) OR
		      (FI(25) AND K(18)));

OUTK(10) <= ((FA(10) AND K(1)) OR 
             (FA(26) AND K(2)) OR 
		       (FB(10) AND K(3))  OR 
		       (FB(26) AND K(4))  OR
		       (FC(10) AND K(5))  OR 
		       (FC(26) AND K(6))  OR 
		       (FD(10) AND K(7))  OR 
		       (FD(26) AND K(8))  OR
             (FE(10) AND K(9))  OR 
		       (FE(26) AND K(10)) OR 
		       (FF(10) AND K(11)) OR 
		       (FF(26) AND K(12)) OR 
             (FG(10) AND K(13)) OR 
		       (FG(26) AND K(14)) OR
		       (FH(10) AND K(15)) OR 
		       (FH(26) AND K(16)) OR
		       (FI(10) AND K(17)) OR
		       (FI(26) AND K(18)));

OUTK(11) <= ((FA(11) AND K(1))  OR 
             (FA(27) AND K(2))  OR 
		       (FB(11) AND K(3))  OR 
		       (FB(27) AND K(4))  OR
		       (FC(11) AND K(5))  OR 
		       (FC(27) AND K(6))  OR 
		       (FD(11) AND K(7))  OR 
		       (FD(27) AND K(8))  OR
             (FE(11) AND K(9))  OR 
	      	 (FE(27) AND K(10)) OR 
	      	 (FF(11) AND K(11)) OR 
	      	 (FF(27) AND K(12)) OR 
             (FG(11) AND K(13)) OR 
		       (FG(27) AND K(14)) OR
		       (FH(11) AND K(15)) OR 
		       (FH(27) AND K(16)) OR
		       (FI(11) AND K(17)) OR
		       (FI(27) AND K(18)));

OUTK(12) <= ((FA(12) AND K(1))  OR 
             (FA(28) AND K(2))  OR 
		       (FB(12) AND K(3))  OR 
		       (FB(28) AND K(4))  OR
		       (FC(12) AND K(5))  OR 
		       (FC(28) AND K(6))  OR 
		       (FD(12) AND K(7))  OR 
		       (FD(28) AND K(8))  OR
             (FE(12) AND K(9))  OR 
	      	 (FE(28) AND K(10)) OR 
	      	 (FF(12) AND K(11)) OR 
	       	 (FF(28) AND K(12)) OR 
             (FG(12) AND K(13)) OR 
		       (FG(28) AND K(14)) OR
		       (FH(12) AND K(15)) OR 
		       (FH(28) AND K(16)) OR
		       (FI(12) AND K(17)) OR
		       (FI(28) AND K(18)));

OUTK(13) <= ((FA(13) AND K(1))  OR 
             (FA(29) AND K(2))  OR 
		       (FB(13) AND K(3))  OR 
		       (FB(29) AND K(4))  OR
		       (FC(13) AND K(5))  OR 
		       (FC(29) AND K(6))  OR 
		       (FD(13) AND K(7))  OR 
		       (FD(29) AND K(8))  OR
             (FE(13) AND K(9))  OR 
	       	 (FE(29) AND K(10)) OR 
	      	 (FF(13) AND K(11)) OR 
	      	 (FF(29) AND K(12)) OR 
             (FG(13) AND K(13)) OR 
	      	 (FG(29) AND K(14)) OR
	       	 (FH(13) AND K(15)) OR 
	      	 (FH(29) AND K(16)) OR
	      	 (FI(13) AND K(17)) OR
	      	 (FI(29) AND K(18)));

OUTK(14) <= ((FA(14) AND K(1))  OR 
             (FA(30) AND K(2))  OR 
	      	 (FB(14) AND K(3))  OR 
	      	 (FB(30) AND K(4))  OR
	      	 (FC(14) AND K(5))  OR 
	      	 (FC(30) AND K(6))  OR 
	      	 (FD(14) AND K(7))  OR 
	      	 (FD(30) AND K(8))  OR
             (FE(14) AND K(9))  OR 
		       (FE(30) AND K(10)) OR 
		       (FF(14) AND K(11)) OR 
		       (FF(30) AND K(12)) OR 
             (FG(14) AND K(13)) OR 
	      	 (FG(30) AND K(14)) OR
	      	 (FH(14) AND K(15)) OR 
	      	 (FH(30) AND K(16)) OR
	      	 (FI(14) AND K(17)) OR
	      	 (FI(30) AND K(18)));
		 
OUTK(15) <= ((FA(15) AND K(1))  OR 
             (FA(31) AND K(2))  OR 
		       (FB(15) AND K(3))  OR 
		       (FB(31) AND K(4))  OR
	      	 (FC(15) AND K(5))  OR 
	       	 (FC(31) AND K(6))  OR 
	      	 (FD(15) AND K(7))  OR 
      		 (FD(31) AND K(8))  OR
             (FE(15) AND K(9))  OR 
	      	 (FE(31) AND K(10)) OR 
	      	 (FF(15) AND K(11)) OR 
	      	 (FF(31) AND K(12)) OR 
             (FG(15) AND K(13)) OR 
	      	 (FG(31) AND K(14)) OR
	      	 (FH(15) AND K(15)) OR 
	       	 (FH(31) AND K(16)) OR
	      	 (FI(15) AND K(17)) OR
	      	 (FI(31) AND K(18)));
		 
OUTK(16) <= ((SA(0) AND K(1))  OR 
            (SA(16) AND K(2))  OR 
		      (SB(0)  AND K(3))  OR 
	      	(SB(16) AND K(4))  OR
	      	(SC(0)  AND K(5))  OR 
		      (SC(16) AND K(6))  OR 
		      (SD(0)  AND K(7))  OR 
		      (SD(16) AND K(8))  OR
            (SE(0)  AND K(9))  OR 
		      (SE(16) AND K(10)) OR 
		      (SF(0)  AND K(11)) OR 
		      (SF(16) AND K(12)) OR 
            (SG(0)  AND K(13)) OR 
		      (SG(16) AND K(14)) OR
		      (SH(0)  AND K(15)) OR 
		      (SH(16) AND K(16)) OR
		      (SI(0)  AND K(17)) OR
		      (SI(16) AND K(18)));
		 
OUTK(17) <= ((SA(1) AND K(1))  OR 
            (SA(17) AND K(2))  OR 
	     	   (SB(1)  AND K(3))  OR 
		      (SB(17) AND K(4))  OR
		      (SC(1)  AND K(5))  OR 
		      (SC(17) AND K(6))  OR 
		      (SD(1)  AND K(7))  OR 
		      (SD(17) AND K(8))  OR
            (SE(1)  AND K(9))  OR 
		      (SE(17) AND K(10)) OR 
		      (SF(1)  AND K(11)) OR 
		      (SF(17) AND K(12)) OR 
            (SG(1)  AND K(13)) OR 
		      (SG(17) AND K(14)) OR
		      (SH(1)  AND K(15)) OR 
		      (SH(17) AND K(16)) OR
		      (SI(1)  AND K(17)) OR
		      (SI(17) AND K(18)));
		 
OUTK(18) <= ((SA(2) AND K(1))  OR 
            (SA(18) AND K(2))  OR 
		      (SB(2)  AND K(3))  OR 
		      (SB(18) AND K(4))  OR
		      (SC(2)  AND K(5))  OR 
		      (SC(18) AND K(6))  OR 
		      (SD(2)  AND K(7))  OR 
		      (SD(18) AND K(8))  OR
            (SE(2)  AND K(9))  OR 
		      (SE(18) AND K(10)) OR 
		      (SF(2)  AND K(11)) OR 
		      (SF(18) AND K(12)) OR 
            (SG(2)  AND K(13)) OR 
		      (SG(18) AND K(14)) OR
		      (SH(2)  AND K(15)) OR 
		      (SH(18) AND K(16)) OR
		      (SI(2)  AND K(17)) OR
		      (SI(18) AND K(18)));

OUTK(19) <= ((SA(3) AND K(1))  OR 
            (SA(19) AND K(2))  OR 
		      (SB(3)  AND K(3))  OR 
		      (SB(19) AND K(4))  OR
		      (SC(3)  AND K(5))  OR 
		      (SC(19) AND K(6))  OR 
		      (SD(3)  AND K(7))  OR 
		      (SD(19) AND K(8))  OR
            (SE(3)  AND K(9))  OR 
		      (SE(19) AND K(10)) OR 
		      (SF(3)  AND K(11)) OR 
		      (SF(19) AND K(12)) OR 
            (SG(3)  AND K(13)) OR 
		      (SG(19) AND K(14)) OR
		      (SH(3)  AND K(15)) OR 
		      (SH(19) AND K(16)) OR
		      (SI(3)  AND K(17)) OR
		      (SI(19) AND K(18)));

OUTK(20) <= ((SA(4) AND K(1))  OR 
            (SA(20) AND K(2))  OR 
		      (SB(4)  AND K(3))  OR 
		      (SB(20) AND K(4))  OR
		      (SC(4)  AND K(5))  OR 
		      (SC(20) AND K(6))  OR 
		      (SD(4)  AND K(7))  OR 
		      (SD(20) AND K(8))  OR
            (SE(4)  AND K(9))  OR 
		      (SE(20) AND K(10)) OR 
		      (SF(4)  AND K(11)) OR 
		      (SF(20) AND K(12)) OR 
            (SG(4)  AND K(13)) OR 
		      (SG(20) AND K(14)) OR
		      (SH(4)  AND K(15)) OR 
		      (SH(20) AND K(16)) OR
		      (SI(4)  AND K(17)) OR
		      (SI(20) AND K(18)));

OUTK(21) <= ((SA(5) AND K(1))  OR 
            (SA(21) AND K(2))  OR 
		      (SB(5)  AND K(3))  OR 
		      (SB(21) AND K(4))  OR
		      (SC(5)  AND K(5))  OR 
		      (SC(21) AND K(6))  OR 
		      (SD(5)  AND K(7))  OR 
		      (SD(21) AND K(8))  OR
            (SE(5)  AND K(9))  OR 
	      	(SE(21) AND K(10)) OR 
		      (SF(5)  AND K(11)) OR 
		      (SF(21) AND K(12)) OR 
            (SG(5)  AND K(13)) OR 
		      (SG(21) AND K(14)) OR
		      (SH(5)  AND K(15)) OR 
		      (SH(21) AND K(16)) OR
		      (SI(5)  AND K(17)) OR
		      (SI(21) AND K(18)));
		 
OUTK(22) <= ((SA(6) AND K(1))  OR 
            (SA(22) AND K(2))  OR 
		      (SB(6)  AND K(3))  OR 
		      (SB(22) AND K(4))  OR
		      (SC(6)  AND K(5))  OR 
		      (SC(22) AND K(6))  OR 
		      (SD(6)  AND K(7))  OR 
		      (SD(22) AND K(8))  OR
            (SE(6)  AND K(9))  OR 
		      (SE(22) AND K(10)) OR 
		      (SF(6)  AND K(11)) OR 
		      (SF(22) AND K(12)) OR 
            (SG(6)  AND K(13)) OR 
		      (SG(22) AND K(14)) OR
		      (SH(6)  AND K(15)) OR 
		      (SH(22) AND K(16)) OR
		      (SI(6)  AND K(17)) OR
		      (SI(22) AND K(18)));
		 
OUTK(23) <= ((SA(7) AND K(1))  OR 
            (SA(23) AND K(2))  OR 
		      (SB(7)  AND K(3))  OR 
		      (SB(23) AND K(4))  OR
		      (SC(7)  AND K(5))  OR 
		      (SC(23) AND K(6))  OR 
		      (SD(7)  AND K(7))  OR 
		      (SD(23) AND K(8))  OR
            (SE(7)  AND K(9))  OR 
		      (SE(23) AND K(10)) OR 
		      (SF(7)  AND K(11)) OR 
		      (SF(23) AND K(12)) OR 
            (SG(7)  AND K(13)) OR 
		      (SG(23) AND K(14)) OR
		      (SH(7)  AND K(15)) OR 
		      (SH(23) AND K(16)) OR
		      (SI(7)  AND K(17)) OR
		      (SI(23) AND K(18)));
		 
OUTK(24) <= ((SA(8) AND K(1))  OR 
            (SA(24) AND K(2))  OR 
		      (SB(8)  AND K(3))  OR 
		      (SB(24) AND K(4))  OR
		      (SC(8)  AND K(5))  OR 
		      (SC(24) AND K(6))  OR 
		      (SD(8)  AND K(7))  OR 
		      (SD(24) AND K(8))  OR
            (SE(8)  AND K(9))  OR 
		      (SE(24) AND K(10)) OR 
		      (SF(8)  AND K(11)) OR 
		      (SF(24) AND K(12)) OR 
            (SG(8)  AND K(13)) OR 
		      (SG(24) AND K(14)) OR
		      (SH(8)  AND K(15)) OR 
		      (SH(24) AND K(16)) OR
		      (SI(8)  AND K(17)) OR
		      (SI(24) AND K(18)));
		 
OUTK(25) <= ((SA(9) AND K(1))  OR 
            (SA(25) AND K(2))  OR 
		      (SB(9)  AND K(3))  OR 
		      (SB(25) AND K(4))  OR
		      (SC(9)  AND K(5))  OR 
		      (SC(25) AND K(6))  OR 
		      (SD(9)  AND K(7))  OR 
		      (SD(25) AND K(8))  OR
            (SE(9)  AND K(9))  OR 
		      (SE(25) AND K(10)) OR 
		      (SF(9)  AND K(11)) OR 
		      (SF(25) AND K(12)) OR 
            (SG(9)  AND K(13)) OR 
		      (SG(25) AND K(14)) OR
	     	   (SH(9)  AND K(15)) OR 
		      (SH(25) AND K(16)) OR
		      (SI(9)  AND K(17)) OR
		      (SI(25) AND K(18)));
		 
OUTK(26) <= ((SA(10) AND K(1))  OR 
             (SA(26) AND K(2))  OR 
		       (SB(10) AND K(3))  OR 
		       (SB(26) AND K(4))  OR
		       (SC(10) AND K(5))  OR 
		       (SC(26) AND K(6))  OR 
		       (SD(10) AND K(7))  OR 
		       (SD(26) AND K(8))  OR
             (SE(10) AND K(9))  OR 
		       (SE(26) AND K(10)) OR 
		       (SF(10) AND K(11)) OR 
		       (SF(26) AND K(12)) OR 
             (SG(10) AND K(13)) OR 
		       (SG(26) AND K(14)) OR
		       (SH(10) AND K(15)) OR 
		       (SH(26) AND K(16)) OR
		       (SI(10) AND K(17)) OR
		       (SI(26) AND K(18)));
		 
OUTK(27) <= (SA(11)  OR 
            SA(27)   OR 
		      SB(11)   OR 
		      SB(27)   OR
		      SC(11)   OR 
		      SC(27)   OR 
		      SD(11)   OR 
		      SD(27)   OR
            SE(11)   OR 
		      SE(27)   OR 
		      SF(11)   OR 
		      SF(27)   OR 
            SG(11)   OR 
		      SG(27)   OR
		      SH(11)   OR 
		      SH(27)   OR
		      SI(11)   OR
		      SI(27));

OUTK(28) <= ((SA(12)  AND K(1))  OR 
              (SA(28) AND K(2))  OR 
		        (SB(12) AND K(3))  OR 
		        (SB(28) AND K(4))  OR
		        (SC(12) AND K(5))  OR 
		        (SC(28) AND K(6))  OR 
		        (SD(12) AND K(7))  OR 
	        	  (SD(28) AND K(8))  OR
              (SE(12) AND K(9))  OR 
		        (SE(28) AND K(10)) OR 
		        (SF(12) AND K(11)) OR 
		        (SF(28) AND K(12)) OR 
              (SG(12) AND K(13)) OR 
		        (SG(28) AND K(14)) OR
		        (SH(12) AND K(15)) OR 
		        (SH(28) AND K(16)) OR
		        (SI(12) AND K(17)) OR
		        (SI(28) AND K(18)));
		 
OUTK(29) <= ((SA(13)  AND K(1))  OR 
              (SA(29) AND K(2))  OR 
		        (SB(13) AND K(3))  OR 
		        (SB(29) AND K(4))  OR
		        (SC(13) AND K(5))  OR 
		        (SC(29) AND K(6))  OR 
		        (SD(13) AND K(7))  OR 
		        (SD(29) AND K(8))  OR
              (SE(13) AND K(9))  OR 
	           (SE(29) AND K(10)) OR 
		        (SF(13) AND K(11)) OR 
		        (SF(29) AND K(12)) OR 
              (SG(13) AND K(13)) OR 
		        (SG(29) AND K(14)) OR
		        (SH(13) AND K(15)) OR 
		        (SH(29) AND K(16)) OR
		        (SI(13) AND K(17)) OR
		        (SI(29) AND K(18)));
		 
OUTK(30) <= ((SA(14)  AND K(1))  OR 
              (SA(30) AND K(2))  OR 
		        (SB(14) AND K(3))  OR 
		        (SB(30) AND K(4))  OR
	           (SC(14) AND K(5))  OR 
		        (SC(30) AND K(6))  OR 
		        (SD(14) AND K(7))  OR 
		        (SD(30) AND K(8))  OR
              (SE(14) AND K(9))  OR 
		        (SE(30) AND K(10)) OR 
		        (SF(14) AND K(11)) OR 
		        (SF(30) AND K(12)) OR 
              (SG(14) AND K(13)) OR 
		        (SG(30) AND K(14)) OR
		        (SH(14) AND K(15)) OR 
		        (SH(30) AND K(16)) OR
		        (SI(14) AND K(17)) OR
	           (SI(30) AND K(18)));
		 
OUTK(31) <= ((SA(15)  AND K(1))  OR 
              (SA(31) AND K(2))  OR 
		        (SB(15) AND K(3))  OR 
		        (SB(31) AND K(4))  OR
		        (SC(15) AND K(5))  OR 
		        (SC(31) AND K(6))  OR 
		        (SD(15) AND K(7))  OR 
		        (SD(31) AND K(8))  OR
              (SE(15) AND K(9))  OR 
		        (SE(31) AND K(10)) OR 
		        (SF(15) AND K(11)) OR 
		        (SF(31) AND K(12)) OR 
              (SG(15) AND K(13)) OR 
		        (SG(31) AND K(14)) OR
		        (SH(15) AND K(15)) OR 
		        (SH(31) AND K(16)) OR
		        (SI(15) AND K(17)) OR
		        (SI(31) AND K(18)));		 

-- TWELVE BEST 

OUTL(0) <= ((FA(0)  AND L(1))  OR 
            (FA(16) AND L(2))  OR 
		      (FB(0)  AND L(3))  OR 
		      (FB(16) AND L(4))  OR
		      (FC(0)  AND L(5))  OR 
		      (FC(16) AND L(6))  OR 
		      (FD(0)  AND L(7))  OR 
		      (FD(16) AND L(8))  OR
            (FE(0)  AND L(9))  OR 
		      (FE(16) AND L(10)) OR 
		      (FF(0)  AND L(11)) OR 
		      (FF(16) AND L(12)) OR 
            (FG(0)  AND L(13)) OR 
		      (FG(16) AND L(14)) OR
		      (FH(0)  AND L(15)) OR 
		      (FH(16) AND L(16)) OR
		      (FI(0)  AND L(17)) OR
		      (FI(16) AND L(18)));

OUTL(1) <= ((FA(1)  AND L(1))  OR 
            (FA(17) AND L(2))  OR 
		      (FB(1)  AND L(3))  OR 
		      (FB(17) AND L(4))  OR
		      (FC(1)  AND L(5))  OR 
		      (FC(17) AND L(6))  OR 
		      (FD(1)  AND L(7))  OR 
		      (FD(17) AND L(8))  OR
            (FE(1)  AND L(9))  OR 
		      (FE(17) AND L(10)) OR 
		      (FF(1)  AND L(11)) OR 
		      (FF(17) AND L(12)) OR 
            (FG(1)  AND L(13)) OR 
		      (FG(17) AND L(14)) OR
		      (FH(1)  AND L(15)) OR 
		      (FH(17) AND L(16)) OR
		      (FI(1)  AND L(17)) OR
		      (FI(17) AND L(18)));

OUTL(2) <= ((FA(2)  AND L(1))  OR 
            (FA(18) AND L(2))  OR 
		      (FB(2)  AND L(3))  OR 
		      (FB(18) AND L(4))  OR
		      (FC(2)  AND L(5))  OR 
		      (FC(18) AND L(6))  OR 
		      (FD(2)  AND L(7))  OR 
		      (FD(18) AND L(8))  OR
            (FE(2)  AND L(9))  OR 
		      (FE(18) AND L(10)) OR 
		      (FF(2)  AND L(11)) OR 
		      (FF(18) AND L(12)) OR 
            (FG(2)  AND L(13)) OR 
		      (FG(18) AND L(14)) OR
		      (FH(2)  AND L(15)) OR 
		      (FH(18) AND L(16)) OR
		      (FI(2)  AND L(17)) OR
		      (FI(18) AND L(18)));

OUTL(3) <= ((FA(3)  AND L(1))  OR 
            (FA(19) AND L(2))  OR 
		      (FB(3)  AND L(3))  OR 
		      (FB(19) AND L(4))  OR
		      (FC(3)  AND L(5))  OR 
		      (FC(19) AND L(6))  OR 
		      (FD(3)  AND L(7))  OR 
		      (FD(19) AND L(8))  OR
            (FE(3)  AND L(9))  OR 
		      (FE(19) AND L(10)) OR 
		      (FF(3)  AND L(11)) OR 
		      (FF(19) AND L(12)) OR 
            (FG(3)  AND L(13)) OR 
		      (FG(19) AND L(14)) OR
		      (FH(3)  AND L(15)) OR 
		      (FH(19) AND L(16)) OR
		      (FI(3)  AND L(17)) OR
		      (FI(19) AND L(18)));
		 
OUTL(4) <= ((FA(4)  AND L(1))  OR 
            (FA(20) AND L(2))  OR 
		      (FB(4)  AND L(3))  OR 
		      (FB(20) AND L(4))  OR
		      (FC(4)  AND L(5))  OR 
		      (FC(20) AND L(6))  OR 
		      (FD(4)  AND L(7))  OR 
		      (FD(20) AND L(8))  OR
            (FE(4)  AND L(9))  OR 
		      (FE(20) AND L(10)) OR 
		      (FF(4)  AND L(11)) OR 
		      (FF(20) AND L(12)) OR 
            (FG(4)  AND L(13)) OR 
		      (FG(20) AND L(14)) OR
		      (FH(4)  AND L(15)) OR 
		      (FH(20) AND L(16)) OR
		      (FI(4)  AND L(17)) OR
		      (FI(20) AND L(18)));

OUTL(5) <= ((FA(5)  AND L(1))  OR 
            (FA(21) AND L(2))  OR 
		      (FB(5)  AND L(3))  OR 
		      (FB(21) AND L(4))  OR
		      (FC(5)  AND L(5))  OR 
		      (FC(21) AND L(6))  OR 
		      (FD(5)  AND L(7))  OR 
		      (FD(21) AND L(8))  OR
            (FE(5)  AND L(9))  OR 
		      (FE(21) AND L(10)) OR 
		      (FF(5)  AND L(11)) OR 
		      (FF(21) AND L(12)) OR 
            (FG(5)  AND L(13)) OR 
		      (FG(21) AND L(14)) OR
		      (FH(5)  AND L(15)) OR 
		      (FH(21) AND L(16)) OR
		      (FI(5)  AND L(17)) OR
		      (FI(21) AND L(18)));

OUTL(6) <= ((FA(6)  AND L(1))  OR 
            (FA(22) AND L(2))  OR 
		      (FB(6)  AND L(3))  OR 
		      (FB(22) AND L(4))  OR
		      (FC(6)  AND L(5))  OR 
		      (FC(22) AND L(6))  OR 
		      (FD(6)  AND L(7))  OR 
		      (FD(22) AND L(8))  OR
            (FE(6)  AND L(9))  OR 
		      (FE(22) AND L(10)) OR 
		      (FF(6)  AND L(11)) OR 
		      (FF(22) AND L(12)) OR 
            (FG(6)  AND L(13)) OR 
		      (FG(22) AND L(14)) OR
		      (FH(6)  AND L(15)) OR 
		      (FH(22) AND L(16)) OR
		      (FI(6)  AND L(17)) OR
		      (FI(22) AND L(18)));

OUTL(7) <= ((FA(7)  AND L(1))  OR 
            (FA(23) AND L(2))  OR 
		      (FB(7)  AND L(3))  OR 
		      (FB(23) AND L(4))  OR
		      (FC(7)  AND L(5))  OR 
		      (FC(23) AND L(6))  OR 
		      (FD(7)  AND L(7))  OR 
		      (FD(23) AND L(8))  OR
            (FE(7)  AND L(9))  OR 
		      (FE(23) AND L(10)) OR 
		      (FF(7)  AND L(11)) OR 
		      (FF(23) AND L(12)) OR 
            (FG(7)  AND L(13)) OR 
		      (FG(23) AND L(14)) OR
		      (FH(7)  AND L(15)) OR 
		      (FH(23) AND L(16)) OR
		      (FI(7)  AND L(17)) OR
		      (FI(23) AND L(18)));
		
OUTL(8) <= ((FA(8)  AND L(1))  OR 
            (FA(24) AND L(2))  OR 
		      (FB(8)  AND L(3))  OR 
		      (FB(24) AND L(4))  OR
		      (FC(8)  AND L(5))  OR 
		      (FC(24) AND L(6))  OR 
		      (FD(8)  AND L(7))  OR 
		      (FD(24) AND L(8))  OR
            (FE(8)  AND L(9))  OR 
		      (FE(24) AND L(10)) OR 
		      (FF(8)  AND L(11)) OR 
		      (FF(24) AND L(12)) OR 
            (FG(8)  AND L(13)) OR 
		      (FG(24) AND L(14)) OR
		      (FH(8)  AND L(15)) OR 
		      (FH(24) AND L(16)) OR
		      (FI(8)  AND L(17)) OR
		      (FI(24) AND L(18)));

OUTL(9) <= ((FA(9)  AND L(1))  OR 
            (FA(25) AND L(2))  OR 
		      (FB(9)  AND L(3))  OR 
		      (FB(25) AND L(4))  OR
		      (FC(9)  AND L(5))  OR 
		      (FC(25) AND L(6))  OR 
		      (FD(9)  AND L(7))  OR 
		      (FD(25) AND L(8))  OR
            (FE(9)  AND L(9))  OR 
		      (FE(25) AND L(10)) OR 
		      (FF(9)  AND L(11)) OR 
		      (FF(25) AND L(12)) OR 
            (FG(9)  AND L(13)) OR 
		      (FG(25) AND L(14)) OR
		      (FH(9)  AND L(15)) OR 
		      (FH(25) AND L(16)) OR
		      (FI(9)  AND L(17)) OR
		      (FI(25) AND L(18)));

OUTL(10) <= ((FA(10) AND L(1)) OR 
             (FA(26) AND L(2)) OR 
		       (FB(10) AND L(3))  OR 
		       (FB(26) AND L(4))  OR
		       (FC(10) AND L(5))  OR 
		       (FC(26) AND L(6))  OR 
		       (FD(10) AND L(7))  OR 
		       (FD(26) AND L(8))  OR
             (FE(10) AND L(9))  OR 
		       (FE(26) AND L(10)) OR 
		       (FF(10) AND L(11)) OR 
		       (FF(26) AND L(12)) OR 
             (FG(10) AND L(13)) OR 
		       (FG(26) AND L(14)) OR
		       (FH(10) AND L(15)) OR 
		       (FH(26) AND L(16)) OR
		       (FI(10) AND L(17)) OR
		       (FI(26) AND L(18)));

OUTL(11) <= ((FA(11) AND L(1))  OR 
             (FA(27) AND L(2))  OR 
		       (FB(11) AND L(3))  OR 
		       (FB(27) AND L(4))  OR
		       (FC(11) AND L(5))  OR 
		       (FC(27) AND L(6))  OR 
		       (FD(11) AND L(7))  OR 
		       (FD(27) AND L(8))  OR
             (FE(11) AND L(9))  OR 
	      	 (FE(27) AND L(10)) OR 
	      	 (FF(11) AND L(11)) OR 
	      	 (FF(27) AND L(12)) OR 
             (FG(11) AND L(13)) OR 
		       (FG(27) AND L(14)) OR
		       (FH(11) AND L(15)) OR 
		       (FH(27) AND L(16)) OR
		       (FI(11) AND L(17)) OR
		       (FI(27) AND L(18)));

OUTL(12) <= ((FA(12) AND L(1))  OR 
             (FA(28) AND L(2))  OR 
		       (FB(12) AND L(3))  OR 
		       (FB(28) AND L(4))  OR
		       (FC(12) AND L(5))  OR 
		       (FC(28) AND L(6))  OR 
		       (FD(12) AND L(7))  OR 
		       (FD(28) AND L(8))  OR
             (FE(12) AND L(9))  OR 
	      	 (FE(28) AND L(10)) OR 
	      	 (FF(12) AND L(11)) OR 
	       	 (FF(28) AND L(12)) OR 
             (FG(12) AND L(13)) OR 
		       (FG(28) AND L(14)) OR
		       (FH(12) AND L(15)) OR 
		       (FH(28) AND L(16)) OR
		       (FI(12) AND L(17)) OR
		       (FI(28) AND L(18)));

OUTL(13) <= ((FA(13) AND L(1))  OR 
             (FA(29) AND L(2))  OR 
		       (FB(13) AND L(3))  OR 
		       (FB(29) AND L(4))  OR
		       (FC(13) AND L(5))  OR 
		       (FC(29) AND L(6))  OR 
		       (FD(13) AND L(7))  OR 
		       (FD(29) AND L(8))  OR
             (FE(13) AND L(9))  OR 
	       	 (FE(29) AND L(10)) OR 
	      	 (FF(13) AND L(11)) OR 
	      	 (FF(29) AND L(12)) OR 
             (FG(13) AND L(13)) OR 
	      	 (FG(29) AND L(14)) OR
	       	 (FH(13) AND L(15)) OR 
	      	 (FH(29) AND L(16)) OR
	      	 (FI(13) AND L(17)) OR
	      	 (FI(29) AND L(18)));

OUTL(14) <= ((FA(14) AND L(1))  OR 
             (FA(30) AND L(2))  OR 
	      	 (FB(14) AND L(3))  OR 
	      	 (FB(30) AND L(4))  OR
	      	 (FC(14) AND L(5))  OR 
	      	 (FC(30) AND L(6))  OR 
	      	 (FD(14) AND L(7))  OR 
	      	 (FD(30) AND L(8))  OR
             (FE(14) AND L(9))  OR 
		       (FE(30) AND L(10)) OR 
		       (FF(14) AND L(11)) OR 
		       (FF(30) AND L(12)) OR 
             (FG(14) AND L(13)) OR 
	      	 (FG(30) AND L(14)) OR
	      	 (FH(14) AND L(15)) OR 
	      	 (FH(30) AND L(16)) OR
	      	 (FI(14) AND L(17)) OR
	      	 (FI(30) AND L(18)));
		 
OUTL(15) <= ((FA(15) AND L(1))  OR 
             (FA(31) AND L(2))  OR 
		       (FB(15) AND L(3))  OR 
		       (FB(31) AND L(4))  OR
	      	 (FC(15) AND L(5))  OR 
	       	 (FC(31) AND L(6))  OR 
	      	 (FD(15) AND L(7))  OR 
      		 (FD(31) AND L(8))  OR
             (FE(15) AND L(9))  OR 
	      	 (FE(31) AND L(10)) OR 
	      	 (FF(15) AND L(11)) OR 
	      	 (FF(31) AND L(12)) OR 
             (FG(15) AND L(13)) OR 
	      	 (FG(31) AND L(14)) OR
	      	 (FH(15) AND L(15)) OR 
	       	 (FH(31) AND L(16)) OR
	      	 (FI(15) AND L(17)) OR
	      	 (FI(31) AND L(18)));
		 
OUTL(16) <= ((SA(0) AND L(1))  OR 
            (SA(16) AND L(2))  OR 
		      (SB(0)  AND L(3))  OR 
	      	(SB(16) AND L(4))  OR
	      	(SC(0)  AND L(5))  OR 
		      (SC(16) AND L(6))  OR 
		      (SD(0)  AND L(7))  OR 
		      (SD(16) AND L(8))  OR
            (SE(0)  AND L(9))  OR 
		      (SE(16) AND L(10)) OR 
		      (SF(0)  AND L(11)) OR 
		      (SF(16) AND L(12)) OR 
            (SG(0)  AND L(13)) OR 
		      (SG(16) AND L(14)) OR
		      (SH(0)  AND L(15)) OR 
		      (SH(16) AND L(16)) OR
		      (SI(0)  AND L(17)) OR
		      (SI(16) AND L(18)));
		
OUTL(17) <= ((SA(1) AND L(1))  OR 
            (SA(17) AND L(2))  OR 
	     	   (SB(1)  AND L(3))  OR 
		      (SB(17) AND L(4))  OR
		      (SC(1)  AND L(5))  OR 
		      (SC(17) AND L(6))  OR 
		      (SD(1)  AND L(7))  OR 
		      (SD(17) AND L(8))  OR
            (SE(1)  AND L(9))  OR 
		      (SE(17) AND L(10)) OR 
		      (SF(1)  AND L(11)) OR 
		      (SF(17) AND L(12)) OR 
            (SG(1)  AND L(13)) OR 
		      (SG(17) AND L(14)) OR
		      (SH(1)  AND L(15)) OR 
		      (SH(17) AND L(16)) OR
		      (SI(1)  AND L(17)) OR
		      (SI(17) AND L(18)));
		 
OUTL(18) <= ((SA(2) AND L(1))  OR 
            (SA(18) AND L(2))  OR 
		      (SB(2)  AND L(3))  OR 
		      (SB(18) AND L(4))  OR
		      (SC(2)  AND L(5))  OR 
		      (SC(18) AND L(6))  OR 
		      (SD(2)  AND L(7))  OR 
		      (SD(18) AND L(8))  OR
            (SE(2)  AND L(9))  OR 
		      (SE(18) AND L(10)) OR 
		      (SF(2)  AND L(11)) OR 
		      (SF(18) AND L(12)) OR 
            (SG(2)  AND L(13)) OR 
		      (SG(18) AND L(14)) OR
		      (SH(2)  AND L(15)) OR 
		      (SH(18) AND L(16)) OR
		      (SI(2)  AND L(17)) OR
		      (SI(18) AND L(18)));

OUTL(19) <= ((SA(3) AND L(1))  OR 
            (SA(19) AND L(2))  OR 
		      (SB(3)  AND L(3))  OR 
		      (SB(19) AND L(4))  OR
		      (SC(3)  AND L(5))  OR 
		      (SC(19) AND L(6))  OR 
		      (SD(3)  AND L(7))  OR 
		      (SD(19) AND L(8))  OR
            (SE(3)  AND L(9))  OR 
		      (SE(19) AND L(10)) OR 
		      (SF(3)  AND L(11)) OR 
		      (SF(19) AND L(12)) OR 
            (SG(3)  AND L(13)) OR 
		      (SG(19) AND L(14)) OR
		      (SH(3)  AND L(15)) OR 
		      (SH(19) AND L(16)) OR
		      (SI(3)  AND L(17)) OR
		      (SI(19) AND L(18)));

OUTL(20) <= ((SA(4) AND L(1))  OR 
            (SA(20) AND L(2))  OR 
		      (SB(4)  AND L(3))  OR 
		      (SB(20) AND L(4))  OR
		      (SC(4)  AND L(5))  OR 
		      (SC(20) AND L(6))  OR 
		      (SD(4)  AND L(7))  OR 
		      (SD(20) AND L(8))  OR
            (SE(4)  AND L(9))  OR 
		      (SE(20) AND L(10)) OR 
		      (SF(4)  AND L(11)) OR 
		      (SF(20) AND L(12)) OR 
            (SG(4)  AND L(13)) OR 
		      (SG(20) AND L(14)) OR
		      (SH(4)  AND L(15)) OR 
		      (SH(20) AND L(16)) OR
		      (SI(4)  AND L(17)) OR
		      (SI(20) AND L(18)));

OUTL(21) <= ((SA(5) AND L(1))  OR 
            (SA(21) AND L(2))  OR 
		      (SB(5)  AND L(3))  OR 
		      (SB(21) AND L(4))  OR
		      (SC(5)  AND L(5))  OR 
		      (SC(21) AND L(6))  OR 
		      (SD(5)  AND L(7))  OR 
		      (SD(21) AND L(8))  OR
            (SE(5)  AND L(9))  OR 
	      	(SE(21) AND L(10)) OR 
		      (SF(5)  AND L(11)) OR 
		      (SF(21) AND L(12)) OR 
            (SG(5)  AND L(13)) OR 
		      (SG(21) AND L(14)) OR
		      (SH(5)  AND L(15)) OR 
		      (SH(21) AND L(16)) OR
		      (SI(5)  AND L(17)) OR
		      (SI(21) AND L(18)));
		 
OUTL(22) <= ((SA(6) AND L(1))  OR 
            (SA(22) AND L(2))  OR 
		      (SB(6)  AND L(3))  OR 
		      (SB(22) AND L(4))  OR
		      (SC(6)  AND L(5))  OR 
		      (SC(22) AND L(6))  OR 
		      (SD(6)  AND L(7))  OR 
		      (SD(22) AND L(8))  OR
            (SE(6)  AND L(9))  OR 
		      (SE(22) AND L(10)) OR 
		      (SF(6)  AND L(11)) OR 
		      (SF(22) AND L(12)) OR 
            (SG(6)  AND L(13)) OR 
		      (SG(22) AND L(14)) OR
		      (SH(6)  AND L(15)) OR 
		      (SH(22) AND L(16)) OR
		      (SI(6)  AND L(17)) OR
		      (SI(22) AND L(18)));
		 
OUTL(23) <= ((SA(7) AND L(1))  OR 
            (SA(23) AND L(2))  OR 
		      (SB(7)  AND L(3))  OR 
		      (SB(23) AND L(4))  OR
		      (SC(7)  AND L(5))  OR 
		      (SC(23) AND L(6))  OR 
		      (SD(7)  AND L(7))  OR 
		      (SD(23) AND L(8))  OR
            (SE(7)  AND L(9))  OR 
		      (SE(23) AND L(10)) OR 
		      (SF(7)  AND L(11)) OR 
		      (SF(23) AND L(12)) OR 
            (SG(7)  AND L(13)) OR 
		      (SG(23) AND L(14)) OR
		      (SH(7)  AND L(15)) OR 
		      (SH(23) AND L(16)) OR
		      (SI(7)  AND L(17)) OR
		      (SI(23) AND L(18)));
		 
OUTL(24) <= ((SA(8) AND L(1))  OR 
            (SA(24) AND L(2))  OR 
		      (SB(8)  AND L(3))  OR 
		      (SB(24) AND L(4))  OR
		      (SC(8)  AND L(5))  OR 
		      (SC(24) AND L(6))  OR 
		      (SD(8)  AND L(7))  OR 
		      (SD(24) AND L(8))  OR
            (SE(8)  AND L(9))  OR 
		      (SE(24) AND L(10)) OR 
		      (SF(8)  AND L(11)) OR 
		      (SF(24) AND L(12)) OR 
            (SG(8)  AND L(13)) OR 
		      (SG(24) AND L(14)) OR
		      (SH(8)  AND L(15)) OR 
		      (SH(24) AND L(16)) OR
		      (SI(8)  AND L(17)) OR
		      (SI(24) AND L(18)));
		 
OUTL(25) <= ((SA(9) AND L(1))  OR 
            (SA(25) AND L(2))  OR 
		      (SB(9)  AND L(3))  OR 
		      (SB(25) AND L(4))  OR
		      (SC(9)  AND L(5))  OR 
		      (SC(25) AND L(6))  OR 
		      (SD(9)  AND L(7))  OR 
		      (SD(25) AND L(8))  OR
            (SE(9)  AND L(9))  OR 
		      (SE(25) AND L(10)) OR 
		      (SF(9)  AND L(11)) OR 
		      (SF(25) AND L(12)) OR 
            (SG(9)  AND L(13)) OR 
		      (SG(25) AND L(14)) OR
	     	   (SH(9)  AND L(15)) OR 
		      (SH(25) AND L(16)) OR
		      (SI(9)  AND L(17)) OR
		      (SI(25) AND L(18)));
		 
OUTL(26) <= ((SA(10) AND L(1))  OR 
             (SA(26) AND L(2))  OR 
		       (SB(10) AND L(3))  OR 
		       (SB(26) AND L(4))  OR
		       (SC(10) AND L(5))  OR 
		       (SC(26) AND L(6))  OR 
		       (SD(10) AND L(7))  OR 
		       (SD(26) AND L(8))  OR
             (SE(10) AND L(9))  OR 
		       (SE(26) AND L(10)) OR 
		       (SF(10) AND L(11)) OR 
		       (SF(26) AND L(12)) OR 
             (SG(10) AND L(13)) OR 
		       (SG(26) AND L(14)) OR
		       (SH(10) AND L(15)) OR 
		       (SH(26) AND L(16)) OR
		       (SI(10) AND L(17)) OR
		       (SI(26) AND L(18)));
		 
OUTL(27) <= (SA(11)  OR 
            SA(27)   OR 
		      SB(11)   OR 
		      SB(27)   OR
		      SC(11)   OR 
		      SC(27)   OR 
		      SD(11)   OR 
		      SD(27)   OR
            SE(11)   OR 
		      SE(27)   OR 
		      SF(11)   OR 
		      SF(27)   OR 
            SG(11)   OR 
		      SG(27)   OR
		      SH(11)   OR 
		      SH(27)   OR
		      SI(11)   OR
		      SI(27));

OUTL(28) <= ((SA(12)  AND L(1))  OR 
              (SA(28) AND L(2))  OR 
		        (SB(12) AND L(3))  OR 
		        (SB(28) AND L(4))  OR
		        (SC(12) AND L(5))  OR 
		        (SC(28) AND L(6))  OR 
		        (SD(12) AND L(7))  OR 
	        	  (SD(28) AND L(8))  OR
              (SE(12) AND L(9))  OR 
		        (SE(28) AND L(10)) OR 
		        (SF(12) AND L(11)) OR 
		        (SF(28) AND L(12)) OR 
              (SG(12) AND L(13)) OR 
		        (SG(28) AND L(14)) OR
		        (SH(12) AND L(15)) OR 
		        (SH(28) AND L(16)) OR
		        (SI(12) AND L(17)) OR
		        (SI(28) AND L(18)));
		 
OUTL(29) <= ((SA(13)  AND L(1))  OR 
              (SA(29) AND L(2))  OR 
		        (SB(13) AND L(3))  OR 
		        (SB(29) AND L(4))  OR
		        (SC(13) AND L(5))  OR 
		        (SC(29) AND L(6))  OR 
		        (SD(13) AND L(7))  OR 
		        (SD(29) AND L(8))  OR
              (SE(13) AND L(9))  OR 
	           (SE(29) AND L(10)) OR 
		        (SF(13) AND L(11)) OR 
		        (SF(29) AND L(12)) OR 
              (SG(13) AND L(13)) OR 
		        (SG(29) AND L(14)) OR
		        (SH(13) AND L(15)) OR 
		        (SH(29) AND L(16)) OR
		        (SI(13) AND L(17)) OR
		        (SI(29) AND L(18)));
		 
OUTL(30) <= ((SA(14)  AND L(1))  OR 
              (SA(30) AND L(2))  OR 
		        (SB(14) AND L(3))  OR 
		        (SB(30) AND L(4))  OR
	           (SC(14) AND L(5))  OR 
		        (SC(30) AND L(6))  OR 
		        (SD(14) AND L(7))  OR 
		        (SD(30) AND L(8))  OR
              (SE(14) AND L(9))  OR 
		        (SE(30) AND L(10)) OR 
		        (SF(14) AND L(11)) OR 
		        (SF(30) AND L(12)) OR 
              (SG(14) AND L(13)) OR 
		        (SG(30) AND L(14)) OR
		        (SH(14) AND L(15)) OR 
		        (SH(30) AND L(16)) OR
		        (SI(14) AND L(17)) OR
	           (SI(30) AND L(18)));
		 
OUTL(31) <= ((SA(15)  AND L(1))  OR 
              (SA(31) AND L(2))  OR 
		        (SB(15) AND L(3))  OR 
		        (SB(31) AND L(4))  OR
		        (SC(15) AND L(5))  OR 
		        (SC(31) AND L(6))  OR 
		        (SD(15) AND L(7))  OR 
		        (SD(31) AND L(8))  OR
              (SE(15) AND L(9))  OR 
		        (SE(31) AND L(10)) OR 
		        (SF(15) AND L(11)) OR 
		        (SF(31) AND L(12)) OR 
              (SG(15) AND L(13)) OR 
		        (SG(31) AND L(14)) OR
		        (SH(15) AND L(15)) OR 
		        (SH(31) AND L(16)) OR
		        (SI(15) AND L(17)) OR
		        (SI(31) AND L(18)));		 

end ARC;
